#line 1 "ad_aarch64.cpp"
//
// Copyright (c) 2003, 2023, Oracle and/or its affiliates. All rights reserved.
// Copyright (c) 2014, 2021, Red Hat, Inc. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/adGlobals_aarch64.hpp"
#include "adfiles/ad_aarch64.hpp"
#include "memory/allocation.inline.hpp"
#include "code/codeCache.hpp"
#include "code/compiledIC.hpp"
#include "code/nativeInst.hpp"
#include "code/vmreg.inline.hpp"
#include "gc/shared/collectedHeap.inline.hpp"
#include "oops/compiledICHolder.hpp"
#include "oops/compressedOops.hpp"
#include "oops/markWord.hpp"
#include "oops/method.hpp"
#include "oops/oop.inline.hpp"
#include "opto/c2_MacroAssembler.hpp"
#include "opto/cfgnode.hpp"
#include "opto/intrinsicnode.hpp"
#include "opto/locknode.hpp"
#include "opto/opcodes.hpp"
#include "opto/regalloc.hpp"
#include "opto/regmask.hpp"
#include "opto/runtime.hpp"
#include "runtime/safepointMechanism.hpp"
#include "runtime/sharedRuntime.hpp"
#include "runtime/stubRoutines.hpp"
#include "utilities/growableArray.hpp"
#include "utilities/powerOfTwo.hpp"

//SourceForm

#line 1201 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"


  // Derived RegMask with conditionally allocatable registers

  void PhaseOutput::pd_perform_mach_node_analysis() {
  }

  int MachNode::pd_alignment_required() const {
    return 1;
  }

  int MachNode::compute_padding(int current_offset) const {
    return 0;
  }

  RegMask _ANY_REG32_mask;
  RegMask _ANY_REG_mask;
  RegMask _PTR_REG_mask;
  RegMask _NO_SPECIAL_REG32_mask;
  RegMask _NO_SPECIAL_REG_mask;
  RegMask _NO_SPECIAL_PTR_REG_mask;
  RegMask _NO_SPECIAL_NO_RFP_PTR_REG_mask;

  void reg_mask_init() {
    // We derive below RegMask(s) from the ones which are auto-generated from
    // adlc register classes to make AArch64 rheapbase (r27) and rfp (r29)
    // registers conditionally reserved.

    _ANY_REG32_mask = _ALL_REG32_mask;
    _ANY_REG32_mask.Remove(OptoReg::as_OptoReg(r31_sp->as_VMReg()));

    _ANY_REG_mask = _ALL_REG_mask;

    _PTR_REG_mask = _ALL_REG_mask;

    _NO_SPECIAL_REG32_mask = _ALL_REG32_mask;
    _NO_SPECIAL_REG32_mask.SUBTRACT(_NON_ALLOCATABLE_REG32_mask);

    _NO_SPECIAL_REG_mask = _ALL_REG_mask;
    _NO_SPECIAL_REG_mask.SUBTRACT(_NON_ALLOCATABLE_REG_mask);

    _NO_SPECIAL_PTR_REG_mask = _ALL_REG_mask;
    _NO_SPECIAL_PTR_REG_mask.SUBTRACT(_NON_ALLOCATABLE_REG_mask);

    // r27 is not allocatable when compressed oops is on and heapbase is not
    // zero, compressed klass pointers doesn't use r27 after JDK-8234794
    if (UseCompressedOops && (CompressedOops::ptrs_base() != NULL)) {
      _NO_SPECIAL_REG32_mask.Remove(OptoReg::as_OptoReg(r27->as_VMReg()));
      _NO_SPECIAL_REG_mask.Remove(OptoReg::as_OptoReg(r27->as_VMReg()));
      _NO_SPECIAL_PTR_REG_mask.Remove(OptoReg::as_OptoReg(r27->as_VMReg()));
    }

    // r29 is not allocatable when PreserveFramePointer is on
    if (PreserveFramePointer) {
      _NO_SPECIAL_REG32_mask.Remove(OptoReg::as_OptoReg(r29->as_VMReg()));
      _NO_SPECIAL_REG_mask.Remove(OptoReg::as_OptoReg(r29->as_VMReg()));
      _NO_SPECIAL_PTR_REG_mask.Remove(OptoReg::as_OptoReg(r29->as_VMReg()));
    }

    _NO_SPECIAL_NO_RFP_PTR_REG_mask = _NO_SPECIAL_PTR_REG_mask;
    _NO_SPECIAL_NO_RFP_PTR_REG_mask.Remove(OptoReg::as_OptoReg(r29->as_VMReg()));
  }

  // Optimizaton of volatile gets and puts
  // -------------------------------------
  //
  // AArch64 has ldar<x> and stlr<x> instructions which we can safely
  // use to implement volatile reads and writes. For a volatile read
  // we simply need
  //
  //   ldar<x>
  //
  // and for a volatile write we need
  //
  //   stlr<x>
  //
  // Alternatively, we can implement them by pairing a normal
  // load/store with a memory barrier. For a volatile read we need
  //
  //   ldr<x>
  //   dmb ishld
  //
  // for a volatile write
  //
  //   dmb ish
  //   str<x>
  //   dmb ish
  //
  // We can also use ldaxr and stlxr to implement compare and swap CAS
  // sequences. These are normally translated to an instruction
  // sequence like the following
  //
  //   dmb      ish
  // retry:
  //   ldxr<x>   rval raddr
  //   cmp       rval rold
  //   b.ne done
  //   stlxr<x>  rval, rnew, rold
  //   cbnz      rval retry
  // done:
  //   cset      r0, eq
  //   dmb ishld
  //
  // Note that the exclusive store is already using an stlxr
  // instruction. That is required to ensure visibility to other
  // threads of the exclusive write (assuming it succeeds) before that
  // of any subsequent writes.
  //
  // The following instruction sequence is an improvement on the above
  //
  // retry:
  //   ldaxr<x>  rval raddr
  //   cmp       rval rold
  //   b.ne done
  //   stlxr<x>  rval, rnew, rold
  //   cbnz      rval retry
  // done:
  //   cset      r0, eq
  //
  // We don't need the leading dmb ish since the stlxr guarantees
  // visibility of prior writes in the case that the swap is
  // successful. Crucially we don't have to worry about the case where
  // the swap is not successful since no valid program should be
  // relying on visibility of prior changes by the attempting thread
  // in the case where the CAS fails.
  //
  // Similarly, we don't need the trailing dmb ishld if we substitute
  // an ldaxr instruction since that will provide all the guarantees we
  // require regarding observation of changes made by other threads
  // before any change to the CAS address observed by the load.
  //
  // In order to generate the desired instruction sequence we need to
  // be able to identify specific 'signature' ideal graph node
  // sequences which i) occur as a translation of a volatile reads or
  // writes or CAS operations and ii) do not occur through any other
  // translation or graph transformation. We can then provide
  // alternative aldc matching rules which translate these node
  // sequences to the desired machine code sequences. Selection of the
  // alternative rules can be implemented by predicates which identify
  // the relevant node sequences.
  //
  // The ideal graph generator translates a volatile read to the node
  // sequence
  //
  //   LoadX[mo_acquire]
  //   MemBarAcquire
  //
  // As a special case when using the compressed oops optimization we
  // may also see this variant
  //
  //   LoadN[mo_acquire]
  //   DecodeN
  //   MemBarAcquire
  //
  // A volatile write is translated to the node sequence
  //
  //   MemBarRelease
  //   StoreX[mo_release] {CardMark}-optional
  //   MemBarVolatile
  //
  // n.b. the above node patterns are generated with a strict
  // 'signature' configuration of input and output dependencies (see
  // the predicates below for exact details). The card mark may be as
  // simple as a few extra nodes or, in a few GC configurations, may
  // include more complex control flow between the leading and
  // trailing memory barriers. However, whatever the card mark
  // configuration these signatures are unique to translated volatile
  // reads/stores -- they will not appear as a result of any other
  // bytecode translation or inlining nor as a consequence of
  // optimizing transforms.
  //
  // We also want to catch inlined unsafe volatile gets and puts and
  // be able to implement them using either ldar<x>/stlr<x> or some
  // combination of ldr<x>/stlr<x> and dmb instructions.
  //
  // Inlined unsafe volatiles puts manifest as a minor variant of the
  // normal volatile put node sequence containing an extra cpuorder
  // membar
  //
  //   MemBarRelease
  //   MemBarCPUOrder
  //   StoreX[mo_release] {CardMark}-optional
  //   MemBarCPUOrder
  //   MemBarVolatile
  //
  // n.b. as an aside, a cpuorder membar is not itself subject to
  // matching and translation by adlc rules.  However, the rule
  // predicates need to detect its presence in order to correctly
  // select the desired adlc rules.
  //
  // Inlined unsafe volatile gets manifest as a slightly different
  // node sequence to a normal volatile get because of the
  // introduction of some CPUOrder memory barriers to bracket the
  // Load. However, but the same basic skeleton of a LoadX feeding a
  // MemBarAcquire, possibly through an optional DecodeN, is still
  // present
  //
  //   MemBarCPUOrder
  //        ||       \\
  //   MemBarCPUOrder LoadX[mo_acquire]
  //        ||            |
  //        ||       {DecodeN} optional
  //        ||       /
  //     MemBarAcquire
  //
  // In this case the acquire membar does not directly depend on the
  // load. However, we can be sure that the load is generated from an
  // inlined unsafe volatile get if we see it dependent on this unique
  // sequence of membar nodes. Similarly, given an acquire membar we
  // can know that it was added because of an inlined unsafe volatile
  // get if it is fed and feeds a cpuorder membar and if its feed
  // membar also feeds an acquiring load.
  //
  // Finally an inlined (Unsafe) CAS operation is translated to the
  // following ideal graph
  //
  //   MemBarRelease
  //   MemBarCPUOrder
  //   CompareAndSwapX {CardMark}-optional
  //   MemBarCPUOrder
  //   MemBarAcquire
  //
  // So, where we can identify these volatile read and write
  // signatures we can choose to plant either of the above two code
  // sequences. For a volatile read we can simply plant a normal
  // ldr<x> and translate the MemBarAcquire to a dmb. However, we can
  // also choose to inhibit translation of the MemBarAcquire and
  // inhibit planting of the ldr<x>, instead planting an ldar<x>.
  //
  // When we recognise a volatile store signature we can choose to
  // plant at a dmb ish as a translation for the MemBarRelease, a
  // normal str<x> and then a dmb ish for the MemBarVolatile.
  // Alternatively, we can inhibit translation of the MemBarRelease
  // and MemBarVolatile and instead plant a simple stlr<x>
  // instruction.
  //
  // when we recognise a CAS signature we can choose to plant a dmb
  // ish as a translation for the MemBarRelease, the conventional
  // macro-instruction sequence for the CompareAndSwap node (which
  // uses ldxr<x>) and then a dmb ishld for the MemBarAcquire.
  // Alternatively, we can elide generation of the dmb instructions
  // and plant the alternative CompareAndSwap macro-instruction
  // sequence (which uses ldaxr<x>).
  //
  // Of course, the above only applies when we see these signature
  // configurations. We still want to plant dmb instructions in any
  // other cases where we may see a MemBarAcquire, MemBarRelease or
  // MemBarVolatile. For example, at the end of a constructor which
  // writes final/volatile fields we will see a MemBarRelease
  // instruction and this needs a 'dmb ish' lest we risk the
  // constructed object being visible without making the
  // final/volatile field writes visible.
  //
  // n.b. the translation rules below which rely on detection of the
  // volatile signatures and insert ldar<x> or stlr<x> are failsafe.
  // If we see anything other than the signature configurations we
  // always just translate the loads and stores to ldr<x> and str<x>
  // and translate acquire, release and volatile membars to the
  // relevant dmb instructions.
  //

  // is_CAS(int opcode, bool maybe_volatile)
  //
  // return true if opcode is one of the possible CompareAndSwapX
  // values otherwise false.

  bool is_CAS(int opcode, bool maybe_volatile)
  {
    switch(opcode) {
      // We handle these
    case Op_CompareAndSwapI:
    case Op_CompareAndSwapL:
    case Op_CompareAndSwapP:
    case Op_CompareAndSwapN:
    case Op_ShenandoahCompareAndSwapP:
    case Op_ShenandoahCompareAndSwapN:
    case Op_CompareAndSwapB:
    case Op_CompareAndSwapS:
    case Op_GetAndSetI:
    case Op_GetAndSetL:
    case Op_GetAndSetP:
    case Op_GetAndSetN:
    case Op_GetAndAddI:
    case Op_GetAndAddL:
      return true;
    case Op_CompareAndExchangeI:
    case Op_CompareAndExchangeN:
    case Op_CompareAndExchangeB:
    case Op_CompareAndExchangeS:
    case Op_CompareAndExchangeL:
    case Op_CompareAndExchangeP:
    case Op_WeakCompareAndSwapB:
    case Op_WeakCompareAndSwapS:
    case Op_WeakCompareAndSwapI:
    case Op_WeakCompareAndSwapL:
    case Op_WeakCompareAndSwapP:
    case Op_WeakCompareAndSwapN:
    case Op_ShenandoahWeakCompareAndSwapP:
    case Op_ShenandoahWeakCompareAndSwapN:
    case Op_ShenandoahCompareAndExchangeP:
    case Op_ShenandoahCompareAndExchangeN:
      return maybe_volatile;
    default:
      return false;
    }
  }

  // helper to determine the maximum number of Phi nodes we may need to
  // traverse when searching from a card mark membar for the merge mem
  // feeding a trailing membar or vice versa

// predicates controlling emit of ldr<x>/ldar<x>

bool unnecessary_acquire(const Node *barrier)
{
  assert(barrier->is_MemBar(), "expecting a membar");

  MemBarNode* mb = barrier->as_MemBar();

  if (mb->trailing_load()) {
    return true;
  }

  if (mb->trailing_load_store()) {
    Node* load_store = mb->in(MemBarNode::Precedent);
    assert(load_store->is_LoadStore(), "unexpected graph shape");
    return is_CAS(load_store->Opcode(), true);
  }

  return false;
}

bool needs_acquiring_load(const Node *n)
{
  assert(n->is_Load(), "expecting a load");
  LoadNode *ld = n->as_Load();
  return ld->is_acquire();
}

bool unnecessary_release(const Node *n)
{
  assert((n->is_MemBar() &&
          n->Opcode() == Op_MemBarRelease),
         "expecting a release membar");

  MemBarNode *barrier = n->as_MemBar();
  if (!barrier->leading()) {
    return false;
  } else {
    Node* trailing = barrier->trailing_membar();
    MemBarNode* trailing_mb = trailing->as_MemBar();
    assert(trailing_mb->trailing(), "Not a trailing membar?");
    assert(trailing_mb->leading_membar() == n, "inconsistent leading/trailing membars");

    Node* mem = trailing_mb->in(MemBarNode::Precedent);
    if (mem->is_Store()) {
      assert(mem->as_Store()->is_release(), "");
      assert(trailing_mb->Opcode() == Op_MemBarVolatile, "");
      return true;
    } else {
      assert(mem->is_LoadStore(), "");
      assert(trailing_mb->Opcode() == Op_MemBarAcquire, "");
      return is_CAS(mem->Opcode(), true);
    }
  }
  return false;
}

bool unnecessary_volatile(const Node *n)
{
  // assert n->is_MemBar();
  MemBarNode *mbvol = n->as_MemBar();

  bool release = mbvol->trailing_store();
  assert(!release || (mbvol->in(MemBarNode::Precedent)->is_Store() && mbvol->in(MemBarNode::Precedent)->as_Store()->is_release()), "");
#ifdef ASSERT
  if (release) {
    Node* leading = mbvol->leading_membar();
    assert(leading->Opcode() == Op_MemBarRelease, "");
    assert(leading->as_MemBar()->leading_store(), "");
    assert(leading->as_MemBar()->trailing_membar() == mbvol, "");
  }
#endif

  return release;
}

// predicates controlling emit of str<x>/stlr<x>

bool needs_releasing_store(const Node *n)
{
  // assert n->is_Store();
  StoreNode *st = n->as_Store();
  return st->trailing_membar() != NULL;
}

// predicate controlling translation of CAS
//
// returns true if CAS needs to use an acquiring load otherwise false

bool needs_acquiring_load_exclusive(const Node *n)
{
  assert(is_CAS(n->Opcode(), true), "expecting a compare and swap");
  LoadStoreNode* ldst = n->as_LoadStore();
  if (is_CAS(n->Opcode(), false)) {
    assert(ldst->trailing_membar() != NULL, "expected trailing membar");
  } else {
    return ldst->trailing_membar() != NULL;
  }

  // so we can just return true here
  return true;
}

#define __ _masm.

// advance declarations for helper functions to convert register
// indices to register objects

// the ad file has to provide implementations of certain methods
// expected by the generic code
//
// REQUIRED FUNCTIONALITY

//=============================================================================

// !!!!! Special hack to get all types of calls to specify the byte offset
//       from the start of the call to the point where the return address
//       will point.

int MachCallStaticJavaNode::ret_addr_offset()
{
  // call should be a simple bl
  int off = 4;
  return off;
}

int MachCallDynamicJavaNode::ret_addr_offset()
{
  return 16; // movz, movk, movk, bl
}

int MachCallRuntimeNode::ret_addr_offset() {
  // for generated stubs the call will be
  //   bl(addr)
  // or with far branches
  //   bl(trampoline_stub)
  // for real runtime callouts it will be six instructions
  // see aarch64_enc_java_to_runtime
  //   adr(rscratch2, retaddr)
  //   lea(rscratch1, RuntimeAddress(addr)
  //   stp(zr, rscratch2, Address(__ pre(sp, -2 * wordSize)))
  //   blr(rscratch1)
  CodeBlob *cb = CodeCache::find_blob(_entry_point);
  if (cb) {
    return 1 * NativeInstruction::instruction_size;
  } else {
    return 6 * NativeInstruction::instruction_size;
  }
}

//=============================================================================

#ifndef PRODUCT
void MachBreakpointNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  st->print("BREAKPOINT");
}
#endif

void MachBreakpointNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  C2_MacroAssembler _masm(&cbuf);
  __ brk(0);
}

uint MachBreakpointNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_);
}

//=============================================================================

#ifndef PRODUCT
  void MachNopNode::format(PhaseRegAlloc*, outputStream* st) const {
    st->print("nop \t# %d bytes pad for loops and calls", _count);
  }
#endif

  void MachNopNode::emit(CodeBuffer &cbuf, PhaseRegAlloc*) const {
    C2_MacroAssembler _masm(&cbuf);
    for (int i = 0; i < _count; i++) {
      __ nop();
    }
  }

  uint MachNopNode::size(PhaseRegAlloc*) const {
    return _count * NativeInstruction::instruction_size;
  }

//=============================================================================
const RegMask& MachConstantBaseNode::_out_RegMask = RegMask::Empty;

int ConstantTable::calculate_table_base_offset() const {
  return 0;  // absolute addressing, no offset
}

bool MachConstantBaseNode::requires_postalloc_expand() const { return false; }
void MachConstantBaseNode::postalloc_expand(GrowableArray <Node *> *nodes, PhaseRegAlloc *ra_) {
  ShouldNotReachHere();
}

void MachConstantBaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  // Empty encoding
}

uint MachConstantBaseNode::size(PhaseRegAlloc* ra_) const {
  return 0;
}

#ifndef PRODUCT
void MachConstantBaseNode::format(PhaseRegAlloc* ra_, outputStream* st) const {
  st->print("-- \t// MachConstantBaseNode (empty encoding)");
}
#endif

#ifndef PRODUCT
void MachPrologNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  Compile* C = ra_->C;

  int framesize = C->output()->frame_slots() << LogBytesPerInt;

  if (C->output()->need_stack_bang(framesize))
    st->print("# stack bang size=%d\n\t", framesize);

  if (VM_Version::use_rop_protection()) {
    st->print("ldr  zr, [lr]\n\t");
    st->print("paciaz\n\t");
  }
  if (framesize < ((1 << 9) + 2 * wordSize)) {
    st->print("sub  sp, sp, #%d\n\t", framesize);
    st->print("stp  rfp, lr, [sp, #%d]", framesize - 2 * wordSize);
    if (PreserveFramePointer) st->print("\n\tadd  rfp, sp, #%d", framesize - 2 * wordSize);
  } else {
    st->print("stp  lr, rfp, [sp, #%d]!\n\t", -(2 * wordSize));
    if (PreserveFramePointer) st->print("mov  rfp, sp\n\t");
    st->print("mov  rscratch1, #%d\n\t", framesize - 2 * wordSize);
    st->print("sub  sp, sp, rscratch1");
  }
  if (C->stub_function() == NULL && BarrierSet::barrier_set()->barrier_set_nmethod() != NULL) {
    st->print("\n\t");
    st->print("ldr  rscratch1, [guard]\n\t");
    st->print("dmb ishld\n\t");
    st->print("ldr  rscratch2, [rthread, #thread_disarmed_guard_value_offset]\n\t");
    st->print("cmp  rscratch1, rscratch2\n\t");
    st->print("b.eq skip");
    st->print("\n\t");
    st->print("blr #nmethod_entry_barrier_stub\n\t");
    st->print("b skip\n\t");
    st->print("guard: int\n\t");
    st->print("\n\t");
    st->print("skip:\n\t");
  }
}
#endif

void MachPrologNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  Compile* C = ra_->C;
  C2_MacroAssembler _masm(&cbuf);

  // n.b. frame size includes space for return pc and rfp
  const int framesize = C->output()->frame_size_in_bytes();

  // insert a nop at the start of the prolog so we can patch in a
  // branch if we need to invalidate the method later
  __ nop();

  if (C->clinit_barrier_on_entry()) {
    assert(!C->method()->holder()->is_not_initialized(), "initialization should have been started");

    Label L_skip_barrier;

    __ mov_metadata(rscratch2, C->method()->holder()->constant_encoding());
    __ clinit_barrier(rscratch2, rscratch1, &L_skip_barrier);
    __ far_jump(RuntimeAddress(SharedRuntime::get_handle_wrong_method_stub()));
    __ bind(L_skip_barrier);
  }

  if (C->max_vector_size() > 0) {
    __ reinitialize_ptrue();
  }

  int bangsize = C->output()->bang_size_in_bytes();
  if (C->output()->need_stack_bang(bangsize))
    __ generate_stack_overflow_check(bangsize);

  __ build_frame(framesize);

  if (C->stub_function() == NULL) {
    BarrierSetAssembler* bs = BarrierSet::barrier_set()->barrier_set_assembler();
    if (BarrierSet::barrier_set()->barrier_set_nmethod() != NULL) {
      // Dummy labels for just measuring the code size
      Label dummy_slow_path;
      Label dummy_continuation;
      Label dummy_guard;
      Label* slow_path = &dummy_slow_path;
      Label* continuation = &dummy_continuation;
      Label* guard = &dummy_guard;
      if (!Compile::current()->output()->in_scratch_emit_size()) {
        // Use real labels from actual stub when not emitting code for the purpose of measuring its size
        C2EntryBarrierStub* stub = new (Compile::current()->comp_arena()) C2EntryBarrierStub();
        Compile::current()->output()->add_stub(stub);
        slow_path = &stub->entry();
        continuation = &stub->continuation();
        guard = &stub->guard();
      }
      // In the C2 code, we move the non-hot part of nmethod entry barriers out-of-line to a stub.
      bs->nmethod_entry_barrier(&_masm, slow_path, continuation, guard);
    }
  }

  if (VerifyStackAtCalls) {
    Unimplemented();
  }

  C->output()->set_frame_complete(cbuf.insts_size());

  if (C->has_mach_constant_base_node()) {
    // NOTE: We set the table base offset here because users might be
    // emitted before MachConstantBaseNode.
    ConstantTable& constant_table = C->output()->constant_table();
    constant_table.set_table_base_offset(constant_table.calculate_table_base_offset());
  }
}

uint MachPrologNode::size(PhaseRegAlloc* ra_) const
{
  return MachNode::size(ra_); // too many variables; just compute it
                              // the hard way
}

int MachPrologNode::reloc() const
{
  return 0;
}

//=============================================================================

#ifndef PRODUCT
void MachEpilogNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  Compile* C = ra_->C;
  int framesize = C->output()->frame_slots() << LogBytesPerInt;

  st->print("# pop frame %d\n\t",framesize);

  if (framesize == 0) {
    st->print("ldp  lr, rfp, [sp],#%d\n\t", (2 * wordSize));
  } else if (framesize < ((1 << 9) + 2 * wordSize)) {
    st->print("ldp  lr, rfp, [sp,#%d]\n\t", framesize - 2 * wordSize);
    st->print("add  sp, sp, #%d\n\t", framesize);
  } else {
    st->print("mov  rscratch1, #%d\n\t", framesize - 2 * wordSize);
    st->print("add  sp, sp, rscratch1\n\t");
    st->print("ldp  lr, rfp, [sp],#%d\n\t", (2 * wordSize));
  }
  if (VM_Version::use_rop_protection()) {
    st->print("autiaz\n\t");
    st->print("ldr  zr, [lr]\n\t");
  }

  if (do_polling() && C->is_method_compilation()) {
    st->print("# test polling word\n\t");
    st->print("ldr  rscratch1, [rthread],#%d\n\t", in_bytes(JavaThread::polling_word_offset()));
    st->print("cmp  sp, rscratch1\n\t");
    st->print("bhi #slow_path");
  }
}
#endif

void MachEpilogNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  Compile* C = ra_->C;
  C2_MacroAssembler _masm(&cbuf);
  int framesize = C->output()->frame_slots() << LogBytesPerInt;

  __ remove_frame(framesize);

  if (StackReservedPages > 0 && C->has_reserved_stack_access()) {
    __ reserved_stack_check();
  }

  if (do_polling() && C->is_method_compilation()) {
    Label dummy_label;
    Label* code_stub = &dummy_label;
    if (!C->output()->in_scratch_emit_size()) {
      C2SafepointPollStub* stub = new (C->comp_arena()) C2SafepointPollStub(__ offset());
      C->output()->add_stub(stub);
      code_stub = &stub->entry();
    }
    __ relocate(relocInfo::poll_return_type);
    __ safepoint_poll(*code_stub, true /* at_return */, false /* acquire */, true /* in_nmethod */);
  }
}

uint MachEpilogNode::size(PhaseRegAlloc *ra_) const {
  // Variable size. Determine dynamically.
  return MachNode::size(ra_);
}

int MachEpilogNode::reloc() const {
  // Return number of relocatable values contained in this instruction.
  return 1; // 1 for polling page.
}

const Pipeline * MachEpilogNode::pipeline() const {
  return MachNode::pipeline_class();
}

//=============================================================================

// Figure out which register class each belongs in: rc_int, rc_float or
// rc_stack.
enum RC { rc_bad, rc_int, rc_float, rc_predicate, rc_stack };

static enum RC rc_class(OptoReg::Name reg) {

  if (reg == OptoReg::Bad) {
    return rc_bad;
  }

  // we have 32 int registers * 2 halves
  int slots_of_int_registers = Register::number_of_registers * Register::max_slots_per_register;

  if (reg < slots_of_int_registers) {
    return rc_int;
  }

  // we have 32 float register * 8 halves
  int slots_of_float_registers = FloatRegister::number_of_registers * FloatRegister::max_slots_per_register;
  if (reg < slots_of_int_registers + slots_of_float_registers) {
    return rc_float;
  }

  int slots_of_predicate_registers = PRegister::number_of_registers * PRegister::max_slots_per_register;
  if (reg < slots_of_int_registers + slots_of_float_registers + slots_of_predicate_registers) {
    return rc_predicate;
  }

  // Between predicate regs & stack is the flags.
  assert(OptoReg::is_stack(reg), "blow up if spilling flags");

  return rc_stack;
}

uint MachSpillCopyNode::implementation(CodeBuffer *cbuf, PhaseRegAlloc *ra_, bool do_size, outputStream *st) const {
  Compile* C = ra_->C;

  // Get registers to move.
  OptoReg::Name src_hi = ra_->get_reg_second(in(1));
  OptoReg::Name src_lo = ra_->get_reg_first(in(1));
  OptoReg::Name dst_hi = ra_->get_reg_second(this);
  OptoReg::Name dst_lo = ra_->get_reg_first(this);

  enum RC src_hi_rc = rc_class(src_hi);
  enum RC src_lo_rc = rc_class(src_lo);
  enum RC dst_hi_rc = rc_class(dst_hi);
  enum RC dst_lo_rc = rc_class(dst_lo);

  assert(src_lo != OptoReg::Bad && dst_lo != OptoReg::Bad, "must move at least 1 register");

  if (src_hi != OptoReg::Bad && !bottom_type()->isa_vectmask()) {
    assert((src_lo&1)==0 && src_lo+1==src_hi &&
           (dst_lo&1)==0 && dst_lo+1==dst_hi,
           "expected aligned-adjacent pairs");
  }

  if (src_lo == dst_lo && src_hi == dst_hi) {
    return 0;            // Self copy, no move.
  }

  bool is64 = (src_lo & 1) == 0 && src_lo + 1 == src_hi &&
              (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi;
  int src_offset = ra_->reg2offset(src_lo);
  int dst_offset = ra_->reg2offset(dst_lo);

  if (bottom_type()->isa_vect() && !bottom_type()->isa_vectmask()) {
    uint ireg = ideal_reg();
    if (ireg == Op_VecA && cbuf) {
      C2_MacroAssembler _masm(cbuf);
      int sve_vector_reg_size_in_bytes = Matcher::scalable_vector_reg_size(T_BYTE);
      if (src_lo_rc == rc_stack && dst_lo_rc == rc_stack) {
        // stack->stack
        __ spill_copy_sve_vector_stack_to_stack(src_offset, dst_offset,
                                                sve_vector_reg_size_in_bytes);
      } else if (src_lo_rc == rc_float && dst_lo_rc == rc_stack) {
        __ spill_sve_vector(as_FloatRegister(Matcher::_regEncode[src_lo]), ra_->reg2offset(dst_lo),
                            sve_vector_reg_size_in_bytes);
      } else if (src_lo_rc == rc_stack && dst_lo_rc == rc_float) {
        __ unspill_sve_vector(as_FloatRegister(Matcher::_regEncode[dst_lo]), ra_->reg2offset(src_lo),
                              sve_vector_reg_size_in_bytes);
      } else if (src_lo_rc == rc_float && dst_lo_rc == rc_float) {
        __ sve_orr(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                   as_FloatRegister(Matcher::_regEncode[src_lo]),
                   as_FloatRegister(Matcher::_regEncode[src_lo]));
      } else {
        ShouldNotReachHere();
      }
    } else if (cbuf) {
      assert(ireg == Op_VecD || ireg == Op_VecX, "must be 64 bit or 128 bit vector");
      C2_MacroAssembler _masm(cbuf);
      assert((src_lo_rc != rc_int && dst_lo_rc != rc_int), "sanity");
      if (src_lo_rc == rc_stack && dst_lo_rc == rc_stack) {
        // stack->stack
        assert((src_offset & 7) == 0 && (dst_offset & 7) == 0, "unaligned stack offset");
        if (ireg == Op_VecD) {
          __ unspill(rscratch1, true, src_offset);
          __ spill(rscratch1, true, dst_offset);
        } else {
          __ spill_copy128(src_offset, dst_offset);
        }
      } else if (src_lo_rc == rc_float && dst_lo_rc == rc_float) {
        __ mov(as_FloatRegister(Matcher::_regEncode[dst_lo]),
               ireg == Op_VecD ? __ T8B : __ T16B,
               as_FloatRegister(Matcher::_regEncode[src_lo]));
      } else if (src_lo_rc == rc_float && dst_lo_rc == rc_stack) {
        __ spill(as_FloatRegister(Matcher::_regEncode[src_lo]),
                 ireg == Op_VecD ? __ D : __ Q,
                 ra_->reg2offset(dst_lo));
      } else if (src_lo_rc == rc_stack && dst_lo_rc == rc_float) {
        __ unspill(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                   ireg == Op_VecD ? __ D : __ Q,
                   ra_->reg2offset(src_lo));
      } else {
        ShouldNotReachHere();
      }
    }
  } else if (cbuf) {
    C2_MacroAssembler _masm(cbuf);
    switch (src_lo_rc) {
    case rc_int:
      if (dst_lo_rc == rc_int) {  // gpr --> gpr copy
        if (is64) {
            __ mov(as_Register(Matcher::_regEncode[dst_lo]),
                   as_Register(Matcher::_regEncode[src_lo]));
        } else {
            C2_MacroAssembler _masm(cbuf);
            __ movw(as_Register(Matcher::_regEncode[dst_lo]),
                    as_Register(Matcher::_regEncode[src_lo]));
        }
      } else if (dst_lo_rc == rc_float) { // gpr --> fpr copy
        if (is64) {
            __ fmovd(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                     as_Register(Matcher::_regEncode[src_lo]));
        } else {
            __ fmovs(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                     as_Register(Matcher::_regEncode[src_lo]));
        }
      } else {                    // gpr --> stack spill
        assert(dst_lo_rc == rc_stack, "spill to bad register class");
        __ spill(as_Register(Matcher::_regEncode[src_lo]), is64, dst_offset);
      }
      break;
    case rc_float:
      if (dst_lo_rc == rc_int) {  // fpr --> gpr copy
        if (is64) {
            __ fmovd(as_Register(Matcher::_regEncode[dst_lo]),
                     as_FloatRegister(Matcher::_regEncode[src_lo]));
        } else {
            __ fmovs(as_Register(Matcher::_regEncode[dst_lo]),
                     as_FloatRegister(Matcher::_regEncode[src_lo]));
        }
      } else if (dst_lo_rc == rc_float) { // fpr --> fpr copy
        if (is64) {
            __ fmovd(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                     as_FloatRegister(Matcher::_regEncode[src_lo]));
        } else {
            __ fmovs(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                     as_FloatRegister(Matcher::_regEncode[src_lo]));
        }
      } else {                    // fpr --> stack spill
        assert(dst_lo_rc == rc_stack, "spill to bad register class");
        __ spill(as_FloatRegister(Matcher::_regEncode[src_lo]),
                 is64 ? __ D : __ S, dst_offset);
      }
      break;
    case rc_stack:
      if (dst_lo_rc == rc_int) {  // stack --> gpr load
        __ unspill(as_Register(Matcher::_regEncode[dst_lo]), is64, src_offset);
      } else if (dst_lo_rc == rc_float) { // stack --> fpr load
        __ unspill(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                   is64 ? __ D : __ S, src_offset);
      } else if (dst_lo_rc == rc_predicate) {
        __ unspill_sve_predicate(as_PRegister(Matcher::_regEncode[dst_lo]), ra_->reg2offset(src_lo),
                                 Matcher::scalable_vector_reg_size(T_BYTE) >> 3);
      } else {                    // stack --> stack copy
        assert(dst_lo_rc == rc_stack, "spill to bad register class");
        if (ideal_reg() == Op_RegVectMask) {
          __ spill_copy_sve_predicate_stack_to_stack(src_offset, dst_offset,
                                                     Matcher::scalable_vector_reg_size(T_BYTE) >> 3);
        } else {
          __ unspill(rscratch1, is64, src_offset);
          __ spill(rscratch1, is64, dst_offset);
        }
      }
      break;
    case rc_predicate:
      if (dst_lo_rc == rc_predicate) {
        __ sve_mov(as_PRegister(Matcher::_regEncode[dst_lo]), as_PRegister(Matcher::_regEncode[src_lo]));
      } else if (dst_lo_rc == rc_stack) {
        __ spill_sve_predicate(as_PRegister(Matcher::_regEncode[src_lo]), ra_->reg2offset(dst_lo),
                               Matcher::scalable_vector_reg_size(T_BYTE) >> 3);
      } else {
        assert(false, "bad src and dst rc_class combination.");
        ShouldNotReachHere();
      }
      break;
    default:
      assert(false, "bad rc_class for spill");
      ShouldNotReachHere();
    }
  }

  if (st) {
    st->print("spill ");
    if (src_lo_rc == rc_stack) {
      st->print("[sp, #%d] -> ", ra_->reg2offset(src_lo));
    } else {
      st->print("%s -> ", Matcher::regName[src_lo]);
    }
    if (dst_lo_rc == rc_stack) {
      st->print("[sp, #%d]", ra_->reg2offset(dst_lo));
    } else {
      st->print("%s", Matcher::regName[dst_lo]);
    }
    if (bottom_type()->isa_vect() && !bottom_type()->isa_vectmask()) {
      int vsize = 0;
      switch (ideal_reg()) {
      case Op_VecD:
        vsize = 64;
        break;
      case Op_VecX:
        vsize = 128;
        break;
      case Op_VecA:
        vsize = Matcher::scalable_vector_reg_size(T_BYTE) * 8;
        break;
      default:
        assert(false, "bad register type for spill");
        ShouldNotReachHere();
      }
      st->print("\t# vector spill size = %d", vsize);
    } else if (ideal_reg() == Op_RegVectMask) {
      assert(Matcher::supports_scalable_vector(), "bad register type for spill");
      int vsize = Matcher::scalable_predicate_reg_slots() * 32;
      st->print("\t# predicate spill size = %d", vsize);
    } else {
      st->print("\t# spill size = %d", is64 ? 64 : 32);
    }
  }

  return 0;

}

#ifndef PRODUCT
void MachSpillCopyNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  if (!ra_)
    st->print("N%d = SpillCopy(N%d)", _idx, in(1)->_idx);
  else
    implementation(NULL, ra_, false, st);
}
#endif

void MachSpillCopyNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  implementation(&cbuf, ra_, false, NULL);
}

uint MachSpillCopyNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_);
}

//=============================================================================

#ifndef PRODUCT
void BoxLockNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg = ra_->get_reg_first(this);
  st->print("add %s, rsp, #%d]\t# box lock",
            Matcher::regName[reg], offset);
}
#endif

void BoxLockNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  C2_MacroAssembler _masm(&cbuf);

  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg    = ra_->get_encode(this);

  // This add will handle any 24-bit signed offset. 24 bits allows an
  // 8 megabyte stack frame.
  __ add(as_Register(reg), sp, offset);
}

uint BoxLockNode::size(PhaseRegAlloc *ra_) const {
  // BoxLockNode is not a MachNode, so we can't just call MachNode::size(ra_).
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());

  if (Assembler::operand_valid_for_add_sub_immediate(offset)) {
    return NativeInstruction::instruction_size;
  } else {
    return 2 * NativeInstruction::instruction_size;
  }
}

//=============================================================================

#ifndef PRODUCT
void MachUEPNode::format(PhaseRegAlloc* ra_, outputStream* st) const
{
  st->print_cr("# MachUEPNode");
  if (UseCompressedClassPointers) {
    st->print_cr("\tldrw rscratch1, j_rarg0 + oopDesc::klass_offset_in_bytes()]\t# compressed klass");
    if (CompressedKlassPointers::shift() != 0) {
      st->print_cr("\tdecode_klass_not_null rscratch1, rscratch1");
    }
  } else {
   st->print_cr("\tldr rscratch1, j_rarg0 + oopDesc::klass_offset_in_bytes()]\t# compressed klass");
  }
  st->print_cr("\tcmp r0, rscratch1\t # Inline cache check");
  st->print_cr("\tbne, SharedRuntime::_ic_miss_stub");
}
#endif

void MachUEPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const
{
  // This is the unverified entry point.
  C2_MacroAssembler _masm(&cbuf);

  __ cmp_klass(j_rarg0, rscratch2, rscratch1);
  Label skip;
  // TODO
  // can we avoid this skip and still use a reloc?
  __ br(Assembler::EQ, skip);
  __ far_jump(RuntimeAddress(SharedRuntime::get_ic_miss_stub()));
  __ bind(skip);
}

uint MachUEPNode::size(PhaseRegAlloc* ra_) const
{
  return MachNode::size(ra_);
}

// REQUIRED EMIT CODE

//=============================================================================

// Emit exception handler code.
int HandlerImpl::emit_exception_handler(CodeBuffer& cbuf)
{
  // mov rscratch1 #exception_blob_entry_point
  // br rscratch1
  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  C2_MacroAssembler _masm(&cbuf);
  address base = __ start_a_stub(size_exception_handler());
  if (base == NULL) {
    ciEnv::current()->record_failure("CodeCache is full");
    return 0;  // CodeBuffer::expand failed
  }
  int offset = __ offset();
  __ far_jump(RuntimeAddress(OptoRuntime::exception_blob()->entry_point()));
  assert(__ offset() - offset <= (int) size_exception_handler(), "overflow");
  __ end_a_stub();
  return offset;
}

// Emit deopt handler code.
int HandlerImpl::emit_deopt_handler(CodeBuffer& cbuf)
{
  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  C2_MacroAssembler _masm(&cbuf);
  address base = __ start_a_stub(size_deopt_handler());
  if (base == NULL) {
    ciEnv::current()->record_failure("CodeCache is full");
    return 0;  // CodeBuffer::expand failed
  }
  int offset = __ offset();

  __ adr(lr, __ pc());
  __ far_jump(RuntimeAddress(SharedRuntime::deopt_blob()->unpack()));

  assert(__ offset() - offset == (int) size_deopt_handler(), "overflow");
  __ end_a_stub();
  return offset;
}

// REQUIRED MATCHER CODE

//=============================================================================

const bool Matcher::match_rule_supported(int opcode) {
  if (!has_match_rule(opcode))
    return false;

  bool ret_value = true;
  switch (opcode) {
    case Op_OnSpinWait:
      return VM_Version::supports_on_spin_wait();
    case Op_CacheWB:
    case Op_CacheWBPreSync:
    case Op_CacheWBPostSync:
      if (!VM_Version::supports_data_cache_line_flush()) {
        ret_value = false;
      }
      break;
    case Op_ExpandBits:
    case Op_CompressBits:
      if (!(UseSVE > 1 && VM_Version::supports_svebitperm())) {
        ret_value = false;
      }
      break;
  }

  return ret_value; // Per default match rules are supported.
}

const RegMask* Matcher::predicate_reg_mask(void) {
  return &_PR_REG_mask;
}

const TypeVectMask* Matcher::predicate_reg_type(const Type* elemTy, int length) {
  return new TypeVectMask(elemTy, length);
}

// Vector calling convention not yet implemented.
const bool Matcher::supports_vector_calling_convention(void) {
  return false;
}

OptoRegPair Matcher::vector_return_value(uint ideal_reg) {
  Unimplemented();
  return OptoRegPair(0, 0);
}

// Is this branch offset short enough that a short branch can be used?
//
// NOTE: If the platform does not provide any short branch variants, then
//       this method should return false for offset 0.
bool Matcher::is_short_branch_offset(int rule, int br_size, int offset) {
  // The passed offset is relative to address of the branch.

  return (-32768 <= offset && offset < 32768);
}

// Vector width in bytes.
const int Matcher::vector_width_in_bytes(BasicType bt) {
  // The MaxVectorSize should have been set by detecting SVE max vector register size.
  int size = MIN2((UseSVE > 0) ? 256 : 16, (int)MaxVectorSize);
  // Minimum 2 values in vector
  if (size < 2*type2aelembytes(bt)) size = 0;
  // But never < 4
  if (size < 4) size = 0;
  return size;
}

// Limits on vector size (number of elements) loaded into vector.
const int Matcher::max_vector_size(const BasicType bt) {
  return vector_width_in_bytes(bt)/type2aelembytes(bt);
}

const int Matcher::min_vector_size(const BasicType bt) {
  int max_size = max_vector_size(bt);
  // Limit the min vector size to 8 bytes.
  int size = 8 / type2aelembytes(bt);
  if (bt == T_BYTE) {
    // To support vector api shuffle/rearrange.
    size = 4;
  } else if (bt == T_BOOLEAN) {
    // To support vector api load/store mask.
    size = 2;
  }
  if (size < 2) size = 2;
  return MIN2(size, max_size);
}

const int Matcher::superword_max_vector_size(const BasicType bt) {
  return Matcher::max_vector_size(bt);
}

// Actual max scalable vector register length.
const int Matcher::scalable_vector_reg_size(const BasicType bt) {
  return Matcher::max_vector_size(bt);
}

// Vector ideal reg.
const uint Matcher::vector_ideal_reg(int len) {
  if (UseSVE > 0 && 16 < len && len <= 256) {
    return Op_VecA;
  }
  switch(len) {
    // For 16-bit/32-bit mask vector, reuse VecD.
    case  2:
    case  4:
    case  8: return Op_VecD;
    case 16: return Op_VecX;
  }
  ShouldNotReachHere();
  return 0;
}

MachOper* Matcher::pd_specialize_generic_vector_operand(MachOper* generic_opnd, uint ideal_reg, bool is_temp) {
  assert(Matcher::is_generic_vector(generic_opnd), "not generic");
  switch (ideal_reg) {
    case Op_VecA: return new vecAOper();
    case Op_VecD: return new vecDOper();
    case Op_VecX: return new vecXOper();
  }
  ShouldNotReachHere();
  return NULL;
}

bool Matcher::is_reg2reg_move(MachNode* m) {
  return false;
}

bool Matcher::is_generic_vector(MachOper* opnd)  {
  return opnd->opcode() == VREG;
}

// Return whether or not this register is ever used as an argument.
// This function is used on startup to build the trampoline stubs in
// generateOptoStub.  Registers not mentioned will be killed by the VM
// call in the trampoline, and arguments in those registers not be
// available to the callee.
bool Matcher::can_be_java_arg(int reg)
{
  return
    reg ==  R0_num || reg == R0_H_num ||
    reg ==  R1_num || reg == R1_H_num ||
    reg ==  R2_num || reg == R2_H_num ||
    reg ==  R3_num || reg == R3_H_num ||
    reg ==  R4_num || reg == R4_H_num ||
    reg ==  R5_num || reg == R5_H_num ||
    reg ==  R6_num || reg == R6_H_num ||
    reg ==  R7_num || reg == R7_H_num ||
    reg ==  V0_num || reg == V0_H_num ||
    reg ==  V1_num || reg == V1_H_num ||
    reg ==  V2_num || reg == V2_H_num ||
    reg ==  V3_num || reg == V3_H_num ||
    reg ==  V4_num || reg == V4_H_num ||
    reg ==  V5_num || reg == V5_H_num ||
    reg ==  V6_num || reg == V6_H_num ||
    reg ==  V7_num || reg == V7_H_num;
}

bool Matcher::is_spillable_arg(int reg)
{
  return can_be_java_arg(reg);
}

uint Matcher::int_pressure_limit()
{
  // JDK-8183543: When taking the number of available registers as int
  // register pressure threshold, the jtreg test:
  // test/hotspot/jtreg/compiler/regalloc/TestC2IntPressure.java
  // failed due to C2 compilation failure with
  // "COMPILE SKIPPED: failed spill-split-recycle sanity check".
  //
  // A derived pointer is live at CallNode and then is flagged by RA
  // as a spilled LRG. Spilling heuristics(Spill-USE) explicitly skip
  // derived pointers and lastly fail to spill after reaching maximum
  // number of iterations. Lowering the default pressure threshold to
  // (_NO_SPECIAL_REG32_mask.Size() minus 1) forces CallNode to become
  // a high register pressure area of the code so that split_DEF can
  // generate DefinitionSpillCopy for the derived pointer.
  uint default_int_pressure_threshold = _NO_SPECIAL_REG32_mask.Size() - 1;
  if (!PreserveFramePointer) {
    // When PreserveFramePointer is off, frame pointer is allocatable,
    // but different from other SOC registers, it is excluded from
    // fatproj's mask because its save type is No-Save. Decrease 1 to
    // ensure high pressure at fatproj when PreserveFramePointer is off.
    // See check_pressure_at_fatproj().
    default_int_pressure_threshold--;
  }
  return (INTPRESSURE == -1) ? default_int_pressure_threshold : INTPRESSURE;
}

uint Matcher::float_pressure_limit()
{
  // _FLOAT_REG_mask is generated by adlc from the float_reg register class.
  return (FLOATPRESSURE == -1) ? _FLOAT_REG_mask.Size() : FLOATPRESSURE;
}

bool Matcher::use_asm_for_ldiv_by_con(jlong divisor) {
  return false;
}

RegMask Matcher::divI_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for MODI projection of divmodI.
RegMask Matcher::modI_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for DIVL projection of divmodL.
RegMask Matcher::divL_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for MODL projection of divmodL.
RegMask Matcher::modL_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

const RegMask Matcher::method_handle_invoke_SP_save_mask() {
  return FP_REG_mask();
}

bool size_fits_all_mem_uses(AddPNode* addp, int shift) {
  for (DUIterator_Fast imax, i = addp->fast_outs(imax); i < imax; i++) {
    Node* u = addp->fast_out(i);
    if (u->is_LoadStore()) {
      // On AArch64, LoadStoreNodes (i.e. compare and swap
      // instructions) only take register indirect as an operand, so
      // any attempt to use an AddPNode as an input to a LoadStoreNode
      // must fail.
      return false;
    }
    if (u->is_Mem()) {
      int opsize = u->as_Mem()->memory_size();
      assert(opsize > 0, "unexpected memory operand size");
      if (u->as_Mem()->memory_size() != (1<<shift)) {
        return false;
      }
    }
  }
  return true;
}

// Convert BootTest condition to Assembler condition.
// Replicate the logic of cmpOpOper::ccode() and cmpOpUOper::ccode().
Assembler::Condition to_assembler_cond(BoolTest::mask cond) {
  Assembler::Condition result;
  switch(cond) {
    case BoolTest::eq:
      result = Assembler::EQ; break;
    case BoolTest::ne:
      result = Assembler::NE; break;
    case BoolTest::le:
      result = Assembler::LE; break;
    case BoolTest::ge:
      result = Assembler::GE; break;
    case BoolTest::lt:
      result = Assembler::LT; break;
    case BoolTest::gt:
      result = Assembler::GT; break;
    case BoolTest::ule:
      result = Assembler::LS; break;
    case BoolTest::uge:
      result = Assembler::HS; break;
    case BoolTest::ult:
      result = Assembler::LO; break;
    case BoolTest::ugt:
      result = Assembler::HI; break;
    case BoolTest::overflow:
      result = Assembler::VS; break;
    case BoolTest::no_overflow:
      result = Assembler::VC; break;
    default:
      ShouldNotReachHere();
      return Assembler::Condition(-1);
  }

  // Check conversion
  if (cond & BoolTest::unsigned_compare) {
    assert(cmpOpUOper((BoolTest::mask)((int)cond & ~(BoolTest::unsigned_compare))).ccode() == result, "Invalid conversion");
  } else {
    assert(cmpOpOper(cond).ccode() == result, "Invalid conversion");
  }

  return result;
}

// Binary src (Replicate con)
bool is_valid_sve_arith_imm_pattern(Node* n, Node* m) {
  if (n == NULL || m == NULL) {
    return false;
  }

  if (UseSVE == 0 || !VectorNode::is_invariant_vector(m)) {
    return false;
  }

  Node* imm_node = m->in(1);
  if (!imm_node->is_Con()) {
    return false;
  }

  const Type* t = imm_node->bottom_type();
  if (!(t->isa_int() || t->isa_long())) {
    return false;
  }

  switch (n->Opcode()) {
  case Op_AndV:
  case Op_OrV:
  case Op_XorV: {
    Assembler::SIMD_RegVariant T = Assembler::elemType_to_regVariant(Matcher::vector_element_basic_type(n));
    uint64_t value = t->isa_long() ? (uint64_t)imm_node->get_long() : (uint64_t)imm_node->get_int();
    return Assembler::operand_valid_for_sve_logical_immediate(Assembler::regVariant_to_elemBits(T), value);
  }
  case Op_AddVB:
    return (imm_node->get_int() <= 255 && imm_node->get_int() >= -255);
  case Op_AddVS:
  case Op_AddVI:
    return Assembler::operand_valid_for_sve_add_sub_immediate((int64_t)imm_node->get_int());
  case Op_AddVL:
    return Assembler::operand_valid_for_sve_add_sub_immediate(imm_node->get_long());
  default:
    return false;
  }
}

// (XorV src (Replicate m1))
// (XorVMask src (MaskAll m1))
bool is_vector_bitwise_not_pattern(Node* n, Node* m) {
  if (n != NULL && m != NULL) {
    return (n->Opcode() == Op_XorV || n->Opcode() == Op_XorVMask) &&
           VectorNode::is_all_ones_vector(m);
  }
  return false;
}

// Should the matcher clone input 'm' of node 'n'?
bool Matcher::pd_clone_node(Node* n, Node* m, Matcher::MStack& mstack) {
  if (is_vshift_con_pattern(n, m) ||
      is_vector_bitwise_not_pattern(n, m) ||
      is_valid_sve_arith_imm_pattern(n, m)) {
    mstack.push(m, Visit);
    return true;
  }
  return false;
}

// Should the Matcher clone shifts on addressing modes, expecting them
// to be subsumed into complex addressing expressions or compute them
// into registers?
bool Matcher::pd_clone_address_expressions(AddPNode* m, Matcher::MStack& mstack, VectorSet& address_visited) {
  if (clone_base_plus_offset_address(m, mstack, address_visited)) {
    return true;
  }

  Node *off = m->in(AddPNode::Offset);
  if (off->Opcode() == Op_LShiftL && off->in(2)->is_Con() &&
      size_fits_all_mem_uses(m, off->in(2)->get_int()) &&
      // Are there other uses besides address expressions?
      !is_visited(off)) {
    address_visited.set(off->_idx); // Flag as address_visited
    mstack.push(off->in(2), Visit);
    Node *conv = off->in(1);
    if (conv->Opcode() == Op_ConvI2L &&
        // Are there other uses besides address expressions?
        !is_visited(conv)) {
      address_visited.set(conv->_idx); // Flag as address_visited
      mstack.push(conv->in(1), Pre_Visit);
    } else {
      mstack.push(conv, Pre_Visit);
    }
    address_visited.test_set(m->_idx); // Flag as address_visited
    mstack.push(m->in(AddPNode::Address), Pre_Visit);
    mstack.push(m->in(AddPNode::Base), Pre_Visit);
    return true;
  } else if (off->Opcode() == Op_ConvI2L &&
             // Are there other uses besides address expressions?
             !is_visited(off)) {
    address_visited.test_set(m->_idx); // Flag as address_visited
    address_visited.set(off->_idx); // Flag as address_visited
    mstack.push(off->in(1), Pre_Visit);
    mstack.push(m->in(AddPNode::Address), Pre_Visit);
    mstack.push(m->in(AddPNode::Base), Pre_Visit);
    return true;
  }
  return false;
}

#define MOV_VOLATILE(REG, BASE, INDEX, SCALE, DISP, SCRATCH, INSN)      \
  C2_MacroAssembler _masm(&cbuf);                                       \
  {                                                                     \
    guarantee(INDEX == -1, "mode not permitted for volatile");          \
    guarantee(DISP == 0, "mode not permitted for volatile");            \
    guarantee(SCALE == 0, "mode not permitted for volatile");           \
    __ INSN(REG, as_Register(BASE));                                    \
  }


static Address mem2address(int opcode, Register base, int index, int size, int disp)
  {
    Address::extend scale;

    // Hooboy, this is fugly.  We need a way to communicate to the
    // encoder that the index needs to be sign extended, so we have to
    // enumerate all the cases.
    switch (opcode) {
    case INDINDEXSCALEDI2L:
    case INDINDEXSCALEDI2LN:
    case INDINDEXI2L:
    case INDINDEXI2LN:
      scale = Address::sxtw(size);
      break;
    default:
      scale = Address::lsl(size);
    }

    if (index == -1) {
      return Address(base, disp);
    } else {
      assert(disp == 0, "unsupported address mode: disp = %d", disp);
      return Address(base, as_Register(index), scale);
    }
  }


typedef void (MacroAssembler::* mem_insn)(Register Rt, const Address &adr);
typedef void (MacroAssembler::* mem_insn2)(Register Rt, Register adr);
typedef void (MacroAssembler::* mem_float_insn)(FloatRegister Rt, const Address &adr);
typedef void (MacroAssembler::* mem_vector_insn)(FloatRegister Rt,
                                  MacroAssembler::SIMD_RegVariant T, const Address &adr);

  // Used for all non-volatile memory accesses.  The use of
  // $mem->opcode() to discover whether this pattern uses sign-extended
  // offsets is something of a kludge.
  static void loadStore(C2_MacroAssembler masm, mem_insn insn,
                        Register reg, int opcode,
                        Register base, int index, int scale, int disp,
                        int size_in_memory)
  {
    Address addr = mem2address(opcode, base, index, scale, disp);
    if (addr.getMode() == Address::base_plus_offset) {
      /* If we get an out-of-range offset it is a bug in the compiler,
         so we assert here. */
      assert(Address::offset_ok_for_immed(addr.offset(), exact_log2(size_in_memory)),
             "c2 compiler bug");
      /* Fix up any out-of-range offsets. */
      assert_different_registers(rscratch1, base);
      assert_different_registers(rscratch1, reg);
      addr = masm.legitimize_address(addr, size_in_memory, rscratch1);
    }
    (masm.*insn)(reg, addr);
  }

  static void loadStore(C2_MacroAssembler masm, mem_float_insn insn,
                        FloatRegister reg, int opcode,
                        Register base, int index, int size, int disp,
                        int size_in_memory)
  {
    Address::extend scale;

    switch (opcode) {
    case INDINDEXSCALEDI2L:
    case INDINDEXSCALEDI2LN:
      scale = Address::sxtw(size);
      break;
    default:
      scale = Address::lsl(size);
    }

    if (index == -1) {
      /* If we get an out-of-range offset it is a bug in the compiler,
         so we assert here. */
      assert(Address::offset_ok_for_immed(disp, exact_log2(size_in_memory)), "c2 compiler bug");
      /* Fix up any out-of-range offsets. */
      assert_different_registers(rscratch1, base);
      Address addr = Address(base, disp);
      addr = masm.legitimize_address(addr, size_in_memory, rscratch1);
      (masm.*insn)(reg, addr);
    } else {
      assert(disp == 0, "unsupported address mode: disp = %d", disp);
      (masm.*insn)(reg, Address(base, as_Register(index), scale));
    }
  }

  static void loadStore(C2_MacroAssembler masm, mem_vector_insn insn,
                        FloatRegister reg, MacroAssembler::SIMD_RegVariant T,
                        int opcode, Register base, int index, int size, int disp)
  {
    if (index == -1) {
      (masm.*insn)(reg, T, Address(base, disp));
    } else {
      assert(disp == 0, "unsupported address mode");
      (masm.*insn)(reg, T, Address(base, as_Register(index), Address::lsl(size)));
    }
  }


#line 1657 "ad_aarch64.cpp"


//SourceForm

#line 90 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"


  typedef void (C2_MacroAssembler::* sve_mem_insn_predicate)(FloatRegister Rt, Assembler::SIMD_RegVariant T,
                                                             PRegister Pg, const Address &adr);

  // Predicated load/store, with optional ptrue to all elements of given predicate register.
  static void loadStoreA_predicated(C2_MacroAssembler masm, bool is_store, FloatRegister reg,
                                    PRegister pg, BasicType mem_elem_bt, BasicType vector_elem_bt,
                                    int opcode, Register base, int index, int size, int disp) {
    sve_mem_insn_predicate insn;
    int mesize = type2aelembytes(mem_elem_bt);
    if (index == -1) {
      assert(size == 0, "unsupported address mode: scale size = %d", size);
      switch(mesize) {
      case 1:
        insn = is_store ? &C2_MacroAssembler::sve_st1b : &C2_MacroAssembler::sve_ld1b;
        break;
      case 2:
        insn = is_store ? &C2_MacroAssembler::sve_st1h : &C2_MacroAssembler::sve_ld1h;
        break;
      case 4:
        insn = is_store ? &C2_MacroAssembler::sve_st1w : &C2_MacroAssembler::sve_ld1w;
        break;
      case 8:
        insn = is_store ? &C2_MacroAssembler::sve_st1d : &C2_MacroAssembler::sve_ld1d;
        break;
      default:
        assert(false, "unsupported");
        ShouldNotReachHere();
      }
      int imm4 = disp / mesize / Matcher::scalable_vector_reg_size(vector_elem_bt);
      (masm.*insn)(reg, Assembler::elemType_to_regVariant(vector_elem_bt), pg, Address(base, imm4));
    } else {
      assert(false, "unimplemented");
      ShouldNotReachHere();
    }
  }

  const bool Matcher::match_rule_supported_superword(int opcode, int vlen, BasicType bt) {
    if (UseSVE == 0) {
      // These operations are not profitable to be vectorized on NEON, because no direct
      // NEON instructions support them. But the match rule support for them is profitable for
      // Vector API intrinsics.
      if ((opcode == Op_VectorCastD2X && bt == T_INT) ||
          (opcode == Op_VectorCastL2X && bt == T_FLOAT) ||
          (opcode == Op_CountLeadingZerosV && bt == T_LONG) ||
          (opcode == Op_CountTrailingZerosV && bt == T_LONG) ||
          // The vector implementation of Op_AddReductionVD/F is for the Vector API only.
          // It is not suitable for auto-vectorization because it does not add the elements
          // in the same order as sequential code, and FP addition is non-associative.
          opcode == Op_AddReductionVD || opcode == Op_AddReductionVF ||
          opcode == Op_MulReductionVD || opcode == Op_MulReductionVF ||
          opcode == Op_MulVL) {
        return false;
      }
    }
    return match_rule_supported_vector(opcode, vlen, bt);
  }

  // Identify extra cases that we might want to provide match rules for vector nodes and
  // other intrinsics guarded with vector length (vlen) and element type (bt).
  const bool Matcher::match_rule_supported_vector(int opcode, int vlen, BasicType bt) {
    if (!match_rule_supported(opcode)) {
      return false;
    }

    int length_in_bytes = vlen * type2aelembytes(bt);
    if (UseSVE == 0 && length_in_bytes > 16) {
      return false;
    }

    // Check whether specific Op is supported.
    // Fail fast, otherwise fall through to common vector_size_supported() check.
    switch (opcode) {
      case Op_AndVMask:
      case Op_OrVMask:
      case Op_XorVMask:
      case Op_MaskAll:
      case Op_VectorMaskGen:
      case Op_LoadVectorMasked:
      case Op_StoreVectorMasked:
      case Op_LoadVectorGather:
      case Op_StoreVectorScatter:
      case Op_LoadVectorGatherMasked:
      case Op_StoreVectorScatterMasked:
      case Op_PopulateIndex:
      case Op_CompressM:
      case Op_CompressV:
        if (UseSVE == 0) {
          return false;
        }
        break;
      case Op_MulAddVS2VI:
        if (length_in_bytes != 16) {
          return false;
        }
        break;
      case Op_MulReductionVD:
      case Op_MulReductionVF:
      case Op_MulReductionVI:
      case Op_MulReductionVL:
        // No vector multiply reduction instructions, but we do
        // emit scalar instructions for 64/128-bit vectors.
        if (length_in_bytes != 8 && length_in_bytes != 16) {
          return false;
        }
        break;
      case Op_VectorMaskCmp:
        if (length_in_bytes < 8) {
          return false;
        }
        break;
      case Op_VectorLoadShuffle:
      case Op_VectorRearrange:
        if (vlen < 4) {
          return false;
        }
        break;
      case Op_ExpandV:
        if (UseSVE < 2 || is_subword_type(bt)) {
          return false;
        }
        break;
      case Op_VectorMaskToLong:
        if (UseSVE > 0 && vlen > 64) {
          return false;
        }
        break;
      case Op_VectorLongToMask:
        if (UseSVE < 2 || vlen > 64 || !VM_Version::supports_svebitperm()) {
          return false;
        }
        break;
      case Op_CompressBitsV:
      case Op_ExpandBitsV:
        if (UseSVE < 2 || !VM_Version::supports_svebitperm()) {
          return false;
        }
        break;
      default:
        break;
    }
    return vector_size_supported(bt, vlen);
  }

  const bool Matcher::match_rule_supported_vector_masked(int opcode, int vlen, BasicType bt) {
    // Only SVE supports masked operations.
    if (UseSVE == 0) {
      return false;
    }

    // If an opcode does not support the masked version,
    // unpredicated node with VectorBlend node will be used instead.
    switch(opcode) {
      case Op_VectorRearrange:
      case Op_MulReductionVD:
      case Op_MulReductionVF:
      case Op_MulReductionVI:
      case Op_MulReductionVL:
      case Op_CompressBitsV:
      case Op_ExpandBitsV:
        return false;
      // We use Op_LoadVectorMasked to implement the predicated Op_LoadVector.
      // Hence we turn to check whether Op_LoadVectorMasked is supported. The
      // same as vector store/gather/scatter.
      case Op_LoadVector:
        opcode = Op_LoadVectorMasked;
        break;
      case Op_StoreVector:
        opcode = Op_StoreVectorMasked;
        break;
      case Op_LoadVectorGather:
        opcode = Op_LoadVectorGatherMasked;
        break;
      case Op_StoreVectorScatter:
        opcode = Op_StoreVectorScatterMasked;
        break;
      default:
        break;
    }

    return match_rule_supported_vector(opcode, vlen, bt);
  }

  const bool Matcher::vector_needs_partial_operations(Node* node, const TypeVect* vt) {
    // Only SVE has partial vector operations
    if (UseSVE == 0) {
      return false;
    }

    switch(node->Opcode()) {
      case Op_VectorLoadMask:
      case Op_VectorMaskCmp:
      case Op_LoadVectorGather:
      case Op_StoreVectorScatter:
      case Op_AddReductionVF:
      case Op_AddReductionVD:
      case Op_AndReductionV:
      case Op_OrReductionV:
      case Op_XorReductionV:
      // Mask is needed for partial Op_VectorMaskFirstTrue, because when the
      // input predicate is all-false, the result should be the vector length
      // instead of the vector register size.
      case Op_VectorMaskFirstTrue:
        return true;
      case Op_MaskAll:
        return !node->in(1)->is_Con();
      case Op_LoadVector:
      case Op_StoreVector:
        // We use NEON load/store instructions if the vector length is <= 128 bits.
        return vt->length_in_bytes() > 16;
      case Op_AddReductionVI:
      case Op_AddReductionVL:
        // We may prefer using NEON instructions rather than SVE partial operations.
        return !VM_Version::use_neon_for_vector(vt->length_in_bytes());
      case Op_MinReductionV:
      case Op_MaxReductionV:
        // For BYTE/SHORT/INT/FLOAT/DOUBLE types, we may prefer using NEON
        // instructions rather than SVE partial operations.
        return vt->element_basic_type() == T_LONG ||
               !VM_Version::use_neon_for_vector(vt->length_in_bytes());
      default:
        // For other ops whose vector size is smaller than the max vector size, a
        // full-sized unpredicated operation does not impact the final vector result.
        return false;
    }
  }

  // Assert that the given node is not a variable shift.
  bool assert_not_var_shift(const Node* n) {
    assert(!n->as_ShiftV()->is_var_shift(), "illegal variable shift");
    return true;
  }

  Assembler::SIMD_Arrangement get_arrangement(const Node* n) {
    BasicType bt = Matcher::vector_element_basic_type(n);
    uint length_in_bytes = Matcher::vector_length_in_bytes(n);
    return Assembler::esize2arrangement((uint)type2aelembytes(bt),
                                        /* isQ */ length_in_bytes == 16);
  }

#line 1904 "ad_aarch64.cpp"


//SourceForm

#line 32 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"


static void x_load_barrier(MacroAssembler& _masm, const MachNode* node, Address ref_addr, Register ref, Register tmp, uint8_t barrier_data) {
  if (barrier_data == XLoadBarrierElided) {
    return;
  }
  XLoadBarrierStubC2* const stub = XLoadBarrierStubC2::create(node, ref_addr, ref, tmp, barrier_data);
  __ ldr(tmp, Address(rthread, XThreadLocalData::address_bad_mask_offset()));
  __ andr(tmp, tmp, ref);
  __ cbnz(tmp, *stub->entry());
  __ bind(*stub->continuation());
}

static void x_load_barrier_slow_path(MacroAssembler& _masm, const MachNode* node, Address ref_addr, Register ref, Register tmp) {
  XLoadBarrierStubC2* const stub = XLoadBarrierStubC2::create(node, ref_addr, ref, tmp, XLoadBarrierStrong);
  __ b(*stub->entry());
  __ bind(*stub->continuation());
}


#line 1930 "ad_aarch64.cpp"


//SourceForm

#line 32 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"


#include "gc/z/zBarrierSetAssembler.hpp"

static void z_color(MacroAssembler& _masm, const MachNode* node, Register dst, Register src) {
  assert_different_registers(src, dst);
  __ relocate(barrier_Relocation::spec(), ZBarrierRelocationFormatStoreGoodBeforeMov);
  __ movzw(dst, barrier_Relocation::unpatched);
  __ orr(dst, dst, src, Assembler::LSL, ZPointerLoadShift);
}

static void z_uncolor(MacroAssembler& _masm, const MachNode* node, Register ref) {
  __ lsr(ref, ref, ZPointerLoadShift);
}

static void z_keep_alive_load_barrier(MacroAssembler& _masm, const MachNode* node, Address ref_addr, Register ref, Register tmp) {
  __ relocate(barrier_Relocation::spec(), ZBarrierRelocationFormatMarkBadBeforeMov);
  __ movzw(tmp, barrier_Relocation::unpatched);
  __ tst(ref, tmp);
  ZLoadBarrierStubC2Aarch64* const stub = ZLoadBarrierStubC2Aarch64::create(node, ref_addr, ref);
  __ br(Assembler::NE, *stub->entry());
  z_uncolor(_masm, node, ref);
  __ bind(*stub->continuation());
}

static void z_load_barrier(MacroAssembler& _masm, const MachNode* node, Address ref_addr, Register ref, Register tmp) {
  Assembler::InlineSkippedInstructionsCounter skipped_counter(&_masm);
  const bool on_non_strong =
      ((node->barrier_data() & ZBarrierWeak) != 0) ||
      ((node->barrier_data() & ZBarrierPhantom) != 0);

  if (on_non_strong) {
    z_keep_alive_load_barrier(_masm, node, ref_addr, ref, tmp);
    return;
  }

  if (node->barrier_data() == ZBarrierElided) {
    z_uncolor(_masm, node, ref);
    return;
  }

  ZLoadBarrierStubC2Aarch64* const stub = ZLoadBarrierStubC2Aarch64::create(node, ref_addr, ref, __ offset());
  if (stub->is_test_and_branch_reachable()) {
    __ relocate(barrier_Relocation::spec(), ZBarrierRelocationFormatLoadGoodBeforeTbX);
    __ tbnz(ref, barrier_Relocation::unpatched, *stub->entry());
  } else {
    Label good;
    __ relocate(barrier_Relocation::spec(), ZBarrierRelocationFormatLoadGoodBeforeTbX);
    __ tbz(ref, barrier_Relocation::unpatched, good);
    __ b(*stub->entry());
    __ bind(good);
  }
  z_uncolor(_masm, node, ref);
  __ bind(*stub->continuation());
}

static void z_store_barrier(MacroAssembler& _masm, const MachNode* node, Address ref_addr, Register rnew_zaddress, Register rnew_zpointer, Register tmp, bool is_atomic) {
  Assembler::InlineSkippedInstructionsCounter skipped_counter(&_masm);
  if (node->barrier_data() == ZBarrierElided) {
    z_color(_masm, node, rnew_zpointer, rnew_zaddress);
  } else {
    bool is_native = (node->barrier_data() & ZBarrierNative) != 0;
    ZStoreBarrierStubC2Aarch64* const stub = ZStoreBarrierStubC2Aarch64::create(node, ref_addr, rnew_zaddress, rnew_zpointer, is_native, is_atomic);
    ZBarrierSetAssembler* bs_asm = ZBarrierSet::assembler();
    bs_asm->store_barrier_fast(&_masm, ref_addr, rnew_zaddress, rnew_zpointer, tmp, true /* in_nmethod */, is_atomic, *stub->entry(), *stub->continuation());
  }
}


#line 2005 "ad_aarch64.cpp"


#ifndef PRODUCT
void Compile::adlc_verification() {

  // Following assertions generated from definition section
  assert( INSN_COST == 100, "Expect (100) to equal 100");
  assert( BRANCH_COST == 200, "Expect (2 * INSN_COST) to equal 200");
  assert( CALL_COST == 200, "Expect (2 * INSN_COST) to equal 200");
  assert( VOLATILE_REF_COST == 1000, "Expect (10 * INSN_COST) to equal 1000");
}
#endif

// Map from machine-independent register number to register_save_policy
const        char register_save_policy[] = {
  'C', // R10
  'C', // R10_H
  'C', // R11
  'C', // R11_H
  'C', // R12
  'C', // R12_H
  'C', // R13
  'C', // R13_H
  'C', // R14
  'C', // R14_H
  'C', // R15
  'C', // R15_H
  'C', // R16
  'C', // R16_H
  'C', // R17
  'C', // R17_H
  'C', // R18
  'C', // R18_H
  'C', // R0
  'C', // R0_H
  'C', // R1
  'C', // R1_H
  'C', // R2
  'C', // R2_H
  'C', // R3
  'C', // R3_H
  'C', // R4
  'C', // R4_H
  'C', // R5
  'C', // R5_H
  'C', // R6
  'C', // R6_H
  'C', // R7
  'C', // R7_H
  'C', // R19
  'C', // R19_H
  'C', // R20
  'C', // R20_H
  'C', // R21
  'C', // R21_H
  'C', // R22
  'C', // R22_H
  'C', // R23
  'C', // R23_H
  'C', // R24
  'C', // R24_H
  'C', // R25
  'C', // R25_H
  'C', // R26
  'C', // R26_H
  'C', // R27
  'C', // R27_H
  'N', // R28
  'N', // R28_H
  'N', // R29
  'N', // R29_H
  'N', // R30
  'N', // R30_H
  'N', // R31
  'N', // R31_H
  'N', // R8
  'N', // R8_H
  'N', // R9
  'N', // R9_H
  'C', // V16
  'C', // V16_H
  'C', // V16_J
  'C', // V16_K
  'C', // V17
  'C', // V17_H
  'C', // V17_J
  'C', // V17_K
  'C', // V18
  'C', // V18_H
  'C', // V18_J
  'C', // V18_K
  'C', // V19
  'C', // V19_H
  'C', // V19_J
  'C', // V19_K
  'C', // V20
  'C', // V20_H
  'C', // V20_J
  'C', // V20_K
  'C', // V21
  'C', // V21_H
  'C', // V21_J
  'C', // V21_K
  'C', // V22
  'C', // V22_H
  'C', // V22_J
  'C', // V22_K
  'C', // V23
  'C', // V23_H
  'C', // V23_J
  'C', // V23_K
  'C', // V24
  'C', // V24_H
  'C', // V24_J
  'C', // V24_K
  'C', // V25
  'C', // V25_H
  'C', // V25_J
  'C', // V25_K
  'C', // V26
  'C', // V26_H
  'C', // V26_J
  'C', // V26_K
  'C', // V27
  'C', // V27_H
  'C', // V27_J
  'C', // V27_K
  'C', // V28
  'C', // V28_H
  'C', // V28_J
  'C', // V28_K
  'C', // V29
  'C', // V29_H
  'C', // V29_J
  'C', // V29_K
  'C', // V30
  'C', // V30_H
  'C', // V30_J
  'C', // V30_K
  'C', // V31
  'C', // V31_H
  'C', // V31_J
  'C', // V31_K
  'C', // V0
  'C', // V0_H
  'C', // V0_J
  'C', // V0_K
  'C', // V1
  'C', // V1_H
  'C', // V1_J
  'C', // V1_K
  'C', // V2
  'C', // V2_H
  'C', // V2_J
  'C', // V2_K
  'C', // V3
  'C', // V3_H
  'C', // V3_J
  'C', // V3_K
  'C', // V4
  'C', // V4_H
  'C', // V4_J
  'C', // V4_K
  'C', // V5
  'C', // V5_H
  'C', // V5_J
  'C', // V5_K
  'C', // V6
  'C', // V6_H
  'C', // V6_J
  'C', // V6_K
  'C', // V7
  'C', // V7_H
  'C', // V7_J
  'C', // V7_K
  'C', // V8
  'C', // V8_H
  'C', // V8_J
  'C', // V8_K
  'C', // V9
  'C', // V9_H
  'C', // V9_J
  'C', // V9_K
  'C', // V10
  'C', // V10_H
  'C', // V10_J
  'C', // V10_K
  'C', // V11
  'C', // V11_H
  'C', // V11_J
  'C', // V11_K
  'C', // V12
  'C', // V12_H
  'C', // V12_J
  'C', // V12_K
  'C', // V13
  'C', // V13_H
  'C', // V13_J
  'C', // V13_K
  'C', // V14
  'C', // V14_H
  'C', // V14_J
  'C', // V14_K
  'C', // V15
  'C', // V15_H
  'C', // V15_J
  'C', // V15_K
  'C', // P0
  'C', // P1
  'C', // P2
  'C', // P3
  'C', // P4
  'C', // P5
  'C', // P6
  'C', // P8
  'C', // P9
  'C', // P10
  'C', // P11
  'C', // P12
  'C', // P13
  'C', // P14
  'C', // P15
  'C', // P7
  'C' // no trailing comma // RFLAGS
};

// Map from machine-independent register number to c_reg_save_policy
const        char c_reg_save_policy[] = {
  'C', // R10
  'C', // R10_H
  'C', // R11
  'C', // R11_H
  'C', // R12
  'C', // R12_H
  'C', // R13
  'C', // R13_H
  'C', // R14
  'C', // R14_H
  'C', // R15
  'C', // R15_H
  'C', // R16
  'C', // R16_H
  'C', // R17
  'C', // R17_H
  'C', // R18
  'C', // R18_H
  'C', // R0
  'C', // R0_H
  'C', // R1
  'C', // R1_H
  'C', // R2
  'C', // R2_H
  'C', // R3
  'C', // R3_H
  'C', // R4
  'C', // R4_H
  'C', // R5
  'C', // R5_H
  'C', // R6
  'C', // R6_H
  'C', // R7
  'C', // R7_H
  'E', // R19
  'E', // R19_H
  'E', // R20
  'E', // R20_H
  'E', // R21
  'E', // R21_H
  'E', // R22
  'E', // R22_H
  'E', // R23
  'E', // R23_H
  'E', // R24
  'E', // R24_H
  'E', // R25
  'E', // R25_H
  'E', // R26
  'E', // R26_H
  'E', // R27
  'E', // R27_H
  'E', // R28
  'E', // R28_H
  'N', // R29
  'N', // R29_H
  'N', // R30
  'N', // R30_H
  'N', // R31
  'N', // R31_H
  'C', // R8
  'C', // R8_H
  'C', // R9
  'C', // R9_H
  'C', // V16
  'C', // V16_H
  'C', // V16_J
  'C', // V16_K
  'C', // V17
  'C', // V17_H
  'C', // V17_J
  'C', // V17_K
  'C', // V18
  'C', // V18_H
  'C', // V18_J
  'C', // V18_K
  'C', // V19
  'C', // V19_H
  'C', // V19_J
  'C', // V19_K
  'C', // V20
  'C', // V20_H
  'C', // V20_J
  'C', // V20_K
  'C', // V21
  'C', // V21_H
  'C', // V21_J
  'C', // V21_K
  'C', // V22
  'C', // V22_H
  'C', // V22_J
  'C', // V22_K
  'C', // V23
  'C', // V23_H
  'C', // V23_J
  'C', // V23_K
  'C', // V24
  'C', // V24_H
  'C', // V24_J
  'C', // V24_K
  'C', // V25
  'C', // V25_H
  'C', // V25_J
  'C', // V25_K
  'C', // V26
  'C', // V26_H
  'C', // V26_J
  'C', // V26_K
  'C', // V27
  'C', // V27_H
  'C', // V27_J
  'C', // V27_K
  'C', // V28
  'C', // V28_H
  'C', // V28_J
  'C', // V28_K
  'C', // V29
  'C', // V29_H
  'C', // V29_J
  'C', // V29_K
  'C', // V30
  'C', // V30_H
  'C', // V30_J
  'C', // V30_K
  'C', // V31
  'C', // V31_H
  'C', // V31_J
  'C', // V31_K
  'C', // V0
  'C', // V0_H
  'C', // V0_J
  'C', // V0_K
  'C', // V1
  'C', // V1_H
  'C', // V1_J
  'C', // V1_K
  'C', // V2
  'C', // V2_H
  'C', // V2_J
  'C', // V2_K
  'C', // V3
  'C', // V3_H
  'C', // V3_J
  'C', // V3_K
  'C', // V4
  'C', // V4_H
  'C', // V4_J
  'C', // V4_K
  'C', // V5
  'C', // V5_H
  'C', // V5_J
  'C', // V5_K
  'C', // V6
  'C', // V6_H
  'C', // V6_J
  'C', // V6_K
  'C', // V7
  'C', // V7_H
  'C', // V7_J
  'C', // V7_K
  'E', // V8
  'E', // V8_H
  'C', // V8_J
  'C', // V8_K
  'E', // V9
  'E', // V9_H
  'C', // V9_J
  'C', // V9_K
  'E', // V10
  'E', // V10_H
  'C', // V10_J
  'C', // V10_K
  'E', // V11
  'E', // V11_H
  'C', // V11_J
  'C', // V11_K
  'E', // V12
  'E', // V12_H
  'C', // V12_J
  'C', // V12_K
  'E', // V13
  'E', // V13_H
  'C', // V13_J
  'C', // V13_K
  'E', // V14
  'E', // V14_H
  'C', // V14_J
  'C', // V14_K
  'E', // V15
  'E', // V15_H
  'C', // V15_J
  'C', // V15_K
  'C', // P0
  'C', // P1
  'C', // P2
  'C', // P3
  'C', // P4
  'C', // P5
  'C', // P6
  'C', // P8
  'C', // P9
  'C', // P10
  'C', // P11
  'C', // P12
  'C', // P13
  'C', // P14
  'C', // P15
  'C', // P7
  'C' // no trailing comma // RFLAGS
};

// Map from machine-independent register number to register_save_type
const        int register_save_type[] = {
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  0 // no trailing comma
};


const        int   reduceOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  immI_rule,
  /*    9 */  immI0_rule,
  /*   10 */  immI_1_rule,
  /*   11 */  immI_M1_rule,
  /*   12 */  immIExt_rule,
  /*   13 */  immI_gt_1_rule,
  /*   14 */  immI_le_4_rule,
  /*   15 */  immI_16_rule,
  /*   16 */  immI_24_rule,
  /*   17 */  immI_32_rule,
  /*   18 */  immI_48_rule,
  /*   19 */  immI_56_rule,
  /*   20 */  immI_63_rule,
  /*   21 */  immI_64_rule,
  /*   22 */  immI_255_rule,
  /*   23 */  immI_65535_rule,
  /*   24 */  immI_positive_rule,
  /*   25 */  immI_cmp_cond_rule,
  /*   26 */  immI_cmpU_cond_rule,
  /*   27 */  immL_255_rule,
  /*   28 */  immL_65535_rule,
  /*   29 */  immL_4294967295_rule,
  /*   30 */  immL_bitmask_rule,
  /*   31 */  immI_bitmask_rule,
  /*   32 */  immL_positive_bitmaskI_rule,
  /*   33 */  immIScale_rule,
  /*   34 */  immI26_rule,
  /*   35 */  immI19_rule,
  /*   36 */  immI5_rule,
  /*   37 */  immIU7_rule,
  /*   38 */  immIU12_rule,
  /*   39 */  immLU12_rule,
  /*   40 */  immIOffset_rule,
  /*   41 */  immIOffset1_rule,
  /*   42 */  immIOffset2_rule,
  /*   43 */  immIOffset4_rule,
  /*   44 */  immIOffset8_rule,
  /*   45 */  immIOffset16_rule,
  /*   46 */  immLoffset_rule,
  /*   47 */  immLoffset1_rule,
  /*   48 */  immLoffset2_rule,
  /*   49 */  immLoffset4_rule,
  /*   50 */  immLoffset8_rule,
  /*   51 */  immLoffset16_rule,
  /*   52 */  immL5_rule,
  /*   53 */  immLU7_rule,
  /*   54 */  immI8_rule,
  /*   55 */  immI8_shift8_rule,
  /*   56 */  immL8_shift8_rule,
  /*   57 */  immBAddSubV_rule,
  /*   58 */  immIAddSub_rule,
  /*   59 */  immIAddSubV_rule,
  /*   60 */  immBLog_rule,
  /*   61 */  immSLog_rule,
  /*   62 */  immILog_rule,
  /*   63 */  immL_rule,
  /*   64 */  immL0_rule,
  /*   65 */  immL_1_rule,
  /*   66 */  immL_M1_rule,
  /*   67 */  immL_pc_off_rule,
  /*   68 */  immLAddSub_rule,
  /*   69 */  immLAddSubV_rule,
  /*   70 */  immLLog_rule,
  /*   71 */  immL_32bits_rule,
  /*   72 */  immP_rule,
  /*   73 */  immP0_rule,
  /*   74 */  immP_1_rule,
  /*   75 */  immByteMapBase_rule,
  /*   76 */  immP_M1_rule,
  /*   77 */  immP_M2_rule,
  /*   78 */  immD_rule,
  /*   79 */  immD0_rule,
  /*   80 */  immDPacked_rule,
  /*   81 */  immF_rule,
  /*   82 */  immF0_rule,
  /*   83 */  immFPacked_rule,
  /*   84 */  immN_rule,
  /*   85 */  immN0_rule,
  /*   86 */  immNKlass_rule,
  /*   87 */  iRegI_rule,
  /*   88 */  iRegINoSp_rule,
  /*   89 */  iRegL_rule,
  /*   90 */  iRegLNoSp_rule,
  /*   91 */  iRegP_rule,
  /*   92 */  iRegPNoSp_rule,
  /*   93 */  iRegPNoSpNoRfp_rule,
  /*   94 */  iRegP_R0_rule,
  /*   95 */  iRegP_R1_rule,
  /*   96 */  iRegP_R2_rule,
  /*   97 */  iRegP_R3_rule,
  /*   98 */  iRegP_R4_rule,
  /*   99 */  iRegP_R5_rule,
  /*  100 */  iRegP_R10_rule,
  /*  101 */  iRegL_R0_rule,
  /*  102 */  iRegL_R2_rule,
  /*  103 */  iRegL_R3_rule,
  /*  104 */  iRegL_R11_rule,
  /*  105 */  iRegP_FP_rule,
  /*  106 */  iRegI_R0_rule,
  /*  107 */  iRegI_R2_rule,
  /*  108 */  iRegI_R3_rule,
  /*  109 */  iRegI_R4_rule,
  /*  110 */  iRegN_rule,
  /*  111 */  iRegN_R0_rule,
  /*  112 */  iRegN_R2_rule,
  /*  113 */  iRegN_R3_rule,
  /*  114 */  iRegNNoSp_rule,
  /*  115 */  vRegF_rule,
  /*  116 */  vRegD_rule,
  /*  117 */  vReg_rule,
  /*  118 */  vecA_rule,
  /*  119 */  vecD_rule,
  /*  120 */  vecX_rule,
  /*  121 */  vRegD_V0_rule,
  /*  122 */  vRegD_V1_rule,
  /*  123 */  vRegD_V2_rule,
  /*  124 */  vRegD_V3_rule,
  /*  125 */  vRegD_V4_rule,
  /*  126 */  vRegD_V5_rule,
  /*  127 */  vRegD_V6_rule,
  /*  128 */  vRegD_V7_rule,
  /*  129 */  vRegD_V8_rule,
  /*  130 */  vRegD_V9_rule,
  /*  131 */  vRegD_V10_rule,
  /*  132 */  vRegD_V11_rule,
  /*  133 */  vRegD_V12_rule,
  /*  134 */  vRegD_V13_rule,
  /*  135 */  vRegD_V14_rule,
  /*  136 */  vRegD_V15_rule,
  /*  137 */  vRegD_V16_rule,
  /*  138 */  vRegD_V17_rule,
  /*  139 */  vRegD_V18_rule,
  /*  140 */  vRegD_V19_rule,
  /*  141 */  vRegD_V20_rule,
  /*  142 */  vRegD_V21_rule,
  /*  143 */  vRegD_V22_rule,
  /*  144 */  vRegD_V23_rule,
  /*  145 */  vRegD_V24_rule,
  /*  146 */  vRegD_V25_rule,
  /*  147 */  vRegD_V26_rule,
  /*  148 */  vRegD_V27_rule,
  /*  149 */  vRegD_V28_rule,
  /*  150 */  vRegD_V29_rule,
  /*  151 */  vRegD_V30_rule,
  /*  152 */  vRegD_V31_rule,
  /*  153 */  pReg_rule,
  /*  154 */  pRegGov_rule,
  /*  155 */  pRegGov_P0_rule,
  /*  156 */  pRegGov_P1_rule,
  /*  157 */  rFlagsReg_rule,
  /*  158 */  rFlagsRegU_rule,
  /*  159 */  inline_cache_RegP_rule,
  /*  160 */  thread_RegP_rule,
  /*  161 */  lr_RegP_rule,
  /*  162 */  indirect_rule,
  /*  163 */  indIndexScaledI2L_rule,
  /*  164 */  indIndexScaled_rule,
  /*  165 */  indIndexI2L_rule,
  /*  166 */  indIndex_rule,
  /*  167 */  indOffI_rule,
  /*  168 */  indOffI1_rule,
  /*  169 */  indOffI2_rule,
  /*  170 */  indOffI4_rule,
  /*  171 */  indOffI8_rule,
  /*  172 */  indOffI16_rule,
  /*  173 */  indOffL_rule,
  /*  174 */  indOffL1_rule,
  /*  175 */  indOffL2_rule,
  /*  176 */  indOffL4_rule,
  /*  177 */  indOffL8_rule,
  /*  178 */  indOffL16_rule,
  /*  179 */  indirectN_rule,
  /*  180 */  indIndexScaledI2LN_rule,
  /*  181 */  indIndexScaledN_rule,
  /*  182 */  indIndexI2LN_rule,
  /*  183 */  indIndexN_rule,
  /*  184 */  indOffIN_rule,
  /*  185 */  indOffLN_rule,
  /*  186 */  thread_anchor_pc_rule,
  /*  187 */  stackSlotP_rule,
  /*  188 */  stackSlotI_rule,
  /*  189 */  stackSlotF_rule,
  /*  190 */  stackSlotD_rule,
  /*  191 */  stackSlotL_rule,
  /*  192 */  cmpOp_rule,
  /*  193 */  cmpOpU_rule,
  /*  194 */  cmpOpEqNe_rule,
  /*  195 */  cmpOpLtGe_rule,
  /*  196 */  cmpOpUEqNeLtGe_rule,
  /*  197 */  iRegL2I_rule,
  /*  198 */  vmemA_immIOffset4_rule,
  /*  199 */  vmemA_immLOffset4_rule,
  /*  200 */  vmemA_indOffI4_rule,
  /*  201 */  vmemA_indOffL4_rule,
  // last operand
  /*  202 */  vmem2_rule,
  /*  203 */  vmem4_rule,
  /*  204 */  vmem8_rule,
  /*  205 */  vmem16_rule,
  /*  206 */  memory1_rule,
  /*  207 */  memory2_rule,
  /*  208 */  memory4_rule,
  /*  209 */  memory8_rule,
  /*  210 */  memory_rule,
  /*  211 */  iRegIorL2I_rule,
  /*  212 */  vmemA_rule,
  // last operand class
  /*  213 */  _ConvI2L_iRegI__rule,
  /*  214 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  215 */  _LShiftL_iRegL_immIScale_rule,
  /*  216 */  _DecodeN_iRegN__rule,
  /*  217 */  _LoadB_memory1__rule,
  /*  218 */  _LoadUB_memory1__rule,
  /*  219 */  _LoadS_memory2__rule,
  /*  220 */  _LoadUS_memory2__rule,
  /*  221 */  _LoadI_memory4__rule,
  /*  222 */  _ConvI2L__LoadI_memory4___rule,
  /*  223 */  _LoadB_indirect__rule,
  /*  224 */  _LoadUB_indirect__rule,
  /*  225 */  _LoadUS_indirect__rule,
  /*  226 */  _LoadS_indirect__rule,
  /*  227 */  _LoadI_indirect__rule,
  /*  228 */  _ConvI2L__LoadI_indirect___rule,
  /*  229 */  _LoadL_memory8__rule,
  /*  230 */  _CastP2X_iRegP__rule,
  /*  231 */  _CastP2X__DecodeN_iRegN___rule,
  /*  232 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  233 */  _Binary_iRegLNoSp_iRegLNoSp_rule,
  /*  234 */  _Binary_iRegP_iRegP_rule,
  /*  235 */  _Binary_iRegNNoSp_iRegNNoSp_rule,
  /*  236 */  _Binary_iRegI_iRegI_rule,
  /*  237 */  _Binary_iRegL_iRegL_rule,
  /*  238 */  _Binary_iRegN_iRegN_rule,
  /*  239 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  240 */  _Binary_iRegIorL2I_iRegIorL2I_rule,
  /*  241 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  242 */  _Binary_immI0_iRegIorL2I_rule,
  /*  243 */  _Binary_iRegIorL2I_immI0_rule,
  /*  244 */  _Binary_immI_1_immI0_rule,
  /*  245 */  _Binary_iRegL_immL0_rule,
  /*  246 */  _Binary_immL0_iRegL_rule,
  /*  247 */  _Binary_iRegP_immP0_rule,
  /*  248 */  _Binary_immP0_iRegP_rule,
  /*  249 */  _Binary_iRegN_immN0_rule,
  /*  250 */  _Binary_immN0_iRegN_rule,
  /*  251 */  _Binary_vRegF_vRegF_rule,
  /*  252 */  _Binary_vRegD_vRegD_rule,
  /*  253 */  _ConvL2I_iRegL__rule,
  /*  254 */  _ConvI2L_iRegIorL2I__rule,
  /*  255 */  _LShiftL__ConvI2L_iRegIorL2I__immIScale_rule,
  /*  256 */  _MulI_iRegIorL2I_iRegIorL2I_rule,
  /*  257 */  _SubI_immI0_iRegIorL2I_rule,
  /*  258 */  _MulL_iRegL_iRegL_rule,
  /*  259 */  _SubL_immL0_iRegL_rule,
  /*  260 */  _MulL__ConvI2L_iRegIorL2I___ConvI2L_iRegIorL2I__rule,
  /*  261 */  _SubL_immL0__ConvI2L_iRegIorL2I__rule,
  /*  262 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  263 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  264 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  265 */  _URShiftL_iRegL_immI_rule,
  /*  266 */  _RShiftL_iRegL_immI_rule,
  /*  267 */  _LShiftL_iRegL_immI_rule,
  /*  268 */  _XorI_iRegIorL2I_immI_M1_rule,
  /*  269 */  _XorL_iRegL_immL_M1_rule,
  /*  270 */  _XorI_iRegIorL2I_iRegIorL2I_rule,
  /*  271 */  _XorL_iRegL_iRegL_rule,
  /*  272 */  _XorI__URShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  273 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  274 */  _XorI__RShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  275 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  276 */  _RotateRight_iRegIorL2I_immI_rule,
  /*  277 */  _XorI__RotateRight_iRegIorL2I_immI_immI_M1_rule,
  /*  278 */  _RotateRight_iRegL_immI_rule,
  /*  279 */  _XorL__RotateRight_iRegL_immI_immL_M1_rule,
  /*  280 */  _XorI__LShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  281 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  282 */  _XorI__URShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  283 */  _XorI_iRegIorL2I__URShiftI_iRegIorL2I_immI_rule,
  /*  284 */  _XorL__URShiftL_iRegL_immI_iRegL_rule,
  /*  285 */  _XorL_iRegL__URShiftL_iRegL_immI_rule,
  /*  286 */  _XorI__RShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  287 */  _XorI_iRegIorL2I__RShiftI_iRegIorL2I_immI_rule,
  /*  288 */  _XorL__RShiftL_iRegL_immI_iRegL_rule,
  /*  289 */  _XorL_iRegL__RShiftL_iRegL_immI_rule,
  /*  290 */  _XorI__RotateRight_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  291 */  _XorI_iRegIorL2I__RotateRight_iRegIorL2I_immI_rule,
  /*  292 */  _XorL__RotateRight_iRegL_immI_iRegL_rule,
  /*  293 */  _XorL_iRegL__RotateRight_iRegL_immI_rule,
  /*  294 */  _XorI__LShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  295 */  _XorI_iRegIorL2I__LShiftI_iRegIorL2I_immI_rule,
  /*  296 */  _XorL__LShiftL_iRegL_immI_iRegL_rule,
  /*  297 */  _XorL_iRegL__LShiftL_iRegL_immI_rule,
  /*  298 */  _AndI__URShiftI_iRegIorL2I_immI_immI_bitmask_rule,
  /*  299 */  _AndI_iRegIorL2I_immI_bitmask_rule,
  /*  300 */  _AndL_iRegL_immL_bitmask_rule,
  /*  301 */  _LShiftI__AndI_iRegIorL2I_immI_bitmask_immI_rule,
  /*  302 */  _AndL_iRegL_immL_positive_bitmaskI_rule,
  /*  303 */  _LShiftL__AndL_iRegL_immL_positive_bitmaskI_immI_rule,
  /*  304 */  _ConvI2L__AndI_iRegIorL2I_immI_bitmask__rule,
  /*  305 */  _ConvL2I__AndL_iRegL_immL_positive_bitmaskI__rule,
  /*  306 */  _AndI_iRegI_immI_bitmask_rule,
  /*  307 */  _LShiftI_iRegIorL2I_immI_16_rule,
  /*  308 */  _RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_rule,
  /*  309 */  _LShiftI_iRegIorL2I_immI_24_rule,
  /*  310 */  _RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /*  311 */  _URShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /*  312 */  _LShiftL_iRegL_immI_48_rule,
  /*  313 */  _RShiftL__LShiftL_iRegL_immI_48_immI_48_rule,
  /*  314 */  _LShiftL_iRegL_immI_32_rule,
  /*  315 */  _RShiftL__LShiftL_iRegL_immI_32_immI_32_rule,
  /*  316 */  _LShiftL_iRegL_immI_56_rule,
  /*  317 */  _RShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  318 */  _URShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  319 */  _AndI_iRegIorL2I_immI_255_rule,
  /*  320 */  _AndI_iRegIorL2I_immI_65535_rule,
  /*  321 */  _AndL_iRegL_immL_255_rule,
  /*  322 */  _AndL_iRegL_immL_65535_rule,
  /*  323 */  _AndL_iRegL_immL_4294967295_rule,
  /*  324 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_56_immI_56_immIExt_rule,
  /*  325 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_48_immI_48_immIExt_rule,
  /*  326 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_32_immI_32_immIExt_rule,
  /*  327 */  _LShiftI__RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_immIExt_rule,
  /*  328 */  _LShiftI__RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_immIExt_rule,
  /*  329 */  _LShiftL__ConvI2L_iRegIorL2I__immIExt_rule,
  /*  330 */  _LShiftL__AndL_iRegL_immL_255_immIExt_rule,
  /*  331 */  _LShiftL__AndL_iRegL_immL_65535_immIExt_rule,
  /*  332 */  _LShiftL__AndL_iRegL_immL_4294967295_immIExt_rule,
  /*  333 */  _LShiftI__AndI_iRegIorL2I_immI_255_immIExt_rule,
  /*  334 */  _LShiftI__AndI_iRegIorL2I_immI_65535_immIExt_rule,
  /*  335 */  _NegF_vRegF__rule,
  /*  336 */  _Binary__NegF_vRegF__vRegF_rule,
  /*  337 */  _Binary_vRegF__NegF_vRegF__rule,
  /*  338 */  _NegD_vRegD__rule,
  /*  339 */  _Binary__NegD_vRegD__vRegD_rule,
  /*  340 */  _Binary_vRegD__NegD_vRegD__rule,
  /*  341 */  _SubF_vRegF_vRegF_rule,
  /*  342 */  _SubD_vRegD_vRegD_rule,
  /*  343 */  _OverflowMulI_iRegIorL2I_iRegIorL2I_rule,
  /*  344 */  _OverflowMulL_iRegL_iRegL_rule,
  /*  345 */  _CmpI_iRegIorL2I_immI0_rule,
  /*  346 */  _CmpL_iRegL_immL0_rule,
  /*  347 */  _CmpP_iRegP_immP0_rule,
  /*  348 */  _CmpN_iRegN_immN0_rule,
  /*  349 */  _CmpP__DecodeN_iRegN__immP0_rule,
  /*  350 */  _CmpU_iRegIorL2I_immI0_rule,
  /*  351 */  _CmpUL_iRegL_immL0_rule,
  /*  352 */  _AndL_iRegL_immL_rule,
  /*  353 */  _CmpL__AndL_iRegL_immL_immL0_rule,
  /*  354 */  _AndI_iRegIorL2I_immI_rule,
  /*  355 */  _CmpI__AndI_iRegIorL2I_immI_immI0_rule,
  /*  356 */  _AndL_iRegL_iRegL_rule,
  /*  357 */  _AndI_iRegIorL2I_iRegIorL2I_rule,
  /*  358 */  _PartialSubtypeCheck_iRegP_R4_iRegP_R0_rule,
  /*  359 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /*  360 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /*  361 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /*  362 */  _Binary_iRegP_R3_iRegI_R2_rule,
  /*  363 */  _Binary_iRegP_R3_immI_le_4_rule,
  /*  364 */  _Binary_iRegP_R3_immI_1_rule,
  /*  365 */  _Binary_iRegP_R1_iRegP_R3_rule,
  /*  366 */  _Binary_iRegP_R1_iRegI_R3_rule,
  /*  367 */  _Binary_vReg_pRegGov_rule,
  /*  368 */  _Binary_vReg_vReg_rule,
  /*  369 */  _ReplicateB_immBAddSubV__rule,
  /*  370 */  _ReplicateS_immIAddSubV__rule,
  /*  371 */  _ReplicateI_immIAddSubV__rule,
  /*  372 */  _ReplicateL_immLAddSubV__rule,
  /*  373 */  _ReplicateB_immBLog__rule,
  /*  374 */  _ReplicateS_immSLog__rule,
  /*  375 */  _ReplicateI_immILog__rule,
  /*  376 */  _ReplicateL_immLLog__rule,
  /*  377 */  _XorV_vReg_vReg_rule,
  /*  378 */  _ReplicateB_immI_M1__rule,
  /*  379 */  _ReplicateS_immI_M1__rule,
  /*  380 */  _ReplicateI_immI_M1__rule,
  /*  381 */  _ReplicateL_immL_M1__rule,
  /*  382 */  _Binary_vReg__ReplicateB_immI_M1__rule,
  /*  383 */  _Binary_vReg__ReplicateS_immI_M1__rule,
  /*  384 */  _Binary_vReg__ReplicateI_immI_M1__rule,
  /*  385 */  _Binary_vReg__ReplicateL_immL_M1__rule,
  /*  386 */  _XorV_vReg__ReplicateB_immI_M1__rule,
  /*  387 */  _XorV__ReplicateB_immI_M1__vReg_rule,
  /*  388 */  _XorV_vReg__ReplicateS_immI_M1__rule,
  /*  389 */  _XorV__ReplicateS_immI_M1__vReg_rule,
  /*  390 */  _XorV_vReg__ReplicateI_immI_M1__rule,
  /*  391 */  _XorV__ReplicateI_immI_M1__vReg_rule,
  /*  392 */  _XorV_vReg__ReplicateL_immL_M1__rule,
  /*  393 */  _XorV__ReplicateL_immL_M1__vReg_rule,
  /*  394 */  _Binary_vReg__XorV_vReg__ReplicateB_immI_M1__rule,
  /*  395 */  _Binary_vReg__XorV__ReplicateB_immI_M1__vReg_rule,
  /*  396 */  _Binary_vReg__XorV_vReg__ReplicateS_immI_M1__rule,
  /*  397 */  _Binary_vReg__XorV__ReplicateS_immI_M1__vReg_rule,
  /*  398 */  _Binary_vReg__XorV_vReg__ReplicateI_immI_M1__rule,
  /*  399 */  _Binary_vReg__XorV__ReplicateI_immI_M1__vReg_rule,
  /*  400 */  _Binary_vReg__XorV_vReg__ReplicateL_immL_M1__rule,
  /*  401 */  _Binary_vReg__XorV__ReplicateL_immL_M1__vReg_rule,
  /*  402 */  _SubVF_vReg_vReg_rule,
  /*  403 */  _SubVD_vReg_vReg_rule,
  /*  404 */  _SubVF__Binary_vReg_vReg_pRegGov_rule,
  /*  405 */  _SubVD__Binary_vReg_vReg_pRegGov_rule,
  /*  406 */  _MulVB_vReg_vReg_rule,
  /*  407 */  _MulVS_vReg_vReg_rule,
  /*  408 */  _MulVI_vReg_vReg_rule,
  /*  409 */  _MulVL_vReg_vReg_rule,
  /*  410 */  _Binary_vReg__MulVB_vReg_vReg_rule,
  /*  411 */  _Binary_vReg__MulVS_vReg_vReg_rule,
  /*  412 */  _Binary_vReg__MulVI_vReg_vReg_rule,
  /*  413 */  _Binary_vReg__MulVL_vReg_vReg_rule,
  /*  414 */  _NegVF_vReg__rule,
  /*  415 */  _Binary__NegVF_vReg__vReg_rule,
  /*  416 */  _NegVD_vReg__rule,
  /*  417 */  _Binary__NegVD_vReg__vReg_rule,
  /*  418 */  _Binary_vReg__NegVF_vReg__rule,
  /*  419 */  _Binary_vReg__NegVD_vReg__rule,
  /*  420 */  _Binary__NegVF_vReg__pRegGov_rule,
  /*  421 */  _Binary__NegVD_vReg__pRegGov_rule,
  /*  422 */  _LShiftCntV_immI__rule,
  /*  423 */  _RShiftCntV_immI_positive__rule,
  /*  424 */  _RShiftVB_vReg__RShiftCntV_immI_positive__rule,
  /*  425 */  _RShiftVS_vReg__RShiftCntV_immI_positive__rule,
  /*  426 */  _RShiftVI_vReg__RShiftCntV_immI_positive__rule,
  /*  427 */  _RShiftVL_vReg__RShiftCntV_immI_positive__rule,
  /*  428 */  _URShiftVB_vReg__RShiftCntV_immI_positive__rule,
  /*  429 */  _URShiftVS_vReg__RShiftCntV_immI_positive__rule,
  /*  430 */  _URShiftVI_vReg__RShiftCntV_immI_positive__rule,
  /*  431 */  _URShiftVL_vReg__RShiftCntV_immI_positive__rule,
  /*  432 */  _Binary_vReg__LShiftCntV_immI__rule,
  /*  433 */  _Binary_vReg__RShiftCntV_immI_positive__rule,
  /*  434 */  _Binary_iRegIorL2I_vReg_rule,
  /*  435 */  _Binary_iRegL_vReg_rule,
  /*  436 */  _Binary_vRegF_vReg_rule,
  /*  437 */  _Binary_vRegD_vReg_rule,
  /*  438 */  _Binary_vReg_iRegIorL2I_rule,
  /*  439 */  _Binary_vReg_iRegL_rule,
  /*  440 */  _Binary_vReg_vRegF_rule,
  /*  441 */  _Binary_vReg_vRegD_rule,
  /*  442 */  _LoadVector_indirect__rule,
  /*  443 */  _LoadVectorMasked_vmemA_pRegGov_rule,
  /*  444 */  _VectorStoreMask_pReg_immI_gt_1_rule,
  /*  445 */  _Binary__VectorStoreMask_pReg_immI_gt_1_pRegGov_rule,
  /*  446 */  _MaskAll_immI_M1__rule,
  /*  447 */  _XorVMask_pReg__MaskAll_immI_M1__rule,
  /*  448 */  _MaskAll_immL_M1__rule,
  /*  449 */  _XorVMask_pReg__MaskAll_immL_M1__rule,
  /*  450 */  _ReplicateB_immI0__rule,
  /*  451 */  _Binary_vReg__ReplicateB_immI0__rule,
  /*  452 */  _ReplicateS_immI0__rule,
  /*  453 */  _Binary_vReg__ReplicateS_immI0__rule,
  /*  454 */  _ReplicateI_immI0__rule,
  /*  455 */  _Binary_vReg__ReplicateI_immI0__rule,
  /*  456 */  _ReplicateL_immL0__rule,
  /*  457 */  _Binary_vReg__ReplicateL_immL0__rule,
  /*  458 */  _ReplicateF_immF0__rule,
  /*  459 */  _Binary_vReg__ReplicateF_immF0__rule,
  /*  460 */  _ReplicateD_immD0__rule,
  /*  461 */  _Binary_vReg__ReplicateD_immD0__rule,
  /*  462 */  _ReplicateB_immI5__rule,
  /*  463 */  _Binary_vReg__ReplicateB_immI5__rule,
  /*  464 */  _ReplicateB_immIU7__rule,
  /*  465 */  _Binary_vReg__ReplicateB_immIU7__rule,
  /*  466 */  _ReplicateS_immI5__rule,
  /*  467 */  _Binary_vReg__ReplicateS_immI5__rule,
  /*  468 */  _ReplicateS_immIU7__rule,
  /*  469 */  _Binary_vReg__ReplicateS_immIU7__rule,
  /*  470 */  _ReplicateI_immI5__rule,
  /*  471 */  _Binary_vReg__ReplicateI_immI5__rule,
  /*  472 */  _ReplicateI_immIU7__rule,
  /*  473 */  _Binary_vReg__ReplicateI_immIU7__rule,
  /*  474 */  _ReplicateL_immL5__rule,
  /*  475 */  _Binary_vReg__ReplicateL_immL5__rule,
  /*  476 */  _ReplicateL_immLU7__rule,
  /*  477 */  _Binary_vReg__ReplicateL_immLU7__rule,
  /*  478 */  _Binary_immI_pRegGov_rule,
  /*  479 */  _VectorStoreMask_vReg_immI_gt_1_rule,
  /*  480 */  _SubL_iRegL_iRegL_rule,
  /*  481 */  _Binary_vReg__Binary_vReg_pRegGov_rule,
  // last internally defined operand
  /*  482 */  iRegINoSp_rule,
  /*  483 */  iRegLNoSp_rule,
  /*  484 */  iRegPNoSp_rule,
  /*  485 */  iRegPNoSp_rule,
  /*  486 */  iRegPNoSp_rule,
  /*  487 */  iRegPNoSp_rule,
  /*  488 */  iRegNNoSp_rule,
  /*  489 */  iRegNNoSp_rule,
  /*  490 */  iRegNNoSp_rule,
  /*  491 */  vRegF_rule,
  /*  492 */  vRegF_rule,
  /*  493 */  vRegD_rule,
  /*  494 */  vRegD_rule,
  /*  495 */  iRegINoSp_rule,
  /*  496 */  iRegINoSp_rule,
  /*  497 */  iRegINoSp_rule,
  /*  498 */  iRegINoSp_rule,
  /*  499 */  iRegPNoSp_rule,
  /*  500 */  iRegLNoSp_rule,
  /*  501 */  iRegPNoSp_rule,
  /*  502 */  iRegPNoSp_rule,
  /*  503 */  iRegI_rule,
  /*  504 */  iRegL_rule,
  /*  505 */  vRegF_rule,
  /*  506 */  vRegD_rule,
  /*  507 */  vReg_rule,
  /*  508 */  pRegGov_rule,
  /*  509 */  iRegINoSp_rule,
  /*  510 */  iRegLNoSp_rule,
  /*  511 */  vRegF_rule,
  /*  512 */  vRegD_rule,
  /*  513 */  vRegF_rule,
  /*  514 */  vRegD_rule,
  /*  515 */  iRegINoSp_rule,
  /*  516 */  vRegF_rule,
  /*  517 */  iRegLNoSp_rule,
  /*  518 */  vRegD_rule,
  /*  519 */  iRegINoSp_rule,
  /*  520 */  vRegF_rule,
  /*  521 */  iRegLNoSp_rule,
  /*  522 */  vRegD_rule,
  /*  523 */  rFlagsReg_rule,
  /*  524 */  rFlagsReg_rule,
  /*  525 */  rFlagsReg_rule,
  /*  526 */  rFlagsReg_rule,
  /*  527 */  rFlagsReg_rule,
  /*  528 */  rFlagsReg_rule,
  /*  529 */  rFlagsReg_rule,
  /*  530 */  rFlagsReg_rule,
  /*  531 */  rFlagsReg_rule,
  /*  532 */  rFlagsReg_rule,
  /*  533 */  rFlagsReg_rule,
  /*  534 */  rFlagsReg_rule,
  /*  535 */  rFlagsReg_rule,
  /*  536 */  rFlagsReg_rule,
  /*  537 */  rFlagsReg_rule,
  /*  538 */  rFlagsReg_rule,
  /*  539 */  rFlagsRegU_rule,
  /*  540 */  rFlagsRegU_rule,
  /*  541 */  rFlagsRegU_rule,
  /*  542 */  rFlagsRegU_rule,
  /*  543 */  rFlagsReg_rule,
  /*  544 */  rFlagsReg_rule,
  /*  545 */  rFlagsReg_rule,
  /*  546 */  rFlagsReg_rule,
  /*  547 */  rFlagsRegU_rule,
  /*  548 */  rFlagsRegU_rule,
  /*  549 */  rFlagsRegU_rule,
  /*  550 */  rFlagsRegU_rule,
  /*  551 */  rFlagsRegU_rule,
  /*  552 */  rFlagsRegU_rule,
  /*  553 */  rFlagsRegU_rule,
  /*  554 */  rFlagsRegU_rule,
  /*  555 */  rFlagsReg_rule,
  /*  556 */  rFlagsReg_rule,
  /*  557 */  rFlagsReg_rule,
  /*  558 */  rFlagsReg_rule,
  /*  559 */  0,
  /*  560 */  rFlagsReg_rule,
  /*  561 */  rFlagsReg_rule,
  /*  562 */  rFlagsReg_rule,
  /*  563 */  rFlagsReg_rule,
  /*  564 */  rFlagsReg_rule,
  /*  565 */  rFlagsReg_rule,
  /*  566 */  rFlagsReg_rule,
  /*  567 */  thread_RegP_rule,
  /*  568 */  vReg_rule,
  /*  569 */  vReg_rule,
  /*  570 */  vReg_rule,
  /*  571 */  vReg_rule,
  /*  572 */  vReg_rule,
  /*  573 */  vReg_rule,
  /*  574 */  vReg_rule,
  /*  575 */  vReg_rule,
  /*  576 */  vReg_rule,
  /*  577 */  vReg_rule,
  /*  578 */  vReg_rule,
  /*  579 */  vReg_rule,
  /*  580 */  vReg_rule,
  /*  581 */  vReg_rule,
  /*  582 */  vReg_rule,
  /*  583 */  vReg_rule,
  /*  584 */  vReg_rule,
  /*  585 */  vReg_rule,
  /*  586 */  vReg_rule,
  /*  587 */  vReg_rule,
  /*  588 */  vReg_rule,
  /*  589 */  vReg_rule,
  /*  590 */  vReg_rule,
  /*  591 */  vReg_rule,
  /*  592 */  vReg_rule,
  /*  593 */  vReg_rule,
  /*  594 */  vReg_rule,
  /*  595 */  vReg_rule,
  /*  596 */  vReg_rule,
  /*  597 */  vReg_rule,
  /*  598 */  vReg_rule,
  /*  599 */  vReg_rule,
  /*  600 */  vReg_rule,
  /*  601 */  vReg_rule,
  /*  602 */  vReg_rule,
  /*  603 */  vReg_rule,
  /*  604 */  vReg_rule,
  /*  605 */  vReg_rule,
  /*  606 */  vReg_rule,
  /*  607 */  vReg_rule,
  /*  608 */  vReg_rule,
  /*  609 */  vReg_rule,
  /*  610 */  vReg_rule,
  /*  611 */  vReg_rule,
  /*  612 */  vReg_rule,
  /*  613 */  vReg_rule,
  /*  614 */  pReg_rule,
  /*  615 */  pReg_rule,
  /*  616 */  pReg_rule,
  /*  617 */  iRegINoSp_rule,
  /*  618 */  iRegINoSp_rule,
  /*  619 */  iRegINoSp_rule,
  /*  620 */  iRegLNoSp_rule,
  /*  621 */  vReg_rule,
  /*  622 */  vReg_rule,
  /*  623 */  rFlagsReg_rule,
  /*  624 */  rFlagsReg_rule,
  /*  625 */  rFlagsReg_rule,
  /*  626 */  rFlagsReg_rule,
  /*  627 */  vReg_rule,
  /*  628 */  vReg_rule,
  /*  629 */  vReg_rule,
  /*  630 */  vReg_rule,
  /*  631 */  vReg_rule,
  /*  632 */  iRegINoSp_rule,
  /*  633 */  iRegLNoSp_rule,
  /*  634 */  iRegINoSp_rule,
  /*  635 */  iRegLNoSp_rule,
  /*  636 */  iRegINoSp_rule,
  /*  637 */  iRegLNoSp_rule,
  /*  638 */  iRegINoSp_rule,
  /*  639 */  iRegLNoSp_rule,
  /*  640 */  iRegINoSp_rule,
  /*  641 */  iRegLNoSp_rule,
  /*  642 */  iRegLNoSp_rule,
  /*  643 */  iRegLNoSp_rule,
  /*  644 */  iRegINoSp_rule,
  /*  645 */  iRegPNoSp_rule,
  /*  646 */  iRegNNoSp_rule,
  /*  647 */  iRegPNoSp_rule,
  /*  648 */  iRegNNoSp_rule,
  /*  649 */  vRegF_rule,
  /*  650 */  vRegD_rule,
  /*  651 */  Universe_rule,
  /*  652 */  Universe_rule,
  /*  653 */  Universe_rule,
  /*  654 */  Universe_rule,
  /*  655 */  Universe_rule,
  /*  656 */  Universe_rule,
  /*  657 */  Universe_rule,
  /*  658 */  Universe_rule,
  /*  659 */  Universe_rule,
  /*  660 */  Universe_rule,
  /*  661 */  Universe_rule,
  /*  662 */  Universe_rule,
  /*  663 */  Universe_rule,
  /*  664 */  Universe_rule,
  /*  665 */  Universe_rule,
  /*  666 */  Universe_rule,
  /*  667 */  Universe_rule,
  /*  668 */  Universe_rule,
  /*  669 */  iRegINoSp_rule,
  /*  670 */  iRegLNoSp_rule,
  /*  671 */  iRegINoSp_rule,
  /*  672 */  iRegLNoSp_rule,
  /*  673 */  iRegINoSp_rule,
  /*  674 */  iRegINoSp_rule,
  /*  675 */  iRegLNoSp_rule,
  /*  676 */  iRegLNoSp_rule,
  /*  677 */  iRegINoSp_rule,
  /*  678 */  iRegLNoSp_rule,
  /*  679 */  iRegLNoSp_rule,
  /*  680 */  iRegPNoSp_rule,
  /*  681 */  iRegNNoSp_rule,
  /*  682 */  vRegF_rule,
  /*  683 */  vRegD_rule,
  /*  684 */  Universe_rule,
  /*  685 */  Universe_rule,
  /*  686 */  Universe_rule,
  /*  687 */  Universe_rule,
  /*  688 */  Universe_rule,
  /*  689 */  Universe_rule,
  /*  690 */  Universe_rule,
  /*  691 */  Universe_rule,
  /*  692 */  Universe_rule,
  /*  693 */  Universe_rule,
  /*  694 */  Universe_rule,
  /*  695 */  Universe_rule,
  /*  696 */  Universe_rule,
  /*  697 */  Universe_rule,
  /*  698 */  Universe_rule,
  /*  699 */  Universe_rule,
  /*  700 */  Universe_rule,
  /*  701 */  iRegINoSp_rule,
  /*  702 */  iRegLNoSp_rule,
  /*  703 */  iRegINoSp_rule,
  /*  704 */  iRegINoSp_rule,
  /*  705 */  iRegINoSp_rule,
  /*  706 */  iRegINoSp_rule,
  /*  707 */  iRegINoSp_rule,
  /*  708 */  iRegINoSp_rule,
  /*  709 */  Universe_rule,
  /*  710 */  Universe_rule,
  /*  711 */  Universe_rule,
  /*  712 */  Universe_rule,
  /*  713 */  Universe_rule,
  /*  714 */  Universe_rule,
  /*  715 */  Universe_rule,
  /*  716 */  Universe_rule,
  /*  717 */  Universe_rule,
  /*  718 */  Universe_rule,
  /*  719 */  Universe_rule,
  /*  720 */  Universe_rule,
  /*  721 */  iRegINoSp_rule,
  /*  722 */  iRegINoSp_rule,
  /*  723 */  iRegNNoSp_rule,
  /*  724 */  iRegNNoSp_rule,
  /*  725 */  iRegPNoSp_rule,
  /*  726 */  iRegPNoSp_rule,
  /*  727 */  iRegNNoSp_rule,
  /*  728 */  iRegPNoSp_rule,
  /*  729 */  iRegINoSp_rule,
  /*  730 */  iRegINoSp_rule,
  /*  731 */  iRegINoSp_rule,
  /*  732 */  iRegINoSp_rule,
  /*  733 */  iRegINoSp_rule,
  /*  734 */  iRegINoSp_rule,
  /*  735 */  iRegINoSp_rule,
  /*  736 */  iRegINoSp_rule,
  /*  737 */  iRegINoSp_rule,
  /*  738 */  iRegINoSp_rule,
  /*  739 */  iRegINoSp_rule,
  /*  740 */  iRegINoSp_rule,
  /*  741 */  iRegINoSp_rule,
  /*  742 */  iRegINoSp_rule,
  /*  743 */  iRegINoSp_rule,
  /*  744 */  iRegLNoSp_rule,
  /*  745 */  iRegNNoSp_rule,
  /*  746 */  iRegPNoSp_rule,
  /*  747 */  iRegINoSp_rule,
  /*  748 */  iRegINoSp_rule,
  /*  749 */  iRegINoSp_rule,
  /*  750 */  iRegLNoSp_rule,
  /*  751 */  iRegNNoSp_rule,
  /*  752 */  iRegPNoSp_rule,
  /*  753 */  iRegINoSp_rule,
  /*  754 */  iRegINoSp_rule,
  /*  755 */  iRegINoSp_rule,
  /*  756 */  iRegINoSp_rule,
  /*  757 */  iRegINoSp_rule,
  /*  758 */  iRegINoSp_rule,
  /*  759 */  iRegINoSp_rule,
  /*  760 */  iRegINoSp_rule,
  /*  761 */  iRegINoSp_rule,
  /*  762 */  iRegINoSp_rule,
  /*  763 */  iRegINoSp_rule,
  /*  764 */  iRegINoSp_rule,
  /*  765 */  iRegINoSp_rule,
  /*  766 */  iRegLNoSp_rule,
  /*  767 */  iRegINoSp_rule,
  /*  768 */  iRegPNoSp_rule,
  /*  769 */  iRegINoSp_rule,
  /*  770 */  iRegLNoSp_rule,
  /*  771 */  iRegINoSp_rule,
  /*  772 */  iRegPNoSp_rule,
  /*  773 */  iRegLNoSp_rule,
  /*  774 */  Universe_rule,
  /*  775 */  iRegLNoSp_rule,
  /*  776 */  Universe_rule,
  /*  777 */  iRegINoSp_rule,
  /*  778 */  Universe_rule,
  /*  779 */  iRegINoSp_rule,
  /*  780 */  Universe_rule,
  /*  781 */  iRegLNoSp_rule,
  /*  782 */  Universe_rule,
  /*  783 */  iRegLNoSp_rule,
  /*  784 */  Universe_rule,
  /*  785 */  iRegINoSp_rule,
  /*  786 */  Universe_rule,
  /*  787 */  iRegINoSp_rule,
  /*  788 */  Universe_rule,
  /*  789 */  iRegINoSp_rule,
  /*  790 */  iRegINoSp_rule,
  /*  791 */  iRegINoSp_rule,
  /*  792 */  iRegINoSp_rule,
  /*  793 */  iRegINoSp_rule,
  /*  794 */  iRegINoSp_rule,
  /*  795 */  iRegINoSp_rule,
  /*  796 */  iRegINoSp_rule,
  /*  797 */  iRegINoSp_rule,
  /*  798 */  iRegINoSp_rule,
  /*  799 */  iRegINoSp_rule,
  /*  800 */  iRegINoSp_rule,
  /*  801 */  iRegINoSp_rule,
  /*  802 */  iRegINoSp_rule,
  /*  803 */  iRegLNoSp_rule,
  /*  804 */  iRegLNoSp_rule,
  /*  805 */  iRegLNoSp_rule,
  /*  806 */  iRegLNoSp_rule,
  /*  807 */  iRegLNoSp_rule,
  /*  808 */  iRegLNoSp_rule,
  /*  809 */  iRegPNoSp_rule,
  /*  810 */  iRegPNoSp_rule,
  /*  811 */  iRegPNoSp_rule,
  /*  812 */  iRegPNoSp_rule,
  /*  813 */  iRegPNoSp_rule,
  /*  814 */  iRegPNoSp_rule,
  /*  815 */  iRegNNoSp_rule,
  /*  816 */  iRegNNoSp_rule,
  /*  817 */  iRegNNoSp_rule,
  /*  818 */  iRegNNoSp_rule,
  /*  819 */  iRegNNoSp_rule,
  /*  820 */  iRegNNoSp_rule,
  /*  821 */  vRegF_rule,
  /*  822 */  vRegF_rule,
  /*  823 */  vRegD_rule,
  /*  824 */  vRegD_rule,
  /*  825 */  iRegINoSp_rule,
  /*  826 */  iRegINoSp_rule,
  /*  827 */  iRegINoSp_rule,
  /*  828 */  iRegPNoSp_rule,
  /*  829 */  iRegPNoSp_rule,
  /*  830 */  iRegPNoSp_rule,
  /*  831 */  iRegPNoSp_rule,
  /*  832 */  iRegLNoSp_rule,
  /*  833 */  iRegPNoSp_rule,
  /*  834 */  iRegLNoSp_rule,
  /*  835 */  iRegLNoSp_rule,
  /*  836 */  iRegINoSp_rule,
  /*  837 */  iRegINoSp_rule,
  /*  838 */  iRegLNoSp_rule,
  /*  839 */  iRegLNoSp_rule,
  /*  840 */  iRegINoSp_rule,
  /*  841 */  iRegLNoSp_rule,
  /*  842 */  iRegINoSp_rule,
  /*  843 */  iRegLNoSp_rule,
  /*  844 */  iRegLNoSp_rule,
  /*  845 */  iRegLNoSp_rule,
  /*  846 */  iRegLNoSp_rule,
  /*  847 */  iRegLNoSp_rule,
  /*  848 */  iRegINoSp_rule,
  /*  849 */  iRegINoSp_rule,
  /*  850 */  iRegINoSp_rule,
  /*  851 */  iRegINoSp_rule,
  /*  852 */  iRegINoSp_rule,
  /*  853 */  iRegLNoSp_rule,
  /*  854 */  iRegLNoSp_rule,
  /*  855 */  iRegLNoSp_rule,
  /*  856 */  iRegLNoSp_rule,
  /*  857 */  iRegLNoSp_rule,
  /*  858 */  iRegLNoSp_rule,
  /*  859 */  iRegLNoSp_rule,
  /*  860 */  iRegLNoSp_rule,
  /*  861 */  iRegLNoSp_rule,
  /*  862 */  iRegLNoSp_rule,
  /*  863 */  iRegLNoSp_rule,
  /*  864 */  iRegLNoSp_rule,
  /*  865 */  iRegLNoSp_rule,
  /*  866 */  iRegINoSp_rule,
  /*  867 */  iRegINoSp_rule,
  /*  868 */  iRegLNoSp_rule,
  /*  869 */  iRegINoSp_rule,
  /*  870 */  iRegLNoSp_rule,
  /*  871 */  iRegINoSp_rule,
  /*  872 */  iRegLNoSp_rule,
  /*  873 */  iRegINoSp_rule,
  /*  874 */  iRegLNoSp_rule,
  /*  875 */  iRegINoSp_rule,
  /*  876 */  iRegINoSp_rule,
  /*  877 */  iRegINoSp_rule,
  /*  878 */  iRegINoSp_rule,
  /*  879 */  iRegINoSp_rule,
  /*  880 */  iRegINoSp_rule,
  /*  881 */  iRegLNoSp_rule,
  /*  882 */  iRegLNoSp_rule,
  /*  883 */  iRegLNoSp_rule,
  /*  884 */  iRegLNoSp_rule,
  /*  885 */  iRegLNoSp_rule,
  /*  886 */  iRegLNoSp_rule,
  /*  887 */  iRegLNoSp_rule,
  /*  888 */  iRegLNoSp_rule,
  /*  889 */  iRegINoSp_rule,
  /*  890 */  iRegINoSp_rule,
  /*  891 */  iRegINoSp_rule,
  /*  892 */  iRegINoSp_rule,
  /*  893 */  iRegLNoSp_rule,
  /*  894 */  iRegLNoSp_rule,
  /*  895 */  iRegLNoSp_rule,
  /*  896 */  iRegINoSp_rule,
  /*  897 */  iRegINoSp_rule,
  /*  898 */  iRegLNoSp_rule,
  /*  899 */  iRegLNoSp_rule,
  /*  900 */  iRegINoSp_rule,
  /*  901 */  iRegINoSp_rule,
  /*  902 */  iRegLNoSp_rule,
  /*  903 */  iRegLNoSp_rule,
  /*  904 */  iRegINoSp_rule,
  /*  905 */  iRegINoSp_rule,
  /*  906 */  iRegLNoSp_rule,
  /*  907 */  iRegLNoSp_rule,
  /*  908 */  iRegINoSp_rule,
  /*  909 */  iRegINoSp_rule,
  /*  910 */  iRegLNoSp_rule,
  /*  911 */  iRegLNoSp_rule,
  /*  912 */  iRegINoSp_rule,
  /*  913 */  iRegINoSp_rule,
  /*  914 */  iRegLNoSp_rule,
  /*  915 */  iRegLNoSp_rule,
  /*  916 */  iRegINoSp_rule,
  /*  917 */  iRegINoSp_rule,
  /*  918 */  iRegLNoSp_rule,
  /*  919 */  iRegLNoSp_rule,
  /*  920 */  iRegINoSp_rule,
  /*  921 */  iRegINoSp_rule,
  /*  922 */  iRegLNoSp_rule,
  /*  923 */  iRegLNoSp_rule,
  /*  924 */  iRegINoSp_rule,
  /*  925 */  iRegINoSp_rule,
  /*  926 */  iRegINoSp_rule,
  /*  927 */  iRegINoSp_rule,
  /*  928 */  iRegLNoSp_rule,
  /*  929 */  iRegLNoSp_rule,
  /*  930 */  iRegLNoSp_rule,
  /*  931 */  iRegLNoSp_rule,
  /*  932 */  iRegINoSp_rule,
  /*  933 */  iRegINoSp_rule,
  /*  934 */  iRegINoSp_rule,
  /*  935 */  iRegINoSp_rule,
  /*  936 */  iRegLNoSp_rule,
  /*  937 */  iRegLNoSp_rule,
  /*  938 */  iRegLNoSp_rule,
  /*  939 */  iRegLNoSp_rule,
  /*  940 */  iRegINoSp_rule,
  /*  941 */  iRegINoSp_rule,
  /*  942 */  iRegINoSp_rule,
  /*  943 */  iRegINoSp_rule,
  /*  944 */  iRegLNoSp_rule,
  /*  945 */  iRegLNoSp_rule,
  /*  946 */  iRegLNoSp_rule,
  /*  947 */  iRegLNoSp_rule,
  /*  948 */  iRegINoSp_rule,
  /*  949 */  iRegINoSp_rule,
  /*  950 */  iRegINoSp_rule,
  /*  951 */  iRegINoSp_rule,
  /*  952 */  iRegLNoSp_rule,
  /*  953 */  iRegLNoSp_rule,
  /*  954 */  iRegLNoSp_rule,
  /*  955 */  iRegLNoSp_rule,
  /*  956 */  iRegINoSp_rule,
  /*  957 */  iRegINoSp_rule,
  /*  958 */  iRegLNoSp_rule,
  /*  959 */  iRegLNoSp_rule,
  /*  960 */  iRegINoSp_rule,
  /*  961 */  iRegINoSp_rule,
  /*  962 */  iRegLNoSp_rule,
  /*  963 */  iRegLNoSp_rule,
  /*  964 */  iRegINoSp_rule,
  /*  965 */  iRegINoSp_rule,
  /*  966 */  iRegLNoSp_rule,
  /*  967 */  iRegLNoSp_rule,
  /*  968 */  iRegINoSp_rule,
  /*  969 */  iRegINoSp_rule,
  /*  970 */  iRegLNoSp_rule,
  /*  971 */  iRegLNoSp_rule,
  /*  972 */  iRegINoSp_rule,
  /*  973 */  iRegINoSp_rule,
  /*  974 */  iRegLNoSp_rule,
  /*  975 */  iRegLNoSp_rule,
  /*  976 */  iRegINoSp_rule,
  /*  977 */  iRegINoSp_rule,
  /*  978 */  iRegLNoSp_rule,
  /*  979 */  iRegLNoSp_rule,
  /*  980 */  iRegINoSp_rule,
  /*  981 */  iRegINoSp_rule,
  /*  982 */  iRegLNoSp_rule,
  /*  983 */  iRegLNoSp_rule,
  /*  984 */  iRegINoSp_rule,
  /*  985 */  iRegINoSp_rule,
  /*  986 */  iRegLNoSp_rule,
  /*  987 */  iRegLNoSp_rule,
  /*  988 */  iRegINoSp_rule,
  /*  989 */  iRegINoSp_rule,
  /*  990 */  iRegLNoSp_rule,
  /*  991 */  iRegLNoSp_rule,
  /*  992 */  iRegINoSp_rule,
  /*  993 */  iRegINoSp_rule,
  /*  994 */  iRegLNoSp_rule,
  /*  995 */  iRegLNoSp_rule,
  /*  996 */  iRegINoSp_rule,
  /*  997 */  iRegINoSp_rule,
  /*  998 */  iRegLNoSp_rule,
  /*  999 */  iRegLNoSp_rule,
  /* 1000 */  iRegINoSp_rule,
  /* 1001 */  iRegINoSp_rule,
  /* 1002 */  iRegLNoSp_rule,
  /* 1003 */  iRegLNoSp_rule,
  /* 1004 */  iRegINoSp_rule,
  /* 1005 */  iRegINoSp_rule,
  /* 1006 */  iRegLNoSp_rule,
  /* 1007 */  iRegLNoSp_rule,
  /* 1008 */  iRegINoSp_rule,
  /* 1009 */  iRegINoSp_rule,
  /* 1010 */  iRegLNoSp_rule,
  /* 1011 */  iRegLNoSp_rule,
  /* 1012 */  iRegINoSp_rule,
  /* 1013 */  iRegINoSp_rule,
  /* 1014 */  iRegLNoSp_rule,
  /* 1015 */  iRegLNoSp_rule,
  /* 1016 */  iRegINoSp_rule,
  /* 1017 */  iRegINoSp_rule,
  /* 1018 */  iRegLNoSp_rule,
  /* 1019 */  iRegLNoSp_rule,
  /* 1020 */  iRegINoSp_rule,
  /* 1021 */  iRegINoSp_rule,
  /* 1022 */  iRegLNoSp_rule,
  /* 1023 */  iRegLNoSp_rule,
  /* 1024 */  iRegINoSp_rule,
  /* 1025 */  iRegINoSp_rule,
  /* 1026 */  iRegLNoSp_rule,
  /* 1027 */  iRegLNoSp_rule,
  /* 1028 */  iRegINoSp_rule,
  /* 1029 */  iRegINoSp_rule,
  /* 1030 */  iRegLNoSp_rule,
  /* 1031 */  iRegLNoSp_rule,
  /* 1032 */  iRegINoSp_rule,
  /* 1033 */  iRegLNoSp_rule,
  /* 1034 */  iRegINoSp_rule,
  /* 1035 */  iRegLNoSp_rule,
  /* 1036 */  iRegINoSp_rule,
  /* 1037 */  iRegLNoSp_rule,
  /* 1038 */  iRegLNoSp_rule,
  /* 1039 */  iRegINoSp_rule,
  /* 1040 */  iRegLNoSp_rule,
  /* 1041 */  iRegINoSp_rule,
  /* 1042 */  iRegINoSp_rule,
  /* 1043 */  iRegLNoSp_rule,
  /* 1044 */  iRegLNoSp_rule,
  /* 1045 */  iRegINoSp_rule,
  /* 1046 */  iRegLNoSp_rule,
  /* 1047 */  iRegLNoSp_rule,
  /* 1048 */  iRegINoSp_rule,
  /* 1049 */  iRegLNoSp_rule,
  /* 1050 */  iRegINoSp_rule,
  /* 1051 */  iRegLNoSp_rule,
  /* 1052 */  iRegLNoSp_rule,
  /* 1053 */  iRegLNoSp_rule,
  /* 1054 */  iRegINoSp_rule,
  /* 1055 */  iRegINoSp_rule,
  /* 1056 */  iRegLNoSp_rule,
  /* 1057 */  iRegLNoSp_rule,
  /* 1058 */  iRegINoSp_rule,
  /* 1059 */  iRegINoSp_rule,
  /* 1060 */  iRegINoSp_rule,
  /* 1061 */  iRegLNoSp_rule,
  /* 1062 */  iRegINoSp_rule,
  /* 1063 */  iRegLNoSp_rule,
  /* 1064 */  iRegINoSp_rule,
  /* 1065 */  iRegLNoSp_rule,
  /* 1066 */  iRegLNoSp_rule,
  /* 1067 */  iRegLNoSp_rule,
  /* 1068 */  iRegLNoSp_rule,
  /* 1069 */  iRegINoSp_rule,
  /* 1070 */  iRegINoSp_rule,
  /* 1071 */  iRegINoSp_rule,
  /* 1072 */  iRegINoSp_rule,
  /* 1073 */  iRegINoSp_rule,
  /* 1074 */  iRegINoSp_rule,
  /* 1075 */  iRegLNoSp_rule,
  /* 1076 */  iRegLNoSp_rule,
  /* 1077 */  iRegLNoSp_rule,
  /* 1078 */  iRegLNoSp_rule,
  /* 1079 */  iRegLNoSp_rule,
  /* 1080 */  iRegLNoSp_rule,
  /* 1081 */  iRegLNoSp_rule,
  /* 1082 */  iRegLNoSp_rule,
  /* 1083 */  iRegINoSp_rule,
  /* 1084 */  iRegINoSp_rule,
  /* 1085 */  iRegINoSp_rule,
  /* 1086 */  iRegINoSp_rule,
  /* 1087 */  iRegLNoSp_rule,
  /* 1088 */  iRegLNoSp_rule,
  /* 1089 */  iRegLNoSp_rule,
  /* 1090 */  iRegLNoSp_rule,
  /* 1091 */  iRegLNoSp_rule,
  /* 1092 */  iRegLNoSp_rule,
  /* 1093 */  iRegINoSp_rule,
  /* 1094 */  iRegINoSp_rule,
  /* 1095 */  iRegLNoSp_rule,
  /* 1096 */  iRegLNoSp_rule,
  /* 1097 */  iRegLNoSp_rule,
  /* 1098 */  iRegLNoSp_rule,
  /* 1099 */  iRegLNoSp_rule,
  /* 1100 */  iRegLNoSp_rule,
  /* 1101 */  iRegLNoSp_rule,
  /* 1102 */  iRegLNoSp_rule,
  /* 1103 */  iRegLNoSp_rule,
  /* 1104 */  iRegLNoSp_rule,
  /* 1105 */  iRegLNoSp_rule,
  /* 1106 */  iRegLNoSp_rule,
  /* 1107 */  iRegINoSp_rule,
  /* 1108 */  iRegINoSp_rule,
  /* 1109 */  iRegINoSp_rule,
  /* 1110 */  iRegINoSp_rule,
  /* 1111 */  iRegINoSp_rule,
  /* 1112 */  iRegINoSp_rule,
  /* 1113 */  iRegLNoSp_rule,
  /* 1114 */  iRegLNoSp_rule,
  /* 1115 */  iRegLNoSp_rule,
  /* 1116 */  iRegLNoSp_rule,
  /* 1117 */  iRegLNoSp_rule,
  /* 1118 */  iRegLNoSp_rule,
  /* 1119 */  iRegLNoSp_rule,
  /* 1120 */  iRegLNoSp_rule,
  /* 1121 */  iRegLNoSp_rule,
  /* 1122 */  iRegLNoSp_rule,
  /* 1123 */  iRegLNoSp_rule,
  /* 1124 */  iRegLNoSp_rule,
  /* 1125 */  iRegINoSp_rule,
  /* 1126 */  iRegINoSp_rule,
  /* 1127 */  iRegINoSp_rule,
  /* 1128 */  iRegINoSp_rule,
  /* 1129 */  iRegINoSp_rule,
  /* 1130 */  iRegINoSp_rule,
  /* 1131 */  0,
  /* 1132 */  0,
  /* 1133 */  0,
  /* 1134 */  0,
  /* 1135 */  0,
  /* 1136 */  0,
  /* 1137 */  0,
  /* 1138 */  0,
  /* 1139 */  iRegINoSp_rule,
  /* 1140 */  iRegINoSp_rule,
  /* 1141 */  iRegINoSp_rule,
  /* 1142 */  iRegINoSp_rule,
  /* 1143 */  iRegINoSp_rule,
  /* 1144 */  iRegINoSp_rule,
  /* 1145 */  iRegINoSp_rule,
  /* 1146 */  iRegINoSp_rule,
  /* 1147 */  iRegINoSp_rule,
  /* 1148 */  iRegINoSp_rule,
  /* 1149 */  iRegINoSp_rule,
  /* 1150 */  iRegINoSp_rule,
  /* 1151 */  vRegF_rule,
  /* 1152 */  vRegD_rule,
  /* 1153 */  vRegF_rule,
  /* 1154 */  vRegD_rule,
  /* 1155 */  vRegF_rule,
  /* 1156 */  vRegD_rule,
  /* 1157 */  vRegF_rule,
  /* 1158 */  vRegD_rule,
  /* 1159 */  vRegF_rule,
  /* 1160 */  vRegF_rule,
  /* 1161 */  vRegD_rule,
  /* 1162 */  vRegD_rule,
  /* 1163 */  vRegF_rule,
  /* 1164 */  vRegF_rule,
  /* 1165 */  vRegD_rule,
  /* 1166 */  vRegD_rule,
  /* 1167 */  vRegF_rule,
  /* 1168 */  vRegD_rule,
  /* 1169 */  vRegF_rule,
  /* 1170 */  vRegF_rule,
  /* 1171 */  vRegD_rule,
  /* 1172 */  vRegD_rule,
  /* 1173 */  vRegF_rule,
  /* 1174 */  vRegD_rule,
  /* 1175 */  iRegINoSp_rule,
  /* 1176 */  iRegLNoSp_rule,
  /* 1177 */  vRegF_rule,
  /* 1178 */  vRegD_rule,
  /* 1179 */  vRegD_rule,
  /* 1180 */  vRegF_rule,
  /* 1181 */  vRegD_rule,
  /* 1182 */  vRegD_rule,
  /* 1183 */  vRegF_rule,
  /* 1184 */  vRegD_rule,
  /* 1185 */  vRegF_rule,
  /* 1186 */  Universe_rule,
  /* 1187 */  iRegINoSp_rule,
  /* 1188 */  iRegINoSp_rule,
  /* 1189 */  iRegINoSp_rule,
  /* 1190 */  iRegINoSp_rule,
  /* 1191 */  iRegINoSp_rule,
  /* 1192 */  iRegINoSp_rule,
  /* 1193 */  iRegLNoSp_rule,
  /* 1194 */  iRegLNoSp_rule,
  /* 1195 */  iRegLNoSp_rule,
  /* 1196 */  iRegLNoSp_rule,
  /* 1197 */  iRegLNoSp_rule,
  /* 1198 */  iRegLNoSp_rule,
  /* 1199 */  iRegLNoSp_rule,
  /* 1200 */  iRegLNoSp_rule,
  /* 1201 */  iRegINoSp_rule,
  /* 1202 */  vRegF_rule,
  /* 1203 */  vRegD_rule,
  /* 1204 */  iRegINoSp_rule,
  /* 1205 */  iRegLNoSp_rule,
  /* 1206 */  iRegINoSp_rule,
  /* 1207 */  vRegF_rule,
  /* 1208 */  vRegF_rule,
  /* 1209 */  vRegF_rule,
  /* 1210 */  iRegINoSp_rule,
  /* 1211 */  iRegLNoSp_rule,
  /* 1212 */  vRegD_rule,
  /* 1213 */  vRegD_rule,
  /* 1214 */  iRegLNoSp_rule,
  /* 1215 */  iRegINoSp_rule,
  /* 1216 */  stackSlotI_rule,
  /* 1217 */  stackSlotF_rule,
  /* 1218 */  stackSlotL_rule,
  /* 1219 */  stackSlotD_rule,
  /* 1220 */  Universe_rule,
  /* 1221 */  Universe_rule,
  /* 1222 */  Universe_rule,
  /* 1223 */  Universe_rule,
  /* 1224 */  iRegINoSp_rule,
  /* 1225 */  iRegINoSp_rule,
  /* 1226 */  iRegINoSp_rule,
  /* 1227 */  iRegINoSp_rule,
  /* 1228 */  iRegINoSp_rule,
  /* 1229 */  iRegINoSp_rule,
  /* 1230 */  iRegINoSp_rule,
  /* 1231 */  iRegINoSp_rule,
  /* 1232 */  Universe_rule,
  /* 1233 */  Universe_rule,
  /* 1234 */  Universe_rule,
  /* 1235 */  Universe_rule,
  /* 1236 */  Universe_rule,
  /* 1237 */  Universe_rule,
  /* 1238 */  Universe_rule,
  /* 1239 */  Universe_rule,
  /* 1240 */  Universe_rule,
  /* 1241 */  Universe_rule,
  /* 1242 */  Universe_rule,
  /* 1243 */  Universe_rule,
  /* 1244 */  Universe_rule,
  /* 1245 */  Universe_rule,
  /* 1246 */  Universe_rule,
  /* 1247 */  Universe_rule,
  /* 1248 */  Universe_rule,
  /* 1249 */  Universe_rule,
  /* 1250 */  Universe_rule,
  /* 1251 */  Universe_rule,
  /* 1252 */  Universe_rule,
  /* 1253 */  Universe_rule,
  /* 1254 */  Universe_rule,
  /* 1255 */  Universe_rule,
  /* 1256 */  Universe_rule,
  /* 1257 */  Universe_rule,
  /* 1258 */  Universe_rule,
  /* 1259 */  iRegP_R0_rule,
  /* 1260 */  Universe_rule,
  /* 1261 */  Universe_rule,
  /* 1262 */  Universe_rule,
  /* 1263 */  iRegP_R5_rule,
  /* 1264 */  iRegI_R0_rule,
  /* 1265 */  iRegI_R0_rule,
  /* 1266 */  iRegI_R0_rule,
  /* 1267 */  iRegI_R0_rule,
  /* 1268 */  iRegI_R0_rule,
  /* 1269 */  iRegI_R0_rule,
  /* 1270 */  iRegI_R0_rule,
  /* 1271 */  iRegI_R0_rule,
  /* 1272 */  iRegI_R0_rule,
  /* 1273 */  iRegI_R0_rule,
  /* 1274 */  iRegI_R0_rule,
  /* 1275 */  iRegI_R0_rule,
  /* 1276 */  iRegI_R0_rule,
  /* 1277 */  iRegI_R0_rule,
  /* 1278 */  iRegI_R0_rule,
  /* 1279 */  iRegI_R0_rule,
  /* 1280 */  iRegI_R0_rule,
  /* 1281 */  iRegI_R0_rule,
  /* 1282 */  iRegI_R0_rule,
  /* 1283 */  iRegI_R0_rule,
  /* 1284 */  iRegI_R0_rule,
  /* 1285 */  iRegI_R0_rule,
  /* 1286 */  iRegI_R0_rule,
  /* 1287 */  iRegI_R0_rule,
  /* 1288 */  Universe_rule,
  /* 1289 */  iRegI_R0_rule,
  /* 1290 */  iRegI_R0_rule,
  /* 1291 */  iRegINoSp_rule,
  /* 1292 */  iRegINoSp_rule,
  /* 1293 */  iRegLNoSp_rule,
  /* 1294 */  iRegLNoSp_rule,
  /* 1295 */  iRegINoSp_rule,
  /* 1296 */  iRegINoSp_rule,
  /* 1297 */  iRegLNoSp_rule,
  /* 1298 */  iRegINoSp_rule,
  /* 1299 */  vReg_rule,
  /* 1300 */  Universe_rule,
  /* 1301 */  vReg_rule,
  /* 1302 */  Universe_rule,
  /* 1303 */  vReg_rule,
  /* 1304 */  Universe_rule,
  /* 1305 */  vReg_rule,
  /* 1306 */  Universe_rule,
  /* 1307 */  vReg_rule,
  /* 1308 */  Universe_rule,
  /* 1309 */  vReg_rule,
  /* 1310 */  Universe_rule,
  /* 1311 */  vReg_rule,
  /* 1312 */  vReg_rule,
  /* 1313 */  vReg_rule,
  /* 1314 */  vReg_rule,
  /* 1315 */  vReg_rule,
  /* 1316 */  vReg_rule,
  /* 1317 */  vReg_rule,
  /* 1318 */  vReg_rule,
  /* 1319 */  vReg_rule,
  /* 1320 */  vReg_rule,
  /* 1321 */  vReg_rule,
  /* 1322 */  vReg_rule,
  /* 1323 */  vReg_rule,
  /* 1324 */  vReg_rule,
  /* 1325 */  vReg_rule,
  /* 1326 */  vReg_rule,
  /* 1327 */  vReg_rule,
  /* 1328 */  vReg_rule,
  /* 1329 */  vReg_rule,
  /* 1330 */  vReg_rule,
  /* 1331 */  vReg_rule,
  /* 1332 */  vReg_rule,
  /* 1333 */  vReg_rule,
  /* 1334 */  vReg_rule,
  /* 1335 */  vReg_rule,
  /* 1336 */  vReg_rule,
  /* 1337 */  vReg_rule,
  /* 1338 */  vReg_rule,
  /* 1339 */  vReg_rule,
  /* 1340 */  vReg_rule,
  /* 1341 */  vReg_rule,
  /* 1342 */  vReg_rule,
  /* 1343 */  vReg_rule,
  /* 1344 */  vReg_rule,
  /* 1345 */  vReg_rule,
  /* 1346 */  vReg_rule,
  /* 1347 */  vReg_rule,
  /* 1348 */  vReg_rule,
  /* 1349 */  vReg_rule,
  /* 1350 */  vReg_rule,
  /* 1351 */  vReg_rule,
  /* 1352 */  vReg_rule,
  /* 1353 */  vReg_rule,
  /* 1354 */  vReg_rule,
  /* 1355 */  vReg_rule,
  /* 1356 */  vReg_rule,
  /* 1357 */  vReg_rule,
  /* 1358 */  vReg_rule,
  /* 1359 */  vReg_rule,
  /* 1360 */  vReg_rule,
  /* 1361 */  vReg_rule,
  /* 1362 */  vReg_rule,
  /* 1363 */  vReg_rule,
  /* 1364 */  vReg_rule,
  /* 1365 */  vReg_rule,
  /* 1366 */  vReg_rule,
  /* 1367 */  vReg_rule,
  /* 1368 */  vReg_rule,
  /* 1369 */  vReg_rule,
  /* 1370 */  vReg_rule,
  /* 1371 */  vReg_rule,
  /* 1372 */  vReg_rule,
  /* 1373 */  vReg_rule,
  /* 1374 */  vReg_rule,
  /* 1375 */  vReg_rule,
  /* 1376 */  vReg_rule,
  /* 1377 */  vReg_rule,
  /* 1378 */  vReg_rule,
  /* 1379 */  vReg_rule,
  /* 1380 */  vReg_rule,
  /* 1381 */  vReg_rule,
  /* 1382 */  vReg_rule,
  /* 1383 */  vReg_rule,
  /* 1384 */  vReg_rule,
  /* 1385 */  vReg_rule,
  /* 1386 */  vReg_rule,
  /* 1387 */  vReg_rule,
  /* 1388 */  vReg_rule,
  /* 1389 */  vReg_rule,
  /* 1390 */  vReg_rule,
  /* 1391 */  vReg_rule,
  /* 1392 */  vReg_rule,
  /* 1393 */  vReg_rule,
  /* 1394 */  vReg_rule,
  /* 1395 */  vReg_rule,
  /* 1396 */  vReg_rule,
  /* 1397 */  vReg_rule,
  /* 1398 */  vReg_rule,
  /* 1399 */  vReg_rule,
  /* 1400 */  vReg_rule,
  /* 1401 */  vReg_rule,
  /* 1402 */  vReg_rule,
  /* 1403 */  vReg_rule,
  /* 1404 */  vReg_rule,
  /* 1405 */  vReg_rule,
  /* 1406 */  vReg_rule,
  /* 1407 */  vReg_rule,
  /* 1408 */  vReg_rule,
  /* 1409 */  vReg_rule,
  /* 1410 */  vReg_rule,
  /* 1411 */  vReg_rule,
  /* 1412 */  vReg_rule,
  /* 1413 */  vReg_rule,
  /* 1414 */  vReg_rule,
  /* 1415 */  vReg_rule,
  /* 1416 */  vReg_rule,
  /* 1417 */  vReg_rule,
  /* 1418 */  vReg_rule,
  /* 1419 */  vReg_rule,
  /* 1420 */  vReg_rule,
  /* 1421 */  vReg_rule,
  /* 1422 */  vReg_rule,
  /* 1423 */  vReg_rule,
  /* 1424 */  vReg_rule,
  /* 1425 */  vReg_rule,
  /* 1426 */  vReg_rule,
  /* 1427 */  vReg_rule,
  /* 1428 */  vReg_rule,
  /* 1429 */  vReg_rule,
  /* 1430 */  vReg_rule,
  /* 1431 */  vReg_rule,
  /* 1432 */  vReg_rule,
  /* 1433 */  vReg_rule,
  /* 1434 */  vReg_rule,
  /* 1435 */  vReg_rule,
  /* 1436 */  vReg_rule,
  /* 1437 */  vReg_rule,
  /* 1438 */  vReg_rule,
  /* 1439 */  vReg_rule,
  /* 1440 */  vReg_rule,
  /* 1441 */  vReg_rule,
  /* 1442 */  vReg_rule,
  /* 1443 */  vReg_rule,
  /* 1444 */  vReg_rule,
  /* 1445 */  vReg_rule,
  /* 1446 */  vReg_rule,
  /* 1447 */  vReg_rule,
  /* 1448 */  vReg_rule,
  /* 1449 */  vReg_rule,
  /* 1450 */  vReg_rule,
  /* 1451 */  vReg_rule,
  /* 1452 */  vReg_rule,
  /* 1453 */  vReg_rule,
  /* 1454 */  vReg_rule,
  /* 1455 */  vReg_rule,
  /* 1456 */  vReg_rule,
  /* 1457 */  vReg_rule,
  /* 1458 */  vReg_rule,
  /* 1459 */  vReg_rule,
  /* 1460 */  vReg_rule,
  /* 1461 */  vReg_rule,
  /* 1462 */  vReg_rule,
  /* 1463 */  vReg_rule,
  /* 1464 */  vReg_rule,
  /* 1465 */  vReg_rule,
  /* 1466 */  vReg_rule,
  /* 1467 */  vReg_rule,
  /* 1468 */  vReg_rule,
  /* 1469 */  vReg_rule,
  /* 1470 */  vReg_rule,
  /* 1471 */  vReg_rule,
  /* 1472 */  vReg_rule,
  /* 1473 */  vReg_rule,
  /* 1474 */  vReg_rule,
  /* 1475 */  vReg_rule,
  /* 1476 */  vReg_rule,
  /* 1477 */  vReg_rule,
  /* 1478 */  vReg_rule,
  /* 1479 */  vReg_rule,
  /* 1480 */  vReg_rule,
  /* 1481 */  vReg_rule,
  /* 1482 */  vReg_rule,
  /* 1483 */  vReg_rule,
  /* 1484 */  vReg_rule,
  /* 1485 */  vReg_rule,
  /* 1486 */  vReg_rule,
  /* 1487 */  vReg_rule,
  /* 1488 */  vReg_rule,
  /* 1489 */  vReg_rule,
  /* 1490 */  vReg_rule,
  /* 1491 */  vReg_rule,
  /* 1492 */  vReg_rule,
  /* 1493 */  vReg_rule,
  /* 1494 */  vReg_rule,
  /* 1495 */  vReg_rule,
  /* 1496 */  vReg_rule,
  /* 1497 */  vReg_rule,
  /* 1498 */  vReg_rule,
  /* 1499 */  vReg_rule,
  /* 1500 */  vReg_rule,
  /* 1501 */  vReg_rule,
  /* 1502 */  vReg_rule,
  /* 1503 */  vReg_rule,
  /* 1504 */  vReg_rule,
  /* 1505 */  vReg_rule,
  /* 1506 */  vReg_rule,
  /* 1507 */  vReg_rule,
  /* 1508 */  vReg_rule,
  /* 1509 */  vReg_rule,
  /* 1510 */  vReg_rule,
  /* 1511 */  vReg_rule,
  /* 1512 */  vReg_rule,
  /* 1513 */  vReg_rule,
  /* 1514 */  vReg_rule,
  /* 1515 */  vReg_rule,
  /* 1516 */  vReg_rule,
  /* 1517 */  vReg_rule,
  /* 1518 */  vReg_rule,
  /* 1519 */  vReg_rule,
  /* 1520 */  vReg_rule,
  /* 1521 */  vReg_rule,
  /* 1522 */  vReg_rule,
  /* 1523 */  vReg_rule,
  /* 1524 */  vReg_rule,
  /* 1525 */  vReg_rule,
  /* 1526 */  vReg_rule,
  /* 1527 */  vReg_rule,
  /* 1528 */  vReg_rule,
  /* 1529 */  vReg_rule,
  /* 1530 */  vReg_rule,
  /* 1531 */  vReg_rule,
  /* 1532 */  vReg_rule,
  /* 1533 */  vReg_rule,
  /* 1534 */  vReg_rule,
  /* 1535 */  vReg_rule,
  /* 1536 */  vReg_rule,
  /* 1537 */  vReg_rule,
  /* 1538 */  vReg_rule,
  /* 1539 */  vReg_rule,
  /* 1540 */  vReg_rule,
  /* 1541 */  vReg_rule,
  /* 1542 */  vReg_rule,
  /* 1543 */  vReg_rule,
  /* 1544 */  vReg_rule,
  /* 1545 */  vReg_rule,
  /* 1546 */  vReg_rule,
  /* 1547 */  vReg_rule,
  /* 1548 */  vReg_rule,
  /* 1549 */  vReg_rule,
  /* 1550 */  vReg_rule,
  /* 1551 */  vReg_rule,
  /* 1552 */  vReg_rule,
  /* 1553 */  vReg_rule,
  /* 1554 */  vReg_rule,
  /* 1555 */  vReg_rule,
  /* 1556 */  vReg_rule,
  /* 1557 */  vReg_rule,
  /* 1558 */  vReg_rule,
  /* 1559 */  vReg_rule,
  /* 1560 */  vReg_rule,
  /* 1561 */  vReg_rule,
  /* 1562 */  vReg_rule,
  /* 1563 */  vReg_rule,
  /* 1564 */  vReg_rule,
  /* 1565 */  vReg_rule,
  /* 1566 */  vReg_rule,
  /* 1567 */  vReg_rule,
  /* 1568 */  vReg_rule,
  /* 1569 */  vReg_rule,
  /* 1570 */  vReg_rule,
  /* 1571 */  vReg_rule,
  /* 1572 */  vReg_rule,
  /* 1573 */  vReg_rule,
  /* 1574 */  vReg_rule,
  /* 1575 */  vReg_rule,
  /* 1576 */  vReg_rule,
  /* 1577 */  vReg_rule,
  /* 1578 */  vReg_rule,
  /* 1579 */  vReg_rule,
  /* 1580 */  vReg_rule,
  /* 1581 */  vReg_rule,
  /* 1582 */  vReg_rule,
  /* 1583 */  vReg_rule,
  /* 1584 */  vReg_rule,
  /* 1585 */  vReg_rule,
  /* 1586 */  vReg_rule,
  /* 1587 */  vReg_rule,
  /* 1588 */  iRegINoSp_rule,
  /* 1589 */  iRegINoSp_rule,
  /* 1590 */  iRegLNoSp_rule,
  /* 1591 */  iRegLNoSp_rule,
  /* 1592 */  vRegF_rule,
  /* 1593 */  vRegF_rule,
  /* 1594 */  vRegF_rule,
  /* 1595 */  vRegD_rule,
  /* 1596 */  vRegD_rule,
  /* 1597 */  iRegINoSp_rule,
  /* 1598 */  iRegLNoSp_rule,
  /* 1599 */  vRegF_rule,
  /* 1600 */  vRegD_rule,
  /* 1601 */  iRegINoSp_rule,
  /* 1602 */  iRegLNoSp_rule,
  /* 1603 */  vRegF_rule,
  /* 1604 */  vRegD_rule,
  /* 1605 */  iRegINoSp_rule,
  /* 1606 */  iRegINoSp_rule,
  /* 1607 */  iRegLNoSp_rule,
  /* 1608 */  iRegLNoSp_rule,
  /* 1609 */  iRegINoSp_rule,
  /* 1610 */  iRegLNoSp_rule,
  /* 1611 */  iRegINoSp_rule,
  /* 1612 */  iRegINoSp_rule,
  /* 1613 */  iRegLNoSp_rule,
  /* 1614 */  iRegLNoSp_rule,
  /* 1615 */  iRegINoSp_rule,
  /* 1616 */  iRegLNoSp_rule,
  /* 1617 */  iRegINoSp_rule,
  /* 1618 */  iRegINoSp_rule,
  /* 1619 */  iRegLNoSp_rule,
  /* 1620 */  iRegLNoSp_rule,
  /* 1621 */  iRegINoSp_rule,
  /* 1622 */  iRegLNoSp_rule,
  /* 1623 */  iRegINoSp_rule,
  /* 1624 */  iRegINoSp_rule,
  /* 1625 */  iRegLNoSp_rule,
  /* 1626 */  iRegLNoSp_rule,
  /* 1627 */  vRegF_rule,
  /* 1628 */  vRegD_rule,
  /* 1629 */  iRegINoSp_rule,
  /* 1630 */  iRegLNoSp_rule,
  /* 1631 */  vRegF_rule,
  /* 1632 */  vRegD_rule,
  /* 1633 */  iRegINoSp_rule,
  /* 1634 */  iRegINoSp_rule,
  /* 1635 */  iRegLNoSp_rule,
  /* 1636 */  iRegLNoSp_rule,
  /* 1637 */  vRegF_rule,
  /* 1638 */  vRegD_rule,
  /* 1639 */  iRegINoSp_rule,
  /* 1640 */  iRegLNoSp_rule,
  /* 1641 */  vRegF_rule,
  /* 1642 */  vRegD_rule,
  /* 1643 */  vReg_rule,
  /* 1644 */  vReg_rule,
  /* 1645 */  vReg_rule,
  /* 1646 */  vReg_rule,
  /* 1647 */  vReg_rule,
  /* 1648 */  vReg_rule,
  /* 1649 */  vReg_rule,
  /* 1650 */  vReg_rule,
  /* 1651 */  vReg_rule,
  /* 1652 */  vReg_rule,
  /* 1653 */  vReg_rule,
  /* 1654 */  vReg_rule,
  /* 1655 */  vReg_rule,
  /* 1656 */  vReg_rule,
  /* 1657 */  vReg_rule,
  /* 1658 */  vReg_rule,
  /* 1659 */  vReg_rule,
  /* 1660 */  vReg_rule,
  /* 1661 */  vReg_rule,
  /* 1662 */  vReg_rule,
  /* 1663 */  vReg_rule,
  /* 1664 */  vReg_rule,
  /* 1665 */  vReg_rule,
  /* 1666 */  iRegINoSp_rule,
  /* 1667 */  iRegINoSp_rule,
  /* 1668 */  iRegINoSp_rule,
  /* 1669 */  iRegINoSp_rule,
  /* 1670 */  iRegINoSp_rule,
  /* 1671 */  iRegINoSp_rule,
  /* 1672 */  iRegLNoSp_rule,
  /* 1673 */  iRegLNoSp_rule,
  /* 1674 */  vRegF_rule,
  /* 1675 */  vRegD_rule,
  /* 1676 */  pReg_rule,
  /* 1677 */  pReg_rule,
  /* 1678 */  pReg_rule,
  /* 1679 */  pReg_rule,
  /* 1680 */  vReg_rule,
  /* 1681 */  vReg_rule,
  /* 1682 */  vReg_rule,
  /* 1683 */  vReg_rule,
  /* 1684 */  pReg_rule,
  /* 1685 */  pReg_rule,
  /* 1686 */  pReg_rule,
  /* 1687 */  pReg_rule,
  /* 1688 */  Universe_rule,
  /* 1689 */  Universe_rule,
  /* 1690 */  Universe_rule,
  /* 1691 */  Universe_rule,
  /* 1692 */  pReg_rule,
  /* 1693 */  pReg_rule,
  /* 1694 */  pReg_rule,
  /* 1695 */  pReg_rule,
  /* 1696 */  pReg_rule,
  /* 1697 */  vReg_rule,
  /* 1698 */  vReg_rule,
  /* 1699 */  vReg_rule,
  /* 1700 */  vReg_rule,
  /* 1701 */  vReg_rule,
  /* 1702 */  vReg_rule,
  /* 1703 */  vReg_rule,
  /* 1704 */  pReg_rule,
  /* 1705 */  pReg_rule,
  /* 1706 */  pReg_rule,
  /* 1707 */  pReg_rule,
  /* 1708 */  pReg_rule,
  /* 1709 */  pReg_rule,
  /* 1710 */  pReg_rule,
  /* 1711 */  pReg_rule,
  /* 1712 */  pReg_rule,
  /* 1713 */  pReg_rule,
  /* 1714 */  pReg_rule,
  /* 1715 */  pReg_rule,
  /* 1716 */  iRegINoSp_rule,
  /* 1717 */  iRegINoSp_rule,
  /* 1718 */  iRegINoSp_rule,
  /* 1719 */  iRegINoSp_rule,
  /* 1720 */  iRegINoSp_rule,
  /* 1721 */  iRegINoSp_rule,
  /* 1722 */  iRegLNoSp_rule,
  /* 1723 */  pReg_rule,
  /* 1724 */  pReg_rule,
  /* 1725 */  pReg_rule,
  /* 1726 */  pReg_rule,
  /* 1727 */  pReg_rule,
  /* 1728 */  pReg_rule,
  /* 1729 */  pReg_rule,
  /* 1730 */  pReg_rule,
  /* 1731 */  pReg_rule,
  /* 1732 */  pReg_rule,
  /* 1733 */  pReg_rule,
  /* 1734 */  vReg_rule,
  /* 1735 */  vReg_rule,
  /* 1736 */  vReg_rule,
  /* 1737 */  vReg_rule,
  /* 1738 */  vReg_rule,
  /* 1739 */  vReg_rule,
  /* 1740 */  vReg_rule,
  /* 1741 */  vReg_rule,
  /* 1742 */  vReg_rule,
  /* 1743 */  vReg_rule,
  /* 1744 */  vReg_rule,
  /* 1745 */  vReg_rule,
  /* 1746 */  vReg_rule,
  /* 1747 */  vReg_rule,
  /* 1748 */  vReg_rule,
  /* 1749 */  Universe_rule,
  /* 1750 */  Universe_rule,
  /* 1751 */  Universe_rule,
  /* 1752 */  Universe_rule,
  /* 1753 */  vReg_rule,
  /* 1754 */  vReg_rule,
  /* 1755 */  vReg_rule,
  /* 1756 */  vReg_rule,
  /* 1757 */  vReg_rule,
  /* 1758 */  pReg_rule,
  /* 1759 */  vReg_rule,
  /* 1760 */  vReg_rule,
  /* 1761 */  vReg_rule,
  /* 1762 */  vReg_rule,
  /* 1763 */  vReg_rule,
  /* 1764 */  vReg_rule,
  /* 1765 */  vReg_rule,
  /* 1766 */  vReg_rule,
  /* 1767 */  vReg_rule,
  /* 1768 */  vReg_rule,
  /* 1769 */  iRegINoSp_rule,
  /* 1770 */  iRegINoSp_rule,
  /* 1771 */  iRegINoSp_rule,
  /* 1772 */  iRegINoSp_rule,
  /* 1773 */  iRegNNoSp_rule,
  /* 1774 */  iRegPNoSp_rule,
  /* 1775 */  iRegNNoSp_rule,
  /* 1776 */  iRegPNoSp_rule,
  /* 1777 */  iRegINoSp_rule,
  /* 1778 */  iRegINoSp_rule,
  /* 1779 */  iRegINoSp_rule,
  /* 1780 */  iRegINoSp_rule,
  /* 1781 */  iRegPNoSp_rule,
  /* 1782 */  iRegPNoSp_rule,
  /* 1783 */  iRegINoSp_rule,
  /* 1784 */  iRegINoSp_rule,
  /* 1785 */  iRegINoSp_rule,
  /* 1786 */  iRegINoSp_rule,
  /* 1787 */  iRegPNoSp_rule,
  /* 1788 */  iRegPNoSp_rule,
  /* 1789 */  iRegPNoSp_rule,
  /* 1790 */  iRegPNoSp_rule,
  /* 1791 */  iRegPNoSp_rule,
  /* 1792 */  iRegPNoSp_rule,
  /* 1793 */  Universe_rule,
  /* 1794 */  Universe_rule,
  /* 1795 */  iRegINoSp_rule,
  /* 1796 */  iRegINoSp_rule,
  /* 1797 */  iRegINoSp_rule,
  /* 1798 */  iRegINoSp_rule,
  /* 1799 */  iRegPNoSp_rule,
  /* 1800 */  iRegPNoSp_rule,
  /* 1801 */  iRegPNoSp_rule,
  /* 1802 */  iRegPNoSp_rule,
  // last instruction
  0 // no trailing comma
};

const        int   leftOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  0,
  /*   86 */  0,
  /*   87 */  0,
  /*   88 */  0,
  /*   89 */  0,
  /*   90 */  0,
  /*   91 */  0,
  /*   92 */  0,
  /*   93 */  0,
  /*   94 */  0,
  /*   95 */  0,
  /*   96 */  0,
  /*   97 */  0,
  /*   98 */  0,
  /*   99 */  0,
  /*  100 */  0,
  /*  101 */  0,
  /*  102 */  0,
  /*  103 */  0,
  /*  104 */  0,
  /*  105 */  0,
  /*  106 */  0,
  /*  107 */  0,
  /*  108 */  0,
  /*  109 */  0,
  /*  110 */  0,
  /*  111 */  0,
  /*  112 */  0,
  /*  113 */  0,
  /*  114 */  0,
  /*  115 */  0,
  /*  116 */  0,
  /*  117 */  0,
  /*  118 */  0,
  /*  119 */  0,
  /*  120 */  0,
  /*  121 */  0,
  /*  122 */  0,
  /*  123 */  0,
  /*  124 */  0,
  /*  125 */  0,
  /*  126 */  0,
  /*  127 */  0,
  /*  128 */  0,
  /*  129 */  0,
  /*  130 */  0,
  /*  131 */  0,
  /*  132 */  0,
  /*  133 */  0,
  /*  134 */  0,
  /*  135 */  0,
  /*  136 */  0,
  /*  137 */  0,
  /*  138 */  0,
  /*  139 */  0,
  /*  140 */  0,
  /*  141 */  0,
  /*  142 */  0,
  /*  143 */  0,
  /*  144 */  0,
  /*  145 */  0,
  /*  146 */  0,
  /*  147 */  0,
  /*  148 */  0,
  /*  149 */  0,
  /*  150 */  0,
  /*  151 */  0,
  /*  152 */  0,
  /*  153 */  0,
  /*  154 */  0,
  /*  155 */  0,
  /*  156 */  0,
  /*  157 */  0,
  /*  158 */  0,
  /*  159 */  0,
  /*  160 */  0,
  /*  161 */  0,
  /*  162 */  0,
  /*  163 */  iRegP_rule,
  /*  164 */  iRegP_rule,
  /*  165 */  iRegP_rule,
  /*  166 */  iRegP_rule,
  /*  167 */  iRegP_rule,
  /*  168 */  iRegP_rule,
  /*  169 */  iRegP_rule,
  /*  170 */  iRegP_rule,
  /*  171 */  iRegP_rule,
  /*  172 */  iRegP_rule,
  /*  173 */  iRegP_rule,
  /*  174 */  iRegP_rule,
  /*  175 */  iRegP_rule,
  /*  176 */  iRegP_rule,
  /*  177 */  iRegP_rule,
  /*  178 */  iRegP_rule,
  /*  179 */  iRegN_rule,
  /*  180 */  _DecodeN_iRegN__rule,
  /*  181 */  _DecodeN_iRegN__rule,
  /*  182 */  _DecodeN_iRegN__rule,
  /*  183 */  _DecodeN_iRegN__rule,
  /*  184 */  _DecodeN_iRegN__rule,
  /*  185 */  _DecodeN_iRegN__rule,
  /*  186 */  thread_RegP_rule,
  /*  187 */  0,
  /*  188 */  0,
  /*  189 */  0,
  /*  190 */  0,
  /*  191 */  0,
  /*  192 */  0,
  /*  193 */  0,
  /*  194 */  0,
  /*  195 */  0,
  /*  196 */  0,
  /*  197 */  iRegL_rule,
  /*  198 */  0,
  /*  199 */  0,
  /*  200 */  iRegP_rule,
  /*  201 */  iRegP_rule,
  // last operand
  /*  202 */  0,
  /*  203 */  0,
  /*  204 */  0,
  /*  205 */  0,
  /*  206 */  0,
  /*  207 */  0,
  /*  208 */  0,
  /*  209 */  0,
  /*  210 */  0,
  /*  211 */  0,
  /*  212 */  0,
  // last operand class
  /*  213 */  iRegI_rule,
  /*  214 */  _ConvI2L_iRegI__rule,
  /*  215 */  iRegL_rule,
  /*  216 */  iRegN_rule,
  /*  217 */  memory1_rule,
  /*  218 */  memory1_rule,
  /*  219 */  memory2_rule,
  /*  220 */  memory2_rule,
  /*  221 */  memory4_rule,
  /*  222 */  _LoadI_memory4__rule,
  /*  223 */  indirect_rule,
  /*  224 */  indirect_rule,
  /*  225 */  indirect_rule,
  /*  226 */  indirect_rule,
  /*  227 */  indirect_rule,
  /*  228 */  _LoadI_indirect__rule,
  /*  229 */  memory8_rule,
  /*  230 */  iRegP_rule,
  /*  231 */  _DecodeN_iRegN__rule,
  /*  232 */  iRegINoSp_rule,
  /*  233 */  iRegLNoSp_rule,
  /*  234 */  iRegP_rule,
  /*  235 */  iRegNNoSp_rule,
  /*  236 */  iRegI_rule,
  /*  237 */  iRegL_rule,
  /*  238 */  iRegN_rule,
  /*  239 */  cmpOp_rule,
  /*  240 */  iRegIorL2I_rule,
  /*  241 */  cmpOpU_rule,
  /*  242 */  immI0_rule,
  /*  243 */  iRegIorL2I_rule,
  /*  244 */  immI_1_rule,
  /*  245 */  iRegL_rule,
  /*  246 */  immL0_rule,
  /*  247 */  iRegP_rule,
  /*  248 */  immP0_rule,
  /*  249 */  iRegN_rule,
  /*  250 */  immN0_rule,
  /*  251 */  vRegF_rule,
  /*  252 */  vRegD_rule,
  /*  253 */  iRegL_rule,
  /*  254 */  iRegIorL2I_rule,
  /*  255 */  _ConvI2L_iRegIorL2I__rule,
  /*  256 */  iRegIorL2I_rule,
  /*  257 */  immI0_rule,
  /*  258 */  iRegL_rule,
  /*  259 */  immL0_rule,
  /*  260 */  _ConvI2L_iRegIorL2I__rule,
  /*  261 */  immL0_rule,
  /*  262 */  iRegIorL2I_rule,
  /*  263 */  iRegIorL2I_rule,
  /*  264 */  iRegIorL2I_rule,
  /*  265 */  iRegL_rule,
  /*  266 */  iRegL_rule,
  /*  267 */  iRegL_rule,
  /*  268 */  iRegIorL2I_rule,
  /*  269 */  iRegL_rule,
  /*  270 */  iRegIorL2I_rule,
  /*  271 */  iRegL_rule,
  /*  272 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  273 */  _URShiftL_iRegL_immI_rule,
  /*  274 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  275 */  _RShiftL_iRegL_immI_rule,
  /*  276 */  iRegIorL2I_rule,
  /*  277 */  _RotateRight_iRegIorL2I_immI_rule,
  /*  278 */  iRegL_rule,
  /*  279 */  _RotateRight_iRegL_immI_rule,
  /*  280 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  281 */  _LShiftL_iRegL_immI_rule,
  /*  282 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  283 */  iRegIorL2I_rule,
  /*  284 */  _URShiftL_iRegL_immI_rule,
  /*  285 */  iRegL_rule,
  /*  286 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  287 */  iRegIorL2I_rule,
  /*  288 */  _RShiftL_iRegL_immI_rule,
  /*  289 */  iRegL_rule,
  /*  290 */  _RotateRight_iRegIorL2I_immI_rule,
  /*  291 */  iRegIorL2I_rule,
  /*  292 */  _RotateRight_iRegL_immI_rule,
  /*  293 */  iRegL_rule,
  /*  294 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  295 */  iRegIorL2I_rule,
  /*  296 */  _LShiftL_iRegL_immI_rule,
  /*  297 */  iRegL_rule,
  /*  298 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  299 */  iRegIorL2I_rule,
  /*  300 */  iRegL_rule,
  /*  301 */  _AndI_iRegIorL2I_immI_bitmask_rule,
  /*  302 */  iRegL_rule,
  /*  303 */  _AndL_iRegL_immL_positive_bitmaskI_rule,
  /*  304 */  _AndI_iRegIorL2I_immI_bitmask_rule,
  /*  305 */  _AndL_iRegL_immL_positive_bitmaskI_rule,
  /*  306 */  iRegI_rule,
  /*  307 */  iRegIorL2I_rule,
  /*  308 */  _LShiftI_iRegIorL2I_immI_16_rule,
  /*  309 */  iRegIorL2I_rule,
  /*  310 */  _LShiftI_iRegIorL2I_immI_24_rule,
  /*  311 */  _LShiftI_iRegIorL2I_immI_24_rule,
  /*  312 */  iRegL_rule,
  /*  313 */  _LShiftL_iRegL_immI_48_rule,
  /*  314 */  iRegL_rule,
  /*  315 */  _LShiftL_iRegL_immI_32_rule,
  /*  316 */  iRegL_rule,
  /*  317 */  _LShiftL_iRegL_immI_56_rule,
  /*  318 */  _LShiftL_iRegL_immI_56_rule,
  /*  319 */  iRegIorL2I_rule,
  /*  320 */  iRegIorL2I_rule,
  /*  321 */  iRegL_rule,
  /*  322 */  iRegL_rule,
  /*  323 */  iRegL_rule,
  /*  324 */  _RShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  325 */  _RShiftL__LShiftL_iRegL_immI_48_immI_48_rule,
  /*  326 */  _RShiftL__LShiftL_iRegL_immI_32_immI_32_rule,
  /*  327 */  _RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /*  328 */  _RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_rule,
  /*  329 */  _ConvI2L_iRegIorL2I__rule,
  /*  330 */  _AndL_iRegL_immL_255_rule,
  /*  331 */  _AndL_iRegL_immL_65535_rule,
  /*  332 */  _AndL_iRegL_immL_4294967295_rule,
  /*  333 */  _AndI_iRegIorL2I_immI_255_rule,
  /*  334 */  _AndI_iRegIorL2I_immI_65535_rule,
  /*  335 */  vRegF_rule,
  /*  336 */  _NegF_vRegF__rule,
  /*  337 */  vRegF_rule,
  /*  338 */  vRegD_rule,
  /*  339 */  _NegD_vRegD__rule,
  /*  340 */  vRegD_rule,
  /*  341 */  vRegF_rule,
  /*  342 */  vRegD_rule,
  /*  343 */  iRegIorL2I_rule,
  /*  344 */  iRegL_rule,
  /*  345 */  iRegIorL2I_rule,
  /*  346 */  iRegL_rule,
  /*  347 */  iRegP_rule,
  /*  348 */  iRegN_rule,
  /*  349 */  _DecodeN_iRegN__rule,
  /*  350 */  iRegIorL2I_rule,
  /*  351 */  iRegL_rule,
  /*  352 */  iRegL_rule,
  /*  353 */  _AndL_iRegL_immL_rule,
  /*  354 */  iRegIorL2I_rule,
  /*  355 */  _AndI_iRegIorL2I_immI_rule,
  /*  356 */  iRegL_rule,
  /*  357 */  iRegIorL2I_rule,
  /*  358 */  iRegP_R4_rule,
  /*  359 */  iRegP_R1_rule,
  /*  360 */  iRegP_R3_rule,
  /*  361 */  iRegP_R1_rule,
  /*  362 */  iRegP_R3_rule,
  /*  363 */  iRegP_R3_rule,
  /*  364 */  iRegP_R3_rule,
  /*  365 */  iRegP_R1_rule,
  /*  366 */  iRegP_R1_rule,
  /*  367 */  vReg_rule,
  /*  368 */  vReg_rule,
  /*  369 */  immBAddSubV_rule,
  /*  370 */  immIAddSubV_rule,
  /*  371 */  immIAddSubV_rule,
  /*  372 */  immLAddSubV_rule,
  /*  373 */  immBLog_rule,
  /*  374 */  immSLog_rule,
  /*  375 */  immILog_rule,
  /*  376 */  immLLog_rule,
  /*  377 */  vReg_rule,
  /*  378 */  immI_M1_rule,
  /*  379 */  immI_M1_rule,
  /*  380 */  immI_M1_rule,
  /*  381 */  immL_M1_rule,
  /*  382 */  vReg_rule,
  /*  383 */  vReg_rule,
  /*  384 */  vReg_rule,
  /*  385 */  vReg_rule,
  /*  386 */  vReg_rule,
  /*  387 */  _ReplicateB_immI_M1__rule,
  /*  388 */  vReg_rule,
  /*  389 */  _ReplicateS_immI_M1__rule,
  /*  390 */  vReg_rule,
  /*  391 */  _ReplicateI_immI_M1__rule,
  /*  392 */  vReg_rule,
  /*  393 */  _ReplicateL_immL_M1__rule,
  /*  394 */  vReg_rule,
  /*  395 */  vReg_rule,
  /*  396 */  vReg_rule,
  /*  397 */  vReg_rule,
  /*  398 */  vReg_rule,
  /*  399 */  vReg_rule,
  /*  400 */  vReg_rule,
  /*  401 */  vReg_rule,
  /*  402 */  vReg_rule,
  /*  403 */  vReg_rule,
  /*  404 */  _Binary_vReg_vReg_rule,
  /*  405 */  _Binary_vReg_vReg_rule,
  /*  406 */  vReg_rule,
  /*  407 */  vReg_rule,
  /*  408 */  vReg_rule,
  /*  409 */  vReg_rule,
  /*  410 */  vReg_rule,
  /*  411 */  vReg_rule,
  /*  412 */  vReg_rule,
  /*  413 */  vReg_rule,
  /*  414 */  vReg_rule,
  /*  415 */  _NegVF_vReg__rule,
  /*  416 */  vReg_rule,
  /*  417 */  _NegVD_vReg__rule,
  /*  418 */  vReg_rule,
  /*  419 */  vReg_rule,
  /*  420 */  _NegVF_vReg__rule,
  /*  421 */  _NegVD_vReg__rule,
  /*  422 */  immI_rule,
  /*  423 */  immI_positive_rule,
  /*  424 */  vReg_rule,
  /*  425 */  vReg_rule,
  /*  426 */  vReg_rule,
  /*  427 */  vReg_rule,
  /*  428 */  vReg_rule,
  /*  429 */  vReg_rule,
  /*  430 */  vReg_rule,
  /*  431 */  vReg_rule,
  /*  432 */  vReg_rule,
  /*  433 */  vReg_rule,
  /*  434 */  iRegIorL2I_rule,
  /*  435 */  iRegL_rule,
  /*  436 */  vRegF_rule,
  /*  437 */  vRegD_rule,
  /*  438 */  vReg_rule,
  /*  439 */  vReg_rule,
  /*  440 */  vReg_rule,
  /*  441 */  vReg_rule,
  /*  442 */  indirect_rule,
  /*  443 */  vmemA_rule,
  /*  444 */  pReg_rule,
  /*  445 */  _VectorStoreMask_pReg_immI_gt_1_rule,
  /*  446 */  immI_M1_rule,
  /*  447 */  pReg_rule,
  /*  448 */  immL_M1_rule,
  /*  449 */  pReg_rule,
  /*  450 */  immI0_rule,
  /*  451 */  vReg_rule,
  /*  452 */  immI0_rule,
  /*  453 */  vReg_rule,
  /*  454 */  immI0_rule,
  /*  455 */  vReg_rule,
  /*  456 */  immL0_rule,
  /*  457 */  vReg_rule,
  /*  458 */  immF0_rule,
  /*  459 */  vReg_rule,
  /*  460 */  immD0_rule,
  /*  461 */  vReg_rule,
  /*  462 */  immI5_rule,
  /*  463 */  vReg_rule,
  /*  464 */  immIU7_rule,
  /*  465 */  vReg_rule,
  /*  466 */  immI5_rule,
  /*  467 */  vReg_rule,
  /*  468 */  immIU7_rule,
  /*  469 */  vReg_rule,
  /*  470 */  immI5_rule,
  /*  471 */  vReg_rule,
  /*  472 */  immIU7_rule,
  /*  473 */  vReg_rule,
  /*  474 */  immL5_rule,
  /*  475 */  vReg_rule,
  /*  476 */  immLU7_rule,
  /*  477 */  vReg_rule,
  /*  478 */  immI_rule,
  /*  479 */  vReg_rule,
  /*  480 */  iRegL_rule,
  /*  481 */  vReg_rule,
  // last internally defined operand
  /*  482 */  immI_rule,
  /*  483 */  immL_rule,
  /*  484 */  immP_rule,
  /*  485 */  immP0_rule,
  /*  486 */  immP_1_rule,
  /*  487 */  immByteMapBase_rule,
  /*  488 */  immN_rule,
  /*  489 */  immN0_rule,
  /*  490 */  immNKlass_rule,
  /*  491 */  immFPacked_rule,
  /*  492 */  immF_rule,
  /*  493 */  immDPacked_rule,
  /*  494 */  immD_rule,
  /*  495 */  iRegIorL2I_rule,
  /*  496 */  iRegL_rule,
  /*  497 */  iRegIorL2I_rule,
  /*  498 */  iRegL_rule,
  /*  499 */  iRegL_rule,
  /*  500 */  iRegP_rule,
  /*  501 */  iRegPNoSp_rule,
  /*  502 */  iRegPNoSp_rule,
  /*  503 */  iRegI_rule,
  /*  504 */  iRegL_rule,
  /*  505 */  vRegF_rule,
  /*  506 */  vRegD_rule,
  /*  507 */  vReg_rule,
  /*  508 */  pRegGov_rule,
  /*  509 */  iRegIorL2I_rule,
  /*  510 */  iRegL_rule,
  /*  511 */  vRegF_rule,
  /*  512 */  vRegD_rule,
  /*  513 */  vRegF_rule,
  /*  514 */  vRegD_rule,
  /*  515 */  stackSlotF_rule,
  /*  516 */  stackSlotI_rule,
  /*  517 */  stackSlotD_rule,
  /*  518 */  stackSlotL_rule,
  /*  519 */  vRegF_rule,
  /*  520 */  iRegI_rule,
  /*  521 */  vRegD_rule,
  /*  522 */  iRegL_rule,
  /*  523 */  iRegIorL2I_rule,
  /*  524 */  iRegIorL2I_rule,
  /*  525 */  iRegL_rule,
  /*  526 */  iRegL_rule,
  /*  527 */  iRegIorL2I_rule,
  /*  528 */  iRegIorL2I_rule,
  /*  529 */  iRegL_rule,
  /*  530 */  iRegL_rule,
  /*  531 */  immI0_rule,
  /*  532 */  immI0_rule,
  /*  533 */  iRegIorL2I_rule,
  /*  534 */  iRegL_rule,
  /*  535 */  iRegI_rule,
  /*  536 */  iRegI_rule,
  /*  537 */  iRegI_rule,
  /*  538 */  iRegI_rule,
  /*  539 */  iRegI_rule,
  /*  540 */  iRegI_rule,
  /*  541 */  iRegI_rule,
  /*  542 */  iRegI_rule,
  /*  543 */  iRegL_rule,
  /*  544 */  iRegL_rule,
  /*  545 */  iRegL_rule,
  /*  546 */  iRegL_rule,
  /*  547 */  iRegL_rule,
  /*  548 */  iRegL_rule,
  /*  549 */  iRegL_rule,
  /*  550 */  iRegL_rule,
  /*  551 */  iRegP_rule,
  /*  552 */  iRegN_rule,
  /*  553 */  iRegP_rule,
  /*  554 */  iRegN_rule,
  /*  555 */  vRegF_rule,
  /*  556 */  vRegF_rule,
  /*  557 */  vRegD_rule,
  /*  558 */  vRegD_rule,
  /*  559 */  0,
  /*  560 */  _AndL_iRegL_immL_rule,
  /*  561 */  _AndI_iRegIorL2I_immI_rule,
  /*  562 */  _AndL_iRegL_iRegL_rule,
  /*  563 */  _AndI_iRegIorL2I_iRegIorL2I_rule,
  /*  564 */  iRegP_rule,
  /*  565 */  iRegP_rule,
  /*  566 */  _PartialSubtypeCheck_iRegP_R4_iRegP_R0_rule,
  /*  567 */  0,
  /*  568 */  immI0_rule,
  /*  569 */  vReg_rule,
  /*  570 */  vReg_rule,
  /*  571 */  vReg_rule,
  /*  572 */  vReg_rule,
  /*  573 */  vReg_rule,
  /*  574 */  vReg_rule,
  /*  575 */  vReg_rule,
  /*  576 */  vReg_rule,
  /*  577 */  vReg_rule,
  /*  578 */  vReg_rule,
  /*  579 */  vReg_rule,
  /*  580 */  vReg_rule,
  /*  581 */  iRegIorL2I_rule,
  /*  582 */  iRegIorL2I_rule,
  /*  583 */  vReg_rule,
  /*  584 */  vReg_rule,
  /*  585 */  vReg_rule,
  /*  586 */  vReg_rule,
  /*  587 */  vReg_rule,
  /*  588 */  vReg_rule,
  /*  589 */  vReg_rule,
  /*  590 */  vReg_rule,
  /*  591 */  vReg_rule,
  /*  592 */  vReg_rule,
  /*  593 */  vReg_rule,
  /*  594 */  vReg_rule,
  /*  595 */  vReg_rule,
  /*  596 */  iRegIorL2I_rule,
  /*  597 */  iRegIorL2I_rule,
  /*  598 */  iRegIorL2I_rule,
  /*  599 */  iRegL_rule,
  /*  600 */  vRegF_rule,
  /*  601 */  vRegD_rule,
  /*  602 */  immI_rule,
  /*  603 */  immI_rule,
  /*  604 */  immI_rule,
  /*  605 */  immI8_rule,
  /*  606 */  immI8_shift8_rule,
  /*  607 */  immI8_shift8_rule,
  /*  608 */  immL_rule,
  /*  609 */  immL8_shift8_rule,
  /*  610 */  vReg_rule,
  /*  611 */  vReg_rule,
  /*  612 */  vReg_rule,
  /*  613 */  vReg_rule,
  /*  614 */  pReg_rule,
  /*  615 */  pReg_rule,
  /*  616 */  pReg_rule,
  /*  617 */  pReg_rule,
  /*  618 */  vReg_rule,
  /*  619 */  vReg_rule,
  /*  620 */  vReg_rule,
  /*  621 */  vReg_rule,
  /*  622 */  vReg_rule,
  /*  623 */  vReg_rule,
  /*  624 */  pReg_rule,
  /*  625 */  vReg_rule,
  /*  626 */  pReg_rule,
  /*  627 */  vReg_rule,
  /*  628 */  vReg_rule,
  /*  629 */  vReg_rule,
  /*  630 */  vReg_rule,
  /*  631 */  vReg_rule,
  /*  632 */  memory1_rule,
  /*  633 */  _LoadB_memory1__rule,
  /*  634 */  memory1_rule,
  /*  635 */  _LoadUB_memory1__rule,
  /*  636 */  memory2_rule,
  /*  637 */  _LoadS_memory2__rule,
  /*  638 */  memory2_rule,
  /*  639 */  _LoadUS_memory2__rule,
  /*  640 */  memory4_rule,
  /*  641 */  _LoadI_memory4__rule,
  /*  642 */  _ConvI2L__LoadI_memory4___rule,
  /*  643 */  memory8_rule,
  /*  644 */  memory4_rule,
  /*  645 */  memory8_rule,
  /*  646 */  memory4_rule,
  /*  647 */  memory8_rule,
  /*  648 */  memory4_rule,
  /*  649 */  memory4_rule,
  /*  650 */  memory8_rule,
  /*  651 */  memory1_rule,
  /*  652 */  memory1_rule,
  /*  653 */  memory1_rule,
  /*  654 */  memory1_rule,
  /*  655 */  memory2_rule,
  /*  656 */  memory2_rule,
  /*  657 */  memory4_rule,
  /*  658 */  memory4_rule,
  /*  659 */  memory8_rule,
  /*  660 */  memory8_rule,
  /*  661 */  memory8_rule,
  /*  662 */  memory8_rule,
  /*  663 */  memory4_rule,
  /*  664 */  memory4_rule,
  /*  665 */  memory4_rule,
  /*  666 */  memory8_rule,
  /*  667 */  memory4_rule,
  /*  668 */  memory8_rule,
  /*  669 */  indirect_rule,
  /*  670 */  _LoadB_indirect__rule,
  /*  671 */  indirect_rule,
  /*  672 */  _LoadUB_indirect__rule,
  /*  673 */  indirect_rule,
  /*  674 */  indirect_rule,
  /*  675 */  _LoadUS_indirect__rule,
  /*  676 */  _LoadS_indirect__rule,
  /*  677 */  indirect_rule,
  /*  678 */  _ConvI2L__LoadI_indirect___rule,
  /*  679 */  indirect_rule,
  /*  680 */  indirect_rule,
  /*  681 */  indirect_rule,
  /*  682 */  indirect_rule,
  /*  683 */  indirect_rule,
  /*  684 */  indirect_rule,
  /*  685 */  indirect_rule,
  /*  686 */  indirect_rule,
  /*  687 */  indirect_rule,
  /*  688 */  indirect_rule,
  /*  689 */  indirect_rule,
  /*  690 */  indirect_rule,
  /*  691 */  indirect_rule,
  /*  692 */  indirect_rule,
  /*  693 */  indirect_rule,
  /*  694 */  indirect_rule,
  /*  695 */  indirect_rule,
  /*  696 */  indirect_rule,
  /*  697 */  indirect_rule,
  /*  698 */  indirect_rule,
  /*  699 */  0,
  /*  700 */  0,
  /*  701 */  iRegIorL2I_rule,
  /*  702 */  iRegL_rule,
  /*  703 */  iRegIorL2I_rule,
  /*  704 */  iRegIorL2I_rule,
  /*  705 */  iRegIorL2I_rule,
  /*  706 */  _LoadI_memory4__rule,
  /*  707 */  iRegL_rule,
  /*  708 */  _LoadL_memory8__rule,
  /*  709 */  0,
  /*  710 */  0,
  /*  711 */  0,
  /*  712 */  0,
  /*  713 */  0,
  /*  714 */  0,
  /*  715 */  0,
  /*  716 */  0,
  /*  717 */  0,
  /*  718 */  0,
  /*  719 */  0,
  /*  720 */  0,
  /*  721 */  _CastP2X_iRegP__rule,
  /*  722 */  _CastP2X__DecodeN_iRegN___rule,
  /*  723 */  iRegP_rule,
  /*  724 */  iRegP_rule,
  /*  725 */  iRegN_rule,
  /*  726 */  iRegN_rule,
  /*  727 */  iRegP_rule,
  /*  728 */  iRegN_rule,
  /*  729 */  indirect_rule,
  /*  730 */  indirect_rule,
  /*  731 */  indirect_rule,
  /*  732 */  indirect_rule,
  /*  733 */  indirect_rule,
  /*  734 */  indirect_rule,
  /*  735 */  indirect_rule,
  /*  736 */  indirect_rule,
  /*  737 */  indirect_rule,
  /*  738 */  indirect_rule,
  /*  739 */  indirect_rule,
  /*  740 */  indirect_rule,
  /*  741 */  indirect_rule,
  /*  742 */  indirect_rule,
  /*  743 */  indirect_rule,
  /*  744 */  indirect_rule,
  /*  745 */  indirect_rule,
  /*  746 */  indirect_rule,
  /*  747 */  indirect_rule,
  /*  748 */  indirect_rule,
  /*  749 */  indirect_rule,
  /*  750 */  indirect_rule,
  /*  751 */  indirect_rule,
  /*  752 */  indirect_rule,
  /*  753 */  indirect_rule,
  /*  754 */  indirect_rule,
  /*  755 */  indirect_rule,
  /*  756 */  indirect_rule,
  /*  757 */  indirect_rule,
  /*  758 */  indirect_rule,
  /*  759 */  indirect_rule,
  /*  760 */  indirect_rule,
  /*  761 */  indirect_rule,
  /*  762 */  indirect_rule,
  /*  763 */  indirect_rule,
  /*  764 */  indirect_rule,
  /*  765 */  indirect_rule,
  /*  766 */  indirect_rule,
  /*  767 */  indirect_rule,
  /*  768 */  indirect_rule,
  /*  769 */  indirect_rule,
  /*  770 */  indirect_rule,
  /*  771 */  indirect_rule,
  /*  772 */  indirect_rule,
  /*  773 */  indirect_rule,
  /*  774 */  indirect_rule,
  /*  775 */  indirect_rule,
  /*  776 */  indirect_rule,
  /*  777 */  indirect_rule,
  /*  778 */  indirect_rule,
  /*  779 */  indirect_rule,
  /*  780 */  indirect_rule,
  /*  781 */  indirect_rule,
  /*  782 */  indirect_rule,
  /*  783 */  indirect_rule,
  /*  784 */  indirect_rule,
  /*  785 */  indirect_rule,
  /*  786 */  indirect_rule,
  /*  787 */  indirect_rule,
  /*  788 */  indirect_rule,
  /*  789 */  iRegI_rule,
  /*  790 */  iRegI_rule,
  /*  791 */  iRegL_rule,
  /*  792 */  iRegL_rule,
  /*  793 */  iRegL_rule,
  /*  794 */  iRegL_rule,
  /*  795 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  796 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  797 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  798 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  799 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  800 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  801 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  802 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  803 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  804 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  805 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  806 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  807 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  808 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  809 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  810 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  811 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  812 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  813 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  814 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  815 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  816 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  817 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  818 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  819 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  820 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  821 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  822 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  823 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  824 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  825 */  iRegIorL2I_rule,
  /*  826 */  iRegIorL2I_rule,
  /*  827 */  _ConvL2I_iRegL__rule,
  /*  828 */  iRegP_rule,
  /*  829 */  iRegP_rule,
  /*  830 */  iRegP_rule,
  /*  831 */  iRegP_rule,
  /*  832 */  _ConvI2L_iRegIorL2I__rule,
  /*  833 */  iRegP_rule,
  /*  834 */  iRegL_rule,
  /*  835 */  iRegL_rule,
  /*  836 */  iRegIorL2I_rule,
  /*  837 */  iRegIorL2I_rule,
  /*  838 */  iRegL_rule,
  /*  839 */  iRegL_rule,
  /*  840 */  immI0_rule,
  /*  841 */  immL0_rule,
  /*  842 */  iRegIorL2I_rule,
  /*  843 */  _ConvI2L_iRegIorL2I__rule,
  /*  844 */  _ConvI2L_iRegIorL2I__rule,
  /*  845 */  iRegL_rule,
  /*  846 */  iRegL_rule,
  /*  847 */  iRegL_rule,
  /*  848 */  iRegIorL2I_rule,
  /*  849 */  _MulI_iRegIorL2I_iRegIorL2I_rule,
  /*  850 */  iRegIorL2I_rule,
  /*  851 */  _SubI_immI0_iRegIorL2I_rule,
  /*  852 */  iRegIorL2I_rule,
  /*  853 */  iRegL_rule,
  /*  854 */  _MulL_iRegL_iRegL_rule,
  /*  855 */  iRegL_rule,
  /*  856 */  _SubL_immL0_iRegL_rule,
  /*  857 */  iRegL_rule,
  /*  858 */  iRegLNoSp_rule,
  /*  859 */  _MulL__ConvI2L_iRegIorL2I___ConvI2L_iRegIorL2I__rule,
  /*  860 */  iRegLNoSp_rule,
  /*  861 */  _MulL__ConvI2L_iRegIorL2I___ConvI2L_iRegIorL2I__rule,
  /*  862 */  iRegLNoSp_rule,
  /*  863 */  iRegLNoSp_rule,
  /*  864 */  _SubL_immL0__ConvI2L_iRegIorL2I__rule,
  /*  865 */  _ConvI2L_iRegIorL2I__rule,
  /*  866 */  _Binary_iRegIorL2I_iRegIorL2I_rule,
  /*  867 */  iRegIorL2I_rule,
  /*  868 */  iRegL_rule,
  /*  869 */  iRegIorL2I_rule,
  /*  870 */  iRegL_rule,
  /*  871 */  iRegIorL2I_rule,
  /*  872 */  iRegL_rule,
  /*  873 */  iRegIorL2I_rule,
  /*  874 */  iRegL_rule,
  /*  875 */  iRegIorL2I_rule,
  /*  876 */  iRegIorL2I_rule,
  /*  877 */  iRegIorL2I_rule,
  /*  878 */  iRegIorL2I_rule,
  /*  879 */  iRegIorL2I_rule,
  /*  880 */  iRegIorL2I_rule,
  /*  881 */  iRegL_rule,
  /*  882 */  iRegL_rule,
  /*  883 */  iRegL_rule,
  /*  884 */  iRegL_rule,
  /*  885 */  _CastP2X_iRegP__rule,
  /*  886 */  iRegL_rule,
  /*  887 */  iRegL_rule,
  /*  888 */  iRegL_rule,
  /*  889 */  iRegIorL2I_rule,
  /*  890 */  immI0_rule,
  /*  891 */  immI0_rule,
  /*  892 */  immI0_rule,
  /*  893 */  immL0_rule,
  /*  894 */  immL0_rule,
  /*  895 */  immL0_rule,
  /*  896 */  iRegIorL2I_rule,
  /*  897 */  _XorI_iRegIorL2I_immI_M1_rule,
  /*  898 */  iRegL_rule,
  /*  899 */  _XorL_iRegL_immL_M1_rule,
  /*  900 */  iRegIorL2I_rule,
  /*  901 */  _XorI_iRegIorL2I_immI_M1_rule,
  /*  902 */  iRegL_rule,
  /*  903 */  _XorL_iRegL_immL_M1_rule,
  /*  904 */  immI_M1_rule,
  /*  905 */  _XorI_iRegIorL2I_iRegIorL2I_rule,
  /*  906 */  immL_M1_rule,
  /*  907 */  _XorL_iRegL_iRegL_rule,
  /*  908 */  iRegIorL2I_rule,
  /*  909 */  _XorI__URShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  910 */  iRegL_rule,
  /*  911 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  912 */  iRegIorL2I_rule,
  /*  913 */  _XorI__RShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  914 */  iRegL_rule,
  /*  915 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  916 */  iRegIorL2I_rule,
  /*  917 */  _XorI__RotateRight_iRegIorL2I_immI_immI_M1_rule,
  /*  918 */  iRegL_rule,
  /*  919 */  _XorL__RotateRight_iRegL_immI_immL_M1_rule,
  /*  920 */  iRegIorL2I_rule,
  /*  921 */  _XorI__LShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  922 */  iRegL_rule,
  /*  923 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  924 */  immI_M1_rule,
  /*  925 */  _XorI__URShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  926 */  immI_M1_rule,
  /*  927 */  _XorI_iRegIorL2I__URShiftI_iRegIorL2I_immI_rule,
  /*  928 */  immL_M1_rule,
  /*  929 */  _XorL__URShiftL_iRegL_immI_iRegL_rule,
  /*  930 */  immL_M1_rule,
  /*  931 */  _XorL_iRegL__URShiftL_iRegL_immI_rule,
  /*  932 */  immI_M1_rule,
  /*  933 */  _XorI__RShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  934 */  immI_M1_rule,
  /*  935 */  _XorI_iRegIorL2I__RShiftI_iRegIorL2I_immI_rule,
  /*  936 */  immL_M1_rule,
  /*  937 */  _XorL__RShiftL_iRegL_immI_iRegL_rule,
  /*  938 */  immL_M1_rule,
  /*  939 */  _XorL_iRegL__RShiftL_iRegL_immI_rule,
  /*  940 */  immI_M1_rule,
  /*  941 */  _XorI__RotateRight_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  942 */  immI_M1_rule,
  /*  943 */  _XorI_iRegIorL2I__RotateRight_iRegIorL2I_immI_rule,
  /*  944 */  immL_M1_rule,
  /*  945 */  _XorL__RotateRight_iRegL_immI_iRegL_rule,
  /*  946 */  immL_M1_rule,
  /*  947 */  _XorL_iRegL__RotateRight_iRegL_immI_rule,
  /*  948 */  immI_M1_rule,
  /*  949 */  _XorI__LShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  950 */  immI_M1_rule,
  /*  951 */  _XorI_iRegIorL2I__LShiftI_iRegIorL2I_immI_rule,
  /*  952 */  immL_M1_rule,
  /*  953 */  _XorL__LShiftL_iRegL_immI_iRegL_rule,
  /*  954 */  immL_M1_rule,
  /*  955 */  _XorL_iRegL__LShiftL_iRegL_immI_rule,
  /*  956 */  iRegIorL2I_rule,
  /*  957 */  _XorI__URShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  958 */  iRegL_rule,
  /*  959 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  960 */  iRegIorL2I_rule,
  /*  961 */  _XorI__RShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  962 */  iRegL_rule,
  /*  963 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  964 */  iRegIorL2I_rule,
  /*  965 */  _XorI__RotateRight_iRegIorL2I_immI_immI_M1_rule,
  /*  966 */  iRegL_rule,
  /*  967 */  _XorL__RotateRight_iRegL_immI_immL_M1_rule,
  /*  968 */  iRegIorL2I_rule,
  /*  969 */  _XorI__LShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  970 */  iRegL_rule,
  /*  971 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  972 */  iRegIorL2I_rule,
  /*  973 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  974 */  iRegL_rule,
  /*  975 */  _URShiftL_iRegL_immI_rule,
  /*  976 */  iRegIorL2I_rule,
  /*  977 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  978 */  iRegL_rule,
  /*  979 */  _RShiftL_iRegL_immI_rule,
  /*  980 */  iRegIorL2I_rule,
  /*  981 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  982 */  iRegL_rule,
  /*  983 */  _LShiftL_iRegL_immI_rule,
  /*  984 */  iRegIorL2I_rule,
  /*  985 */  _RotateRight_iRegIorL2I_immI_rule,
  /*  986 */  iRegL_rule,
  /*  987 */  _RotateRight_iRegL_immI_rule,
  /*  988 */  iRegIorL2I_rule,
  /*  989 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  990 */  iRegL_rule,
  /*  991 */  _URShiftL_iRegL_immI_rule,
  /*  992 */  iRegIorL2I_rule,
  /*  993 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  994 */  iRegL_rule,
  /*  995 */  _RShiftL_iRegL_immI_rule,
  /*  996 */  iRegIorL2I_rule,
  /*  997 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  998 */  iRegL_rule,
  /*  999 */  _LShiftL_iRegL_immI_rule,
  /* 1000 */  iRegIorL2I_rule,
  /* 1001 */  _RotateRight_iRegIorL2I_immI_rule,
  /* 1002 */  iRegL_rule,
  /* 1003 */  _RotateRight_iRegL_immI_rule,
  /* 1004 */  iRegIorL2I_rule,
  /* 1005 */  _URShiftI_iRegIorL2I_immI_rule,
  /* 1006 */  iRegL_rule,
  /* 1007 */  _URShiftL_iRegL_immI_rule,
  /* 1008 */  iRegIorL2I_rule,
  /* 1009 */  _RShiftI_iRegIorL2I_immI_rule,
  /* 1010 */  iRegL_rule,
  /* 1011 */  _RShiftL_iRegL_immI_rule,
  /* 1012 */  iRegIorL2I_rule,
  /* 1013 */  _LShiftI_iRegIorL2I_immI_rule,
  /* 1014 */  iRegL_rule,
  /* 1015 */  _LShiftL_iRegL_immI_rule,
  /* 1016 */  iRegIorL2I_rule,
  /* 1017 */  _RotateRight_iRegIorL2I_immI_rule,
  /* 1018 */  iRegL_rule,
  /* 1019 */  _RotateRight_iRegL_immI_rule,
  /* 1020 */  iRegIorL2I_rule,
  /* 1021 */  _URShiftI_iRegIorL2I_immI_rule,
  /* 1022 */  iRegL_rule,
  /* 1023 */  _URShiftL_iRegL_immI_rule,
  /* 1024 */  iRegIorL2I_rule,
  /* 1025 */  _RShiftI_iRegIorL2I_immI_rule,
  /* 1026 */  iRegL_rule,
  /* 1027 */  _RShiftL_iRegL_immI_rule,
  /* 1028 */  iRegIorL2I_rule,
  /* 1029 */  _LShiftI_iRegIorL2I_immI_rule,
  /* 1030 */  iRegL_rule,
  /* 1031 */  _LShiftL_iRegL_immI_rule,
  /* 1032 */  iRegIorL2I_rule,
  /* 1033 */  iRegL_rule,
  /* 1034 */  iRegIorL2I_rule,
  /* 1035 */  iRegL_rule,
  /* 1036 */  iRegIorL2I_rule,
  /* 1037 */  iRegL_rule,
  /* 1038 */  _LShiftL_iRegL_immI_rule,
  /* 1039 */  _LShiftI_iRegIorL2I_immI_rule,
  /* 1040 */  _LShiftL_iRegL_immI_rule,
  /* 1041 */  _LShiftI_iRegIorL2I_immI_rule,
  /* 1042 */  _URShiftI_iRegIorL2I_immI_rule,
  /* 1043 */  _URShiftL_iRegL_immI_rule,
  /* 1044 */  _AndI__URShiftI_iRegIorL2I_immI_immI_bitmask_rule,
  /* 1045 */  _AndI_iRegIorL2I_immI_bitmask_rule,
  /* 1046 */  _AndL_iRegL_immL_bitmask_rule,
  /* 1047 */  _LShiftI__AndI_iRegIorL2I_immI_bitmask_immI_rule,
  /* 1048 */  _LShiftL__AndL_iRegL_immL_positive_bitmaskI_immI_rule,
  /* 1049 */  _ConvI2L__AndI_iRegIorL2I_immI_bitmask__rule,
  /* 1050 */  _ConvL2I__AndL_iRegL_immL_positive_bitmaskI__rule,
  /* 1051 */  _AndI_iRegI_immI_bitmask_rule,
  /* 1052 */  _LShiftL_iRegL_immI_rule,
  /* 1053 */  _URShiftL_iRegL_immI_rule,
  /* 1054 */  _LShiftI_iRegIorL2I_immI_rule,
  /* 1055 */  _URShiftI_iRegIorL2I_immI_rule,
  /* 1056 */  _LShiftL_iRegL_immI_rule,
  /* 1057 */  _URShiftL_iRegL_immI_rule,
  /* 1058 */  _LShiftI_iRegIorL2I_immI_rule,
  /* 1059 */  _URShiftI_iRegIorL2I_immI_rule,
  /* 1060 */  iRegI_rule,
  /* 1061 */  iRegL_rule,
  /* 1062 */  iRegI_rule,
  /* 1063 */  iRegL_rule,
  /* 1064 */  iRegI_rule,
  /* 1065 */  iRegL_rule,
  /* 1066 */  iRegL_rule,
  /* 1067 */  _ConvI2L_iRegIorL2I__rule,
  /* 1068 */  iRegL_rule,
  /* 1069 */  iRegIorL2I_rule,
  /* 1070 */  _RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_rule,
  /* 1071 */  iRegIorL2I_rule,
  /* 1072 */  _RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /* 1073 */  iRegIorL2I_rule,
  /* 1074 */  _URShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /* 1075 */  iRegL_rule,
  /* 1076 */  _RShiftL__LShiftL_iRegL_immI_48_immI_48_rule,
  /* 1077 */  iRegL_rule,
  /* 1078 */  _RShiftL__LShiftL_iRegL_immI_32_immI_32_rule,
  /* 1079 */  iRegL_rule,
  /* 1080 */  _RShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /* 1081 */  iRegL_rule,
  /* 1082 */  _URShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /* 1083 */  iRegIorL2I_rule,
  /* 1084 */  _AndI_iRegIorL2I_immI_255_rule,
  /* 1085 */  iRegIorL2I_rule,
  /* 1086 */  _AndI_iRegIorL2I_immI_65535_rule,
  /* 1087 */  iRegL_rule,
  /* 1088 */  _AndL_iRegL_immL_255_rule,
  /* 1089 */  iRegL_rule,
  /* 1090 */  _AndL_iRegL_immL_65535_rule,
  /* 1091 */  iRegL_rule,
  /* 1092 */  _AndL_iRegL_immL_4294967295_rule,
  /* 1093 */  iRegIorL2I_rule,
  /* 1094 */  iRegIorL2I_rule,
  /* 1095 */  iRegL_rule,
  /* 1096 */  iRegL_rule,
  /* 1097 */  iRegL_rule,
  /* 1098 */  iRegL_rule,
  /* 1099 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_56_immI_56_immIExt_rule,
  /* 1100 */  iRegL_rule,
  /* 1101 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_48_immI_48_immIExt_rule,
  /* 1102 */  iRegL_rule,
  /* 1103 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_32_immI_32_immIExt_rule,
  /* 1104 */  iRegL_rule,
  /* 1105 */  iRegL_rule,
  /* 1106 */  iRegL_rule,
  /* 1107 */  iRegIorL2I_rule,
  /* 1108 */  _LShiftI__RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_immIExt_rule,
  /* 1109 */  iRegIorL2I_rule,
  /* 1110 */  _LShiftI__RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_immIExt_rule,
  /* 1111 */  iRegIorL2I_rule,
  /* 1112 */  iRegIorL2I_rule,
  /* 1113 */  iRegL_rule,
  /* 1114 */  _LShiftL__ConvI2L_iRegIorL2I__immIExt_rule,
  /* 1115 */  iRegL_rule,
  /* 1116 */  iRegL_rule,
  /* 1117 */  _LShiftL__AndL_iRegL_immL_255_immIExt_rule,
  /* 1118 */  iRegL_rule,
  /* 1119 */  _LShiftL__AndL_iRegL_immL_65535_immIExt_rule,
  /* 1120 */  iRegL_rule,
  /* 1121 */  _LShiftL__AndL_iRegL_immL_4294967295_immIExt_rule,
  /* 1122 */  iRegL_rule,
  /* 1123 */  iRegL_rule,
  /* 1124 */  iRegL_rule,
  /* 1125 */  iRegIorL2I_rule,
  /* 1126 */  _LShiftI__AndI_iRegIorL2I_immI_255_immIExt_rule,
  /* 1127 */  iRegIorL2I_rule,
  /* 1128 */  _LShiftI__AndI_iRegIorL2I_immI_65535_immIExt_rule,
  /* 1129 */  iRegIorL2I_rule,
  /* 1130 */  iRegIorL2I_rule,
  /* 1131 */  0,
  /* 1132 */  0,
  /* 1133 */  0,
  /* 1134 */  0,
  /* 1135 */  0,
  /* 1136 */  0,
  /* 1137 */  0,
  /* 1138 */  0,
  /* 1139 */  iRegIorL2I_rule,
  /* 1140 */  immI0_rule,
  /* 1141 */  iRegIorL2I_rule,
  /* 1142 */  immI_1_rule,
  /* 1143 */  iRegIorL2I_rule,
  /* 1144 */  immI_M1_rule,
  /* 1145 */  iRegIorL2I_rule,
  /* 1146 */  immI0_rule,
  /* 1147 */  iRegIorL2I_rule,
  /* 1148 */  immI_1_rule,
  /* 1149 */  iRegIorL2I_rule,
  /* 1150 */  immI_M1_rule,
  /* 1151 */  vRegF_rule,
  /* 1152 */  vRegD_rule,
  /* 1153 */  vRegF_rule,
  /* 1154 */  vRegD_rule,
  /* 1155 */  vRegF_rule,
  /* 1156 */  vRegD_rule,
  /* 1157 */  vRegF_rule,
  /* 1158 */  vRegD_rule,
  /* 1159 */  vRegF_rule,
  /* 1160 */  vRegF_rule,
  /* 1161 */  vRegD_rule,
  /* 1162 */  vRegD_rule,
  /* 1163 */  _NegF_vRegF__rule,
  /* 1164 */  _NegF_vRegF__rule,
  /* 1165 */  _NegD_vRegD__rule,
  /* 1166 */  _NegD_vRegD__rule,
  /* 1167 */  _NegF_vRegF__rule,
  /* 1168 */  _NegD_vRegD__rule,
  /* 1169 */  vRegF_rule,
  /* 1170 */  vRegF_rule,
  /* 1171 */  vRegD_rule,
  /* 1172 */  vRegD_rule,
  /* 1173 */  vRegF_rule,
  /* 1174 */  vRegD_rule,
  /* 1175 */  iRegIorL2I_rule,
  /* 1176 */  iRegL_rule,
  /* 1177 */  _SubF_vRegF_vRegF_rule,
  /* 1178 */  _SubD_vRegD_vRegD_rule,
  /* 1179 */  vRegD_rule,
  /* 1180 */  vRegF_rule,
  /* 1181 */  vRegD_rule,
  /* 1182 */  vRegD_rule,
  /* 1183 */  vRegF_rule,
  /* 1184 */  vRegD_rule,
  /* 1185 */  vRegF_rule,
  /* 1186 */  0,
  /* 1187 */  iRegIorL2I_rule,
  /* 1188 */  iRegIorL2I_rule,
  /* 1189 */  iRegIorL2I_rule,
  /* 1190 */  iRegIorL2I_rule,
  /* 1191 */  iRegIorL2I_rule,
  /* 1192 */  iRegIorL2I_rule,
  /* 1193 */  iRegL_rule,
  /* 1194 */  iRegL_rule,
  /* 1195 */  iRegL_rule,
  /* 1196 */  iRegL_rule,
  /* 1197 */  iRegL_rule,
  /* 1198 */  iRegL_rule,
  /* 1199 */  iRegIorL2I_rule,
  /* 1200 */  _ConvI2L_iRegIorL2I__rule,
  /* 1201 */  iRegL_rule,
  /* 1202 */  vRegD_rule,
  /* 1203 */  vRegF_rule,
  /* 1204 */  vRegF_rule,
  /* 1205 */  vRegF_rule,
  /* 1206 */  vRegF_rule,
  /* 1207 */  iRegINoSp_rule,
  /* 1208 */  iRegIorL2I_rule,
  /* 1209 */  iRegL_rule,
  /* 1210 */  vRegD_rule,
  /* 1211 */  vRegD_rule,
  /* 1212 */  iRegIorL2I_rule,
  /* 1213 */  iRegL_rule,
  /* 1214 */  vRegD_rule,
  /* 1215 */  vRegF_rule,
  /* 1216 */  vRegF_rule,
  /* 1217 */  iRegI_rule,
  /* 1218 */  vRegD_rule,
  /* 1219 */  iRegL_rule,
  /* 1220 */  iRegL_R11_rule,
  /* 1221 */  immL_rule,
  /* 1222 */  cmpOp_rule,
  /* 1223 */  cmpOp_rule,
  /* 1224 */  vRegF_rule,
  /* 1225 */  vRegD_rule,
  /* 1226 */  vRegF_rule,
  /* 1227 */  vRegD_rule,
  /* 1228 */  iRegIorL2I_rule,
  /* 1229 */  iRegIorL2I_rule,
  /* 1230 */  iRegIorL2I_rule,
  /* 1231 */  iRegIorL2I_rule,
  /* 1232 */  0,
  /* 1233 */  cmpOp_rule,
  /* 1234 */  cmpOpU_rule,
  /* 1235 */  cmpOpEqNe_rule,
  /* 1236 */  cmpOpEqNe_rule,
  /* 1237 */  cmpOpEqNe_rule,
  /* 1238 */  cmpOpEqNe_rule,
  /* 1239 */  cmpOpEqNe_rule,
  /* 1240 */  cmpOpUEqNeLtGe_rule,
  /* 1241 */  cmpOpUEqNeLtGe_rule,
  /* 1242 */  cmpOpLtGe_rule,
  /* 1243 */  cmpOpLtGe_rule,
  /* 1244 */  cmpOpEqNe_rule,
  /* 1245 */  cmpOpEqNe_rule,
  /* 1246 */  cmpOpLtGe_rule,
  /* 1247 */  cmpOpLtGe_rule,
  /* 1248 */  cmpOpEqNe_rule,
  /* 1249 */  cmpOpEqNe_rule,
  /* 1250 */  cmpOp_rule,
  /* 1251 */  iRegP_rule,
  /* 1252 */  0,
  /* 1253 */  0,
  /* 1254 */  0,
  /* 1255 */  0,
  /* 1256 */  0,
  /* 1257 */  iRegPNoSpNoRfp_rule,
  /* 1258 */  iRegPNoSpNoRfp_rule,
  /* 1259 */  0,
  /* 1260 */  0,
  /* 1261 */  0,
  /* 1262 */  0,
  /* 1263 */  iRegP_R4_rule,
  /* 1264 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1265 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1266 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1267 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1268 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1269 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1270 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1271 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1272 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /* 1273 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /* 1274 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /* 1275 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /* 1276 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /* 1277 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /* 1278 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1279 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1280 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1281 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1282 */  _Binary_iRegP_R1_iRegP_R3_rule,
  /* 1283 */  _Binary_iRegP_R1_iRegP_R3_rule,
  /* 1284 */  iRegP_R1_rule,
  /* 1285 */  iRegP_R1_rule,
  /* 1286 */  iRegP_R1_rule,
  /* 1287 */  iRegP_R2_rule,
  /* 1288 */  iRegP_R0_rule,
  /* 1289 */  iRegP_R2_rule,
  /* 1290 */  iRegP_R2_rule,
  /* 1291 */  iRegIorL2I_rule,
  /* 1292 */  _LoadI_memory4__rule,
  /* 1293 */  iRegL_rule,
  /* 1294 */  _LoadL_memory8__rule,
  /* 1295 */  iRegIorL2I_rule,
  /* 1296 */  _LoadI_memory4__rule,
  /* 1297 */  iRegL_rule,
  /* 1298 */  _LoadL_memory8__rule,
  /* 1299 */  vmem2_rule,
  /* 1300 */  vmem2_rule,
  /* 1301 */  vmem4_rule,
  /* 1302 */  vmem4_rule,
  /* 1303 */  vmem8_rule,
  /* 1304 */  vmem8_rule,
  /* 1305 */  vmem16_rule,
  /* 1306 */  vmem16_rule,
  /* 1307 */  vmemA_rule,
  /* 1308 */  vmemA_rule,
  /* 1309 */  vmemA_rule,
  /* 1310 */  vmemA_rule,
  /* 1311 */  vReg_rule,
  /* 1312 */  vReg_rule,
  /* 1313 */  vReg_rule,
  /* 1314 */  vReg_rule,
  /* 1315 */  vReg_rule,
  /* 1316 */  vReg_rule,
  /* 1317 */  _Binary_vReg_vReg_rule,
  /* 1318 */  _Binary_vReg_vReg_rule,
  /* 1319 */  _Binary_vReg_vReg_rule,
  /* 1320 */  _Binary_vReg_vReg_rule,
  /* 1321 */  _Binary_vReg_vReg_rule,
  /* 1322 */  _Binary_vReg_vReg_rule,
  /* 1323 */  vReg_rule,
  /* 1324 */  _ReplicateB_immBAddSubV__rule,
  /* 1325 */  vReg_rule,
  /* 1326 */  _ReplicateS_immIAddSubV__rule,
  /* 1327 */  vReg_rule,
  /* 1328 */  _ReplicateI_immIAddSubV__rule,
  /* 1329 */  vReg_rule,
  /* 1330 */  _ReplicateL_immLAddSubV__rule,
  /* 1331 */  vReg_rule,
  /* 1332 */  vReg_rule,
  /* 1333 */  vReg_rule,
  /* 1334 */  vReg_rule,
  /* 1335 */  vReg_rule,
  /* 1336 */  vReg_rule,
  /* 1337 */  _Binary_vReg_vReg_rule,
  /* 1338 */  _Binary_vReg_vReg_rule,
  /* 1339 */  _Binary_vReg_vReg_rule,
  /* 1340 */  _Binary_vReg_vReg_rule,
  /* 1341 */  _Binary_vReg_vReg_rule,
  /* 1342 */  _Binary_vReg_vReg_rule,
  /* 1343 */  vReg_rule,
  /* 1344 */  vReg_rule,
  /* 1345 */  vReg_rule,
  /* 1346 */  vReg_rule,
  /* 1347 */  vReg_rule,
  /* 1348 */  vReg_rule,
  /* 1349 */  vReg_rule,
  /* 1350 */  vReg_rule,
  /* 1351 */  vReg_rule,
  /* 1352 */  vReg_rule,
  /* 1353 */  _Binary_vReg_vReg_rule,
  /* 1354 */  _Binary_vReg_vReg_rule,
  /* 1355 */  _Binary_vReg_vReg_rule,
  /* 1356 */  _Binary_vReg_vReg_rule,
  /* 1357 */  _Binary_vReg_vReg_rule,
  /* 1358 */  _Binary_vReg_vReg_rule,
  /* 1359 */  vReg_rule,
  /* 1360 */  vReg_rule,
  /* 1361 */  vReg_rule,
  /* 1362 */  vReg_rule,
  /* 1363 */  _Binary_vReg_vReg_rule,
  /* 1364 */  _Binary_vReg_vReg_rule,
  /* 1365 */  vReg_rule,
  /* 1366 */  _Binary_vReg_vReg_rule,
  /* 1367 */  vReg_rule,
  /* 1368 */  _ReplicateB_immBLog__rule,
  /* 1369 */  vReg_rule,
  /* 1370 */  _ReplicateS_immSLog__rule,
  /* 1371 */  vReg_rule,
  /* 1372 */  _ReplicateI_immILog__rule,
  /* 1373 */  vReg_rule,
  /* 1374 */  _ReplicateL_immLLog__rule,
  /* 1375 */  vReg_rule,
  /* 1376 */  _Binary_vReg_vReg_rule,
  /* 1377 */  vReg_rule,
  /* 1378 */  _ReplicateB_immBLog__rule,
  /* 1379 */  vReg_rule,
  /* 1380 */  _ReplicateS_immSLog__rule,
  /* 1381 */  vReg_rule,
  /* 1382 */  _ReplicateI_immILog__rule,
  /* 1383 */  vReg_rule,
  /* 1384 */  _ReplicateL_immLLog__rule,
  /* 1385 */  vReg_rule,
  /* 1386 */  _Binary_vReg_vReg_rule,
  /* 1387 */  vReg_rule,
  /* 1388 */  _ReplicateB_immBLog__rule,
  /* 1389 */  vReg_rule,
  /* 1390 */  _ReplicateS_immSLog__rule,
  /* 1391 */  vReg_rule,
  /* 1392 */  _ReplicateI_immILog__rule,
  /* 1393 */  vReg_rule,
  /* 1394 */  _ReplicateL_immLLog__rule,
  /* 1395 */  vReg_rule,
  /* 1396 */  _XorV_vReg_vReg_rule,
  /* 1397 */  vReg_rule,
  /* 1398 */  _XorV_vReg_vReg_rule,
  /* 1399 */  vReg_rule,
  /* 1400 */  _ReplicateB_immI_M1__rule,
  /* 1401 */  vReg_rule,
  /* 1402 */  _ReplicateS_immI_M1__rule,
  /* 1403 */  vReg_rule,
  /* 1404 */  _ReplicateI_immI_M1__rule,
  /* 1405 */  vReg_rule,
  /* 1406 */  _ReplicateL_immL_M1__rule,
  /* 1407 */  _Binary_vReg__ReplicateB_immI_M1__rule,
  /* 1408 */  _Binary_vReg__ReplicateS_immI_M1__rule,
  /* 1409 */  _Binary_vReg__ReplicateI_immI_M1__rule,
  /* 1410 */  _Binary_vReg__ReplicateL_immL_M1__rule,
  /* 1411 */  vReg_rule,
  /* 1412 */  _XorV_vReg__ReplicateB_immI_M1__rule,
  /* 1413 */  vReg_rule,
  /* 1414 */  _XorV__ReplicateB_immI_M1__vReg_rule,
  /* 1415 */  vReg_rule,
  /* 1416 */  _XorV_vReg__ReplicateS_immI_M1__rule,
  /* 1417 */  vReg_rule,
  /* 1418 */  _XorV__ReplicateS_immI_M1__vReg_rule,
  /* 1419 */  vReg_rule,
  /* 1420 */  _XorV_vReg__ReplicateI_immI_M1__rule,
  /* 1421 */  vReg_rule,
  /* 1422 */  _XorV__ReplicateI_immI_M1__vReg_rule,
  /* 1423 */  vReg_rule,
  /* 1424 */  _XorV_vReg__ReplicateL_immL_M1__rule,
  /* 1425 */  vReg_rule,
  /* 1426 */  _XorV__ReplicateL_immL_M1__vReg_rule,
  /* 1427 */  _Binary_vReg__XorV_vReg__ReplicateB_immI_M1__rule,
  /* 1428 */  _Binary_vReg__XorV__ReplicateB_immI_M1__vReg_rule,
  /* 1429 */  _Binary_vReg__XorV_vReg__ReplicateS_immI_M1__rule,
  /* 1430 */  _Binary_vReg__XorV__ReplicateS_immI_M1__vReg_rule,
  /* 1431 */  _Binary_vReg__XorV_vReg__ReplicateI_immI_M1__rule,
  /* 1432 */  _Binary_vReg__XorV__ReplicateI_immI_M1__vReg_rule,
  /* 1433 */  _Binary_vReg__XorV_vReg__ReplicateL_immL_M1__rule,
  /* 1434 */  _Binary_vReg__XorV__ReplicateL_immL_M1__vReg_rule,
  /* 1435 */  vReg_rule,
  /* 1436 */  vReg_rule,
  /* 1437 */  vReg_rule,
  /* 1438 */  vReg_rule,
  /* 1439 */  vReg_rule,
  /* 1440 */  vReg_rule,
  /* 1441 */  _SubVF_vReg_vReg_rule,
  /* 1442 */  _SubVD_vReg_vReg_rule,
  /* 1443 */  _SubVF_vReg_vReg_rule,
  /* 1444 */  _SubVD_vReg_vReg_rule,
  /* 1445 */  _SubVF__Binary_vReg_vReg_pRegGov_rule,
  /* 1446 */  _SubVD__Binary_vReg_vReg_pRegGov_rule,
  /* 1447 */  vReg_rule,
  /* 1448 */  vReg_rule,
  /* 1449 */  vReg_rule,
  /* 1450 */  vReg_rule,
  /* 1451 */  vReg_rule,
  /* 1452 */  vReg_rule,
  /* 1453 */  vReg_rule,
  /* 1454 */  vReg_rule,
  /* 1455 */  vReg_rule,
  /* 1456 */  vReg_rule,
  /* 1457 */  _Binary_vReg_vReg_rule,
  /* 1458 */  vReg_rule,
  /* 1459 */  vReg_rule,
  /* 1460 */  vReg_rule,
  /* 1461 */  vReg_rule,
  /* 1462 */  _Binary_vReg_vReg_rule,
  /* 1463 */  vReg_rule,
  /* 1464 */  _MulVB_vReg_vReg_rule,
  /* 1465 */  vReg_rule,
  /* 1466 */  _MulVS_vReg_vReg_rule,
  /* 1467 */  vReg_rule,
  /* 1468 */  _MulVI_vReg_vReg_rule,
  /* 1469 */  vReg_rule,
  /* 1470 */  _MulVL_vReg_vReg_rule,
  /* 1471 */  _Binary_vReg__MulVB_vReg_vReg_rule,
  /* 1472 */  _Binary_vReg__MulVS_vReg_vReg_rule,
  /* 1473 */  _Binary_vReg__MulVI_vReg_vReg_rule,
  /* 1474 */  _Binary_vReg__MulVL_vReg_vReg_rule,
  /* 1475 */  vReg_rule,
  /* 1476 */  vReg_rule,
  /* 1477 */  _Binary_vReg_vReg_rule,
  /* 1478 */  _Binary_vReg_vReg_rule,
  /* 1479 */  vReg_rule,
  /* 1480 */  vReg_rule,
  /* 1481 */  vReg_rule,
  /* 1482 */  vReg_rule,
  /* 1483 */  _Binary_vReg__MulVB_vReg_vReg_rule,
  /* 1484 */  _Binary_vReg__MulVS_vReg_vReg_rule,
  /* 1485 */  _Binary_vReg__MulVI_vReg_vReg_rule,
  /* 1486 */  _Binary_vReg__MulVL_vReg_vReg_rule,
  /* 1487 */  vReg_rule,
  /* 1488 */  vReg_rule,
  /* 1489 */  vReg_rule,
  /* 1490 */  vReg_rule,
  /* 1491 */  _Binary_vReg__NegVF_vReg__rule,
  /* 1492 */  _Binary_vReg__NegVD_vReg__rule,
  /* 1493 */  _NegVF_vReg__rule,
  /* 1494 */  _NegVD_vReg__rule,
  /* 1495 */  _NegVF_vReg__rule,
  /* 1496 */  _NegVD_vReg__rule,
  /* 1497 */  _Binary_vReg__NegVF_vReg__rule,
  /* 1498 */  _Binary_vReg__NegVD_vReg__rule,
  /* 1499 */  _NegVF_vReg__rule,
  /* 1500 */  _NegVD_vReg__rule,
  /* 1501 */  _Binary_vReg_vReg_rule,
  /* 1502 */  _Binary_vReg_vReg_rule,
  /* 1503 */  vReg_rule,
  /* 1504 */  vReg_rule,
  /* 1505 */  vReg_rule,
  /* 1506 */  vReg_rule,
  /* 1507 */  vReg_rule,
  /* 1508 */  vReg_rule,
  /* 1509 */  vReg_rule,
  /* 1510 */  vReg_rule,
  /* 1511 */  vReg_rule,
  /* 1512 */  vReg_rule,
  /* 1513 */  vReg_rule,
  /* 1514 */  vReg_rule,
  /* 1515 */  vReg_rule,
  /* 1516 */  vReg_rule,
  /* 1517 */  vReg_rule,
  /* 1518 */  vReg_rule,
  /* 1519 */  vReg_rule,
  /* 1520 */  vReg_rule,
  /* 1521 */  vReg_rule,
  /* 1522 */  vReg_rule,
  /* 1523 */  vReg_rule,
  /* 1524 */  vReg_rule,
  /* 1525 */  vReg_rule,
  /* 1526 */  vReg_rule,
  /* 1527 */  vReg_rule,
  /* 1528 */  vReg_rule,
  /* 1529 */  vReg_rule,
  /* 1530 */  vReg_rule,
  /* 1531 */  vReg_rule,
  /* 1532 */  vReg_rule,
  /* 1533 */  vReg_rule,
  /* 1534 */  vReg_rule,
  /* 1535 */  vReg_rule,
  /* 1536 */  vReg_rule,
  /* 1537 */  vReg_rule,
  /* 1538 */  vReg_rule,
  /* 1539 */  vReg_rule,
  /* 1540 */  vReg_rule,
  /* 1541 */  vReg_rule,
  /* 1542 */  vReg_rule,
  /* 1543 */  vReg_rule,
  /* 1544 */  vReg_rule,
  /* 1545 */  vReg_rule,
  /* 1546 */  vReg_rule,
  /* 1547 */  vReg_rule,
  /* 1548 */  vReg_rule,
  /* 1549 */  _RShiftVB_vReg__RShiftCntV_immI_positive__rule,
  /* 1550 */  vReg_rule,
  /* 1551 */  _RShiftVS_vReg__RShiftCntV_immI_positive__rule,
  /* 1552 */  vReg_rule,
  /* 1553 */  _RShiftVI_vReg__RShiftCntV_immI_positive__rule,
  /* 1554 */  vReg_rule,
  /* 1555 */  _RShiftVL_vReg__RShiftCntV_immI_positive__rule,
  /* 1556 */  vReg_rule,
  /* 1557 */  _URShiftVB_vReg__RShiftCntV_immI_positive__rule,
  /* 1558 */  vReg_rule,
  /* 1559 */  _URShiftVS_vReg__RShiftCntV_immI_positive__rule,
  /* 1560 */  vReg_rule,
  /* 1561 */  _URShiftVI_vReg__RShiftCntV_immI_positive__rule,
  /* 1562 */  vReg_rule,
  /* 1563 */  _URShiftVL_vReg__RShiftCntV_immI_positive__rule,
  /* 1564 */  _Binary_vReg_vReg_rule,
  /* 1565 */  _Binary_vReg_vReg_rule,
  /* 1566 */  _Binary_vReg_vReg_rule,
  /* 1567 */  _Binary_vReg_vReg_rule,
  /* 1568 */  _Binary_vReg_vReg_rule,
  /* 1569 */  _Binary_vReg_vReg_rule,
  /* 1570 */  _Binary_vReg_vReg_rule,
  /* 1571 */  _Binary_vReg_vReg_rule,
  /* 1572 */  _Binary_vReg_vReg_rule,
  /* 1573 */  _Binary_vReg_vReg_rule,
  /* 1574 */  _Binary_vReg_vReg_rule,
  /* 1575 */  _Binary_vReg_vReg_rule,
  /* 1576 */  _Binary_vReg__LShiftCntV_immI__rule,
  /* 1577 */  _Binary_vReg__LShiftCntV_immI__rule,
  /* 1578 */  _Binary_vReg__LShiftCntV_immI__rule,
  /* 1579 */  _Binary_vReg__LShiftCntV_immI__rule,
  /* 1580 */  _Binary_vReg__RShiftCntV_immI_positive__rule,
  /* 1581 */  _Binary_vReg__RShiftCntV_immI_positive__rule,
  /* 1582 */  _Binary_vReg__RShiftCntV_immI_positive__rule,
  /* 1583 */  _Binary_vReg__RShiftCntV_immI_positive__rule,
  /* 1584 */  _Binary_vReg__RShiftCntV_immI_positive__rule,
  /* 1585 */  _Binary_vReg__RShiftCntV_immI_positive__rule,
  /* 1586 */  _Binary_vReg__RShiftCntV_immI_positive__rule,
  /* 1587 */  _Binary_vReg__RShiftCntV_immI_positive__rule,
  /* 1588 */  iRegIorL2I_rule,
  /* 1589 */  iRegIorL2I_rule,
  /* 1590 */  iRegL_rule,
  /* 1591 */  iRegL_rule,
  /* 1592 */  vRegF_rule,
  /* 1593 */  vRegF_rule,
  /* 1594 */  vRegF_rule,
  /* 1595 */  vRegD_rule,
  /* 1596 */  vRegD_rule,
  /* 1597 */  _Binary_iRegIorL2I_vReg_rule,
  /* 1598 */  _Binary_iRegL_vReg_rule,
  /* 1599 */  _Binary_vRegF_vReg_rule,
  /* 1600 */  _Binary_vRegD_vReg_rule,
  /* 1601 */  iRegIorL2I_rule,
  /* 1602 */  iRegL_rule,
  /* 1603 */  vRegF_rule,
  /* 1604 */  vRegD_rule,
  /* 1605 */  iRegIorL2I_rule,
  /* 1606 */  iRegIorL2I_rule,
  /* 1607 */  iRegL_rule,
  /* 1608 */  iRegL_rule,
  /* 1609 */  _Binary_iRegIorL2I_vReg_rule,
  /* 1610 */  _Binary_iRegL_vReg_rule,
  /* 1611 */  iRegIorL2I_rule,
  /* 1612 */  iRegIorL2I_rule,
  /* 1613 */  iRegL_rule,
  /* 1614 */  iRegL_rule,
  /* 1615 */  _Binary_iRegIorL2I_vReg_rule,
  /* 1616 */  _Binary_iRegL_vReg_rule,
  /* 1617 */  iRegIorL2I_rule,
  /* 1618 */  iRegIorL2I_rule,
  /* 1619 */  iRegL_rule,
  /* 1620 */  iRegL_rule,
  /* 1621 */  _Binary_iRegIorL2I_vReg_rule,
  /* 1622 */  _Binary_iRegL_vReg_rule,
  /* 1623 */  iRegIorL2I_rule,
  /* 1624 */  iRegIorL2I_rule,
  /* 1625 */  iRegL_rule,
  /* 1626 */  iRegL_rule,
  /* 1627 */  vRegF_rule,
  /* 1628 */  vRegD_rule,
  /* 1629 */  _Binary_iRegIorL2I_vReg_rule,
  /* 1630 */  _Binary_iRegL_vReg_rule,
  /* 1631 */  _Binary_vRegF_vReg_rule,
  /* 1632 */  _Binary_vRegD_vReg_rule,
  /* 1633 */  iRegIorL2I_rule,
  /* 1634 */  iRegIorL2I_rule,
  /* 1635 */  iRegL_rule,
  /* 1636 */  iRegL_rule,
  /* 1637 */  vRegF_rule,
  /* 1638 */  vRegD_rule,
  /* 1639 */  _Binary_iRegIorL2I_vReg_rule,
  /* 1640 */  _Binary_iRegL_vReg_rule,
  /* 1641 */  _Binary_vRegF_vReg_rule,
  /* 1642 */  _Binary_vRegD_vReg_rule,
  /* 1643 */  vReg_rule,
  /* 1644 */  vReg_rule,
  /* 1645 */  vReg_rule,
  /* 1646 */  vReg_rule,
  /* 1647 */  vReg_rule,
  /* 1648 */  vReg_rule,
  /* 1649 */  vReg_rule,
  /* 1650 */  vReg_rule,
  /* 1651 */  vReg_rule,
  /* 1652 */  vReg_rule,
  /* 1653 */  vReg_rule,
  /* 1654 */  vReg_rule,
  /* 1655 */  vReg_rule,
  /* 1656 */  _Binary_vReg_iRegIorL2I_rule,
  /* 1657 */  _Binary_vReg_iRegIorL2I_rule,
  /* 1658 */  _Binary_vReg_iRegIorL2I_rule,
  /* 1659 */  _Binary_vReg_iRegL_rule,
  /* 1660 */  _Binary_vReg_iRegL_rule,
  /* 1661 */  _Binary_vReg_vRegF_rule,
  /* 1662 */  _Binary_vReg_vRegF_rule,
  /* 1663 */  _Binary_vReg_vRegF_rule,
  /* 1664 */  _Binary_vReg_vRegD_rule,
  /* 1665 */  _Binary_vReg_vRegD_rule,
  /* 1666 */  vReg_rule,
  /* 1667 */  vReg_rule,
  /* 1668 */  vReg_rule,
  /* 1669 */  vReg_rule,
  /* 1670 */  vReg_rule,
  /* 1671 */  vReg_rule,
  /* 1672 */  vReg_rule,
  /* 1673 */  vReg_rule,
  /* 1674 */  vReg_rule,
  /* 1675 */  vReg_rule,
  /* 1676 */  vReg_rule,
  /* 1677 */  vReg_rule,
  /* 1678 */  vReg_rule,
  /* 1679 */  vReg_rule,
  /* 1680 */  vReg_rule,
  /* 1681 */  vReg_rule,
  /* 1682 */  pReg_rule,
  /* 1683 */  pReg_rule,
  /* 1684 */  _LoadVector_indirect__rule,
  /* 1685 */  _LoadVector_indirect__rule,
  /* 1686 */  _LoadVectorMasked_vmemA_pRegGov_rule,
  /* 1687 */  _LoadVectorMasked_vmemA_pRegGov_rule,
  /* 1688 */  indirect_rule,
  /* 1689 */  indirect_rule,
  /* 1690 */  vmemA_rule,
  /* 1691 */  vmemA_rule,
  /* 1692 */  pReg_rule,
  /* 1693 */  pReg_rule,
  /* 1694 */  pReg_rule,
  /* 1695 */  pReg_rule,
  /* 1696 */  pReg_rule,
  /* 1697 */  _Binary_vReg_vReg_rule,
  /* 1698 */  _Binary_vReg__ReplicateB_immI0__rule,
  /* 1699 */  _Binary_vReg__ReplicateS_immI0__rule,
  /* 1700 */  _Binary_vReg__ReplicateI_immI0__rule,
  /* 1701 */  _Binary_vReg__ReplicateL_immL0__rule,
  /* 1702 */  _Binary_vReg__ReplicateF_immF0__rule,
  /* 1703 */  _Binary_vReg__ReplicateD_immD0__rule,
  /* 1704 */  _Binary_vReg_vReg_rule,
  /* 1705 */  _Binary_vReg__ReplicateB_immI5__rule,
  /* 1706 */  _Binary_vReg__ReplicateB_immIU7__rule,
  /* 1707 */  _Binary_vReg__ReplicateS_immI5__rule,
  /* 1708 */  _Binary_vReg__ReplicateS_immIU7__rule,
  /* 1709 */  _Binary_vReg__ReplicateI_immI5__rule,
  /* 1710 */  _Binary_vReg__ReplicateI_immIU7__rule,
  /* 1711 */  _Binary_vReg__ReplicateL_immL5__rule,
  /* 1712 */  _Binary_vReg__ReplicateL_immLU7__rule,
  /* 1713 */  _Binary_vReg_vReg_rule,
  /* 1714 */  pReg_rule,
  /* 1715 */  pReg_rule,
  /* 1716 */  vReg_rule,
  /* 1717 */  _VectorStoreMask_vReg_immI_gt_1_rule,
  /* 1718 */  vReg_rule,
  /* 1719 */  pReg_rule,
  /* 1720 */  pReg_rule,
  /* 1721 */  pReg_rule,
  /* 1722 */  pReg_rule,
  /* 1723 */  iRegL_rule,
  /* 1724 */  immI_rule,
  /* 1725 */  iRegIorL2I_rule,
  /* 1726 */  iRegIorL2I_rule,
  /* 1727 */  immL_rule,
  /* 1728 */  iRegL_rule,
  /* 1729 */  iRegL_rule,
  /* 1730 */  _ConvI2L_iRegIorL2I__rule,
  /* 1731 */  iRegL_rule,
  /* 1732 */  immL_rule,
  /* 1733 */  _SubL_iRegL_iRegL_rule,
  /* 1734 */  vReg_rule,
  /* 1735 */  vReg_rule,
  /* 1736 */  _Binary_vReg_vReg_rule,
  /* 1737 */  _Binary_vReg_vReg_rule,
  /* 1738 */  vReg_rule,
  /* 1739 */  vReg_rule,
  /* 1740 */  vReg_rule,
  /* 1741 */  vReg_rule,
  /* 1742 */  vReg_rule,
  /* 1743 */  vReg_rule,
  /* 1744 */  vReg_rule,
  /* 1745 */  indirect_rule,
  /* 1746 */  indirect_rule,
  /* 1747 */  indirect_rule,
  /* 1748 */  indirect_rule,
  /* 1749 */  indirect_rule,
  /* 1750 */  indirect_rule,
  /* 1751 */  indirect_rule,
  /* 1752 */  indirect_rule,
  /* 1753 */  vReg_rule,
  /* 1754 */  vReg_rule,
  /* 1755 */  vReg_rule,
  /* 1756 */  vReg_rule,
  /* 1757 */  iRegIorL2I_rule,
  /* 1758 */  pReg_rule,
  /* 1759 */  vReg_rule,
  /* 1760 */  vReg_rule,
  /* 1761 */  vReg_rule,
  /* 1762 */  vReg_rule,
  /* 1763 */  vReg_rule,
  /* 1764 */  vReg_rule,
  /* 1765 */  vReg_rule,
  /* 1766 */  vReg_rule,
  /* 1767 */  vReg_rule,
  /* 1768 */  vReg_rule,
  /* 1769 */  indirect_rule,
  /* 1770 */  indirect_rule,
  /* 1771 */  indirect_rule,
  /* 1772 */  indirect_rule,
  /* 1773 */  indirect_rule,
  /* 1774 */  indirect_rule,
  /* 1775 */  indirect_rule,
  /* 1776 */  indirect_rule,
  /* 1777 */  indirect_rule,
  /* 1778 */  indirect_rule,
  /* 1779 */  indirect_rule,
  /* 1780 */  indirect_rule,
  /* 1781 */  memory8_rule,
  /* 1782 */  indirect_rule,
  /* 1783 */  indirect_rule,
  /* 1784 */  indirect_rule,
  /* 1785 */  indirect_rule,
  /* 1786 */  indirect_rule,
  /* 1787 */  indirect_rule,
  /* 1788 */  indirect_rule,
  /* 1789 */  indirect_rule,
  /* 1790 */  indirect_rule,
  /* 1791 */  memory8_rule,
  /* 1792 */  indirect_rule,
  /* 1793 */  memory_rule,
  /* 1794 */  indirect_rule,
  /* 1795 */  indirect_rule,
  /* 1796 */  indirect_rule,
  /* 1797 */  indirect_rule,
  /* 1798 */  indirect_rule,
  /* 1799 */  indirect_rule,
  /* 1800 */  indirect_rule,
  /* 1801 */  indirect_rule,
  /* 1802 */  indirect_rule,
  // last instruction
  0 // no trailing comma
};

const        int   rightOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  0,
  /*   86 */  0,
  /*   87 */  0,
  /*   88 */  0,
  /*   89 */  0,
  /*   90 */  0,
  /*   91 */  0,
  /*   92 */  0,
  /*   93 */  0,
  /*   94 */  0,
  /*   95 */  0,
  /*   96 */  0,
  /*   97 */  0,
  /*   98 */  0,
  /*   99 */  0,
  /*  100 */  0,
  /*  101 */  0,
  /*  102 */  0,
  /*  103 */  0,
  /*  104 */  0,
  /*  105 */  0,
  /*  106 */  0,
  /*  107 */  0,
  /*  108 */  0,
  /*  109 */  0,
  /*  110 */  0,
  /*  111 */  0,
  /*  112 */  0,
  /*  113 */  0,
  /*  114 */  0,
  /*  115 */  0,
  /*  116 */  0,
  /*  117 */  0,
  /*  118 */  0,
  /*  119 */  0,
  /*  120 */  0,
  /*  121 */  0,
  /*  122 */  0,
  /*  123 */  0,
  /*  124 */  0,
  /*  125 */  0,
  /*  126 */  0,
  /*  127 */  0,
  /*  128 */  0,
  /*  129 */  0,
  /*  130 */  0,
  /*  131 */  0,
  /*  132 */  0,
  /*  133 */  0,
  /*  134 */  0,
  /*  135 */  0,
  /*  136 */  0,
  /*  137 */  0,
  /*  138 */  0,
  /*  139 */  0,
  /*  140 */  0,
  /*  141 */  0,
  /*  142 */  0,
  /*  143 */  0,
  /*  144 */  0,
  /*  145 */  0,
  /*  146 */  0,
  /*  147 */  0,
  /*  148 */  0,
  /*  149 */  0,
  /*  150 */  0,
  /*  151 */  0,
  /*  152 */  0,
  /*  153 */  0,
  /*  154 */  0,
  /*  155 */  0,
  /*  156 */  0,
  /*  157 */  0,
  /*  158 */  0,
  /*  159 */  0,
  /*  160 */  0,
  /*  161 */  0,
  /*  162 */  0,
  /*  163 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  164 */  _LShiftL_iRegL_immIScale_rule,
  /*  165 */  _ConvI2L_iRegI__rule,
  /*  166 */  iRegL_rule,
  /*  167 */  immIOffset_rule,
  /*  168 */  immIOffset1_rule,
  /*  169 */  immIOffset2_rule,
  /*  170 */  immIOffset4_rule,
  /*  171 */  immIOffset8_rule,
  /*  172 */  immIOffset16_rule,
  /*  173 */  immLoffset_rule,
  /*  174 */  immLoffset1_rule,
  /*  175 */  immLoffset2_rule,
  /*  176 */  immLoffset4_rule,
  /*  177 */  immLoffset8_rule,
  /*  178 */  immLoffset16_rule,
  /*  179 */  0,
  /*  180 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  181 */  _LShiftL_iRegL_immIScale_rule,
  /*  182 */  _ConvI2L_iRegI__rule,
  /*  183 */  iRegL_rule,
  /*  184 */  immIOffset_rule,
  /*  185 */  immLoffset_rule,
  /*  186 */  immL_pc_off_rule,
  /*  187 */  0,
  /*  188 */  0,
  /*  189 */  0,
  /*  190 */  0,
  /*  191 */  0,
  /*  192 */  0,
  /*  193 */  0,
  /*  194 */  0,
  /*  195 */  0,
  /*  196 */  0,
  /*  197 */  0,
  /*  198 */  0,
  /*  199 */  0,
  /*  200 */  vmemA_immIOffset4_rule,
  /*  201 */  vmemA_immLOffset4_rule,
  // last operand
  /*  202 */  0,
  /*  203 */  0,
  /*  204 */  0,
  /*  205 */  0,
  /*  206 */  0,
  /*  207 */  0,
  /*  208 */  0,
  /*  209 */  0,
  /*  210 */  0,
  /*  211 */  0,
  /*  212 */  0,
  // last operand class
  /*  213 */  0,
  /*  214 */  immIScale_rule,
  /*  215 */  immIScale_rule,
  /*  216 */  0,
  /*  217 */  0,
  /*  218 */  0,
  /*  219 */  0,
  /*  220 */  0,
  /*  221 */  0,
  /*  222 */  0,
  /*  223 */  0,
  /*  224 */  0,
  /*  225 */  0,
  /*  226 */  0,
  /*  227 */  0,
  /*  228 */  0,
  /*  229 */  0,
  /*  230 */  0,
  /*  231 */  0,
  /*  232 */  iRegINoSp_rule,
  /*  233 */  iRegLNoSp_rule,
  /*  234 */  iRegP_rule,
  /*  235 */  iRegNNoSp_rule,
  /*  236 */  iRegI_rule,
  /*  237 */  iRegL_rule,
  /*  238 */  iRegN_rule,
  /*  239 */  rFlagsReg_rule,
  /*  240 */  iRegIorL2I_rule,
  /*  241 */  rFlagsRegU_rule,
  /*  242 */  iRegIorL2I_rule,
  /*  243 */  immI0_rule,
  /*  244 */  immI0_rule,
  /*  245 */  immL0_rule,
  /*  246 */  iRegL_rule,
  /*  247 */  immP0_rule,
  /*  248 */  iRegP_rule,
  /*  249 */  immN0_rule,
  /*  250 */  iRegN_rule,
  /*  251 */  vRegF_rule,
  /*  252 */  vRegD_rule,
  /*  253 */  0,
  /*  254 */  0,
  /*  255 */  immIScale_rule,
  /*  256 */  iRegIorL2I_rule,
  /*  257 */  iRegIorL2I_rule,
  /*  258 */  iRegL_rule,
  /*  259 */  iRegL_rule,
  /*  260 */  _ConvI2L_iRegIorL2I__rule,
  /*  261 */  _ConvI2L_iRegIorL2I__rule,
  /*  262 */  immI_rule,
  /*  263 */  immI_rule,
  /*  264 */  immI_rule,
  /*  265 */  immI_rule,
  /*  266 */  immI_rule,
  /*  267 */  immI_rule,
  /*  268 */  immI_M1_rule,
  /*  269 */  immL_M1_rule,
  /*  270 */  iRegIorL2I_rule,
  /*  271 */  iRegL_rule,
  /*  272 */  immI_M1_rule,
  /*  273 */  immL_M1_rule,
  /*  274 */  immI_M1_rule,
  /*  275 */  immL_M1_rule,
  /*  276 */  immI_rule,
  /*  277 */  immI_M1_rule,
  /*  278 */  immI_rule,
  /*  279 */  immL_M1_rule,
  /*  280 */  immI_M1_rule,
  /*  281 */  immL_M1_rule,
  /*  282 */  iRegIorL2I_rule,
  /*  283 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  284 */  iRegL_rule,
  /*  285 */  _URShiftL_iRegL_immI_rule,
  /*  286 */  iRegIorL2I_rule,
  /*  287 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  288 */  iRegL_rule,
  /*  289 */  _RShiftL_iRegL_immI_rule,
  /*  290 */  iRegIorL2I_rule,
  /*  291 */  _RotateRight_iRegIorL2I_immI_rule,
  /*  292 */  iRegL_rule,
  /*  293 */  _RotateRight_iRegL_immI_rule,
  /*  294 */  iRegIorL2I_rule,
  /*  295 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  296 */  iRegL_rule,
  /*  297 */  _LShiftL_iRegL_immI_rule,
  /*  298 */  immI_bitmask_rule,
  /*  299 */  immI_bitmask_rule,
  /*  300 */  immL_bitmask_rule,
  /*  301 */  immI_rule,
  /*  302 */  immL_positive_bitmaskI_rule,
  /*  303 */  immI_rule,
  /*  304 */  0,
  /*  305 */  0,
  /*  306 */  immI_bitmask_rule,
  /*  307 */  immI_16_rule,
  /*  308 */  immI_16_rule,
  /*  309 */  immI_24_rule,
  /*  310 */  immI_24_rule,
  /*  311 */  immI_24_rule,
  /*  312 */  immI_48_rule,
  /*  313 */  immI_48_rule,
  /*  314 */  immI_32_rule,
  /*  315 */  immI_32_rule,
  /*  316 */  immI_56_rule,
  /*  317 */  immI_56_rule,
  /*  318 */  immI_56_rule,
  /*  319 */  immI_255_rule,
  /*  320 */  immI_65535_rule,
  /*  321 */  immL_255_rule,
  /*  322 */  immL_65535_rule,
  /*  323 */  immL_4294967295_rule,
  /*  324 */  immIExt_rule,
  /*  325 */  immIExt_rule,
  /*  326 */  immIExt_rule,
  /*  327 */  immIExt_rule,
  /*  328 */  immIExt_rule,
  /*  329 */  immIExt_rule,
  /*  330 */  immIExt_rule,
  /*  331 */  immIExt_rule,
  /*  332 */  immIExt_rule,
  /*  333 */  immIExt_rule,
  /*  334 */  immIExt_rule,
  /*  335 */  0,
  /*  336 */  vRegF_rule,
  /*  337 */  _NegF_vRegF__rule,
  /*  338 */  0,
  /*  339 */  vRegD_rule,
  /*  340 */  _NegD_vRegD__rule,
  /*  341 */  vRegF_rule,
  /*  342 */  vRegD_rule,
  /*  343 */  iRegIorL2I_rule,
  /*  344 */  iRegL_rule,
  /*  345 */  immI0_rule,
  /*  346 */  immL0_rule,
  /*  347 */  immP0_rule,
  /*  348 */  immN0_rule,
  /*  349 */  immP0_rule,
  /*  350 */  immI0_rule,
  /*  351 */  immL0_rule,
  /*  352 */  immL_rule,
  /*  353 */  immL0_rule,
  /*  354 */  immI_rule,
  /*  355 */  immI0_rule,
  /*  356 */  iRegL_rule,
  /*  357 */  iRegIorL2I_rule,
  /*  358 */  iRegP_R0_rule,
  /*  359 */  iRegI_R2_rule,
  /*  360 */  iRegI_R4_rule,
  /*  361 */  iRegI_R4_rule,
  /*  362 */  iRegI_R2_rule,
  /*  363 */  immI_le_4_rule,
  /*  364 */  immI_1_rule,
  /*  365 */  iRegP_R3_rule,
  /*  366 */  iRegI_R3_rule,
  /*  367 */  pRegGov_rule,
  /*  368 */  vReg_rule,
  /*  369 */  0,
  /*  370 */  0,
  /*  371 */  0,
  /*  372 */  0,
  /*  373 */  0,
  /*  374 */  0,
  /*  375 */  0,
  /*  376 */  0,
  /*  377 */  vReg_rule,
  /*  378 */  0,
  /*  379 */  0,
  /*  380 */  0,
  /*  381 */  0,
  /*  382 */  _ReplicateB_immI_M1__rule,
  /*  383 */  _ReplicateS_immI_M1__rule,
  /*  384 */  _ReplicateI_immI_M1__rule,
  /*  385 */  _ReplicateL_immL_M1__rule,
  /*  386 */  _ReplicateB_immI_M1__rule,
  /*  387 */  vReg_rule,
  /*  388 */  _ReplicateS_immI_M1__rule,
  /*  389 */  vReg_rule,
  /*  390 */  _ReplicateI_immI_M1__rule,
  /*  391 */  vReg_rule,
  /*  392 */  _ReplicateL_immL_M1__rule,
  /*  393 */  vReg_rule,
  /*  394 */  _XorV_vReg__ReplicateB_immI_M1__rule,
  /*  395 */  _XorV__ReplicateB_immI_M1__vReg_rule,
  /*  396 */  _XorV_vReg__ReplicateS_immI_M1__rule,
  /*  397 */  _XorV__ReplicateS_immI_M1__vReg_rule,
  /*  398 */  _XorV_vReg__ReplicateI_immI_M1__rule,
  /*  399 */  _XorV__ReplicateI_immI_M1__vReg_rule,
  /*  400 */  _XorV_vReg__ReplicateL_immL_M1__rule,
  /*  401 */  _XorV__ReplicateL_immL_M1__vReg_rule,
  /*  402 */  vReg_rule,
  /*  403 */  vReg_rule,
  /*  404 */  pRegGov_rule,
  /*  405 */  pRegGov_rule,
  /*  406 */  vReg_rule,
  /*  407 */  vReg_rule,
  /*  408 */  vReg_rule,
  /*  409 */  vReg_rule,
  /*  410 */  _MulVB_vReg_vReg_rule,
  /*  411 */  _MulVS_vReg_vReg_rule,
  /*  412 */  _MulVI_vReg_vReg_rule,
  /*  413 */  _MulVL_vReg_vReg_rule,
  /*  414 */  0,
  /*  415 */  vReg_rule,
  /*  416 */  0,
  /*  417 */  vReg_rule,
  /*  418 */  _NegVF_vReg__rule,
  /*  419 */  _NegVD_vReg__rule,
  /*  420 */  pRegGov_rule,
  /*  421 */  pRegGov_rule,
  /*  422 */  0,
  /*  423 */  0,
  /*  424 */  _RShiftCntV_immI_positive__rule,
  /*  425 */  _RShiftCntV_immI_positive__rule,
  /*  426 */  _RShiftCntV_immI_positive__rule,
  /*  427 */  _RShiftCntV_immI_positive__rule,
  /*  428 */  _RShiftCntV_immI_positive__rule,
  /*  429 */  _RShiftCntV_immI_positive__rule,
  /*  430 */  _RShiftCntV_immI_positive__rule,
  /*  431 */  _RShiftCntV_immI_positive__rule,
  /*  432 */  _LShiftCntV_immI__rule,
  /*  433 */  _RShiftCntV_immI_positive__rule,
  /*  434 */  vReg_rule,
  /*  435 */  vReg_rule,
  /*  436 */  vReg_rule,
  /*  437 */  vReg_rule,
  /*  438 */  iRegIorL2I_rule,
  /*  439 */  iRegL_rule,
  /*  440 */  vRegF_rule,
  /*  441 */  vRegD_rule,
  /*  442 */  0,
  /*  443 */  pRegGov_rule,
  /*  444 */  immI_gt_1_rule,
  /*  445 */  pRegGov_rule,
  /*  446 */  0,
  /*  447 */  _MaskAll_immI_M1__rule,
  /*  448 */  0,
  /*  449 */  _MaskAll_immL_M1__rule,
  /*  450 */  0,
  /*  451 */  _ReplicateB_immI0__rule,
  /*  452 */  0,
  /*  453 */  _ReplicateS_immI0__rule,
  /*  454 */  0,
  /*  455 */  _ReplicateI_immI0__rule,
  /*  456 */  0,
  /*  457 */  _ReplicateL_immL0__rule,
  /*  458 */  0,
  /*  459 */  _ReplicateF_immF0__rule,
  /*  460 */  0,
  /*  461 */  _ReplicateD_immD0__rule,
  /*  462 */  0,
  /*  463 */  _ReplicateB_immI5__rule,
  /*  464 */  0,
  /*  465 */  _ReplicateB_immIU7__rule,
  /*  466 */  0,
  /*  467 */  _ReplicateS_immI5__rule,
  /*  468 */  0,
  /*  469 */  _ReplicateS_immIU7__rule,
  /*  470 */  0,
  /*  471 */  _ReplicateI_immI5__rule,
  /*  472 */  0,
  /*  473 */  _ReplicateI_immIU7__rule,
  /*  474 */  0,
  /*  475 */  _ReplicateL_immL5__rule,
  /*  476 */  0,
  /*  477 */  _ReplicateL_immLU7__rule,
  /*  478 */  pRegGov_rule,
  /*  479 */  immI_gt_1_rule,
  /*  480 */  iRegL_rule,
  /*  481 */  _Binary_vReg_pRegGov_rule,
  // last internally defined operand
  /*  482 */  0,
  /*  483 */  0,
  /*  484 */  0,
  /*  485 */  0,
  /*  486 */  0,
  /*  487 */  0,
  /*  488 */  0,
  /*  489 */  0,
  /*  490 */  0,
  /*  491 */  0,
  /*  492 */  0,
  /*  493 */  0,
  /*  494 */  0,
  /*  495 */  0,
  /*  496 */  0,
  /*  497 */  0,
  /*  498 */  0,
  /*  499 */  0,
  /*  500 */  0,
  /*  501 */  0,
  /*  502 */  0,
  /*  503 */  0,
  /*  504 */  0,
  /*  505 */  0,
  /*  506 */  0,
  /*  507 */  0,
  /*  508 */  0,
  /*  509 */  0,
  /*  510 */  0,
  /*  511 */  0,
  /*  512 */  0,
  /*  513 */  0,
  /*  514 */  0,
  /*  515 */  0,
  /*  516 */  0,
  /*  517 */  0,
  /*  518 */  0,
  /*  519 */  0,
  /*  520 */  0,
  /*  521 */  0,
  /*  522 */  0,
  /*  523 */  iRegIorL2I_rule,
  /*  524 */  immIAddSub_rule,
  /*  525 */  iRegL_rule,
  /*  526 */  immLAddSub_rule,
  /*  527 */  iRegIorL2I_rule,
  /*  528 */  immIAddSub_rule,
  /*  529 */  iRegL_rule,
  /*  530 */  immLAddSub_rule,
  /*  531 */  iRegIorL2I_rule,
  /*  532 */  iRegL_rule,
  /*  533 */  iRegIorL2I_rule,
  /*  534 */  iRegL_rule,
  /*  535 */  iRegI_rule,
  /*  536 */  immI0_rule,
  /*  537 */  immIAddSub_rule,
  /*  538 */  immI_rule,
  /*  539 */  iRegI_rule,
  /*  540 */  immI0_rule,
  /*  541 */  immIAddSub_rule,
  /*  542 */  immI_rule,
  /*  543 */  iRegL_rule,
  /*  544 */  immL0_rule,
  /*  545 */  immLAddSub_rule,
  /*  546 */  immL_rule,
  /*  547 */  iRegL_rule,
  /*  548 */  immL0_rule,
  /*  549 */  immLAddSub_rule,
  /*  550 */  immL_rule,
  /*  551 */  iRegP_rule,
  /*  552 */  iRegN_rule,
  /*  553 */  immP0_rule,
  /*  554 */  immN0_rule,
  /*  555 */  vRegF_rule,
  /*  556 */  immF0_rule,
  /*  557 */  vRegD_rule,
  /*  558 */  immD0_rule,
  /*  559 */  0,
  /*  560 */  immL0_rule,
  /*  561 */  immI0_rule,
  /*  562 */  immL0_rule,
  /*  563 */  immI0_rule,
  /*  564 */  iRegP_rule,
  /*  565 */  iRegP_rule,
  /*  566 */  immP0_rule,
  /*  567 */  0,
  /*  568 */  0,
  /*  569 */  0,
  /*  570 */  0,
  /*  571 */  0,
  /*  572 */  0,
  /*  573 */  0,
  /*  574 */  0,
  /*  575 */  0,
  /*  576 */  0,
  /*  577 */  0,
  /*  578 */  0,
  /*  579 */  0,
  /*  580 */  0,
  /*  581 */  0,
  /*  582 */  0,
  /*  583 */  0,
  /*  584 */  0,
  /*  585 */  0,
  /*  586 */  0,
  /*  587 */  0,
  /*  588 */  0,
  /*  589 */  0,
  /*  590 */  0,
  /*  591 */  0,
  /*  592 */  0,
  /*  593 */  0,
  /*  594 */  0,
  /*  595 */  0,
  /*  596 */  0,
  /*  597 */  0,
  /*  598 */  0,
  /*  599 */  0,
  /*  600 */  0,
  /*  601 */  0,
  /*  602 */  0,
  /*  603 */  0,
  /*  604 */  0,
  /*  605 */  0,
  /*  606 */  0,
  /*  607 */  0,
  /*  608 */  0,
  /*  609 */  0,
  /*  610 */  0,
  /*  611 */  0,
  /*  612 */  0,
  /*  613 */  0,
  /*  614 */  0,
  /*  615 */  0,
  /*  616 */  0,
  /*  617 */  0,
  /*  618 */  0,
  /*  619 */  0,
  /*  620 */  0,
  /*  621 */  0,
  /*  622 */  0,
  /*  623 */  vReg_rule,
  /*  624 */  pReg_rule,
  /*  625 */  vReg_rule,
  /*  626 */  pReg_rule,
  /*  627 */  0,
  /*  628 */  0,
  /*  629 */  0,
  /*  630 */  0,
  /*  631 */  0,
  /*  632 */  0,
  /*  633 */  0,
  /*  634 */  0,
  /*  635 */  0,
  /*  636 */  0,
  /*  637 */  0,
  /*  638 */  0,
  /*  639 */  0,
  /*  640 */  0,
  /*  641 */  0,
  /*  642 */  immL_32bits_rule,
  /*  643 */  0,
  /*  644 */  0,
  /*  645 */  0,
  /*  646 */  0,
  /*  647 */  0,
  /*  648 */  0,
  /*  649 */  0,
  /*  650 */  0,
  /*  651 */  immI0_rule,
  /*  652 */  immI0_rule,
  /*  653 */  iRegIorL2I_rule,
  /*  654 */  immI0_rule,
  /*  655 */  iRegIorL2I_rule,
  /*  656 */  immI0_rule,
  /*  657 */  iRegIorL2I_rule,
  /*  658 */  immI0_rule,
  /*  659 */  iRegL_rule,
  /*  660 */  immL0_rule,
  /*  661 */  iRegP_rule,
  /*  662 */  immP0_rule,
  /*  663 */  iRegN_rule,
  /*  664 */  immN0_rule,
  /*  665 */  vRegF_rule,
  /*  666 */  vRegD_rule,
  /*  667 */  iRegN_rule,
  /*  668 */  0,
  /*  669 */  0,
  /*  670 */  0,
  /*  671 */  0,
  /*  672 */  0,
  /*  673 */  0,
  /*  674 */  0,
  /*  675 */  0,
  /*  676 */  0,
  /*  677 */  0,
  /*  678 */  immL_32bits_rule,
  /*  679 */  0,
  /*  680 */  0,
  /*  681 */  0,
  /*  682 */  0,
  /*  683 */  0,
  /*  684 */  iRegIorL2I_rule,
  /*  685 */  immI0_rule,
  /*  686 */  iRegIorL2I_rule,
  /*  687 */  immI0_rule,
  /*  688 */  iRegIorL2I_rule,
  /*  689 */  immI0_rule,
  /*  690 */  iRegL_rule,
  /*  691 */  immL0_rule,
  /*  692 */  iRegP_rule,
  /*  693 */  immP0_rule,
  /*  694 */  iRegN_rule,
  /*  695 */  immN0_rule,
  /*  696 */  vRegF_rule,
  /*  697 */  vRegD_rule,
  /*  698 */  0,
  /*  699 */  0,
  /*  700 */  0,
  /*  701 */  0,
  /*  702 */  0,
  /*  703 */  0,
  /*  704 */  0,
  /*  705 */  0,
  /*  706 */  0,
  /*  707 */  0,
  /*  708 */  0,
  /*  709 */  0,
  /*  710 */  0,
  /*  711 */  0,
  /*  712 */  0,
  /*  713 */  0,
  /*  714 */  0,
  /*  715 */  0,
  /*  716 */  0,
  /*  717 */  0,
  /*  718 */  0,
  /*  719 */  0,
  /*  720 */  0,
  /*  721 */  0,
  /*  722 */  0,
  /*  723 */  0,
  /*  724 */  0,
  /*  725 */  0,
  /*  726 */  0,
  /*  727 */  0,
  /*  728 */  0,
  /*  729 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  730 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  731 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  732 */  _Binary_iRegLNoSp_iRegLNoSp_rule,
  /*  733 */  _Binary_iRegP_iRegP_rule,
  /*  734 */  _Binary_iRegNNoSp_iRegNNoSp_rule,
  /*  735 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  736 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  737 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  738 */  _Binary_iRegLNoSp_iRegLNoSp_rule,
  /*  739 */  _Binary_iRegP_iRegP_rule,
  /*  740 */  _Binary_iRegNNoSp_iRegNNoSp_rule,
  /*  741 */  _Binary_iRegI_iRegI_rule,
  /*  742 */  _Binary_iRegI_iRegI_rule,
  /*  743 */  _Binary_iRegI_iRegI_rule,
  /*  744 */  _Binary_iRegL_iRegL_rule,
  /*  745 */  _Binary_iRegN_iRegN_rule,
  /*  746 */  _Binary_iRegP_iRegP_rule,
  /*  747 */  _Binary_iRegI_iRegI_rule,
  /*  748 */  _Binary_iRegI_iRegI_rule,
  /*  749 */  _Binary_iRegI_iRegI_rule,
  /*  750 */  _Binary_iRegL_iRegL_rule,
  /*  751 */  _Binary_iRegN_iRegN_rule,
  /*  752 */  _Binary_iRegP_iRegP_rule,
  /*  753 */  _Binary_iRegI_iRegI_rule,
  /*  754 */  _Binary_iRegI_iRegI_rule,
  /*  755 */  _Binary_iRegI_iRegI_rule,
  /*  756 */  _Binary_iRegL_iRegL_rule,
  /*  757 */  _Binary_iRegN_iRegN_rule,
  /*  758 */  _Binary_iRegP_iRegP_rule,
  /*  759 */  _Binary_iRegI_iRegI_rule,
  /*  760 */  _Binary_iRegI_iRegI_rule,
  /*  761 */  _Binary_iRegI_iRegI_rule,
  /*  762 */  _Binary_iRegL_iRegL_rule,
  /*  763 */  _Binary_iRegN_iRegN_rule,
  /*  764 */  _Binary_iRegP_iRegP_rule,
  /*  765 */  iRegI_rule,
  /*  766 */  iRegL_rule,
  /*  767 */  iRegN_rule,
  /*  768 */  iRegP_rule,
  /*  769 */  iRegI_rule,
  /*  770 */  iRegL_rule,
  /*  771 */  iRegN_rule,
  /*  772 */  iRegP_rule,
  /*  773 */  iRegL_rule,
  /*  774 */  iRegL_rule,
  /*  775 */  immLAddSub_rule,
  /*  776 */  immLAddSub_rule,
  /*  777 */  iRegIorL2I_rule,
  /*  778 */  iRegIorL2I_rule,
  /*  779 */  immIAddSub_rule,
  /*  780 */  immIAddSub_rule,
  /*  781 */  iRegL_rule,
  /*  782 */  iRegL_rule,
  /*  783 */  immLAddSub_rule,
  /*  784 */  immLAddSub_rule,
  /*  785 */  iRegIorL2I_rule,
  /*  786 */  iRegIorL2I_rule,
  /*  787 */  immIAddSub_rule,
  /*  788 */  immIAddSub_rule,
  /*  789 */  iRegI_rule,
  /*  790 */  immIAddSub_rule,
  /*  791 */  iRegL_rule,
  /*  792 */  immLAddSub_rule,
  /*  793 */  iRegL_rule,
  /*  794 */  immLAddSub_rule,
  /*  795 */  _Binary_iRegIorL2I_iRegIorL2I_rule,
  /*  796 */  _Binary_iRegIorL2I_iRegIorL2I_rule,
  /*  797 */  _Binary_immI0_iRegIorL2I_rule,
  /*  798 */  _Binary_immI0_iRegIorL2I_rule,
  /*  799 */  _Binary_iRegIorL2I_immI0_rule,
  /*  800 */  _Binary_iRegIorL2I_immI0_rule,
  /*  801 */  _Binary_immI_1_immI0_rule,
  /*  802 */  _Binary_immI_1_immI0_rule,
  /*  803 */  _Binary_iRegL_iRegL_rule,
  /*  804 */  _Binary_iRegL_iRegL_rule,
  /*  805 */  _Binary_iRegL_immL0_rule,
  /*  806 */  _Binary_iRegL_immL0_rule,
  /*  807 */  _Binary_immL0_iRegL_rule,
  /*  808 */  _Binary_immL0_iRegL_rule,
  /*  809 */  _Binary_iRegP_iRegP_rule,
  /*  810 */  _Binary_iRegP_iRegP_rule,
  /*  811 */  _Binary_iRegP_immP0_rule,
  /*  812 */  _Binary_iRegP_immP0_rule,
  /*  813 */  _Binary_immP0_iRegP_rule,
  /*  814 */  _Binary_immP0_iRegP_rule,
  /*  815 */  _Binary_iRegN_iRegN_rule,
  /*  816 */  _Binary_iRegN_iRegN_rule,
  /*  817 */  _Binary_iRegN_immN0_rule,
  /*  818 */  _Binary_iRegN_immN0_rule,
  /*  819 */  _Binary_immN0_iRegN_rule,
  /*  820 */  _Binary_immN0_iRegN_rule,
  /*  821 */  _Binary_vRegF_vRegF_rule,
  /*  822 */  _Binary_vRegF_vRegF_rule,
  /*  823 */  _Binary_vRegD_vRegD_rule,
  /*  824 */  _Binary_vRegD_vRegD_rule,
  /*  825 */  iRegIorL2I_rule,
  /*  826 */  immIAddSub_rule,
  /*  827 */  immIAddSub_rule,
  /*  828 */  iRegL_rule,
  /*  829 */  _ConvI2L_iRegIorL2I__rule,
  /*  830 */  _LShiftL_iRegL_immIScale_rule,
  /*  831 */  _LShiftL__ConvI2L_iRegIorL2I__immIScale_rule,
  /*  832 */  immI_rule,
  /*  833 */  immLAddSub_rule,
  /*  834 */  iRegL_rule,
  /*  835 */  immLAddSub_rule,
  /*  836 */  iRegIorL2I_rule,
  /*  837 */  immIAddSub_rule,
  /*  838 */  iRegL_rule,
  /*  839 */  immLAddSub_rule,
  /*  840 */  iRegIorL2I_rule,
  /*  841 */  iRegL_rule,
  /*  842 */  iRegIorL2I_rule,
  /*  843 */  _ConvI2L_iRegIorL2I__rule,
  /*  844 */  _ConvI2L_iRegIorL2I__rule,
  /*  845 */  iRegL_rule,
  /*  846 */  iRegL_rule,
  /*  847 */  iRegL_rule,
  /*  848 */  _MulI_iRegIorL2I_iRegIorL2I_rule,
  /*  849 */  iRegIorL2I_rule,
  /*  850 */  _MulI_iRegIorL2I_iRegIorL2I_rule,
  /*  851 */  iRegIorL2I_rule,
  /*  852 */  _SubI_immI0_iRegIorL2I_rule,
  /*  853 */  _MulL_iRegL_iRegL_rule,
  /*  854 */  iRegL_rule,
  /*  855 */  _MulL_iRegL_iRegL_rule,
  /*  856 */  iRegL_rule,
  /*  857 */  _SubL_immL0_iRegL_rule,
  /*  858 */  _MulL__ConvI2L_iRegIorL2I___ConvI2L_iRegIorL2I__rule,
  /*  859 */  iRegLNoSp_rule,
  /*  860 */  _MulL__ConvI2L_iRegIorL2I___ConvI2L_iRegIorL2I__rule,
  /*  861 */  iRegLNoSp_rule,
  /*  862 */  _MulL__ConvI2L_iRegIorL2I___ConvI2L_iRegIorL2I__rule,
  /*  863 */  _MulL__ConvI2L_iRegIorL2I___ConvI2L_iRegIorL2I__rule,
  /*  864 */  _ConvI2L_iRegIorL2I__rule,
  /*  865 */  _SubL_immL0__ConvI2L_iRegIorL2I__rule,
  /*  866 */  _Binary_iRegIorL2I_iRegIorL2I_rule,
  /*  867 */  iRegIorL2I_rule,
  /*  868 */  iRegL_rule,
  /*  869 */  iRegIorL2I_rule,
  /*  870 */  iRegL_rule,
  /*  871 */  iRegIorL2I_rule,
  /*  872 */  iRegL_rule,
  /*  873 */  iRegIorL2I_rule,
  /*  874 */  iRegL_rule,
  /*  875 */  iRegIorL2I_rule,
  /*  876 */  immI_rule,
  /*  877 */  iRegIorL2I_rule,
  /*  878 */  immI_rule,
  /*  879 */  iRegIorL2I_rule,
  /*  880 */  immI_rule,
  /*  881 */  iRegIorL2I_rule,
  /*  882 */  immI_rule,
  /*  883 */  iRegIorL2I_rule,
  /*  884 */  immI_rule,
  /*  885 */  immI_rule,
  /*  886 */  iRegIorL2I_rule,
  /*  887 */  immI_rule,
  /*  888 */  immL_M1_rule,
  /*  889 */  immI_M1_rule,
  /*  890 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  891 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  892 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  893 */  _URShiftL_iRegL_immI_rule,
  /*  894 */  _RShiftL_iRegL_immI_rule,
  /*  895 */  _LShiftL_iRegL_immI_rule,
  /*  896 */  _XorI_iRegIorL2I_immI_M1_rule,
  /*  897 */  iRegIorL2I_rule,
  /*  898 */  _XorL_iRegL_immL_M1_rule,
  /*  899 */  iRegL_rule,
  /*  900 */  _XorI_iRegIorL2I_immI_M1_rule,
  /*  901 */  iRegIorL2I_rule,
  /*  902 */  _XorL_iRegL_immL_M1_rule,
  /*  903 */  iRegL_rule,
  /*  904 */  _XorI_iRegIorL2I_iRegIorL2I_rule,
  /*  905 */  immI_M1_rule,
  /*  906 */  _XorL_iRegL_iRegL_rule,
  /*  907 */  immL_M1_rule,
  /*  908 */  _XorI__URShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  909 */  iRegIorL2I_rule,
  /*  910 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  911 */  iRegL_rule,
  /*  912 */  _XorI__RShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  913 */  iRegIorL2I_rule,
  /*  914 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  915 */  iRegL_rule,
  /*  916 */  _XorI__RotateRight_iRegIorL2I_immI_immI_M1_rule,
  /*  917 */  iRegIorL2I_rule,
  /*  918 */  _XorL__RotateRight_iRegL_immI_immL_M1_rule,
  /*  919 */  iRegL_rule,
  /*  920 */  _XorI__LShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  921 */  iRegIorL2I_rule,
  /*  922 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  923 */  iRegL_rule,
  /*  924 */  _XorI__URShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  925 */  immI_M1_rule,
  /*  926 */  _XorI_iRegIorL2I__URShiftI_iRegIorL2I_immI_rule,
  /*  927 */  immI_M1_rule,
  /*  928 */  _XorL__URShiftL_iRegL_immI_iRegL_rule,
  /*  929 */  immL_M1_rule,
  /*  930 */  _XorL_iRegL__URShiftL_iRegL_immI_rule,
  /*  931 */  immL_M1_rule,
  /*  932 */  _XorI__RShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  933 */  immI_M1_rule,
  /*  934 */  _XorI_iRegIorL2I__RShiftI_iRegIorL2I_immI_rule,
  /*  935 */  immI_M1_rule,
  /*  936 */  _XorL__RShiftL_iRegL_immI_iRegL_rule,
  /*  937 */  immL_M1_rule,
  /*  938 */  _XorL_iRegL__RShiftL_iRegL_immI_rule,
  /*  939 */  immL_M1_rule,
  /*  940 */  _XorI__RotateRight_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  941 */  immI_M1_rule,
  /*  942 */  _XorI_iRegIorL2I__RotateRight_iRegIorL2I_immI_rule,
  /*  943 */  immI_M1_rule,
  /*  944 */  _XorL__RotateRight_iRegL_immI_iRegL_rule,
  /*  945 */  immL_M1_rule,
  /*  946 */  _XorL_iRegL__RotateRight_iRegL_immI_rule,
  /*  947 */  immL_M1_rule,
  /*  948 */  _XorI__LShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  949 */  immI_M1_rule,
  /*  950 */  _XorI_iRegIorL2I__LShiftI_iRegIorL2I_immI_rule,
  /*  951 */  immI_M1_rule,
  /*  952 */  _XorL__LShiftL_iRegL_immI_iRegL_rule,
  /*  953 */  immL_M1_rule,
  /*  954 */  _XorL_iRegL__LShiftL_iRegL_immI_rule,
  /*  955 */  immL_M1_rule,
  /*  956 */  _XorI__URShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  957 */  iRegIorL2I_rule,
  /*  958 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  959 */  iRegL_rule,
  /*  960 */  _XorI__RShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  961 */  iRegIorL2I_rule,
  /*  962 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  963 */  iRegL_rule,
  /*  964 */  _XorI__RotateRight_iRegIorL2I_immI_immI_M1_rule,
  /*  965 */  iRegIorL2I_rule,
  /*  966 */  _XorL__RotateRight_iRegL_immI_immL_M1_rule,
  /*  967 */  iRegL_rule,
  /*  968 */  _XorI__LShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  969 */  iRegIorL2I_rule,
  /*  970 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  971 */  iRegL_rule,
  /*  972 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  973 */  iRegIorL2I_rule,
  /*  974 */  _URShiftL_iRegL_immI_rule,
  /*  975 */  iRegL_rule,
  /*  976 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  977 */  iRegIorL2I_rule,
  /*  978 */  _RShiftL_iRegL_immI_rule,
  /*  979 */  iRegL_rule,
  /*  980 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  981 */  iRegIorL2I_rule,
  /*  982 */  _LShiftL_iRegL_immI_rule,
  /*  983 */  iRegL_rule,
  /*  984 */  _RotateRight_iRegIorL2I_immI_rule,
  /*  985 */  iRegIorL2I_rule,
  /*  986 */  _RotateRight_iRegL_immI_rule,
  /*  987 */  iRegL_rule,
  /*  988 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  989 */  iRegIorL2I_rule,
  /*  990 */  _URShiftL_iRegL_immI_rule,
  /*  991 */  iRegL_rule,
  /*  992 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  993 */  iRegIorL2I_rule,
  /*  994 */  _RShiftL_iRegL_immI_rule,
  /*  995 */  iRegL_rule,
  /*  996 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  997 */  iRegIorL2I_rule,
  /*  998 */  _LShiftL_iRegL_immI_rule,
  /*  999 */  iRegL_rule,
  /* 1000 */  _RotateRight_iRegIorL2I_immI_rule,
  /* 1001 */  iRegIorL2I_rule,
  /* 1002 */  _RotateRight_iRegL_immI_rule,
  /* 1003 */  iRegL_rule,
  /* 1004 */  _URShiftI_iRegIorL2I_immI_rule,
  /* 1005 */  iRegIorL2I_rule,
  /* 1006 */  _URShiftL_iRegL_immI_rule,
  /* 1007 */  iRegL_rule,
  /* 1008 */  _RShiftI_iRegIorL2I_immI_rule,
  /* 1009 */  iRegIorL2I_rule,
  /* 1010 */  _RShiftL_iRegL_immI_rule,
  /* 1011 */  iRegL_rule,
  /* 1012 */  _LShiftI_iRegIorL2I_immI_rule,
  /* 1013 */  iRegIorL2I_rule,
  /* 1014 */  _LShiftL_iRegL_immI_rule,
  /* 1015 */  iRegL_rule,
  /* 1016 */  _RotateRight_iRegIorL2I_immI_rule,
  /* 1017 */  iRegIorL2I_rule,
  /* 1018 */  _RotateRight_iRegL_immI_rule,
  /* 1019 */  iRegL_rule,
  /* 1020 */  _URShiftI_iRegIorL2I_immI_rule,
  /* 1021 */  iRegIorL2I_rule,
  /* 1022 */  _URShiftL_iRegL_immI_rule,
  /* 1023 */  iRegL_rule,
  /* 1024 */  _RShiftI_iRegIorL2I_immI_rule,
  /* 1025 */  iRegIorL2I_rule,
  /* 1026 */  _RShiftL_iRegL_immI_rule,
  /* 1027 */  iRegL_rule,
  /* 1028 */  _LShiftI_iRegIorL2I_immI_rule,
  /* 1029 */  iRegIorL2I_rule,
  /* 1030 */  _LShiftL_iRegL_immI_rule,
  /* 1031 */  iRegL_rule,
  /* 1032 */  _URShiftI_iRegIorL2I_immI_rule,
  /* 1033 */  _URShiftL_iRegL_immI_rule,
  /* 1034 */  _RShiftI_iRegIorL2I_immI_rule,
  /* 1035 */  _RShiftL_iRegL_immI_rule,
  /* 1036 */  _LShiftI_iRegIorL2I_immI_rule,
  /* 1037 */  _LShiftL_iRegL_immI_rule,
  /* 1038 */  immI_rule,
  /* 1039 */  immI_rule,
  /* 1040 */  immI_rule,
  /* 1041 */  immI_rule,
  /* 1042 */  immI_bitmask_rule,
  /* 1043 */  immL_bitmask_rule,
  /* 1044 */  0,
  /* 1045 */  immI_rule,
  /* 1046 */  immI_rule,
  /* 1047 */  0,
  /* 1048 */  0,
  /* 1049 */  immI_rule,
  /* 1050 */  immI_rule,
  /* 1051 */  0,
  /* 1052 */  _URShiftL_iRegL_immI_rule,
  /* 1053 */  _LShiftL_iRegL_immI_rule,
  /* 1054 */  _URShiftI_iRegIorL2I_immI_rule,
  /* 1055 */  _LShiftI_iRegIorL2I_immI_rule,
  /* 1056 */  _URShiftL_iRegL_immI_rule,
  /* 1057 */  _LShiftL_iRegL_immI_rule,
  /* 1058 */  _URShiftI_iRegIorL2I_immI_rule,
  /* 1059 */  _LShiftI_iRegIorL2I_immI_rule,
  /* 1060 */  immI_rule,
  /* 1061 */  immI_rule,
  /* 1062 */  iRegI_rule,
  /* 1063 */  iRegI_rule,
  /* 1064 */  iRegI_rule,
  /* 1065 */  iRegI_rule,
  /* 1066 */  _ConvI2L_iRegIorL2I__rule,
  /* 1067 */  iRegL_rule,
  /* 1068 */  _ConvI2L_iRegIorL2I__rule,
  /* 1069 */  _RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_rule,
  /* 1070 */  iRegIorL2I_rule,
  /* 1071 */  _RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /* 1072 */  iRegIorL2I_rule,
  /* 1073 */  _URShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /* 1074 */  iRegIorL2I_rule,
  /* 1075 */  _RShiftL__LShiftL_iRegL_immI_48_immI_48_rule,
  /* 1076 */  iRegL_rule,
  /* 1077 */  _RShiftL__LShiftL_iRegL_immI_32_immI_32_rule,
  /* 1078 */  iRegL_rule,
  /* 1079 */  _RShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /* 1080 */  iRegL_rule,
  /* 1081 */  _URShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /* 1082 */  iRegL_rule,
  /* 1083 */  _AndI_iRegIorL2I_immI_255_rule,
  /* 1084 */  iRegIorL2I_rule,
  /* 1085 */  _AndI_iRegIorL2I_immI_65535_rule,
  /* 1086 */  iRegIorL2I_rule,
  /* 1087 */  _AndL_iRegL_immL_255_rule,
  /* 1088 */  iRegL_rule,
  /* 1089 */  _AndL_iRegL_immL_65535_rule,
  /* 1090 */  iRegL_rule,
  /* 1091 */  _AndL_iRegL_immL_4294967295_rule,
  /* 1092 */  iRegL_rule,
  /* 1093 */  _AndI_iRegIorL2I_immI_255_rule,
  /* 1094 */  _AndI_iRegIorL2I_immI_65535_rule,
  /* 1095 */  _AndL_iRegL_immL_255_rule,
  /* 1096 */  _AndL_iRegL_immL_65535_rule,
  /* 1097 */  _AndL_iRegL_immL_4294967295_rule,
  /* 1098 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_56_immI_56_immIExt_rule,
  /* 1099 */  iRegL_rule,
  /* 1100 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_48_immI_48_immIExt_rule,
  /* 1101 */  iRegL_rule,
  /* 1102 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_32_immI_32_immIExt_rule,
  /* 1103 */  iRegL_rule,
  /* 1104 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_56_immI_56_immIExt_rule,
  /* 1105 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_48_immI_48_immIExt_rule,
  /* 1106 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_32_immI_32_immIExt_rule,
  /* 1107 */  _LShiftI__RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_immIExt_rule,
  /* 1108 */  iRegIorL2I_rule,
  /* 1109 */  _LShiftI__RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_immIExt_rule,
  /* 1110 */  iRegIorL2I_rule,
  /* 1111 */  _LShiftI__RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_immIExt_rule,
  /* 1112 */  _LShiftI__RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_immIExt_rule,
  /* 1113 */  _LShiftL__ConvI2L_iRegIorL2I__immIExt_rule,
  /* 1114 */  iRegL_rule,
  /* 1115 */  _LShiftL__ConvI2L_iRegIorL2I__immIExt_rule,
  /* 1116 */  _LShiftL__AndL_iRegL_immL_255_immIExt_rule,
  /* 1117 */  iRegL_rule,
  /* 1118 */  _LShiftL__AndL_iRegL_immL_65535_immIExt_rule,
  /* 1119 */  iRegL_rule,
  /* 1120 */  _LShiftL__AndL_iRegL_immL_4294967295_immIExt_rule,
  /* 1121 */  iRegL_rule,
  /* 1122 */  _LShiftL__AndL_iRegL_immL_255_immIExt_rule,
  /* 1123 */  _LShiftL__AndL_iRegL_immL_65535_immIExt_rule,
  /* 1124 */  _LShiftL__AndL_iRegL_immL_4294967295_immIExt_rule,
  /* 1125 */  _LShiftI__AndI_iRegIorL2I_immI_255_immIExt_rule,
  /* 1126 */  iRegIorL2I_rule,
  /* 1127 */  _LShiftI__AndI_iRegIorL2I_immI_65535_immIExt_rule,
  /* 1128 */  iRegIorL2I_rule,
  /* 1129 */  _LShiftI__AndI_iRegIorL2I_immI_255_immIExt_rule,
  /* 1130 */  _LShiftI__AndI_iRegIorL2I_immI_65535_immIExt_rule,
  /* 1131 */  0,
  /* 1132 */  0,
  /* 1133 */  0,
  /* 1134 */  0,
  /* 1135 */  0,
  /* 1136 */  0,
  /* 1137 */  0,
  /* 1138 */  0,
  /* 1139 */  immI0_rule,
  /* 1140 */  iRegIorL2I_rule,
  /* 1141 */  immI_1_rule,
  /* 1142 */  iRegIorL2I_rule,
  /* 1143 */  immI_M1_rule,
  /* 1144 */  iRegIorL2I_rule,
  /* 1145 */  immI0_rule,
  /* 1146 */  iRegIorL2I_rule,
  /* 1147 */  immI_1_rule,
  /* 1148 */  iRegIorL2I_rule,
  /* 1149 */  immI_M1_rule,
  /* 1150 */  iRegIorL2I_rule,
  /* 1151 */  vRegF_rule,
  /* 1152 */  vRegD_rule,
  /* 1153 */  vRegF_rule,
  /* 1154 */  vRegD_rule,
  /* 1155 */  vRegF_rule,
  /* 1156 */  vRegD_rule,
  /* 1157 */  _Binary_vRegF_vRegF_rule,
  /* 1158 */  _Binary_vRegD_vRegD_rule,
  /* 1159 */  _Binary__NegF_vRegF__vRegF_rule,
  /* 1160 */  _Binary_vRegF__NegF_vRegF__rule,
  /* 1161 */  _Binary__NegD_vRegD__vRegD_rule,
  /* 1162 */  _Binary_vRegD__NegD_vRegD__rule,
  /* 1163 */  _Binary__NegF_vRegF__vRegF_rule,
  /* 1164 */  _Binary_vRegF__NegF_vRegF__rule,
  /* 1165 */  _Binary__NegD_vRegD__vRegD_rule,
  /* 1166 */  _Binary_vRegD__NegD_vRegD__rule,
  /* 1167 */  _Binary_vRegF_vRegF_rule,
  /* 1168 */  _Binary_vRegD_vRegD_rule,
  /* 1169 */  vRegF_rule,
  /* 1170 */  vRegF_rule,
  /* 1171 */  vRegD_rule,
  /* 1172 */  vRegD_rule,
  /* 1173 */  vRegF_rule,
  /* 1174 */  vRegD_rule,
  /* 1175 */  0,
  /* 1176 */  0,
  /* 1177 */  0,
  /* 1178 */  0,
  /* 1179 */  0,
  /* 1180 */  0,
  /* 1181 */  immI_rule,
  /* 1182 */  _Binary_vRegD_vRegD_rule,
  /* 1183 */  vRegF_rule,
  /* 1184 */  _Binary_vRegD_vRegD_rule,
  /* 1185 */  _Binary_vRegF_vRegF_rule,
  /* 1186 */  0,
  /* 1187 */  iRegIorL2I_rule,
  /* 1188 */  immILog_rule,
  /* 1189 */  iRegIorL2I_rule,
  /* 1190 */  immILog_rule,
  /* 1191 */  iRegIorL2I_rule,
  /* 1192 */  immILog_rule,
  /* 1193 */  iRegL_rule,
  /* 1194 */  immLLog_rule,
  /* 1195 */  iRegL_rule,
  /* 1196 */  immLLog_rule,
  /* 1197 */  iRegL_rule,
  /* 1198 */  immLLog_rule,
  /* 1199 */  0,
  /* 1200 */  immL_32bits_rule,
  /* 1201 */  0,
  /* 1202 */  0,
  /* 1203 */  0,
  /* 1204 */  0,
  /* 1205 */  0,
  /* 1206 */  0,
  /* 1207 */  0,
  /* 1208 */  0,
  /* 1209 */  0,
  /* 1210 */  0,
  /* 1211 */  0,
  /* 1212 */  0,
  /* 1213 */  0,
  /* 1214 */  0,
  /* 1215 */  0,
  /* 1216 */  0,
  /* 1217 */  0,
  /* 1218 */  0,
  /* 1219 */  0,
  /* 1220 */  iRegP_R10_rule,
  /* 1221 */  iRegP_R10_rule,
  /* 1222 */  _OverflowMulI_iRegIorL2I_iRegIorL2I_rule,
  /* 1223 */  _OverflowMulL_iRegL_iRegL_rule,
  /* 1224 */  vRegF_rule,
  /* 1225 */  vRegD_rule,
  /* 1226 */  immF0_rule,
  /* 1227 */  immD0_rule,
  /* 1228 */  iRegIorL2I_rule,
  /* 1229 */  immI0_rule,
  /* 1230 */  iRegIorL2I_rule,
  /* 1231 */  iRegIorL2I_rule,
  /* 1232 */  0,
  /* 1233 */  rFlagsReg_rule,
  /* 1234 */  rFlagsRegU_rule,
  /* 1235 */  _CmpI_iRegIorL2I_immI0_rule,
  /* 1236 */  _CmpL_iRegL_immL0_rule,
  /* 1237 */  _CmpP_iRegP_immP0_rule,
  /* 1238 */  _CmpN_iRegN_immN0_rule,
  /* 1239 */  _CmpP__DecodeN_iRegN__immP0_rule,
  /* 1240 */  _CmpU_iRegIorL2I_immI0_rule,
  /* 1241 */  _CmpUL_iRegL_immL0_rule,
  /* 1242 */  _CmpL_iRegL_immL0_rule,
  /* 1243 */  _CmpI_iRegIorL2I_immI0_rule,
  /* 1244 */  _CmpL__AndL_iRegL_immL_immL0_rule,
  /* 1245 */  _CmpI__AndI_iRegIorL2I_immI_immI0_rule,
  /* 1246 */  _CmpL_iRegL_immL0_rule,
  /* 1247 */  _CmpI_iRegIorL2I_immI0_rule,
  /* 1248 */  _CmpL__AndL_iRegL_immL_immL0_rule,
  /* 1249 */  _CmpI__AndI_iRegIorL2I_immI_immI0_rule,
  /* 1250 */  rFlagsReg_rule,
  /* 1251 */  0,
  /* 1252 */  0,
  /* 1253 */  0,
  /* 1254 */  0,
  /* 1255 */  0,
  /* 1256 */  0,
  /* 1257 */  inline_cache_RegP_rule,
  /* 1258 */  iRegP_R0_rule,
  /* 1259 */  0,
  /* 1260 */  0,
  /* 1261 */  0,
  /* 1262 */  0,
  /* 1263 */  iRegP_R0_rule,
  /* 1264 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /* 1265 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /* 1266 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /* 1267 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /* 1268 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /* 1269 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /* 1270 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /* 1271 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /* 1272 */  _Binary_iRegP_R3_iRegI_R2_rule,
  /* 1273 */  _Binary_iRegP_R3_iRegI_R2_rule,
  /* 1274 */  _Binary_iRegP_R3_iRegI_R2_rule,
  /* 1275 */  _Binary_iRegP_R3_immI_le_4_rule,
  /* 1276 */  _Binary_iRegP_R3_immI_le_4_rule,
  /* 1277 */  _Binary_iRegP_R3_immI_1_rule,
  /* 1278 */  iRegI_R3_rule,
  /* 1279 */  iRegI_R3_rule,
  /* 1280 */  iRegI_R3_rule,
  /* 1281 */  iRegI_R3_rule,
  /* 1282 */  iRegI_R4_rule,
  /* 1283 */  iRegI_R4_rule,
  /* 1284 */  iRegP_R2_rule,
  /* 1285 */  iRegP_R2_rule,
  /* 1286 */  iRegI_R2_rule,
  /* 1287 */  _Binary_iRegP_R1_iRegI_R3_rule,
  /* 1288 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1289 */  _Binary_iRegP_R1_iRegI_R3_rule,
  /* 1290 */  _Binary_iRegP_R1_iRegI_R3_rule,
  /* 1291 */  iRegIorL2I_rule,
  /* 1292 */  immI_rule,
  /* 1293 */  iRegL_rule,
  /* 1294 */  immL_rule,
  /* 1295 */  iRegIorL2I_rule,
  /* 1296 */  immI_rule,
  /* 1297 */  iRegL_rule,
  /* 1298 */  immL_rule,
  /* 1299 */  0,
  /* 1300 */  vReg_rule,
  /* 1301 */  0,
  /* 1302 */  vReg_rule,
  /* 1303 */  0,
  /* 1304 */  vReg_rule,
  /* 1305 */  0,
  /* 1306 */  vReg_rule,
  /* 1307 */  0,
  /* 1308 */  vReg_rule,
  /* 1309 */  pRegGov_rule,
  /* 1310 */  _Binary_vReg_pRegGov_rule,
  /* 1311 */  vReg_rule,
  /* 1312 */  vReg_rule,
  /* 1313 */  vReg_rule,
  /* 1314 */  vReg_rule,
  /* 1315 */  vReg_rule,
  /* 1316 */  vReg_rule,
  /* 1317 */  pRegGov_rule,
  /* 1318 */  pRegGov_rule,
  /* 1319 */  pRegGov_rule,
  /* 1320 */  pRegGov_rule,
  /* 1321 */  pRegGov_rule,
  /* 1322 */  pRegGov_rule,
  /* 1323 */  _ReplicateB_immBAddSubV__rule,
  /* 1324 */  vReg_rule,
  /* 1325 */  _ReplicateS_immIAddSubV__rule,
  /* 1326 */  vReg_rule,
  /* 1327 */  _ReplicateI_immIAddSubV__rule,
  /* 1328 */  vReg_rule,
  /* 1329 */  _ReplicateL_immLAddSubV__rule,
  /* 1330 */  vReg_rule,
  /* 1331 */  vReg_rule,
  /* 1332 */  vReg_rule,
  /* 1333 */  vReg_rule,
  /* 1334 */  vReg_rule,
  /* 1335 */  vReg_rule,
  /* 1336 */  vReg_rule,
  /* 1337 */  pRegGov_rule,
  /* 1338 */  pRegGov_rule,
  /* 1339 */  pRegGov_rule,
  /* 1340 */  pRegGov_rule,
  /* 1341 */  pRegGov_rule,
  /* 1342 */  pRegGov_rule,
  /* 1343 */  vReg_rule,
  /* 1344 */  vReg_rule,
  /* 1345 */  vReg_rule,
  /* 1346 */  vReg_rule,
  /* 1347 */  vReg_rule,
  /* 1348 */  vReg_rule,
  /* 1349 */  vReg_rule,
  /* 1350 */  vReg_rule,
  /* 1351 */  vReg_rule,
  /* 1352 */  vReg_rule,
  /* 1353 */  pRegGov_rule,
  /* 1354 */  pRegGov_rule,
  /* 1355 */  pRegGov_rule,
  /* 1356 */  pRegGov_rule,
  /* 1357 */  pRegGov_rule,
  /* 1358 */  pRegGov_rule,
  /* 1359 */  vReg_rule,
  /* 1360 */  vReg_rule,
  /* 1361 */  vReg_rule,
  /* 1362 */  vReg_rule,
  /* 1363 */  pRegGov_rule,
  /* 1364 */  pRegGov_rule,
  /* 1365 */  vReg_rule,
  /* 1366 */  pRegGov_rule,
  /* 1367 */  _ReplicateB_immBLog__rule,
  /* 1368 */  vReg_rule,
  /* 1369 */  _ReplicateS_immSLog__rule,
  /* 1370 */  vReg_rule,
  /* 1371 */  _ReplicateI_immILog__rule,
  /* 1372 */  vReg_rule,
  /* 1373 */  _ReplicateL_immLLog__rule,
  /* 1374 */  vReg_rule,
  /* 1375 */  vReg_rule,
  /* 1376 */  pRegGov_rule,
  /* 1377 */  _ReplicateB_immBLog__rule,
  /* 1378 */  vReg_rule,
  /* 1379 */  _ReplicateS_immSLog__rule,
  /* 1380 */  vReg_rule,
  /* 1381 */  _ReplicateI_immILog__rule,
  /* 1382 */  vReg_rule,
  /* 1383 */  _ReplicateL_immLLog__rule,
  /* 1384 */  vReg_rule,
  /* 1385 */  vReg_rule,
  /* 1386 */  pRegGov_rule,
  /* 1387 */  _ReplicateB_immBLog__rule,
  /* 1388 */  vReg_rule,
  /* 1389 */  _ReplicateS_immSLog__rule,
  /* 1390 */  vReg_rule,
  /* 1391 */  _ReplicateI_immILog__rule,
  /* 1392 */  vReg_rule,
  /* 1393 */  _ReplicateL_immLLog__rule,
  /* 1394 */  vReg_rule,
  /* 1395 */  _XorV_vReg_vReg_rule,
  /* 1396 */  vReg_rule,
  /* 1397 */  _XorV_vReg_vReg_rule,
  /* 1398 */  vReg_rule,
  /* 1399 */  _ReplicateB_immI_M1__rule,
  /* 1400 */  vReg_rule,
  /* 1401 */  _ReplicateS_immI_M1__rule,
  /* 1402 */  vReg_rule,
  /* 1403 */  _ReplicateI_immI_M1__rule,
  /* 1404 */  vReg_rule,
  /* 1405 */  _ReplicateL_immL_M1__rule,
  /* 1406 */  vReg_rule,
  /* 1407 */  pRegGov_rule,
  /* 1408 */  pRegGov_rule,
  /* 1409 */  pRegGov_rule,
  /* 1410 */  pRegGov_rule,
  /* 1411 */  _XorV_vReg__ReplicateB_immI_M1__rule,
  /* 1412 */  vReg_rule,
  /* 1413 */  _XorV__ReplicateB_immI_M1__vReg_rule,
  /* 1414 */  vReg_rule,
  /* 1415 */  _XorV_vReg__ReplicateS_immI_M1__rule,
  /* 1416 */  vReg_rule,
  /* 1417 */  _XorV__ReplicateS_immI_M1__vReg_rule,
  /* 1418 */  vReg_rule,
  /* 1419 */  _XorV_vReg__ReplicateI_immI_M1__rule,
  /* 1420 */  vReg_rule,
  /* 1421 */  _XorV__ReplicateI_immI_M1__vReg_rule,
  /* 1422 */  vReg_rule,
  /* 1423 */  _XorV_vReg__ReplicateL_immL_M1__rule,
  /* 1424 */  vReg_rule,
  /* 1425 */  _XorV__ReplicateL_immL_M1__vReg_rule,
  /* 1426 */  vReg_rule,
  /* 1427 */  pRegGov_rule,
  /* 1428 */  pRegGov_rule,
  /* 1429 */  pRegGov_rule,
  /* 1430 */  pRegGov_rule,
  /* 1431 */  pRegGov_rule,
  /* 1432 */  pRegGov_rule,
  /* 1433 */  pRegGov_rule,
  /* 1434 */  pRegGov_rule,
  /* 1435 */  pRegGov_rule,
  /* 1436 */  pRegGov_rule,
  /* 1437 */  pRegGov_rule,
  /* 1438 */  pRegGov_rule,
  /* 1439 */  pRegGov_rule,
  /* 1440 */  pRegGov_rule,
  /* 1441 */  0,
  /* 1442 */  0,
  /* 1443 */  0,
  /* 1444 */  0,
  /* 1445 */  pRegGov_rule,
  /* 1446 */  pRegGov_rule,
  /* 1447 */  pRegGov_rule,
  /* 1448 */  pRegGov_rule,
  /* 1449 */  pRegGov_rule,
  /* 1450 */  pRegGov_rule,
  /* 1451 */  pRegGov_rule,
  /* 1452 */  pRegGov_rule,
  /* 1453 */  vReg_rule,
  /* 1454 */  vReg_rule,
  /* 1455 */  vReg_rule,
  /* 1456 */  vReg_rule,
  /* 1457 */  pRegGov_rule,
  /* 1458 */  vReg_rule,
  /* 1459 */  vReg_rule,
  /* 1460 */  vReg_rule,
  /* 1461 */  vReg_rule,
  /* 1462 */  pRegGov_rule,
  /* 1463 */  _MulVB_vReg_vReg_rule,
  /* 1464 */  vReg_rule,
  /* 1465 */  _MulVS_vReg_vReg_rule,
  /* 1466 */  vReg_rule,
  /* 1467 */  _MulVI_vReg_vReg_rule,
  /* 1468 */  vReg_rule,
  /* 1469 */  _MulVL_vReg_vReg_rule,
  /* 1470 */  vReg_rule,
  /* 1471 */  pRegGov_rule,
  /* 1472 */  pRegGov_rule,
  /* 1473 */  pRegGov_rule,
  /* 1474 */  pRegGov_rule,
  /* 1475 */  _Binary_vReg_vReg_rule,
  /* 1476 */  _Binary_vReg_vReg_rule,
  /* 1477 */  _Binary_vReg_pRegGov_rule,
  /* 1478 */  _Binary_vReg_pRegGov_rule,
  /* 1479 */  _MulVB_vReg_vReg_rule,
  /* 1480 */  _MulVS_vReg_vReg_rule,
  /* 1481 */  _MulVI_vReg_vReg_rule,
  /* 1482 */  _MulVL_vReg_vReg_rule,
  /* 1483 */  pRegGov_rule,
  /* 1484 */  pRegGov_rule,
  /* 1485 */  pRegGov_rule,
  /* 1486 */  pRegGov_rule,
  /* 1487 */  _Binary__NegVF_vReg__vReg_rule,
  /* 1488 */  _Binary__NegVD_vReg__vReg_rule,
  /* 1489 */  _Binary_vReg__NegVF_vReg__rule,
  /* 1490 */  _Binary_vReg__NegVD_vReg__rule,
  /* 1491 */  _Binary_vReg_pRegGov_rule,
  /* 1492 */  _Binary_vReg_pRegGov_rule,
  /* 1493 */  _Binary__NegVF_vReg__vReg_rule,
  /* 1494 */  _Binary__NegVD_vReg__vReg_rule,
  /* 1495 */  _Binary_vReg__NegVF_vReg__rule,
  /* 1496 */  _Binary_vReg__NegVD_vReg__rule,
  /* 1497 */  _Binary__NegVF_vReg__pRegGov_rule,
  /* 1498 */  _Binary__NegVD_vReg__pRegGov_rule,
  /* 1499 */  _Binary_vReg_vReg_rule,
  /* 1500 */  _Binary_vReg_vReg_rule,
  /* 1501 */  _Binary__NegVF_vReg__pRegGov_rule,
  /* 1502 */  _Binary__NegVD_vReg__pRegGov_rule,
  /* 1503 */  vReg_rule,
  /* 1504 */  vReg_rule,
  /* 1505 */  vReg_rule,
  /* 1506 */  vReg_rule,
  /* 1507 */  vReg_rule,
  /* 1508 */  vReg_rule,
  /* 1509 */  vReg_rule,
  /* 1510 */  vReg_rule,
  /* 1511 */  vReg_rule,
  /* 1512 */  vReg_rule,
  /* 1513 */  vReg_rule,
  /* 1514 */  vReg_rule,
  /* 1515 */  vReg_rule,
  /* 1516 */  vReg_rule,
  /* 1517 */  vReg_rule,
  /* 1518 */  vReg_rule,
  /* 1519 */  vReg_rule,
  /* 1520 */  vReg_rule,
  /* 1521 */  vReg_rule,
  /* 1522 */  vReg_rule,
  /* 1523 */  vReg_rule,
  /* 1524 */  vReg_rule,
  /* 1525 */  vReg_rule,
  /* 1526 */  vReg_rule,
  /* 1527 */  vReg_rule,
  /* 1528 */  vReg_rule,
  /* 1529 */  vReg_rule,
  /* 1530 */  vReg_rule,
  /* 1531 */  vReg_rule,
  /* 1532 */  vReg_rule,
  /* 1533 */  vReg_rule,
  /* 1534 */  vReg_rule,
  /* 1535 */  vReg_rule,
  /* 1536 */  _LShiftCntV_immI__rule,
  /* 1537 */  _LShiftCntV_immI__rule,
  /* 1538 */  _LShiftCntV_immI__rule,
  /* 1539 */  _LShiftCntV_immI__rule,
  /* 1540 */  _RShiftCntV_immI_positive__rule,
  /* 1541 */  _RShiftCntV_immI_positive__rule,
  /* 1542 */  _RShiftCntV_immI_positive__rule,
  /* 1543 */  _RShiftCntV_immI_positive__rule,
  /* 1544 */  _RShiftCntV_immI_positive__rule,
  /* 1545 */  _RShiftCntV_immI_positive__rule,
  /* 1546 */  _RShiftCntV_immI_positive__rule,
  /* 1547 */  _RShiftCntV_immI_positive__rule,
  /* 1548 */  _RShiftVB_vReg__RShiftCntV_immI_positive__rule,
  /* 1549 */  vReg_rule,
  /* 1550 */  _RShiftVS_vReg__RShiftCntV_immI_positive__rule,
  /* 1551 */  vReg_rule,
  /* 1552 */  _RShiftVI_vReg__RShiftCntV_immI_positive__rule,
  /* 1553 */  vReg_rule,
  /* 1554 */  _RShiftVL_vReg__RShiftCntV_immI_positive__rule,
  /* 1555 */  vReg_rule,
  /* 1556 */  _URShiftVB_vReg__RShiftCntV_immI_positive__rule,
  /* 1557 */  vReg_rule,
  /* 1558 */  _URShiftVS_vReg__RShiftCntV_immI_positive__rule,
  /* 1559 */  vReg_rule,
  /* 1560 */  _URShiftVI_vReg__RShiftCntV_immI_positive__rule,
  /* 1561 */  vReg_rule,
  /* 1562 */  _URShiftVL_vReg__RShiftCntV_immI_positive__rule,
  /* 1563 */  vReg_rule,
  /* 1564 */  pRegGov_rule,
  /* 1565 */  pRegGov_rule,
  /* 1566 */  pRegGov_rule,
  /* 1567 */  pRegGov_rule,
  /* 1568 */  pRegGov_rule,
  /* 1569 */  pRegGov_rule,
  /* 1570 */  pRegGov_rule,
  /* 1571 */  pRegGov_rule,
  /* 1572 */  pRegGov_rule,
  /* 1573 */  pRegGov_rule,
  /* 1574 */  pRegGov_rule,
  /* 1575 */  pRegGov_rule,
  /* 1576 */  pRegGov_rule,
  /* 1577 */  pRegGov_rule,
  /* 1578 */  pRegGov_rule,
  /* 1579 */  pRegGov_rule,
  /* 1580 */  pRegGov_rule,
  /* 1581 */  pRegGov_rule,
  /* 1582 */  pRegGov_rule,
  /* 1583 */  pRegGov_rule,
  /* 1584 */  pRegGov_rule,
  /* 1585 */  pRegGov_rule,
  /* 1586 */  pRegGov_rule,
  /* 1587 */  pRegGov_rule,
  /* 1588 */  vReg_rule,
  /* 1589 */  vReg_rule,
  /* 1590 */  vReg_rule,
  /* 1591 */  vReg_rule,
  /* 1592 */  vReg_rule,
  /* 1593 */  vReg_rule,
  /* 1594 */  vReg_rule,
  /* 1595 */  vReg_rule,
  /* 1596 */  vReg_rule,
  /* 1597 */  pRegGov_rule,
  /* 1598 */  pRegGov_rule,
  /* 1599 */  pRegGov_rule,
  /* 1600 */  pRegGov_rule,
  /* 1601 */  vReg_rule,
  /* 1602 */  vReg_rule,
  /* 1603 */  vReg_rule,
  /* 1604 */  vReg_rule,
  /* 1605 */  vReg_rule,
  /* 1606 */  vReg_rule,
  /* 1607 */  vReg_rule,
  /* 1608 */  vReg_rule,
  /* 1609 */  pRegGov_rule,
  /* 1610 */  pRegGov_rule,
  /* 1611 */  vReg_rule,
  /* 1612 */  vReg_rule,
  /* 1613 */  vReg_rule,
  /* 1614 */  vReg_rule,
  /* 1615 */  pRegGov_rule,
  /* 1616 */  pRegGov_rule,
  /* 1617 */  vReg_rule,
  /* 1618 */  vReg_rule,
  /* 1619 */  vReg_rule,
  /* 1620 */  vReg_rule,
  /* 1621 */  pRegGov_rule,
  /* 1622 */  pRegGov_rule,
  /* 1623 */  vReg_rule,
  /* 1624 */  vReg_rule,
  /* 1625 */  vReg_rule,
  /* 1626 */  vReg_rule,
  /* 1627 */  vReg_rule,
  /* 1628 */  vReg_rule,
  /* 1629 */  pRegGov_rule,
  /* 1630 */  pRegGov_rule,
  /* 1631 */  pRegGov_rule,
  /* 1632 */  pRegGov_rule,
  /* 1633 */  vReg_rule,
  /* 1634 */  vReg_rule,
  /* 1635 */  vReg_rule,
  /* 1636 */  vReg_rule,
  /* 1637 */  vReg_rule,
  /* 1638 */  vReg_rule,
  /* 1639 */  pRegGov_rule,
  /* 1640 */  pRegGov_rule,
  /* 1641 */  pRegGov_rule,
  /* 1642 */  pRegGov_rule,
  /* 1643 */  0,
  /* 1644 */  0,
  /* 1645 */  0,
  /* 1646 */  0,
  /* 1647 */  0,
  /* 1648 */  0,
  /* 1649 */  0,
  /* 1650 */  0,
  /* 1651 */  0,
  /* 1652 */  0,
  /* 1653 */  0,
  /* 1654 */  0,
  /* 1655 */  0,
  /* 1656 */  immI_rule,
  /* 1657 */  immI_rule,
  /* 1658 */  immI_rule,
  /* 1659 */  immI_rule,
  /* 1660 */  immI_rule,
  /* 1661 */  immI_rule,
  /* 1662 */  immI_rule,
  /* 1663 */  immI_rule,
  /* 1664 */  immI_rule,
  /* 1665 */  immI_rule,
  /* 1666 */  immI_rule,
  /* 1667 */  immI_rule,
  /* 1668 */  immI_rule,
  /* 1669 */  immI_rule,
  /* 1670 */  immI_rule,
  /* 1671 */  immI_rule,
  /* 1672 */  immI_rule,
  /* 1673 */  immI_rule,
  /* 1674 */  immI_rule,
  /* 1675 */  immI_rule,
  /* 1676 */  0,
  /* 1677 */  0,
  /* 1678 */  pRegGov_rule,
  /* 1679 */  pRegGov_rule,
  /* 1680 */  immI_1_rule,
  /* 1681 */  immI_gt_1_rule,
  /* 1682 */  immI_1_rule,
  /* 1683 */  immI_gt_1_rule,
  /* 1684 */  0,
  /* 1685 */  pRegGov_rule,
  /* 1686 */  0,
  /* 1687 */  pRegGov_rule,
  /* 1688 */  _VectorStoreMask_pReg_immI_gt_1_rule,
  /* 1689 */  _VectorStoreMask_pReg_immI_gt_1_rule,
  /* 1690 */  _Binary__VectorStoreMask_pReg_immI_gt_1_pRegGov_rule,
  /* 1691 */  _Binary__VectorStoreMask_pReg_immI_gt_1_pRegGov_rule,
  /* 1692 */  pReg_rule,
  /* 1693 */  pReg_rule,
  /* 1694 */  pReg_rule,
  /* 1695 */  _XorVMask_pReg__MaskAll_immI_M1__rule,
  /* 1696 */  _XorVMask_pReg__MaskAll_immL_M1__rule,
  /* 1697 */  immI_rule,
  /* 1698 */  immI_cmp_cond_rule,
  /* 1699 */  immI_cmp_cond_rule,
  /* 1700 */  immI_cmp_cond_rule,
  /* 1701 */  immI_cmp_cond_rule,
  /* 1702 */  immI_cmp_cond_rule,
  /* 1703 */  immI_cmp_cond_rule,
  /* 1704 */  immI_rule,
  /* 1705 */  immI_cmp_cond_rule,
  /* 1706 */  immI_cmpU_cond_rule,
  /* 1707 */  immI_cmp_cond_rule,
  /* 1708 */  immI_cmpU_cond_rule,
  /* 1709 */  immI_cmp_cond_rule,
  /* 1710 */  immI_cmpU_cond_rule,
  /* 1711 */  immI_cmp_cond_rule,
  /* 1712 */  immI_cmpU_cond_rule,
  /* 1713 */  _Binary_immI_pRegGov_rule,
  /* 1714 */  0,
  /* 1715 */  0,
  /* 1716 */  0,
  /* 1717 */  0,
  /* 1718 */  0,
  /* 1719 */  0,
  /* 1720 */  pReg_rule,
  /* 1721 */  0,
  /* 1722 */  0,
  /* 1723 */  0,
  /* 1724 */  0,
  /* 1725 */  0,
  /* 1726 */  pRegGov_rule,
  /* 1727 */  0,
  /* 1728 */  0,
  /* 1729 */  pRegGov_rule,
  /* 1730 */  0,
  /* 1731 */  0,
  /* 1732 */  0,
  /* 1733 */  0,
  /* 1734 */  pRegGov_rule,
  /* 1735 */  pRegGov_rule,
  /* 1736 */  vReg_rule,
  /* 1737 */  pReg_rule,
  /* 1738 */  0,
  /* 1739 */  0,
  /* 1740 */  0,
  /* 1741 */  0,
  /* 1742 */  immI_rule,
  /* 1743 */  vReg_rule,
  /* 1744 */  vReg_rule,
  /* 1745 */  vReg_rule,
  /* 1746 */  vReg_rule,
  /* 1747 */  _Binary_vReg_pRegGov_rule,
  /* 1748 */  _Binary_vReg_pRegGov_rule,
  /* 1749 */  _Binary_vReg_vReg_rule,
  /* 1750 */  _Binary_vReg_vReg_rule,
  /* 1751 */  _Binary_vReg__Binary_vReg_pRegGov_rule,
  /* 1752 */  _Binary_vReg__Binary_vReg_pRegGov_rule,
  /* 1753 */  pRegGov_rule,
  /* 1754 */  pRegGov_rule,
  /* 1755 */  pRegGov_rule,
  /* 1756 */  pRegGov_rule,
  /* 1757 */  immI_rule,
  /* 1758 */  0,
  /* 1759 */  pRegGov_rule,
  /* 1760 */  pReg_rule,
  /* 1761 */  pReg_rule,
  /* 1762 */  pRegGov_rule,
  /* 1763 */  _Binary_vReg_vReg_rule,
  /* 1764 */  _Binary_vReg_vReg_rule,
  /* 1765 */  _Binary_vReg_vReg_rule,
  /* 1766 */  _Binary_vReg_vReg_rule,
  /* 1767 */  vReg_rule,
  /* 1768 */  vReg_rule,
  /* 1769 */  _Binary_iRegP_iRegP_rule,
  /* 1770 */  _Binary_iRegN_iRegN_rule,
  /* 1771 */  _Binary_iRegP_iRegP_rule,
  /* 1772 */  _Binary_iRegN_iRegN_rule,
  /* 1773 */  _Binary_iRegN_iRegN_rule,
  /* 1774 */  _Binary_iRegP_iRegP_rule,
  /* 1775 */  _Binary_iRegN_iRegN_rule,
  /* 1776 */  _Binary_iRegP_iRegP_rule,
  /* 1777 */  _Binary_iRegN_iRegN_rule,
  /* 1778 */  _Binary_iRegP_iRegP_rule,
  /* 1779 */  _Binary_iRegN_iRegN_rule,
  /* 1780 */  _Binary_iRegP_iRegP_rule,
  /* 1781 */  0,
  /* 1782 */  0,
  /* 1783 */  _Binary_iRegP_iRegP_rule,
  /* 1784 */  _Binary_iRegP_iRegP_rule,
  /* 1785 */  _Binary_iRegP_iRegP_rule,
  /* 1786 */  _Binary_iRegP_iRegP_rule,
  /* 1787 */  _Binary_iRegP_iRegP_rule,
  /* 1788 */  _Binary_iRegP_iRegP_rule,
  /* 1789 */  iRegP_rule,
  /* 1790 */  iRegP_rule,
  /* 1791 */  0,
  /* 1792 */  0,
  /* 1793 */  iRegP_rule,
  /* 1794 */  iRegP_rule,
  /* 1795 */  _Binary_iRegP_iRegP_rule,
  /* 1796 */  _Binary_iRegP_iRegP_rule,
  /* 1797 */  _Binary_iRegP_iRegP_rule,
  /* 1798 */  _Binary_iRegP_iRegP_rule,
  /* 1799 */  _Binary_iRegP_iRegP_rule,
  /* 1800 */  _Binary_iRegP_iRegP_rule,
  /* 1801 */  iRegP_rule,
  /* 1802 */  iRegP_rule,
  // last instruction
  0 // no trailing comma
};

const char        *ruleName[] = {
  /*    0 */  "UNIVERSE",
  /*    1 */  "LABEL",
  /*    2 */  "SREGI",
  /*    3 */  "SREGP",
  /*    4 */  "SREGF",
  /*    5 */  "SREGD",
  /*    6 */  "SREGL",
  /*    7 */  "METHOD",
  /*    8 */  "IMMI",
  /*    9 */  "IMMI0",
  /*   10 */  "IMMI_1",
  /*   11 */  "IMMI_M1",
  /*   12 */  "IMMIEXT",
  /*   13 */  "IMMI_GT_1",
  /*   14 */  "IMMI_LE_4",
  /*   15 */  "IMMI_16",
  /*   16 */  "IMMI_24",
  /*   17 */  "IMMI_32",
  /*   18 */  "IMMI_48",
  /*   19 */  "IMMI_56",
  /*   20 */  "IMMI_63",
  /*   21 */  "IMMI_64",
  /*   22 */  "IMMI_255",
  /*   23 */  "IMMI_65535",
  /*   24 */  "IMMI_POSITIVE",
  /*   25 */  "IMMI_CMP_COND",
  /*   26 */  "IMMI_CMPU_COND",
  /*   27 */  "IMML_255",
  /*   28 */  "IMML_65535",
  /*   29 */  "IMML_4294967295",
  /*   30 */  "IMML_BITMASK",
  /*   31 */  "IMMI_BITMASK",
  /*   32 */  "IMML_POSITIVE_BITMASKI",
  /*   33 */  "IMMISCALE",
  /*   34 */  "IMMI26",
  /*   35 */  "IMMI19",
  /*   36 */  "IMMI5",
  /*   37 */  "IMMIU7",
  /*   38 */  "IMMIU12",
  /*   39 */  "IMMLU12",
  /*   40 */  "IMMIOFFSET",
  /*   41 */  "IMMIOFFSET1",
  /*   42 */  "IMMIOFFSET2",
  /*   43 */  "IMMIOFFSET4",
  /*   44 */  "IMMIOFFSET8",
  /*   45 */  "IMMIOFFSET16",
  /*   46 */  "IMMLOFFSET",
  /*   47 */  "IMMLOFFSET1",
  /*   48 */  "IMMLOFFSET2",
  /*   49 */  "IMMLOFFSET4",
  /*   50 */  "IMMLOFFSET8",
  /*   51 */  "IMMLOFFSET16",
  /*   52 */  "IMML5",
  /*   53 */  "IMMLU7",
  /*   54 */  "IMMI8",
  /*   55 */  "IMMI8_SHIFT8",
  /*   56 */  "IMML8_SHIFT8",
  /*   57 */  "IMMBADDSUBV",
  /*   58 */  "IMMIADDSUB",
  /*   59 */  "IMMIADDSUBV",
  /*   60 */  "IMMBLOG",
  /*   61 */  "IMMSLOG",
  /*   62 */  "IMMILOG",
  /*   63 */  "IMML",
  /*   64 */  "IMML0",
  /*   65 */  "IMML_1",
  /*   66 */  "IMML_M1",
  /*   67 */  "IMML_PC_OFF",
  /*   68 */  "IMMLADDSUB",
  /*   69 */  "IMMLADDSUBV",
  /*   70 */  "IMMLLOG",
  /*   71 */  "IMML_32BITS",
  /*   72 */  "IMMP",
  /*   73 */  "IMMP0",
  /*   74 */  "IMMP_1",
  /*   75 */  "IMMBYTEMAPBASE",
  /*   76 */  "IMMP_M1",
  /*   77 */  "IMMP_M2",
  /*   78 */  "IMMD",
  /*   79 */  "IMMD0",
  /*   80 */  "IMMDPACKED",
  /*   81 */  "IMMF",
  /*   82 */  "IMMF0",
  /*   83 */  "IMMFPACKED",
  /*   84 */  "IMMN",
  /*   85 */  "IMMN0",
  /*   86 */  "IMMNKLASS",
  /*   87 */  "IREGI",
  /*   88 */  "IREGINOSP",
  /*   89 */  "IREGL",
  /*   90 */  "IREGLNOSP",
  /*   91 */  "IREGP",
  /*   92 */  "IREGPNOSP",
  /*   93 */  "IREGPNOSPNORFP",
  /*   94 */  "IREGP_R0",
  /*   95 */  "IREGP_R1",
  /*   96 */  "IREGP_R2",
  /*   97 */  "IREGP_R3",
  /*   98 */  "IREGP_R4",
  /*   99 */  "IREGP_R5",
  /*  100 */  "IREGP_R10",
  /*  101 */  "IREGL_R0",
  /*  102 */  "IREGL_R2",
  /*  103 */  "IREGL_R3",
  /*  104 */  "IREGL_R11",
  /*  105 */  "IREGP_FP",
  /*  106 */  "IREGI_R0",
  /*  107 */  "IREGI_R2",
  /*  108 */  "IREGI_R3",
  /*  109 */  "IREGI_R4",
  /*  110 */  "IREGN",
  /*  111 */  "IREGN_R0",
  /*  112 */  "IREGN_R2",
  /*  113 */  "IREGN_R3",
  /*  114 */  "IREGNNOSP",
  /*  115 */  "VREGF",
  /*  116 */  "VREGD",
  /*  117 */  "VREG",
  /*  118 */  "VECA",
  /*  119 */  "VECD",
  /*  120 */  "VECX",
  /*  121 */  "VREGD_V0",
  /*  122 */  "VREGD_V1",
  /*  123 */  "VREGD_V2",
  /*  124 */  "VREGD_V3",
  /*  125 */  "VREGD_V4",
  /*  126 */  "VREGD_V5",
  /*  127 */  "VREGD_V6",
  /*  128 */  "VREGD_V7",
  /*  129 */  "VREGD_V8",
  /*  130 */  "VREGD_V9",
  /*  131 */  "VREGD_V10",
  /*  132 */  "VREGD_V11",
  /*  133 */  "VREGD_V12",
  /*  134 */  "VREGD_V13",
  /*  135 */  "VREGD_V14",
  /*  136 */  "VREGD_V15",
  /*  137 */  "VREGD_V16",
  /*  138 */  "VREGD_V17",
  /*  139 */  "VREGD_V18",
  /*  140 */  "VREGD_V19",
  /*  141 */  "VREGD_V20",
  /*  142 */  "VREGD_V21",
  /*  143 */  "VREGD_V22",
  /*  144 */  "VREGD_V23",
  /*  145 */  "VREGD_V24",
  /*  146 */  "VREGD_V25",
  /*  147 */  "VREGD_V26",
  /*  148 */  "VREGD_V27",
  /*  149 */  "VREGD_V28",
  /*  150 */  "VREGD_V29",
  /*  151 */  "VREGD_V30",
  /*  152 */  "VREGD_V31",
  /*  153 */  "PREG",
  /*  154 */  "PREGGOV",
  /*  155 */  "PREGGOV_P0",
  /*  156 */  "PREGGOV_P1",
  /*  157 */  "RFLAGSREG",
  /*  158 */  "RFLAGSREGU",
  /*  159 */  "INLINE_CACHE_REGP",
  /*  160 */  "THREAD_REGP",
  /*  161 */  "LR_REGP",
  /*  162 */  "INDIRECT",
  /*  163 */  "INDINDEXSCALEDI2L",
  /*  164 */  "INDINDEXSCALED",
  /*  165 */  "INDINDEXI2L",
  /*  166 */  "INDINDEX",
  /*  167 */  "INDOFFI",
  /*  168 */  "INDOFFI1",
  /*  169 */  "INDOFFI2",
  /*  170 */  "INDOFFI4",
  /*  171 */  "INDOFFI8",
  /*  172 */  "INDOFFI16",
  /*  173 */  "INDOFFL",
  /*  174 */  "INDOFFL1",
  /*  175 */  "INDOFFL2",
  /*  176 */  "INDOFFL4",
  /*  177 */  "INDOFFL8",
  /*  178 */  "INDOFFL16",
  /*  179 */  "INDIRECTN",
  /*  180 */  "INDINDEXSCALEDI2LN",
  /*  181 */  "INDINDEXSCALEDN",
  /*  182 */  "INDINDEXI2LN",
  /*  183 */  "INDINDEXN",
  /*  184 */  "INDOFFIN",
  /*  185 */  "INDOFFLN",
  /*  186 */  "THREAD_ANCHOR_PC",
  /*  187 */  "STACKSLOTP",
  /*  188 */  "STACKSLOTI",
  /*  189 */  "STACKSLOTF",
  /*  190 */  "STACKSLOTD",
  /*  191 */  "STACKSLOTL",
  /*  192 */  "CMPOP",
  /*  193 */  "CMPOPU",
  /*  194 */  "CMPOPEQNE",
  /*  195 */  "CMPOPLTGE",
  /*  196 */  "CMPOPUEQNELTGE",
  /*  197 */  "IREGL2I",
  /*  198 */  "VMEMA_IMMIOFFSET4",
  /*  199 */  "VMEMA_IMMLOFFSET4",
  /*  200 */  "VMEMA_INDOFFI4",
  /*  201 */  "VMEMA_INDOFFL4",
  // last operand
  /*  202 */  "VMEM2",
  /*  203 */  "VMEM4",
  /*  204 */  "VMEM8",
  /*  205 */  "VMEM16",
  /*  206 */  "MEMORY1",
  /*  207 */  "MEMORY2",
  /*  208 */  "MEMORY4",
  /*  209 */  "MEMORY8",
  /*  210 */  "MEMORY",
  /*  211 */  "IREGIORL2I",
  /*  212 */  "VMEMA",
  // last operand class
  /*  213 */  "_ConvI2L_iRegI_",
  /*  214 */  "_LShiftL__ConvI2L_iRegI__immIScale",
  /*  215 */  "_LShiftL_iRegL_immIScale",
  /*  216 */  "_DecodeN_iRegN_",
  /*  217 */  "_LoadB_memory1_",
  /*  218 */  "_LoadUB_memory1_",
  /*  219 */  "_LoadS_memory2_",
  /*  220 */  "_LoadUS_memory2_",
  /*  221 */  "_LoadI_memory4_",
  /*  222 */  "_ConvI2L__LoadI_memory4__",
  /*  223 */  "_LoadB_indirect_",
  /*  224 */  "_LoadUB_indirect_",
  /*  225 */  "_LoadUS_indirect_",
  /*  226 */  "_LoadS_indirect_",
  /*  227 */  "_LoadI_indirect_",
  /*  228 */  "_ConvI2L__LoadI_indirect__",
  /*  229 */  "_LoadL_memory8_",
  /*  230 */  "_CastP2X_iRegP_",
  /*  231 */  "_CastP2X__DecodeN_iRegN__",
  /*  232 */  "_Binary_iRegINoSp_iRegINoSp",
  /*  233 */  "_Binary_iRegLNoSp_iRegLNoSp",
  /*  234 */  "_Binary_iRegP_iRegP",
  /*  235 */  "_Binary_iRegNNoSp_iRegNNoSp",
  /*  236 */  "_Binary_iRegI_iRegI",
  /*  237 */  "_Binary_iRegL_iRegL",
  /*  238 */  "_Binary_iRegN_iRegN",
  /*  239 */  "_Binary_cmpOp_rFlagsReg",
  /*  240 */  "_Binary_iRegIorL2I_iRegIorL2I",
  /*  241 */  "_Binary_cmpOpU_rFlagsRegU",
  /*  242 */  "_Binary_immI0_iRegIorL2I",
  /*  243 */  "_Binary_iRegIorL2I_immI0",
  /*  244 */  "_Binary_immI_1_immI0",
  /*  245 */  "_Binary_iRegL_immL0",
  /*  246 */  "_Binary_immL0_iRegL",
  /*  247 */  "_Binary_iRegP_immP0",
  /*  248 */  "_Binary_immP0_iRegP",
  /*  249 */  "_Binary_iRegN_immN0",
  /*  250 */  "_Binary_immN0_iRegN",
  /*  251 */  "_Binary_vRegF_vRegF",
  /*  252 */  "_Binary_vRegD_vRegD",
  /*  253 */  "_ConvL2I_iRegL_",
  /*  254 */  "_ConvI2L_iRegIorL2I_",
  /*  255 */  "_LShiftL__ConvI2L_iRegIorL2I__immIScale",
  /*  256 */  "_MulI_iRegIorL2I_iRegIorL2I",
  /*  257 */  "_SubI_immI0_iRegIorL2I",
  /*  258 */  "_MulL_iRegL_iRegL",
  /*  259 */  "_SubL_immL0_iRegL",
  /*  260 */  "_MulL__ConvI2L_iRegIorL2I___ConvI2L_iRegIorL2I_",
  /*  261 */  "_SubL_immL0__ConvI2L_iRegIorL2I_",
  /*  262 */  "_URShiftI_iRegIorL2I_immI",
  /*  263 */  "_RShiftI_iRegIorL2I_immI",
  /*  264 */  "_LShiftI_iRegIorL2I_immI",
  /*  265 */  "_URShiftL_iRegL_immI",
  /*  266 */  "_RShiftL_iRegL_immI",
  /*  267 */  "_LShiftL_iRegL_immI",
  /*  268 */  "_XorI_iRegIorL2I_immI_M1",
  /*  269 */  "_XorL_iRegL_immL_M1",
  /*  270 */  "_XorI_iRegIorL2I_iRegIorL2I",
  /*  271 */  "_XorL_iRegL_iRegL",
  /*  272 */  "_XorI__URShiftI_iRegIorL2I_immI_immI_M1",
  /*  273 */  "_XorL__URShiftL_iRegL_immI_immL_M1",
  /*  274 */  "_XorI__RShiftI_iRegIorL2I_immI_immI_M1",
  /*  275 */  "_XorL__RShiftL_iRegL_immI_immL_M1",
  /*  276 */  "_RotateRight_iRegIorL2I_immI",
  /*  277 */  "_XorI__RotateRight_iRegIorL2I_immI_immI_M1",
  /*  278 */  "_RotateRight_iRegL_immI",
  /*  279 */  "_XorL__RotateRight_iRegL_immI_immL_M1",
  /*  280 */  "_XorI__LShiftI_iRegIorL2I_immI_immI_M1",
  /*  281 */  "_XorL__LShiftL_iRegL_immI_immL_M1",
  /*  282 */  "_XorI__URShiftI_iRegIorL2I_immI_iRegIorL2I",
  /*  283 */  "_XorI_iRegIorL2I__URShiftI_iRegIorL2I_immI",
  /*  284 */  "_XorL__URShiftL_iRegL_immI_iRegL",
  /*  285 */  "_XorL_iRegL__URShiftL_iRegL_immI",
  /*  286 */  "_XorI__RShiftI_iRegIorL2I_immI_iRegIorL2I",
  /*  287 */  "_XorI_iRegIorL2I__RShiftI_iRegIorL2I_immI",
  /*  288 */  "_XorL__RShiftL_iRegL_immI_iRegL",
  /*  289 */  "_XorL_iRegL__RShiftL_iRegL_immI",
  /*  290 */  "_XorI__RotateRight_iRegIorL2I_immI_iRegIorL2I",
  /*  291 */  "_XorI_iRegIorL2I__RotateRight_iRegIorL2I_immI",
  /*  292 */  "_XorL__RotateRight_iRegL_immI_iRegL",
  /*  293 */  "_XorL_iRegL__RotateRight_iRegL_immI",
  /*  294 */  "_XorI__LShiftI_iRegIorL2I_immI_iRegIorL2I",
  /*  295 */  "_XorI_iRegIorL2I__LShiftI_iRegIorL2I_immI",
  /*  296 */  "_XorL__LShiftL_iRegL_immI_iRegL",
  /*  297 */  "_XorL_iRegL__LShiftL_iRegL_immI",
  /*  298 */  "_AndI__URShiftI_iRegIorL2I_immI_immI_bitmask",
  /*  299 */  "_AndI_iRegIorL2I_immI_bitmask",
  /*  300 */  "_AndL_iRegL_immL_bitmask",
  /*  301 */  "_LShiftI__AndI_iRegIorL2I_immI_bitmask_immI",
  /*  302 */  "_AndL_iRegL_immL_positive_bitmaskI",
  /*  303 */  "_LShiftL__AndL_iRegL_immL_positive_bitmaskI_immI",
  /*  304 */  "_ConvI2L__AndI_iRegIorL2I_immI_bitmask_",
  /*  305 */  "_ConvL2I__AndL_iRegL_immL_positive_bitmaskI_",
  /*  306 */  "_AndI_iRegI_immI_bitmask",
  /*  307 */  "_LShiftI_iRegIorL2I_immI_16",
  /*  308 */  "_RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16",
  /*  309 */  "_LShiftI_iRegIorL2I_immI_24",
  /*  310 */  "_RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24",
  /*  311 */  "_URShiftI__LShiftI_iRegIorL2I_immI_24_immI_24",
  /*  312 */  "_LShiftL_iRegL_immI_48",
  /*  313 */  "_RShiftL__LShiftL_iRegL_immI_48_immI_48",
  /*  314 */  "_LShiftL_iRegL_immI_32",
  /*  315 */  "_RShiftL__LShiftL_iRegL_immI_32_immI_32",
  /*  316 */  "_LShiftL_iRegL_immI_56",
  /*  317 */  "_RShiftL__LShiftL_iRegL_immI_56_immI_56",
  /*  318 */  "_URShiftL__LShiftL_iRegL_immI_56_immI_56",
  /*  319 */  "_AndI_iRegIorL2I_immI_255",
  /*  320 */  "_AndI_iRegIorL2I_immI_65535",
  /*  321 */  "_AndL_iRegL_immL_255",
  /*  322 */  "_AndL_iRegL_immL_65535",
  /*  323 */  "_AndL_iRegL_immL_4294967295",
  /*  324 */  "_LShiftL__RShiftL__LShiftL_iRegL_immI_56_immI_56_immIExt",
  /*  325 */  "_LShiftL__RShiftL__LShiftL_iRegL_immI_48_immI_48_immIExt",
  /*  326 */  "_LShiftL__RShiftL__LShiftL_iRegL_immI_32_immI_32_immIExt",
  /*  327 */  "_LShiftI__RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_immIExt",
  /*  328 */  "_LShiftI__RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_immIExt",
  /*  329 */  "_LShiftL__ConvI2L_iRegIorL2I__immIExt",
  /*  330 */  "_LShiftL__AndL_iRegL_immL_255_immIExt",
  /*  331 */  "_LShiftL__AndL_iRegL_immL_65535_immIExt",
  /*  332 */  "_LShiftL__AndL_iRegL_immL_4294967295_immIExt",
  /*  333 */  "_LShiftI__AndI_iRegIorL2I_immI_255_immIExt",
  /*  334 */  "_LShiftI__AndI_iRegIorL2I_immI_65535_immIExt",
  /*  335 */  "_NegF_vRegF_",
  /*  336 */  "_Binary__NegF_vRegF__vRegF",
  /*  337 */  "_Binary_vRegF__NegF_vRegF_",
  /*  338 */  "_NegD_vRegD_",
  /*  339 */  "_Binary__NegD_vRegD__vRegD",
  /*  340 */  "_Binary_vRegD__NegD_vRegD_",
  /*  341 */  "_SubF_vRegF_vRegF",
  /*  342 */  "_SubD_vRegD_vRegD",
  /*  343 */  "_OverflowMulI_iRegIorL2I_iRegIorL2I",
  /*  344 */  "_OverflowMulL_iRegL_iRegL",
  /*  345 */  "_CmpI_iRegIorL2I_immI0",
  /*  346 */  "_CmpL_iRegL_immL0",
  /*  347 */  "_CmpP_iRegP_immP0",
  /*  348 */  "_CmpN_iRegN_immN0",
  /*  349 */  "_CmpP__DecodeN_iRegN__immP0",
  /*  350 */  "_CmpU_iRegIorL2I_immI0",
  /*  351 */  "_CmpUL_iRegL_immL0",
  /*  352 */  "_AndL_iRegL_immL",
  /*  353 */  "_CmpL__AndL_iRegL_immL_immL0",
  /*  354 */  "_AndI_iRegIorL2I_immI",
  /*  355 */  "_CmpI__AndI_iRegIorL2I_immI_immI0",
  /*  356 */  "_AndL_iRegL_iRegL",
  /*  357 */  "_AndI_iRegIorL2I_iRegIorL2I",
  /*  358 */  "_PartialSubtypeCheck_iRegP_R4_iRegP_R0",
  /*  359 */  "_Binary_iRegP_R1_iRegI_R2",
  /*  360 */  "_Binary_iRegP_R3_iRegI_R4",
  /*  361 */  "_Binary_iRegP_R1_iRegI_R4",
  /*  362 */  "_Binary_iRegP_R3_iRegI_R2",
  /*  363 */  "_Binary_iRegP_R3_immI_le_4",
  /*  364 */  "_Binary_iRegP_R3_immI_1",
  /*  365 */  "_Binary_iRegP_R1_iRegP_R3",
  /*  366 */  "_Binary_iRegP_R1_iRegI_R3",
  /*  367 */  "_Binary_vReg_pRegGov",
  /*  368 */  "_Binary_vReg_vReg",
  /*  369 */  "_ReplicateB_immBAddSubV_",
  /*  370 */  "_ReplicateS_immIAddSubV_",
  /*  371 */  "_ReplicateI_immIAddSubV_",
  /*  372 */  "_ReplicateL_immLAddSubV_",
  /*  373 */  "_ReplicateB_immBLog_",
  /*  374 */  "_ReplicateS_immSLog_",
  /*  375 */  "_ReplicateI_immILog_",
  /*  376 */  "_ReplicateL_immLLog_",
  /*  377 */  "_XorV_vReg_vReg",
  /*  378 */  "_ReplicateB_immI_M1_",
  /*  379 */  "_ReplicateS_immI_M1_",
  /*  380 */  "_ReplicateI_immI_M1_",
  /*  381 */  "_ReplicateL_immL_M1_",
  /*  382 */  "_Binary_vReg__ReplicateB_immI_M1_",
  /*  383 */  "_Binary_vReg__ReplicateS_immI_M1_",
  /*  384 */  "_Binary_vReg__ReplicateI_immI_M1_",
  /*  385 */  "_Binary_vReg__ReplicateL_immL_M1_",
  /*  386 */  "_XorV_vReg__ReplicateB_immI_M1_",
  /*  387 */  "_XorV__ReplicateB_immI_M1__vReg",
  /*  388 */  "_XorV_vReg__ReplicateS_immI_M1_",
  /*  389 */  "_XorV__ReplicateS_immI_M1__vReg",
  /*  390 */  "_XorV_vReg__ReplicateI_immI_M1_",
  /*  391 */  "_XorV__ReplicateI_immI_M1__vReg",
  /*  392 */  "_XorV_vReg__ReplicateL_immL_M1_",
  /*  393 */  "_XorV__ReplicateL_immL_M1__vReg",
  /*  394 */  "_Binary_vReg__XorV_vReg__ReplicateB_immI_M1_",
  /*  395 */  "_Binary_vReg__XorV__ReplicateB_immI_M1__vReg",
  /*  396 */  "_Binary_vReg__XorV_vReg__ReplicateS_immI_M1_",
  /*  397 */  "_Binary_vReg__XorV__ReplicateS_immI_M1__vReg",
  /*  398 */  "_Binary_vReg__XorV_vReg__ReplicateI_immI_M1_",
  /*  399 */  "_Binary_vReg__XorV__ReplicateI_immI_M1__vReg",
  /*  400 */  "_Binary_vReg__XorV_vReg__ReplicateL_immL_M1_",
  /*  401 */  "_Binary_vReg__XorV__ReplicateL_immL_M1__vReg",
  /*  402 */  "_SubVF_vReg_vReg",
  /*  403 */  "_SubVD_vReg_vReg",
  /*  404 */  "_SubVF__Binary_vReg_vReg_pRegGov",
  /*  405 */  "_SubVD__Binary_vReg_vReg_pRegGov",
  /*  406 */  "_MulVB_vReg_vReg",
  /*  407 */  "_MulVS_vReg_vReg",
  /*  408 */  "_MulVI_vReg_vReg",
  /*  409 */  "_MulVL_vReg_vReg",
  /*  410 */  "_Binary_vReg__MulVB_vReg_vReg",
  /*  411 */  "_Binary_vReg__MulVS_vReg_vReg",
  /*  412 */  "_Binary_vReg__MulVI_vReg_vReg",
  /*  413 */  "_Binary_vReg__MulVL_vReg_vReg",
  /*  414 */  "_NegVF_vReg_",
  /*  415 */  "_Binary__NegVF_vReg__vReg",
  /*  416 */  "_NegVD_vReg_",
  /*  417 */  "_Binary__NegVD_vReg__vReg",
  /*  418 */  "_Binary_vReg__NegVF_vReg_",
  /*  419 */  "_Binary_vReg__NegVD_vReg_",
  /*  420 */  "_Binary__NegVF_vReg__pRegGov",
  /*  421 */  "_Binary__NegVD_vReg__pRegGov",
  /*  422 */  "_LShiftCntV_immI_",
  /*  423 */  "_RShiftCntV_immI_positive_",
  /*  424 */  "_RShiftVB_vReg__RShiftCntV_immI_positive_",
  /*  425 */  "_RShiftVS_vReg__RShiftCntV_immI_positive_",
  /*  426 */  "_RShiftVI_vReg__RShiftCntV_immI_positive_",
  /*  427 */  "_RShiftVL_vReg__RShiftCntV_immI_positive_",
  /*  428 */  "_URShiftVB_vReg__RShiftCntV_immI_positive_",
  /*  429 */  "_URShiftVS_vReg__RShiftCntV_immI_positive_",
  /*  430 */  "_URShiftVI_vReg__RShiftCntV_immI_positive_",
  /*  431 */  "_URShiftVL_vReg__RShiftCntV_immI_positive_",
  /*  432 */  "_Binary_vReg__LShiftCntV_immI_",
  /*  433 */  "_Binary_vReg__RShiftCntV_immI_positive_",
  /*  434 */  "_Binary_iRegIorL2I_vReg",
  /*  435 */  "_Binary_iRegL_vReg",
  /*  436 */  "_Binary_vRegF_vReg",
  /*  437 */  "_Binary_vRegD_vReg",
  /*  438 */  "_Binary_vReg_iRegIorL2I",
  /*  439 */  "_Binary_vReg_iRegL",
  /*  440 */  "_Binary_vReg_vRegF",
  /*  441 */  "_Binary_vReg_vRegD",
  /*  442 */  "_LoadVector_indirect_",
  /*  443 */  "_LoadVectorMasked_vmemA_pRegGov",
  /*  444 */  "_VectorStoreMask_pReg_immI_gt_1",
  /*  445 */  "_Binary__VectorStoreMask_pReg_immI_gt_1_pRegGov",
  /*  446 */  "_MaskAll_immI_M1_",
  /*  447 */  "_XorVMask_pReg__MaskAll_immI_M1_",
  /*  448 */  "_MaskAll_immL_M1_",
  /*  449 */  "_XorVMask_pReg__MaskAll_immL_M1_",
  /*  450 */  "_ReplicateB_immI0_",
  /*  451 */  "_Binary_vReg__ReplicateB_immI0_",
  /*  452 */  "_ReplicateS_immI0_",
  /*  453 */  "_Binary_vReg__ReplicateS_immI0_",
  /*  454 */  "_ReplicateI_immI0_",
  /*  455 */  "_Binary_vReg__ReplicateI_immI0_",
  /*  456 */  "_ReplicateL_immL0_",
  /*  457 */  "_Binary_vReg__ReplicateL_immL0_",
  /*  458 */  "_ReplicateF_immF0_",
  /*  459 */  "_Binary_vReg__ReplicateF_immF0_",
  /*  460 */  "_ReplicateD_immD0_",
  /*  461 */  "_Binary_vReg__ReplicateD_immD0_",
  /*  462 */  "_ReplicateB_immI5_",
  /*  463 */  "_Binary_vReg__ReplicateB_immI5_",
  /*  464 */  "_ReplicateB_immIU7_",
  /*  465 */  "_Binary_vReg__ReplicateB_immIU7_",
  /*  466 */  "_ReplicateS_immI5_",
  /*  467 */  "_Binary_vReg__ReplicateS_immI5_",
  /*  468 */  "_ReplicateS_immIU7_",
  /*  469 */  "_Binary_vReg__ReplicateS_immIU7_",
  /*  470 */  "_ReplicateI_immI5_",
  /*  471 */  "_Binary_vReg__ReplicateI_immI5_",
  /*  472 */  "_ReplicateI_immIU7_",
  /*  473 */  "_Binary_vReg__ReplicateI_immIU7_",
  /*  474 */  "_ReplicateL_immL5_",
  /*  475 */  "_Binary_vReg__ReplicateL_immL5_",
  /*  476 */  "_ReplicateL_immLU7_",
  /*  477 */  "_Binary_vReg__ReplicateL_immLU7_",
  /*  478 */  "_Binary_immI_pRegGov",
  /*  479 */  "_VectorStoreMask_vReg_immI_gt_1",
  /*  480 */  "_SubL_iRegL_iRegL",
  /*  481 */  "_Binary_vReg__Binary_vReg_pRegGov",
  // last internally defined operand
  /*  482 */  "loadConI",
  /*  483 */  "loadConL",
  /*  484 */  "loadConP",
  /*  485 */  "loadConP0",
  /*  486 */  "loadConP1",
  /*  487 */  "loadByteMapBase",
  /*  488 */  "loadConN",
  /*  489 */  "loadConN0",
  /*  490 */  "loadConNKlass",
  /*  491 */  "loadConF_packed",
  /*  492 */  "loadConF",
  /*  493 */  "loadConD_packed",
  /*  494 */  "loadConD",
  /*  495 */  "countLeadingZerosI",
  /*  496 */  "countLeadingZerosL",
  /*  497 */  "countTrailingZerosI",
  /*  498 */  "countTrailingZerosL",
  /*  499 */  "castX2P",
  /*  500 */  "castP2X",
  /*  501 */  "checkCastPP",
  /*  502 */  "castPP",
  /*  503 */  "castII",
  /*  504 */  "castLL",
  /*  505 */  "castFF",
  /*  506 */  "castDD",
  /*  507 */  "castVV",
  /*  508 */  "castVVMask",
  /*  509 */  "bits_reverse_I",
  /*  510 */  "bits_reverse_L",
  /*  511 */  "negF_reg_reg",
  /*  512 */  "negD_reg_reg",
  /*  513 */  "absF_reg",
  /*  514 */  "absD_reg",
  /*  515 */  "MoveF2I_stack_reg",
  /*  516 */  "MoveI2F_stack_reg",
  /*  517 */  "MoveD2L_stack_reg",
  /*  518 */  "MoveL2D_stack_reg",
  /*  519 */  "MoveF2I_reg_reg",
  /*  520 */  "MoveI2F_reg_reg",
  /*  521 */  "MoveD2L_reg_reg",
  /*  522 */  "MoveL2D_reg_reg",
  /*  523 */  "overflowAddI_reg_reg",
  /*  524 */  "overflowAddI_reg_imm",
  /*  525 */  "overflowAddL_reg_reg",
  /*  526 */  "overflowAddL_reg_imm",
  /*  527 */  "overflowSubI_reg_reg",
  /*  528 */  "overflowSubI_reg_imm",
  /*  529 */  "overflowSubL_reg_reg",
  /*  530 */  "overflowSubL_reg_imm",
  /*  531 */  "overflowNegI_reg",
  /*  532 */  "overflowNegL_reg",
  /*  533 */  "overflowMulI_reg",
  /*  534 */  "overflowMulL_reg",
  /*  535 */  "compI_reg_reg",
  /*  536 */  "compI_reg_immI0",
  /*  537 */  "compI_reg_immIAddSub",
  /*  538 */  "compI_reg_immI",
  /*  539 */  "compU_reg_reg",
  /*  540 */  "compU_reg_immI0",
  /*  541 */  "compU_reg_immIAddSub",
  /*  542 */  "compU_reg_immI",
  /*  543 */  "compL_reg_reg",
  /*  544 */  "compL_reg_immL0",
  /*  545 */  "compL_reg_immLAddSub",
  /*  546 */  "compL_reg_immL",
  /*  547 */  "compUL_reg_reg",
  /*  548 */  "compUL_reg_immL0",
  /*  549 */  "compUL_reg_immLAddSub",
  /*  550 */  "compUL_reg_immL",
  /*  551 */  "compP_reg_reg",
  /*  552 */  "compN_reg_reg",
  /*  553 */  "testP_reg",
  /*  554 */  "testN_reg",
  /*  555 */  "compF_reg_reg",
  /*  556 */  "compF_reg_zero",
  /*  557 */  "compD_reg_reg",
  /*  558 */  "compD_reg_zero",
  /*  559 */  "compI_reg_imm0",
  /*  560 */  "cmpL_and",
  /*  561 */  "cmpI_and",
  /*  562 */  "cmpL_and_reg",
  /*  563 */  "cmpI_and_reg",
  /*  564 */  "cmpFastLock",
  /*  565 */  "cmpFastUnlock",
  /*  566 */  "partialSubtypeCheckVsZero",
  /*  567 */  "tlsLoadP",
  /*  568 */  "vloadcon",
  /*  569 */  "vabsB",
  /*  570 */  "vabsS",
  /*  571 */  "vabsI",
  /*  572 */  "vabsL",
  /*  573 */  "vabsF",
  /*  574 */  "vabsD",
  /*  575 */  "vnegI",
  /*  576 */  "vnegL",
  /*  577 */  "vnegF",
  /*  578 */  "vnegD",
  /*  579 */  "vsqrtF",
  /*  580 */  "vsqrtD",
  /*  581 */  "vshiftcntL",
  /*  582 */  "vshiftcntR",
  /*  583 */  "reinterpret_same_size",
  /*  584 */  "reinterpret_resize_le128b",
  /*  585 */  "vcvtBtoX",
  /*  586 */  "vcvtStoB_neon",
  /*  587 */  "vcvtStoX_extend",
  /*  588 */  "vcvtItoX",
  /*  589 */  "vcvtLtoI_neon",
  /*  590 */  "vcvtLtoD",
  /*  591 */  "vcvtFtoX",
  /*  592 */  "vcvtDtoL",
  /*  593 */  "vcvtDtoF_64b",
  /*  594 */  "vcvtHFtoF",
  /*  595 */  "vcvtFtoHF_neon",
  /*  596 */  "replicateB",
  /*  597 */  "replicateS",
  /*  598 */  "replicateI",
  /*  599 */  "replicateL",
  /*  600 */  "replicateF",
  /*  601 */  "replicateD",
  /*  602 */  "replicateI_imm_le128b",
  /*  603 */  "replicateI_imm_le128b_0",
  /*  604 */  "replicateI_imm_le128b_1",
  /*  605 */  "replicateB_imm8_gt128b",
  /*  606 */  "replicateS_imm8_gt128b",
  /*  607 */  "replicateI_imm8_gt128b",
  /*  608 */  "replicateL_imm_128b",
  /*  609 */  "replicateL_imm8_gt128b",
  /*  610 */  "vloadmask_neon",
  /*  611 */  "vmaskcast_same_esize_neon",
  /*  612 */  "vmaskcast_extend_neon",
  /*  613 */  "vmaskcast_narrow_neon",
  /*  614 */  "vmaskcast_same_esize_sve",
  /*  615 */  "vmaskcast_extend_sve",
  /*  616 */  "vmask_reinterpret_same_esize",
  /*  617 */  "vmask_truecount_sve",
  /*  618 */  "vmask_firsttrue_8or16e",
  /*  619 */  "vmask_lasttrue_neon",
  /*  620 */  "vmask_tolong_neon",
  /*  621 */  "vpopcountI",
  /*  622 */  "vpopcountL",
  /*  623 */  "vtest_anytrue_neon",
  /*  624 */  "vtest_anytrue_sve",
  /*  625 */  "vtest_alltrue_neon",
  /*  626 */  "vtest_alltrue_sve",
  /*  627 */  "loadshuffle",
  /*  628 */  "vcountLeadingZeros",
  /*  629 */  "vcountTrailingZeros",
  /*  630 */  "vreverse",
  /*  631 */  "vreverseBytes",
  /*  632 */  "loadB",
  /*  633 */  "loadB2L",
  /*  634 */  "loadUB",
  /*  635 */  "loadUB2L",
  /*  636 */  "loadS",
  /*  637 */  "loadS2L",
  /*  638 */  "loadUS",
  /*  639 */  "loadUS2L",
  /*  640 */  "loadI",
  /*  641 */  "loadI2L",
  /*  642 */  "loadUI2L",
  /*  643 */  "loadL",
  /*  644 */  "loadRange",
  /*  645 */  "loadP",
  /*  646 */  "loadN",
  /*  647 */  "loadKlass",
  /*  648 */  "loadNKlass",
  /*  649 */  "loadF",
  /*  650 */  "loadD",
  /*  651 */  "storeimmCM0",
  /*  652 */  "storeimmCM0_ordered",
  /*  653 */  "storeB",
  /*  654 */  "storeimmB0",
  /*  655 */  "storeC",
  /*  656 */  "storeimmC0",
  /*  657 */  "storeI",
  /*  658 */  "storeimmI0",
  /*  659 */  "storeL",
  /*  660 */  "storeimmL0",
  /*  661 */  "storeP",
  /*  662 */  "storeimmP0",
  /*  663 */  "storeN",
  /*  664 */  "storeImmN0",
  /*  665 */  "storeF",
  /*  666 */  "storeD",
  /*  667 */  "storeNKlass",
  /*  668 */  "prefetchalloc",
  /*  669 */  "loadB_volatile",
  /*  670 */  "loadB2L_volatile",
  /*  671 */  "loadUB_volatile",
  /*  672 */  "loadUB2L_volatile",
  /*  673 */  "loadS_volatile",
  /*  674 */  "loadUS_volatile",
  /*  675 */  "loadUS2L_volatile",
  /*  676 */  "loadS2L_volatile",
  /*  677 */  "loadI_volatile",
  /*  678 */  "loadUI2L_volatile",
  /*  679 */  "loadL_volatile",
  /*  680 */  "loadP_volatile",
  /*  681 */  "loadN_volatile",
  /*  682 */  "loadF_volatile",
  /*  683 */  "loadD_volatile",
  /*  684 */  "storeB_volatile",
  /*  685 */  "storeimmB0_volatile",
  /*  686 */  "storeC_volatile",
  /*  687 */  "storeimmC0_volatile",
  /*  688 */  "storeI_volatile",
  /*  689 */  "storeimmI0_volatile",
  /*  690 */  "storeL_volatile",
  /*  691 */  "storeimmL0_volatile",
  /*  692 */  "storeP_volatile",
  /*  693 */  "storeimmP0_volatile",
  /*  694 */  "storeN_volatile",
  /*  695 */  "storeimmN0_volatile",
  /*  696 */  "storeF_volatile",
  /*  697 */  "storeD_volatile",
  /*  698 */  "cacheWB",
  /*  699 */  "cacheWBPreSync",
  /*  700 */  "cacheWBPostSync",
  /*  701 */  "bytes_reverse_int",
  /*  702 */  "bytes_reverse_long",
  /*  703 */  "bytes_reverse_unsigned_short",
  /*  704 */  "bytes_reverse_short",
  /*  705 */  "popCountI",
  /*  706 */  "popCountI_mem",
  /*  707 */  "popCountL",
  /*  708 */  "popCountL_mem",
  /*  709 */  "load_fence",
  /*  710 */  "unnecessary_membar_acquire",
  /*  711 */  "membar_acquire",
  /*  712 */  "membar_acquire_lock",
  /*  713 */  "store_fence",
  /*  714 */  "unnecessary_membar_release",
  /*  715 */  "membar_release",
  /*  716 */  "membar_storestore",
  /*  717 */  "membar_storestore_0",
  /*  718 */  "membar_release_lock",
  /*  719 */  "unnecessary_membar_volatile",
  /*  720 */  "membar_volatile",
  /*  721 */  "convP2I",
  /*  722 */  "convN2I",
  /*  723 */  "encodeHeapOop",
  /*  724 */  "encodeHeapOop_not_null",
  /*  725 */  "decodeHeapOop",
  /*  726 */  "decodeHeapOop_not_null",
  /*  727 */  "encodeKlass_not_null",
  /*  728 */  "decodeKlass_not_null",
  /*  729 */  "compareAndSwapB",
  /*  730 */  "compareAndSwapS",
  /*  731 */  "compareAndSwapI",
  /*  732 */  "compareAndSwapL",
  /*  733 */  "compareAndSwapP",
  /*  734 */  "compareAndSwapN",
  /*  735 */  "compareAndSwapBAcq",
  /*  736 */  "compareAndSwapSAcq",
  /*  737 */  "compareAndSwapIAcq",
  /*  738 */  "compareAndSwapLAcq",
  /*  739 */  "compareAndSwapPAcq",
  /*  740 */  "compareAndSwapNAcq",
  /*  741 */  "compareAndExchangeB",
  /*  742 */  "compareAndExchangeS",
  /*  743 */  "compareAndExchangeI",
  /*  744 */  "compareAndExchangeL",
  /*  745 */  "compareAndExchangeN",
  /*  746 */  "compareAndExchangeP",
  /*  747 */  "compareAndExchangeBAcq",
  /*  748 */  "compareAndExchangeSAcq",
  /*  749 */  "compareAndExchangeIAcq",
  /*  750 */  "compareAndExchangeLAcq",
  /*  751 */  "compareAndExchangeNAcq",
  /*  752 */  "compareAndExchangePAcq",
  /*  753 */  "weakCompareAndSwapB",
  /*  754 */  "weakCompareAndSwapS",
  /*  755 */  "weakCompareAndSwapI",
  /*  756 */  "weakCompareAndSwapL",
  /*  757 */  "weakCompareAndSwapN",
  /*  758 */  "weakCompareAndSwapP",
  /*  759 */  "weakCompareAndSwapBAcq",
  /*  760 */  "weakCompareAndSwapSAcq",
  /*  761 */  "weakCompareAndSwapIAcq",
  /*  762 */  "weakCompareAndSwapLAcq",
  /*  763 */  "weakCompareAndSwapNAcq",
  /*  764 */  "weakCompareAndSwapPAcq",
  /*  765 */  "get_and_setI",
  /*  766 */  "get_and_setL",
  /*  767 */  "get_and_setN",
  /*  768 */  "get_and_setP",
  /*  769 */  "get_and_setIAcq",
  /*  770 */  "get_and_setLAcq",
  /*  771 */  "get_and_setNAcq",
  /*  772 */  "get_and_setPAcq",
  /*  773 */  "get_and_addL",
  /*  774 */  "get_and_addL_no_res",
  /*  775 */  "get_and_addLi",
  /*  776 */  "get_and_addLi_no_res",
  /*  777 */  "get_and_addI",
  /*  778 */  "get_and_addI_no_res",
  /*  779 */  "get_and_addIi",
  /*  780 */  "get_and_addIi_no_res",
  /*  781 */  "get_and_addLAcq",
  /*  782 */  "get_and_addL_no_resAcq",
  /*  783 */  "get_and_addLiAcq",
  /*  784 */  "get_and_addLi_no_resAcq",
  /*  785 */  "get_and_addIAcq",
  /*  786 */  "get_and_addI_no_resAcq",
  /*  787 */  "get_and_addIiAcq",
  /*  788 */  "get_and_addIi_no_resAcq",
  /*  789 */  "cmpU3_reg_reg",
  /*  790 */  "cmpU3_reg_imm",
  /*  791 */  "cmpUL3_reg_reg",
  /*  792 */  "cmpUL3_reg_imm",
  /*  793 */  "cmpL3_reg_reg",
  /*  794 */  "cmpL3_reg_imm",
  /*  795 */  "cmovI_reg_reg",
  /*  796 */  "cmovUI_reg_reg",
  /*  797 */  "cmovI_zero_reg",
  /*  798 */  "cmovUI_zero_reg",
  /*  799 */  "cmovI_reg_zero",
  /*  800 */  "cmovUI_reg_zero",
  /*  801 */  "cmovI_reg_zero_one",
  /*  802 */  "cmovUI_reg_zero_one",
  /*  803 */  "cmovL_reg_reg",
  /*  804 */  "cmovUL_reg_reg",
  /*  805 */  "cmovL_reg_zero",
  /*  806 */  "cmovUL_reg_zero",
  /*  807 */  "cmovL_zero_reg",
  /*  808 */  "cmovUL_zero_reg",
  /*  809 */  "cmovP_reg_reg",
  /*  810 */  "cmovUP_reg_reg",
  /*  811 */  "cmovP_reg_zero",
  /*  812 */  "cmovUP_reg_zero",
  /*  813 */  "cmovP_zero_reg",
  /*  814 */  "cmovUP_zero_reg",
  /*  815 */  "cmovN_reg_reg",
  /*  816 */  "cmovUN_reg_reg",
  /*  817 */  "cmovN_reg_zero",
  /*  818 */  "cmovUN_reg_zero",
  /*  819 */  "cmovN_zero_reg",
  /*  820 */  "cmovUN_zero_reg",
  /*  821 */  "cmovF_reg",
  /*  822 */  "cmovUF_reg",
  /*  823 */  "cmovD_reg",
  /*  824 */  "cmovUD_reg",
  /*  825 */  "addI_reg_reg",
  /*  826 */  "addI_reg_imm",
  /*  827 */  "addI_reg_imm_i2l",
  /*  828 */  "addP_reg_reg",
  /*  829 */  "addP_reg_reg_ext",
  /*  830 */  "addP_reg_reg_lsl",
  /*  831 */  "addP_reg_reg_ext_shift",
  /*  832 */  "lshift_ext",
  /*  833 */  "addP_reg_imm",
  /*  834 */  "addL_reg_reg",
  /*  835 */  "addL_reg_imm",
  /*  836 */  "subI_reg_reg",
  /*  837 */  "subI_reg_imm",
  /*  838 */  "subL_reg_reg",
  /*  839 */  "subL_reg_imm",
  /*  840 */  "negI_reg",
  /*  841 */  "negL_reg",
  /*  842 */  "mulI",
  /*  843 */  "smulI",
  /*  844 */  "smulI_0",
  /*  845 */  "mulL",
  /*  846 */  "mulHiL_rReg",
  /*  847 */  "umulHiL_rReg",
  /*  848 */  "maddI",
  /*  849 */  "maddI_0",
  /*  850 */  "msubI",
  /*  851 */  "mnegI",
  /*  852 */  "mnegI_0",
  /*  853 */  "maddL",
  /*  854 */  "maddL_0",
  /*  855 */  "msubL",
  /*  856 */  "mnegL",
  /*  857 */  "mnegL_0",
  /*  858 */  "smaddL",
  /*  859 */  "smaddL_1",
  /*  860 */  "smaddL_0",
  /*  861 */  "smaddL_2",
  /*  862 */  "smsubL",
  /*  863 */  "smsubL_0",
  /*  864 */  "smnegL",
  /*  865 */  "smnegL_0",
  /*  866 */  "muladdS2I",
  /*  867 */  "divI",
  /*  868 */  "divL",
  /*  869 */  "modI",
  /*  870 */  "modL",
  /*  871 */  "UdivI_reg_reg",
  /*  872 */  "UdivL_reg_reg",
  /*  873 */  "UmodI_reg_reg",
  /*  874 */  "UModL_reg_reg",
  /*  875 */  "lShiftI_reg_reg",
  /*  876 */  "lShiftI_reg_imm",
  /*  877 */  "urShiftI_reg_reg",
  /*  878 */  "urShiftI_reg_imm",
  /*  879 */  "rShiftI_reg_reg",
  /*  880 */  "rShiftI_reg_imm",
  /*  881 */  "lShiftL_reg_reg",
  /*  882 */  "lShiftL_reg_imm",
  /*  883 */  "urShiftL_reg_reg",
  /*  884 */  "urShiftL_reg_imm",
  /*  885 */  "urShiftP_reg_imm",
  /*  886 */  "rShiftL_reg_reg",
  /*  887 */  "rShiftL_reg_imm",
  /*  888 */  "regL_not_reg",
  /*  889 */  "regI_not_reg",
  /*  890 */  "NegI_reg_URShift_reg",
  /*  891 */  "NegI_reg_RShift_reg",
  /*  892 */  "NegI_reg_LShift_reg",
  /*  893 */  "NegL_reg_URShift_reg",
  /*  894 */  "NegL_reg_RShift_reg",
  /*  895 */  "NegL_reg_LShift_reg",
  /*  896 */  "AndI_reg_not_reg",
  /*  897 */  "AndI_reg_not_reg_0",
  /*  898 */  "AndL_reg_not_reg",
  /*  899 */  "AndL_reg_not_reg_0",
  /*  900 */  "OrI_reg_not_reg",
  /*  901 */  "OrI_reg_not_reg_0",
  /*  902 */  "OrL_reg_not_reg",
  /*  903 */  "OrL_reg_not_reg_0",
  /*  904 */  "XorI_reg_not_reg",
  /*  905 */  "XorI_reg_not_reg_0",
  /*  906 */  "XorL_reg_not_reg",
  /*  907 */  "XorL_reg_not_reg_0",
  /*  908 */  "AndI_reg_URShift_not_reg",
  /*  909 */  "AndI_reg_URShift_not_reg_0",
  /*  910 */  "AndL_reg_URShift_not_reg",
  /*  911 */  "AndL_reg_URShift_not_reg_0",
  /*  912 */  "AndI_reg_RShift_not_reg",
  /*  913 */  "AndI_reg_RShift_not_reg_0",
  /*  914 */  "AndL_reg_RShift_not_reg",
  /*  915 */  "AndL_reg_RShift_not_reg_0",
  /*  916 */  "AndI_reg_RotateRight_not_reg",
  /*  917 */  "AndI_reg_RotateRight_not_reg_0",
  /*  918 */  "AndL_reg_RotateRight_not_reg",
  /*  919 */  "AndL_reg_RotateRight_not_reg_0",
  /*  920 */  "AndI_reg_LShift_not_reg",
  /*  921 */  "AndI_reg_LShift_not_reg_0",
  /*  922 */  "AndL_reg_LShift_not_reg",
  /*  923 */  "AndL_reg_LShift_not_reg_0",
  /*  924 */  "XorI_reg_URShift_not_reg",
  /*  925 */  "XorI_reg_URShift_not_reg_1",
  /*  926 */  "XorI_reg_URShift_not_reg_0",
  /*  927 */  "XorI_reg_URShift_not_reg_2",
  /*  928 */  "XorL_reg_URShift_not_reg",
  /*  929 */  "XorL_reg_URShift_not_reg_1",
  /*  930 */  "XorL_reg_URShift_not_reg_0",
  /*  931 */  "XorL_reg_URShift_not_reg_2",
  /*  932 */  "XorI_reg_RShift_not_reg",
  /*  933 */  "XorI_reg_RShift_not_reg_1",
  /*  934 */  "XorI_reg_RShift_not_reg_0",
  /*  935 */  "XorI_reg_RShift_not_reg_2",
  /*  936 */  "XorL_reg_RShift_not_reg",
  /*  937 */  "XorL_reg_RShift_not_reg_1",
  /*  938 */  "XorL_reg_RShift_not_reg_0",
  /*  939 */  "XorL_reg_RShift_not_reg_2",
  /*  940 */  "XorI_reg_RotateRight_not_reg",
  /*  941 */  "XorI_reg_RotateRight_not_reg_1",
  /*  942 */  "XorI_reg_RotateRight_not_reg_0",
  /*  943 */  "XorI_reg_RotateRight_not_reg_2",
  /*  944 */  "XorL_reg_RotateRight_not_reg",
  /*  945 */  "XorL_reg_RotateRight_not_reg_1",
  /*  946 */  "XorL_reg_RotateRight_not_reg_0",
  /*  947 */  "XorL_reg_RotateRight_not_reg_2",
  /*  948 */  "XorI_reg_LShift_not_reg",
  /*  949 */  "XorI_reg_LShift_not_reg_1",
  /*  950 */  "XorI_reg_LShift_not_reg_0",
  /*  951 */  "XorI_reg_LShift_not_reg_2",
  /*  952 */  "XorL_reg_LShift_not_reg",
  /*  953 */  "XorL_reg_LShift_not_reg_1",
  /*  954 */  "XorL_reg_LShift_not_reg_0",
  /*  955 */  "XorL_reg_LShift_not_reg_2",
  /*  956 */  "OrI_reg_URShift_not_reg",
  /*  957 */  "OrI_reg_URShift_not_reg_0",
  /*  958 */  "OrL_reg_URShift_not_reg",
  /*  959 */  "OrL_reg_URShift_not_reg_0",
  /*  960 */  "OrI_reg_RShift_not_reg",
  /*  961 */  "OrI_reg_RShift_not_reg_0",
  /*  962 */  "OrL_reg_RShift_not_reg",
  /*  963 */  "OrL_reg_RShift_not_reg_0",
  /*  964 */  "OrI_reg_RotateRight_not_reg",
  /*  965 */  "OrI_reg_RotateRight_not_reg_0",
  /*  966 */  "OrL_reg_RotateRight_not_reg",
  /*  967 */  "OrL_reg_RotateRight_not_reg_0",
  /*  968 */  "OrI_reg_LShift_not_reg",
  /*  969 */  "OrI_reg_LShift_not_reg_0",
  /*  970 */  "OrL_reg_LShift_not_reg",
  /*  971 */  "OrL_reg_LShift_not_reg_0",
  /*  972 */  "AndI_reg_URShift_reg",
  /*  973 */  "AndI_reg_URShift_reg_0",
  /*  974 */  "AndL_reg_URShift_reg",
  /*  975 */  "AndL_reg_URShift_reg_0",
  /*  976 */  "AndI_reg_RShift_reg",
  /*  977 */  "AndI_reg_RShift_reg_0",
  /*  978 */  "AndL_reg_RShift_reg",
  /*  979 */  "AndL_reg_RShift_reg_0",
  /*  980 */  "AndI_reg_LShift_reg",
  /*  981 */  "AndI_reg_LShift_reg_0",
  /*  982 */  "AndL_reg_LShift_reg",
  /*  983 */  "AndL_reg_LShift_reg_0",
  /*  984 */  "AndI_reg_RotateRight_reg",
  /*  985 */  "AndI_reg_RotateRight_reg_0",
  /*  986 */  "AndL_reg_RotateRight_reg",
  /*  987 */  "AndL_reg_RotateRight_reg_0",
  /*  988 */  "XorI_reg_URShift_reg",
  /*  989 */  "XorI_reg_URShift_reg_0",
  /*  990 */  "XorL_reg_URShift_reg",
  /*  991 */  "XorL_reg_URShift_reg_0",
  /*  992 */  "XorI_reg_RShift_reg",
  /*  993 */  "XorI_reg_RShift_reg_0",
  /*  994 */  "XorL_reg_RShift_reg",
  /*  995 */  "XorL_reg_RShift_reg_0",
  /*  996 */  "XorI_reg_LShift_reg",
  /*  997 */  "XorI_reg_LShift_reg_0",
  /*  998 */  "XorL_reg_LShift_reg",
  /*  999 */  "XorL_reg_LShift_reg_0",
  /* 1000 */  "XorI_reg_RotateRight_reg",
  /* 1001 */  "XorI_reg_RotateRight_reg_0",
  /* 1002 */  "XorL_reg_RotateRight_reg",
  /* 1003 */  "XorL_reg_RotateRight_reg_0",
  /* 1004 */  "OrI_reg_URShift_reg",
  /* 1005 */  "OrI_reg_URShift_reg_0",
  /* 1006 */  "OrL_reg_URShift_reg",
  /* 1007 */  "OrL_reg_URShift_reg_0",
  /* 1008 */  "OrI_reg_RShift_reg",
  /* 1009 */  "OrI_reg_RShift_reg_0",
  /* 1010 */  "OrL_reg_RShift_reg",
  /* 1011 */  "OrL_reg_RShift_reg_0",
  /* 1012 */  "OrI_reg_LShift_reg",
  /* 1013 */  "OrI_reg_LShift_reg_0",
  /* 1014 */  "OrL_reg_LShift_reg",
  /* 1015 */  "OrL_reg_LShift_reg_0",
  /* 1016 */  "OrI_reg_RotateRight_reg",
  /* 1017 */  "OrI_reg_RotateRight_reg_0",
  /* 1018 */  "OrL_reg_RotateRight_reg",
  /* 1019 */  "OrL_reg_RotateRight_reg_0",
  /* 1020 */  "AddI_reg_URShift_reg",
  /* 1021 */  "AddI_reg_URShift_reg_0",
  /* 1022 */  "AddL_reg_URShift_reg",
  /* 1023 */  "AddL_reg_URShift_reg_0",
  /* 1024 */  "AddI_reg_RShift_reg",
  /* 1025 */  "AddI_reg_RShift_reg_0",
  /* 1026 */  "AddL_reg_RShift_reg",
  /* 1027 */  "AddL_reg_RShift_reg_0",
  /* 1028 */  "AddI_reg_LShift_reg",
  /* 1029 */  "AddI_reg_LShift_reg_0",
  /* 1030 */  "AddL_reg_LShift_reg",
  /* 1031 */  "AddL_reg_LShift_reg_0",
  /* 1032 */  "SubI_reg_URShift_reg",
  /* 1033 */  "SubL_reg_URShift_reg",
  /* 1034 */  "SubI_reg_RShift_reg",
  /* 1035 */  "SubL_reg_RShift_reg",
  /* 1036 */  "SubI_reg_LShift_reg",
  /* 1037 */  "SubL_reg_LShift_reg",
  /* 1038 */  "sbfmL",
  /* 1039 */  "sbfmwI",
  /* 1040 */  "ubfmL",
  /* 1041 */  "ubfmwI",
  /* 1042 */  "ubfxwI",
  /* 1043 */  "ubfxL",
  /* 1044 */  "ubfxIConvI2L",
  /* 1045 */  "ubfizwI",
  /* 1046 */  "ubfizL",
  /* 1047 */  "ubfizwIConvI2L",
  /* 1048 */  "ubfizLConvL2I",
  /* 1049 */  "ubfizIConvI2L",
  /* 1050 */  "ubfizLConvL2Ix",
  /* 1051 */  "ubfizIConvI2LAndI",
  /* 1052 */  "extrOrL",
  /* 1053 */  "extrOrL_0",
  /* 1054 */  "extrOrI",
  /* 1055 */  "extrOrI_0",
  /* 1056 */  "extrAddL",
  /* 1057 */  "extrAddL_0",
  /* 1058 */  "extrAddI",
  /* 1059 */  "extrAddI_0",
  /* 1060 */  "rorI_imm",
  /* 1061 */  "rorL_imm",
  /* 1062 */  "rorI_reg",
  /* 1063 */  "rorL_reg",
  /* 1064 */  "rolI_reg",
  /* 1065 */  "rolL_reg",
  /* 1066 */  "AddExtI",
  /* 1067 */  "AddExtI_0",
  /* 1068 */  "SubExtI",
  /* 1069 */  "AddExtI_sxth",
  /* 1070 */  "AddExtI_sxth_0",
  /* 1071 */  "AddExtI_sxtb",
  /* 1072 */  "AddExtI_sxtb_0",
  /* 1073 */  "AddExtI_uxtb",
  /* 1074 */  "AddExtI_uxtb_0",
  /* 1075 */  "AddExtL_sxth",
  /* 1076 */  "AddExtL_sxth_0",
  /* 1077 */  "AddExtL_sxtw",
  /* 1078 */  "AddExtL_sxtw_0",
  /* 1079 */  "AddExtL_sxtb",
  /* 1080 */  "AddExtL_sxtb_0",
  /* 1081 */  "AddExtL_uxtb",
  /* 1082 */  "AddExtL_uxtb_0",
  /* 1083 */  "AddExtI_uxtb_and",
  /* 1084 */  "AddExtI_uxtb_and_0",
  /* 1085 */  "AddExtI_uxth_and",
  /* 1086 */  "AddExtI_uxth_and_0",
  /* 1087 */  "AddExtL_uxtb_and",
  /* 1088 */  "AddExtL_uxtb_and_0",
  /* 1089 */  "AddExtL_uxth_and",
  /* 1090 */  "AddExtL_uxth_and_0",
  /* 1091 */  "AddExtL_uxtw_and",
  /* 1092 */  "AddExtL_uxtw_and_0",
  /* 1093 */  "SubExtI_uxtb_and",
  /* 1094 */  "SubExtI_uxth_and",
  /* 1095 */  "SubExtL_uxtb_and",
  /* 1096 */  "SubExtL_uxth_and",
  /* 1097 */  "SubExtL_uxtw_and",
  /* 1098 */  "AddExtL_sxtb_shift",
  /* 1099 */  "AddExtL_sxtb_shift_0",
  /* 1100 */  "AddExtL_sxth_shift",
  /* 1101 */  "AddExtL_sxth_shift_0",
  /* 1102 */  "AddExtL_sxtw_shift",
  /* 1103 */  "AddExtL_sxtw_shift_0",
  /* 1104 */  "SubExtL_sxtb_shift",
  /* 1105 */  "SubExtL_sxth_shift",
  /* 1106 */  "SubExtL_sxtw_shift",
  /* 1107 */  "AddExtI_sxtb_shift",
  /* 1108 */  "AddExtI_sxtb_shift_0",
  /* 1109 */  "AddExtI_sxth_shift",
  /* 1110 */  "AddExtI_sxth_shift_0",
  /* 1111 */  "SubExtI_sxtb_shift",
  /* 1112 */  "SubExtI_sxth_shift",
  /* 1113 */  "AddExtI_shift",
  /* 1114 */  "AddExtI_shift_0",
  /* 1115 */  "SubExtI_shift",
  /* 1116 */  "AddExtL_uxtb_and_shift",
  /* 1117 */  "AddExtL_uxtb_and_shift_0",
  /* 1118 */  "AddExtL_uxth_and_shift",
  /* 1119 */  "AddExtL_uxth_and_shift_0",
  /* 1120 */  "AddExtL_uxtw_and_shift",
  /* 1121 */  "AddExtL_uxtw_and_shift_0",
  /* 1122 */  "SubExtL_uxtb_and_shift",
  /* 1123 */  "SubExtL_uxth_and_shift",
  /* 1124 */  "SubExtL_uxtw_and_shift",
  /* 1125 */  "AddExtI_uxtb_and_shift",
  /* 1126 */  "AddExtI_uxtb_and_shift_0",
  /* 1127 */  "AddExtI_uxth_and_shift",
  /* 1128 */  "AddExtI_uxth_and_shift_0",
  /* 1129 */  "SubExtI_uxtb_and_shift",
  /* 1130 */  "SubExtI_uxth_and_shift",
  /* 1131 */  "cmovI_reg_reg_lt",
  /* 1132 */  "cmovI_reg_reg_gt",
  /* 1133 */  "cmovI_reg_imm0_lt",
  /* 1134 */  "cmovI_reg_imm0_gt",
  /* 1135 */  "cmovI_reg_imm1_le",
  /* 1136 */  "cmovI_reg_imm1_gt",
  /* 1137 */  "cmovI_reg_immM1_lt",
  /* 1138 */  "cmovI_reg_immM1_ge",
  /* 1139 */  "minI_reg_imm0",
  /* 1140 */  "minI_imm0_reg",
  /* 1141 */  "minI_reg_imm1",
  /* 1142 */  "minI_imm1_reg",
  /* 1143 */  "minI_reg_immM1",
  /* 1144 */  "minI_immM1_reg",
  /* 1145 */  "maxI_reg_imm0",
  /* 1146 */  "maxI_imm0_reg",
  /* 1147 */  "maxI_reg_imm1",
  /* 1148 */  "maxI_imm1_reg",
  /* 1149 */  "maxI_reg_immM1",
  /* 1150 */  "maxI_immM1_reg",
  /* 1151 */  "addF_reg_reg",
  /* 1152 */  "addD_reg_reg",
  /* 1153 */  "subF_reg_reg",
  /* 1154 */  "subD_reg_reg",
  /* 1155 */  "mulF_reg_reg",
  /* 1156 */  "mulD_reg_reg",
  /* 1157 */  "maddF_reg_reg",
  /* 1158 */  "maddD_reg_reg",
  /* 1159 */  "msubF_reg_reg",
  /* 1160 */  "msubF_reg_reg_0",
  /* 1161 */  "msubD_reg_reg",
  /* 1162 */  "msubD_reg_reg_0",
  /* 1163 */  "mnaddF_reg_reg",
  /* 1164 */  "mnaddF_reg_reg_0",
  /* 1165 */  "mnaddD_reg_reg",
  /* 1166 */  "mnaddD_reg_reg_0",
  /* 1167 */  "mnsubF_reg_reg",
  /* 1168 */  "mnsubD_reg_reg",
  /* 1169 */  "maxF_reg_reg",
  /* 1170 */  "minF_reg_reg",
  /* 1171 */  "maxD_reg_reg",
  /* 1172 */  "minD_reg_reg",
  /* 1173 */  "divF_reg_reg",
  /* 1174 */  "divD_reg_reg",
  /* 1175 */  "absI_reg",
  /* 1176 */  "absL_reg",
  /* 1177 */  "absdF_reg",
  /* 1178 */  "absdD_reg",
  /* 1179 */  "sqrtD_reg",
  /* 1180 */  "sqrtF_reg",
  /* 1181 */  "roundD_reg",
  /* 1182 */  "copySignD_reg",
  /* 1183 */  "copySignF_reg",
  /* 1184 */  "signumD_reg",
  /* 1185 */  "signumF_reg",
  /* 1186 */  "onspinwait",
  /* 1187 */  "andI_reg_reg",
  /* 1188 */  "andI_reg_imm",
  /* 1189 */  "orI_reg_reg",
  /* 1190 */  "orI_reg_imm",
  /* 1191 */  "xorI_reg_reg",
  /* 1192 */  "xorI_reg_imm",
  /* 1193 */  "andL_reg_reg",
  /* 1194 */  "andL_reg_imm",
  /* 1195 */  "orL_reg_reg",
  /* 1196 */  "orL_reg_imm",
  /* 1197 */  "xorL_reg_reg",
  /* 1198 */  "xorL_reg_imm",
  /* 1199 */  "convI2L_reg_reg",
  /* 1200 */  "convUI2L_reg_reg",
  /* 1201 */  "convL2I_reg",
  /* 1202 */  "convD2F_reg",
  /* 1203 */  "convF2D_reg",
  /* 1204 */  "convF2I_reg_reg",
  /* 1205 */  "convF2L_reg_reg",
  /* 1206 */  "convF2HF_reg_reg",
  /* 1207 */  "convHF2F_reg_reg",
  /* 1208 */  "convI2F_reg_reg",
  /* 1209 */  "convL2F_reg_reg",
  /* 1210 */  "convD2I_reg_reg",
  /* 1211 */  "convD2L_reg_reg",
  /* 1212 */  "convI2D_reg_reg",
  /* 1213 */  "convL2D_reg_reg",
  /* 1214 */  "round_double_reg",
  /* 1215 */  "round_float_reg",
  /* 1216 */  "MoveF2I_reg_stack",
  /* 1217 */  "MoveI2F_reg_stack",
  /* 1218 */  "MoveD2L_reg_stack",
  /* 1219 */  "MoveL2D_reg_stack",
  /* 1220 */  "clearArray_reg_reg",
  /* 1221 */  "clearArray_imm_reg",
  /* 1222 */  "overflowMulI_reg_branch",
  /* 1223 */  "overflowMulL_reg_branch",
  /* 1224 */  "compF3_reg_reg",
  /* 1225 */  "compD3_reg_reg",
  /* 1226 */  "compF3_reg_immF0",
  /* 1227 */  "compD3_reg_immD0",
  /* 1228 */  "cmpLTMask_reg_reg",
  /* 1229 */  "cmpLTMask_reg_zero",
  /* 1230 */  "minI_reg_reg",
  /* 1231 */  "maxI_reg_reg",
  /* 1232 */  "branch",
  /* 1233 */  "branchCon",
  /* 1234 */  "branchConU",
  /* 1235 */  "cmpI_imm0_branch",
  /* 1236 */  "cmpL_imm0_branch",
  /* 1237 */  "cmpP_imm0_branch",
  /* 1238 */  "cmpN_imm0_branch",
  /* 1239 */  "cmpP_narrowOop_imm0_branch",
  /* 1240 */  "cmpUI_imm0_branch",
  /* 1241 */  "cmpUL_imm0_branch",
  /* 1242 */  "cmpL_branch_sign",
  /* 1243 */  "cmpI_branch_sign",
  /* 1244 */  "cmpL_branch_bit",
  /* 1245 */  "cmpI_branch_bit",
  /* 1246 */  "far_cmpL_branch_sign",
  /* 1247 */  "far_cmpI_branch_sign",
  /* 1248 */  "far_cmpL_branch_bit",
  /* 1249 */  "far_cmpI_branch_bit",
  /* 1250 */  "branchLoopEnd",
  /* 1251 */  "safePoint",
  /* 1252 */  "CallStaticJavaDirect",
  /* 1253 */  "CallDynamicJavaDirect",
  /* 1254 */  "CallRuntimeDirect",
  /* 1255 */  "CallLeafDirect",
  /* 1256 */  "CallLeafNoFPDirect",
  /* 1257 */  "TailCalljmpInd",
  /* 1258 */  "TailjmpInd",
  /* 1259 */  "CreateException",
  /* 1260 */  "RethrowException",
  /* 1261 */  "Ret",
  /* 1262 */  "ShouldNotReachHere",
  /* 1263 */  "partialSubtypeCheck",
  /* 1264 */  "string_compareU",
  /* 1265 */  "string_compareL",
  /* 1266 */  "string_compareUL",
  /* 1267 */  "string_compareLU",
  /* 1268 */  "string_compareLL_sve",
  /* 1269 */  "string_compareLU_sve",
  /* 1270 */  "string_compareUL_sve",
  /* 1271 */  "string_compareUU_sve",
  /* 1272 */  "string_indexofUU",
  /* 1273 */  "string_indexofLL",
  /* 1274 */  "string_indexofUL",
  /* 1275 */  "string_indexof_conUU",
  /* 1276 */  "string_indexof_conLL",
  /* 1277 */  "string_indexof_conUL",
  /* 1278 */  "string_indexof_char",
  /* 1279 */  "stringL_indexof_char",
  /* 1280 */  "stringL_indexof_char_sve",
  /* 1281 */  "stringU_indexof_char_sve",
  /* 1282 */  "string_equalsL",
  /* 1283 */  "string_equalsU",
  /* 1284 */  "array_equalsB",
  /* 1285 */  "array_equalsC",
  /* 1286 */  "count_positives",
  /* 1287 */  "string_compress",
  /* 1288 */  "string_inflate",
  /* 1289 */  "encode_iso_array",
  /* 1290 */  "encode_ascii_array",
  /* 1291 */  "compressBitsI_reg",
  /* 1292 */  "compressBitsI_memcon",
  /* 1293 */  "compressBitsL_reg",
  /* 1294 */  "compressBitsL_memcon",
  /* 1295 */  "expandBitsI_reg",
  /* 1296 */  "expandBitsI_memcon",
  /* 1297 */  "expandBitsL_reg",
  /* 1298 */  "expandBitsL_memcon",
  /* 1299 */  "loadV2",
  /* 1300 */  "storeV2",
  /* 1301 */  "loadV4",
  /* 1302 */  "storeV4",
  /* 1303 */  "loadV8",
  /* 1304 */  "storeV8",
  /* 1305 */  "loadV16",
  /* 1306 */  "storeV16",
  /* 1307 */  "loadV",
  /* 1308 */  "storeV",
  /* 1309 */  "loadV_masked",
  /* 1310 */  "storeV_masked",
  /* 1311 */  "vaddB",
  /* 1312 */  "vaddS",
  /* 1313 */  "vaddI",
  /* 1314 */  "vaddL",
  /* 1315 */  "vaddF",
  /* 1316 */  "vaddD",
  /* 1317 */  "vaddB_masked",
  /* 1318 */  "vaddS_masked",
  /* 1319 */  "vaddI_masked",
  /* 1320 */  "vaddL_masked",
  /* 1321 */  "vaddF_masked",
  /* 1322 */  "vaddD_masked",
  /* 1323 */  "vaddImmB",
  /* 1324 */  "vaddImmB_0",
  /* 1325 */  "vaddImmS",
  /* 1326 */  "vaddImmS_0",
  /* 1327 */  "vaddImmI",
  /* 1328 */  "vaddImmI_0",
  /* 1329 */  "vaddImmL",
  /* 1330 */  "vaddImmL_0",
  /* 1331 */  "vsubB",
  /* 1332 */  "vsubS",
  /* 1333 */  "vsubI",
  /* 1334 */  "vsubL",
  /* 1335 */  "vsubF",
  /* 1336 */  "vsubD",
  /* 1337 */  "vsubB_masked",
  /* 1338 */  "vsubS_masked",
  /* 1339 */  "vsubI_masked",
  /* 1340 */  "vsubL_masked",
  /* 1341 */  "vsubF_masked",
  /* 1342 */  "vsubD_masked",
  /* 1343 */  "vmulB_neon",
  /* 1344 */  "vmulB_sve",
  /* 1345 */  "vmulS_neon",
  /* 1346 */  "vmulS_sve",
  /* 1347 */  "vmulI_neon",
  /* 1348 */  "vmulI_sve",
  /* 1349 */  "vmulL_neon",
  /* 1350 */  "vmulL_sve",
  /* 1351 */  "vmulF",
  /* 1352 */  "vmulD",
  /* 1353 */  "vmulB_masked",
  /* 1354 */  "vmulS_masked",
  /* 1355 */  "vmulI_masked",
  /* 1356 */  "vmulL_masked",
  /* 1357 */  "vmulF_masked",
  /* 1358 */  "vmulD_masked",
  /* 1359 */  "vdivF_neon",
  /* 1360 */  "vdivF_sve",
  /* 1361 */  "vdivD_neon",
  /* 1362 */  "vdivD_sve",
  /* 1363 */  "vdivF_masked",
  /* 1364 */  "vdivD_masked",
  /* 1365 */  "vand",
  /* 1366 */  "vand_masked",
  /* 1367 */  "vandImmB",
  /* 1368 */  "vandImmB_0",
  /* 1369 */  "vandImmS",
  /* 1370 */  "vandImmS_0",
  /* 1371 */  "vandImmI",
  /* 1372 */  "vandImmI_0",
  /* 1373 */  "vandImmL",
  /* 1374 */  "vandImmL_0",
  /* 1375 */  "vor",
  /* 1376 */  "vor_masked",
  /* 1377 */  "vorImmB",
  /* 1378 */  "vorImmB_0",
  /* 1379 */  "vorImmS",
  /* 1380 */  "vorImmS_0",
  /* 1381 */  "vorImmI",
  /* 1382 */  "vorImmI_0",
  /* 1383 */  "vorImmL",
  /* 1384 */  "vorImmL_0",
  /* 1385 */  "vxor",
  /* 1386 */  "vxor_masked",
  /* 1387 */  "vxorImmB",
  /* 1388 */  "vxorImmB_0",
  /* 1389 */  "vxorImmS",
  /* 1390 */  "vxorImmS_0",
  /* 1391 */  "vxorImmI",
  /* 1392 */  "vxorImmI_0",
  /* 1393 */  "vxorImmL",
  /* 1394 */  "vxorImmL_0",
  /* 1395 */  "veor3_neon",
  /* 1396 */  "veor3_neon_0",
  /* 1397 */  "veor3_sve",
  /* 1398 */  "veor3_sve_0",
  /* 1399 */  "vnotI",
  /* 1400 */  "vnotI_0",
  /* 1401 */  "vnotI_1",
  /* 1402 */  "vnotI_2",
  /* 1403 */  "vnotI_3",
  /* 1404 */  "vnotI_4",
  /* 1405 */  "vnotL",
  /* 1406 */  "vnotL_0",
  /* 1407 */  "vnotI_masked",
  /* 1408 */  "vnotI_masked_0",
  /* 1409 */  "vnotI_masked_1",
  /* 1410 */  "vnotL_masked",
  /* 1411 */  "vand_notI",
  /* 1412 */  "vand_notI_1",
  /* 1413 */  "vand_notI_0",
  /* 1414 */  "vand_notI_2",
  /* 1415 */  "vand_notI_3",
  /* 1416 */  "vand_notI_5",
  /* 1417 */  "vand_notI_4",
  /* 1418 */  "vand_notI_6",
  /* 1419 */  "vand_notI_7",
  /* 1420 */  "vand_notI_9",
  /* 1421 */  "vand_notI_8",
  /* 1422 */  "vand_notI_10",
  /* 1423 */  "vand_notL",
  /* 1424 */  "vand_notL_1",
  /* 1425 */  "vand_notL_0",
  /* 1426 */  "vand_notL_2",
  /* 1427 */  "vand_notI_masked",
  /* 1428 */  "vand_notI_masked_0",
  /* 1429 */  "vand_notI_masked_1",
  /* 1430 */  "vand_notI_masked_2",
  /* 1431 */  "vand_notI_masked_3",
  /* 1432 */  "vand_notI_masked_4",
  /* 1433 */  "vand_notL_masked",
  /* 1434 */  "vand_notL_masked_0",
  /* 1435 */  "vabsB_masked",
  /* 1436 */  "vabsS_masked",
  /* 1437 */  "vabsI_masked",
  /* 1438 */  "vabsL_masked",
  /* 1439 */  "vabsF_masked",
  /* 1440 */  "vabsD_masked",
  /* 1441 */  "vfabd_neon",
  /* 1442 */  "vfabd_neon_0",
  /* 1443 */  "vfabd_sve",
  /* 1444 */  "vfabd_sve_0",
  /* 1445 */  "vfabd_masked",
  /* 1446 */  "vfabd_masked_0",
  /* 1447 */  "vnegI_masked",
  /* 1448 */  "vnegL_masked",
  /* 1449 */  "vnegF_masked",
  /* 1450 */  "vnegD_masked",
  /* 1451 */  "vsqrtF_masked",
  /* 1452 */  "vsqrtD_masked",
  /* 1453 */  "vminL_neon",
  /* 1454 */  "vminL_sve",
  /* 1455 */  "vmin_neon",
  /* 1456 */  "vmin_sve",
  /* 1457 */  "vmin_masked",
  /* 1458 */  "vmaxL_neon",
  /* 1459 */  "vmaxL_sve",
  /* 1460 */  "vmax_neon",
  /* 1461 */  "vmax_sve",
  /* 1462 */  "vmax_masked",
  /* 1463 */  "vmla",
  /* 1464 */  "vmla_0",
  /* 1465 */  "vmla_1",
  /* 1466 */  "vmla_2",
  /* 1467 */  "vmla_3",
  /* 1468 */  "vmla_4",
  /* 1469 */  "vmlaL",
  /* 1470 */  "vmlaL_0",
  /* 1471 */  "vmla_masked",
  /* 1472 */  "vmla_masked_0",
  /* 1473 */  "vmla_masked_1",
  /* 1474 */  "vmla_masked_2",
  /* 1475 */  "vfmla",
  /* 1476 */  "vfmla_0",
  /* 1477 */  "vfmad_masked",
  /* 1478 */  "vfmad_masked_0",
  /* 1479 */  "vmls",
  /* 1480 */  "vmls_0",
  /* 1481 */  "vmls_1",
  /* 1482 */  "vmlsL",
  /* 1483 */  "vmls_masked",
  /* 1484 */  "vmls_masked_0",
  /* 1485 */  "vmls_masked_1",
  /* 1486 */  "vmls_masked_2",
  /* 1487 */  "vfmls1",
  /* 1488 */  "vfmls1_0",
  /* 1489 */  "vfmls2",
  /* 1490 */  "vfmls2_0",
  /* 1491 */  "vfmsb_masked",
  /* 1492 */  "vfmsb_masked_0",
  /* 1493 */  "vfnmla1",
  /* 1494 */  "vfnmla1_0",
  /* 1495 */  "vfnmla2",
  /* 1496 */  "vfnmla2_0",
  /* 1497 */  "vfnmad_masked",
  /* 1498 */  "vfnmad_masked_0",
  /* 1499 */  "vfnmls",
  /* 1500 */  "vfnmls_0",
  /* 1501 */  "vfnmsb_masked",
  /* 1502 */  "vfnmsb_masked_0",
  /* 1503 */  "vmuladdS2I",
  /* 1504 */  "vlsl_neon",
  /* 1505 */  "vlsl_neon_0",
  /* 1506 */  "vlsl_neon_1",
  /* 1507 */  "vlsl_neon_2",
  /* 1508 */  "vlsl_sve",
  /* 1509 */  "vlsl_sve_0",
  /* 1510 */  "vlsl_sve_1",
  /* 1511 */  "vlsl_sve_2",
  /* 1512 */  "vasr_neon",
  /* 1513 */  "vasr_neon_0",
  /* 1514 */  "vasr_neon_1",
  /* 1515 */  "vasr_neon_2",
  /* 1516 */  "vasr_neon_var",
  /* 1517 */  "vasr_neon_var_0",
  /* 1518 */  "vasr_neon_var_1",
  /* 1519 */  "vasr_neon_var_2",
  /* 1520 */  "vasr_sve",
  /* 1521 */  "vasr_sve_0",
  /* 1522 */  "vasr_sve_1",
  /* 1523 */  "vasr_sve_2",
  /* 1524 */  "vlsr_neon",
  /* 1525 */  "vlsr_neon_0",
  /* 1526 */  "vlsr_neon_1",
  /* 1527 */  "vlsr_neon_2",
  /* 1528 */  "vlsr_neon_var",
  /* 1529 */  "vlsr_neon_var_0",
  /* 1530 */  "vlsr_neon_var_1",
  /* 1531 */  "vlsr_neon_var_2",
  /* 1532 */  "vlsr_sve",
  /* 1533 */  "vlsr_sve_0",
  /* 1534 */  "vlsr_sve_1",
  /* 1535 */  "vlsr_sve_2",
  /* 1536 */  "vlsl_imm",
  /* 1537 */  "vlsl_imm_0",
  /* 1538 */  "vlsl_imm_1",
  /* 1539 */  "vlsl_imm_2",
  /* 1540 */  "vasr_imm",
  /* 1541 */  "vasr_imm_0",
  /* 1542 */  "vasr_imm_1",
  /* 1543 */  "vasr_imm_2",
  /* 1544 */  "vlsr_imm",
  /* 1545 */  "vlsr_imm_0",
  /* 1546 */  "vlsr_imm_1",
  /* 1547 */  "vlsr_imm_2",
  /* 1548 */  "vasra_imm",
  /* 1549 */  "vasra_imm_0",
  /* 1550 */  "vasra_imm_1",
  /* 1551 */  "vasra_imm_2",
  /* 1552 */  "vasra_imm_3",
  /* 1553 */  "vasra_imm_4",
  /* 1554 */  "vasra_imm_5",
  /* 1555 */  "vasra_imm_6",
  /* 1556 */  "vlsra_imm",
  /* 1557 */  "vlsra_imm_0",
  /* 1558 */  "vlsra_imm_1",
  /* 1559 */  "vlsra_imm_2",
  /* 1560 */  "vlsra_imm_3",
  /* 1561 */  "vlsra_imm_4",
  /* 1562 */  "vlsra_imm_5",
  /* 1563 */  "vlsra_imm_6",
  /* 1564 */  "vlsl_masked",
  /* 1565 */  "vlsl_masked_0",
  /* 1566 */  "vlsl_masked_1",
  /* 1567 */  "vlsl_masked_2",
  /* 1568 */  "vasr_masked",
  /* 1569 */  "vasr_masked_0",
  /* 1570 */  "vasr_masked_1",
  /* 1571 */  "vasr_masked_2",
  /* 1572 */  "vlsr_masked",
  /* 1573 */  "vlsr_masked_0",
  /* 1574 */  "vlsr_masked_1",
  /* 1575 */  "vlsr_masked_2",
  /* 1576 */  "vlsl_imm_masked",
  /* 1577 */  "vlsl_imm_masked_0",
  /* 1578 */  "vlsl_imm_masked_1",
  /* 1579 */  "vlsl_imm_masked_2",
  /* 1580 */  "vasr_imm_masked",
  /* 1581 */  "vasr_imm_masked_0",
  /* 1582 */  "vasr_imm_masked_1",
  /* 1583 */  "vasr_imm_masked_2",
  /* 1584 */  "vlsr_imm_masked",
  /* 1585 */  "vlsr_imm_masked_0",
  /* 1586 */  "vlsr_imm_masked_1",
  /* 1587 */  "vlsr_imm_masked_2",
  /* 1588 */  "reduce_addI_neon",
  /* 1589 */  "reduce_addI_sve",
  /* 1590 */  "reduce_addL_neon",
  /* 1591 */  "reduce_addL_sve",
  /* 1592 */  "reduce_add2F_neon",
  /* 1593 */  "reduce_add4F_neon",
  /* 1594 */  "reduce_addF_sve",
  /* 1595 */  "reduce_addD_neon",
  /* 1596 */  "reduce_addD_sve",
  /* 1597 */  "reduce_addI_masked",
  /* 1598 */  "reduce_addL_masked",
  /* 1599 */  "reduce_addF_masked",
  /* 1600 */  "reduce_addD_masked",
  /* 1601 */  "reduce_mulI",
  /* 1602 */  "reduce_mulL",
  /* 1603 */  "reduce_mulF",
  /* 1604 */  "reduce_mulD",
  /* 1605 */  "reduce_andI_neon",
  /* 1606 */  "reduce_andI_sve",
  /* 1607 */  "reduce_andL_neon",
  /* 1608 */  "reduce_andL_sve",
  /* 1609 */  "reduce_andI_masked",
  /* 1610 */  "reduce_andL_masked",
  /* 1611 */  "reduce_orI_neon",
  /* 1612 */  "reduce_orI_sve",
  /* 1613 */  "reduce_orL_neon",
  /* 1614 */  "reduce_orL_sve",
  /* 1615 */  "reduce_orI_masked",
  /* 1616 */  "reduce_orL_masked",
  /* 1617 */  "reduce_xorI_neon",
  /* 1618 */  "reduce_xorI_sve",
  /* 1619 */  "reduce_xorL_neon",
  /* 1620 */  "reduce_xorL_sve",
  /* 1621 */  "reduce_xorI_masked",
  /* 1622 */  "reduce_xorL_masked",
  /* 1623 */  "reduce_maxI_neon",
  /* 1624 */  "reduce_maxI_sve",
  /* 1625 */  "reduce_maxL_neon",
  /* 1626 */  "reduce_maxL_sve",
  /* 1627 */  "reduce_maxF",
  /* 1628 */  "reduce_maxD",
  /* 1629 */  "reduce_maxI_masked",
  /* 1630 */  "reduce_maxL_masked",
  /* 1631 */  "reduce_maxF_masked",
  /* 1632 */  "reduce_maxD_masked",
  /* 1633 */  "reduce_minI_neon",
  /* 1634 */  "reduce_minI_sve",
  /* 1635 */  "reduce_minL_neon",
  /* 1636 */  "reduce_minL_sve",
  /* 1637 */  "reduce_minF",
  /* 1638 */  "reduce_minD",
  /* 1639 */  "reduce_minI_masked",
  /* 1640 */  "reduce_minL_masked",
  /* 1641 */  "reduce_minF_masked",
  /* 1642 */  "reduce_minD_masked",
  /* 1643 */  "reinterpret_resize_gt128b",
  /* 1644 */  "vcvtStoB_sve",
  /* 1645 */  "vcvtItoX_narrow_neon",
  /* 1646 */  "vcvtItoX_narrow_sve",
  /* 1647 */  "vcvtLtoI_sve",
  /* 1648 */  "vcvtLtoF_neon",
  /* 1649 */  "vcvtLtoF_sve",
  /* 1650 */  "vcvtFtoX_narrow_neon",
  /* 1651 */  "vcvtFtoX_narrow_sve",
  /* 1652 */  "vcvtDtoI_neon",
  /* 1653 */  "vcvtDtoI_sve",
  /* 1654 */  "vcvtDtoF_gt64b",
  /* 1655 */  "vcvtFtoHF_sve",
  /* 1656 */  "insertI_le128b",
  /* 1657 */  "insertI_index_lt32",
  /* 1658 */  "insertI_index_ge32",
  /* 1659 */  "insertL_128b",
  /* 1660 */  "insertL_gt128b",
  /* 1661 */  "insertF_le128b",
  /* 1662 */  "insertF_index_lt32",
  /* 1663 */  "insertF_index_ge32",
  /* 1664 */  "insertD_128b",
  /* 1665 */  "insertD_gt128b",
  /* 1666 */  "extractB_index_lt16",
  /* 1667 */  "extractB_index_ge16",
  /* 1668 */  "extractS_index_lt8",
  /* 1669 */  "extractS_index_ge8",
  /* 1670 */  "extractI_index_lt4",
  /* 1671 */  "extractI_index_ge4",
  /* 1672 */  "extractL_index_lt2",
  /* 1673 */  "extractL_index_ge2",
  /* 1674 */  "extractF",
  /* 1675 */  "extractD",
  /* 1676 */  "vloadmaskB_sve",
  /* 1677 */  "vloadmask_extend_sve",
  /* 1678 */  "vloadmaskB_masked",
  /* 1679 */  "vloadmask_extend_masked",
  /* 1680 */  "vstoremaskB_neon",
  /* 1681 */  "vstoremask_narrow_neon",
  /* 1682 */  "vstoremaskB_sve",
  /* 1683 */  "vstoremask_narrow_sve",
  /* 1684 */  "vloadmask_loadV",
  /* 1685 */  "vloadmask_loadV_masked",
  /* 1686 */  "vloadmask_loadVMasked",
  /* 1687 */  "vloadmask_loadVMasked_masked",
  /* 1688 */  "storeV_vstoremask",
  /* 1689 */  "storeV_vstoremask_masked",
  /* 1690 */  "storeVMasked_vstoremask",
  /* 1691 */  "storeVMasked_vstoremask_masked",
  /* 1692 */  "vmask_and",
  /* 1693 */  "vmask_or",
  /* 1694 */  "vmask_xor",
  /* 1695 */  "vmask_and_notI",
  /* 1696 */  "vmask_and_notL",
  /* 1697 */  "vmaskcmp_neon",
  /* 1698 */  "vmaskcmp_zeroI_neon",
  /* 1699 */  "vmaskcmp_zeroI_neon_0",
  /* 1700 */  "vmaskcmp_zeroI_neon_1",
  /* 1701 */  "vmaskcmp_zeroL_neon",
  /* 1702 */  "vmaskcmp_zeroF_neon",
  /* 1703 */  "vmaskcmp_zeroD_neon",
  /* 1704 */  "vmaskcmp_sve",
  /* 1705 */  "vmaskcmp_immB_sve",
  /* 1706 */  "vmaskcmpU_immB_sve",
  /* 1707 */  "vmaskcmp_immS_sve",
  /* 1708 */  "vmaskcmpU_immS_sve",
  /* 1709 */  "vmaskcmp_immI_sve",
  /* 1710 */  "vmaskcmpU_immI_sve",
  /* 1711 */  "vmaskcmp_immL_sve",
  /* 1712 */  "vmaskcmpU_immL_sve",
  /* 1713 */  "vmaskcmp_masked",
  /* 1714 */  "vmaskcast_narrow_sve",
  /* 1715 */  "vmask_reinterpret_diff_esize",
  /* 1716 */  "vmask_truecount_neon",
  /* 1717 */  "vstoremask_truecount_neon",
  /* 1718 */  "vmask_firsttrue_lt8e",
  /* 1719 */  "vmask_firsttrue_sve",
  /* 1720 */  "vmask_firsttrue_masked",
  /* 1721 */  "vmask_lasttrue_sve",
  /* 1722 */  "vmask_tolong_sve",
  /* 1723 */  "vmask_fromlong",
  /* 1724 */  "vmaskAll_immI",
  /* 1725 */  "vmaskAllI",
  /* 1726 */  "vmaskAllI_masked",
  /* 1727 */  "vmaskAll_immL",
  /* 1728 */  "vmaskAllL",
  /* 1729 */  "vmaskAllL_masked",
  /* 1730 */  "vmask_gen_I",
  /* 1731 */  "vmask_gen_L",
  /* 1732 */  "vmask_gen_imm",
  /* 1733 */  "vmask_gen_sub",
  /* 1734 */  "vpopcountI_masked",
  /* 1735 */  "vpopcountL_masked",
  /* 1736 */  "vblend_neon",
  /* 1737 */  "vblend_sve",
  /* 1738 */  "vround_le128b",
  /* 1739 */  "vround_le128b_0",
  /* 1740 */  "vround_gt128b",
  /* 1741 */  "vround_gt128b_0",
  /* 1742 */  "vroundD",
  /* 1743 */  "rearrange_HS_neon",
  /* 1744 */  "rearrange",
  /* 1745 */  "gather_loadS",
  /* 1746 */  "gather_loadD",
  /* 1747 */  "gather_loadS_masked",
  /* 1748 */  "gather_loadD_masked",
  /* 1749 */  "scatter_storeS",
  /* 1750 */  "scatter_storeD",
  /* 1751 */  "scatter_storeS_masked",
  /* 1752 */  "scatter_storeD_masked",
  /* 1753 */  "vcountLeadingZeros_masked",
  /* 1754 */  "vcountTrailingZeros_masked",
  /* 1755 */  "vreverse_masked",
  /* 1756 */  "vreverseBytes_masked",
  /* 1757 */  "populateindex",
  /* 1758 */  "mcompress",
  /* 1759 */  "vcompress",
  /* 1760 */  "vcompressB",
  /* 1761 */  "vcompressS",
  /* 1762 */  "vexpand",
  /* 1763 */  "vsignum_le128b",
  /* 1764 */  "vsignum_le128b_0",
  /* 1765 */  "vsignum_gt128b",
  /* 1766 */  "vsignum_gt128b_0",
  /* 1767 */  "vcompressBits",
  /* 1768 */  "vexpandBits",
  /* 1769 */  "compareAndSwapP_shenandoah",
  /* 1770 */  "compareAndSwapN_shenandoah",
  /* 1771 */  "compareAndSwapPAcq_shenandoah",
  /* 1772 */  "compareAndSwapNAcq_shenandoah",
  /* 1773 */  "compareAndExchangeN_shenandoah",
  /* 1774 */  "compareAndExchangeP_shenandoah",
  /* 1775 */  "compareAndExchangeNAcq_shenandoah",
  /* 1776 */  "compareAndExchangePAcq_shenandoah",
  /* 1777 */  "weakCompareAndSwapN_shenandoah",
  /* 1778 */  "weakCompareAndSwapP_shenandoah",
  /* 1779 */  "weakCompareAndSwapNAcq_shenandoah",
  /* 1780 */  "weakCompareAndSwapPAcq_shenandoah",
  /* 1781 */  "xLoadP",
  /* 1782 */  "xLoadPVolatile",
  /* 1783 */  "xCompareAndSwapP",
  /* 1784 */  "xCompareAndSwapP_0",
  /* 1785 */  "xCompareAndSwapPAcq",
  /* 1786 */  "xCompareAndSwapPAcq_0",
  /* 1787 */  "xCompareAndExchangeP",
  /* 1788 */  "xCompareAndExchangePAcq",
  /* 1789 */  "xGetAndSetP",
  /* 1790 */  "xGetAndSetPAcq",
  /* 1791 */  "zLoadP",
  /* 1792 */  "zLoadPVolatile",
  /* 1793 */  "zStoreP",
  /* 1794 */  "zStorePVolatile",
  /* 1795 */  "zCompareAndSwapP",
  /* 1796 */  "zCompareAndSwapP_0",
  /* 1797 */  "zCompareAndSwapPAcq",
  /* 1798 */  "zCompareAndSwapPAcq_0",
  /* 1799 */  "zCompareAndExchangeP",
  /* 1800 */  "zCompareAndExchangePAcq",
  /* 1801 */  "zGetAndSetP",
  /* 1802 */  "zGetAndSetPAcq",
  // last instruction
  "invalid rule name" // no trailing comma
};

const        bool  swallowed[] = {
  /*    0 */  false,
  /*    1 */  false,
  /*    2 */  false,
  /*    3 */  false,
  /*    4 */  false,
  /*    5 */  false,
  /*    6 */  false,
  /*    7 */  false,
  /*    8 */  true,
  /*    9 */  true,
  /*   10 */  true,
  /*   11 */  true,
  /*   12 */  true,
  /*   13 */  true,
  /*   14 */  true,
  /*   15 */  true,
  /*   16 */  true,
  /*   17 */  true,
  /*   18 */  true,
  /*   19 */  true,
  /*   20 */  true,
  /*   21 */  true,
  /*   22 */  true,
  /*   23 */  true,
  /*   24 */  true,
  /*   25 */  true,
  /*   26 */  true,
  /*   27 */  true,
  /*   28 */  true,
  /*   29 */  true,
  /*   30 */  true,
  /*   31 */  true,
  /*   32 */  true,
  /*   33 */  true,
  /*   34 */  true,
  /*   35 */  true,
  /*   36 */  true,
  /*   37 */  true,
  /*   38 */  true,
  /*   39 */  true,
  /*   40 */  true,
  /*   41 */  true,
  /*   42 */  true,
  /*   43 */  true,
  /*   44 */  true,
  /*   45 */  true,
  /*   46 */  true,
  /*   47 */  true,
  /*   48 */  true,
  /*   49 */  true,
  /*   50 */  true,
  /*   51 */  true,
  /*   52 */  true,
  /*   53 */  true,
  /*   54 */  true,
  /*   55 */  true,
  /*   56 */  true,
  /*   57 */  true,
  /*   58 */  true,
  /*   59 */  true,
  /*   60 */  true,
  /*   61 */  true,
  /*   62 */  true,
  /*   63 */  true,
  /*   64 */  true,
  /*   65 */  true,
  /*   66 */  true,
  /*   67 */  true,
  /*   68 */  true,
  /*   69 */  true,
  /*   70 */  true,
  /*   71 */  true,
  /*   72 */  true,
  /*   73 */  true,
  /*   74 */  true,
  /*   75 */  true,
  /*   76 */  true,
  /*   77 */  true,
  /*   78 */  true,
  /*   79 */  true,
  /*   80 */  true,
  /*   81 */  true,
  /*   82 */  true,
  /*   83 */  true,
  /*   84 */  true,
  /*   85 */  true,
  /*   86 */  true,
  /*   87 */  false,
  /*   88 */  false,
  /*   89 */  false,
  /*   90 */  false,
  /*   91 */  false,
  /*   92 */  false,
  /*   93 */  false,
  /*   94 */  false,
  /*   95 */  false,
  /*   96 */  false,
  /*   97 */  false,
  /*   98 */  false,
  /*   99 */  false,
  /*  100 */  false,
  /*  101 */  false,
  /*  102 */  false,
  /*  103 */  false,
  /*  104 */  false,
  /*  105 */  false,
  /*  106 */  false,
  /*  107 */  false,
  /*  108 */  false,
  /*  109 */  false,
  /*  110 */  false,
  /*  111 */  false,
  /*  112 */  false,
  /*  113 */  false,
  /*  114 */  false,
  /*  115 */  false,
  /*  116 */  false,
  /*  117 */  false,
  /*  118 */  false,
  /*  119 */  false,
  /*  120 */  false,
  /*  121 */  false,
  /*  122 */  false,
  /*  123 */  false,
  /*  124 */  false,
  /*  125 */  false,
  /*  126 */  false,
  /*  127 */  false,
  /*  128 */  false,
  /*  129 */  false,
  /*  130 */  false,
  /*  131 */  false,
  /*  132 */  false,
  /*  133 */  false,
  /*  134 */  false,
  /*  135 */  false,
  /*  136 */  false,
  /*  137 */  false,
  /*  138 */  false,
  /*  139 */  false,
  /*  140 */  false,
  /*  141 */  false,
  /*  142 */  false,
  /*  143 */  false,
  /*  144 */  false,
  /*  145 */  false,
  /*  146 */  false,
  /*  147 */  false,
  /*  148 */  false,
  /*  149 */  false,
  /*  150 */  false,
  /*  151 */  false,
  /*  152 */  false,
  /*  153 */  false,
  /*  154 */  false,
  /*  155 */  false,
  /*  156 */  false,
  /*  157 */  false,
  /*  158 */  false,
  /*  159 */  false,
  /*  160 */  false,
  /*  161 */  false,
  /*  162 */  false,
  /*  163 */  false,
  /*  164 */  false,
  /*  165 */  false,
  /*  166 */  false,
  /*  167 */  false,
  /*  168 */  false,
  /*  169 */  false,
  /*  170 */  false,
  /*  171 */  false,
  /*  172 */  false,
  /*  173 */  false,
  /*  174 */  false,
  /*  175 */  false,
  /*  176 */  false,
  /*  177 */  false,
  /*  178 */  false,
  /*  179 */  false,
  /*  180 */  false,
  /*  181 */  false,
  /*  182 */  false,
  /*  183 */  false,
  /*  184 */  false,
  /*  185 */  false,
  /*  186 */  false,
  /*  187 */  false,
  /*  188 */  false,
  /*  189 */  false,
  /*  190 */  false,
  /*  191 */  false,
  /*  192 */  true,
  /*  193 */  true,
  /*  194 */  true,
  /*  195 */  true,
  /*  196 */  true,
  /*  197 */  false,
  /*  198 */  true,
  /*  199 */  true,
  /*  200 */  false,
  /*  201 */  false,
  // last operand
  /*  202 */  false,
  /*  203 */  false,
  /*  204 */  false,
  /*  205 */  false,
  /*  206 */  false,
  /*  207 */  false,
  /*  208 */  false,
  /*  209 */  false,
  /*  210 */  false,
  /*  211 */  false,
  /*  212 */  false,
  // last operand class
  /*  213 */  false,
  /*  214 */  false,
  /*  215 */  false,
  /*  216 */  false,
  /*  217 */  false,
  /*  218 */  false,
  /*  219 */  false,
  /*  220 */  false,
  /*  221 */  false,
  /*  222 */  false,
  /*  223 */  false,
  /*  224 */  false,
  /*  225 */  false,
  /*  226 */  false,
  /*  227 */  false,
  /*  228 */  false,
  /*  229 */  false,
  /*  230 */  false,
  /*  231 */  false,
  /*  232 */  false,
  /*  233 */  false,
  /*  234 */  false,
  /*  235 */  false,
  /*  236 */  false,
  /*  237 */  false,
  /*  238 */  false,
  /*  239 */  false,
  /*  240 */  false,
  /*  241 */  false,
  /*  242 */  false,
  /*  243 */  false,
  /*  244 */  false,
  /*  245 */  false,
  /*  246 */  false,
  /*  247 */  false,
  /*  248 */  false,
  /*  249 */  false,
  /*  250 */  false,
  /*  251 */  false,
  /*  252 */  false,
  /*  253 */  false,
  /*  254 */  false,
  /*  255 */  false,
  /*  256 */  false,
  /*  257 */  false,
  /*  258 */  false,
  /*  259 */  false,
  /*  260 */  false,
  /*  261 */  false,
  /*  262 */  false,
  /*  263 */  false,
  /*  264 */  false,
  /*  265 */  false,
  /*  266 */  false,
  /*  267 */  false,
  /*  268 */  false,
  /*  269 */  false,
  /*  270 */  false,
  /*  271 */  false,
  /*  272 */  false,
  /*  273 */  false,
  /*  274 */  false,
  /*  275 */  false,
  /*  276 */  false,
  /*  277 */  false,
  /*  278 */  false,
  /*  279 */  false,
  /*  280 */  false,
  /*  281 */  false,
  /*  282 */  false,
  /*  283 */  false,
  /*  284 */  false,
  /*  285 */  false,
  /*  286 */  false,
  /*  287 */  false,
  /*  288 */  false,
  /*  289 */  false,
  /*  290 */  false,
  /*  291 */  false,
  /*  292 */  false,
  /*  293 */  false,
  /*  294 */  false,
  /*  295 */  false,
  /*  296 */  false,
  /*  297 */  false,
  /*  298 */  false,
  /*  299 */  false,
  /*  300 */  false,
  /*  301 */  false,
  /*  302 */  false,
  /*  303 */  false,
  /*  304 */  false,
  /*  305 */  false,
  /*  306 */  false,
  /*  307 */  false,
  /*  308 */  false,
  /*  309 */  false,
  /*  310 */  false,
  /*  311 */  false,
  /*  312 */  false,
  /*  313 */  false,
  /*  314 */  false,
  /*  315 */  false,
  /*  316 */  false,
  /*  317 */  false,
  /*  318 */  false,
  /*  319 */  false,
  /*  320 */  false,
  /*  321 */  false,
  /*  322 */  false,
  /*  323 */  false,
  /*  324 */  false,
  /*  325 */  false,
  /*  326 */  false,
  /*  327 */  false,
  /*  328 */  false,
  /*  329 */  false,
  /*  330 */  false,
  /*  331 */  false,
  /*  332 */  false,
  /*  333 */  false,
  /*  334 */  false,
  /*  335 */  false,
  /*  336 */  false,
  /*  337 */  false,
  /*  338 */  false,
  /*  339 */  false,
  /*  340 */  false,
  /*  341 */  false,
  /*  342 */  false,
  /*  343 */  false,
  /*  344 */  false,
  /*  345 */  false,
  /*  346 */  false,
  /*  347 */  false,
  /*  348 */  false,
  /*  349 */  false,
  /*  350 */  false,
  /*  351 */  false,
  /*  352 */  false,
  /*  353 */  false,
  /*  354 */  false,
  /*  355 */  false,
  /*  356 */  false,
  /*  357 */  false,
  /*  358 */  false,
  /*  359 */  false,
  /*  360 */  false,
  /*  361 */  false,
  /*  362 */  false,
  /*  363 */  false,
  /*  364 */  false,
  /*  365 */  false,
  /*  366 */  false,
  /*  367 */  false,
  /*  368 */  false,
  /*  369 */  false,
  /*  370 */  false,
  /*  371 */  false,
  /*  372 */  false,
  /*  373 */  false,
  /*  374 */  false,
  /*  375 */  false,
  /*  376 */  false,
  /*  377 */  false,
  /*  378 */  false,
  /*  379 */  false,
  /*  380 */  false,
  /*  381 */  false,
  /*  382 */  false,
  /*  383 */  false,
  /*  384 */  false,
  /*  385 */  false,
  /*  386 */  false,
  /*  387 */  false,
  /*  388 */  false,
  /*  389 */  false,
  /*  390 */  false,
  /*  391 */  false,
  /*  392 */  false,
  /*  393 */  false,
  /*  394 */  false,
  /*  395 */  false,
  /*  396 */  false,
  /*  397 */  false,
  /*  398 */  false,
  /*  399 */  false,
  /*  400 */  false,
  /*  401 */  false,
  /*  402 */  false,
  /*  403 */  false,
  /*  404 */  false,
  /*  405 */  false,
  /*  406 */  false,
  /*  407 */  false,
  /*  408 */  false,
  /*  409 */  false,
  /*  410 */  false,
  /*  411 */  false,
  /*  412 */  false,
  /*  413 */  false,
  /*  414 */  false,
  /*  415 */  false,
  /*  416 */  false,
  /*  417 */  false,
  /*  418 */  false,
  /*  419 */  false,
  /*  420 */  false,
  /*  421 */  false,
  /*  422 */  false,
  /*  423 */  false,
  /*  424 */  false,
  /*  425 */  false,
  /*  426 */  false,
  /*  427 */  false,
  /*  428 */  false,
  /*  429 */  false,
  /*  430 */  false,
  /*  431 */  false,
  /*  432 */  false,
  /*  433 */  false,
  /*  434 */  false,
  /*  435 */  false,
  /*  436 */  false,
  /*  437 */  false,
  /*  438 */  false,
  /*  439 */  false,
  /*  440 */  false,
  /*  441 */  false,
  /*  442 */  false,
  /*  443 */  false,
  /*  444 */  false,
  /*  445 */  false,
  /*  446 */  false,
  /*  447 */  false,
  /*  448 */  false,
  /*  449 */  false,
  /*  450 */  false,
  /*  451 */  false,
  /*  452 */  false,
  /*  453 */  false,
  /*  454 */  false,
  /*  455 */  false,
  /*  456 */  false,
  /*  457 */  false,
  /*  458 */  false,
  /*  459 */  false,
  /*  460 */  false,
  /*  461 */  false,
  /*  462 */  false,
  /*  463 */  false,
  /*  464 */  false,
  /*  465 */  false,
  /*  466 */  false,
  /*  467 */  false,
  /*  468 */  false,
  /*  469 */  false,
  /*  470 */  false,
  /*  471 */  false,
  /*  472 */  false,
  /*  473 */  false,
  /*  474 */  false,
  /*  475 */  false,
  /*  476 */  false,
  /*  477 */  false,
  /*  478 */  false,
  /*  479 */  false,
  /*  480 */  false,
  /*  481 */  false,
  // last internally defined operand
  /*  482 */  false,
  /*  483 */  false,
  /*  484 */  false,
  /*  485 */  false,
  /*  486 */  false,
  /*  487 */  false,
  /*  488 */  false,
  /*  489 */  false,
  /*  490 */  false,
  /*  491 */  false,
  /*  492 */  false,
  /*  493 */  false,
  /*  494 */  false,
  /*  495 */  false,
  /*  496 */  false,
  /*  497 */  false,
  /*  498 */  false,
  /*  499 */  false,
  /*  500 */  false,
  /*  501 */  false,
  /*  502 */  false,
  /*  503 */  false,
  /*  504 */  false,
  /*  505 */  false,
  /*  506 */  false,
  /*  507 */  false,
  /*  508 */  false,
  /*  509 */  false,
  /*  510 */  false,
  /*  511 */  false,
  /*  512 */  false,
  /*  513 */  false,
  /*  514 */  false,
  /*  515 */  false,
  /*  516 */  false,
  /*  517 */  false,
  /*  518 */  false,
  /*  519 */  false,
  /*  520 */  false,
  /*  521 */  false,
  /*  522 */  false,
  /*  523 */  false,
  /*  524 */  false,
  /*  525 */  false,
  /*  526 */  false,
  /*  527 */  false,
  /*  528 */  false,
  /*  529 */  false,
  /*  530 */  false,
  /*  531 */  false,
  /*  532 */  false,
  /*  533 */  false,
  /*  534 */  false,
  /*  535 */  false,
  /*  536 */  false,
  /*  537 */  false,
  /*  538 */  false,
  /*  539 */  false,
  /*  540 */  false,
  /*  541 */  false,
  /*  542 */  false,
  /*  543 */  false,
  /*  544 */  false,
  /*  545 */  false,
  /*  546 */  false,
  /*  547 */  false,
  /*  548 */  false,
  /*  549 */  false,
  /*  550 */  false,
  /*  551 */  false,
  /*  552 */  false,
  /*  553 */  false,
  /*  554 */  false,
  /*  555 */  false,
  /*  556 */  false,
  /*  557 */  false,
  /*  558 */  false,
  /*  559 */  false,
  /*  560 */  false,
  /*  561 */  false,
  /*  562 */  false,
  /*  563 */  false,
  /*  564 */  false,
  /*  565 */  false,
  /*  566 */  false,
  /*  567 */  false,
  /*  568 */  false,
  /*  569 */  false,
  /*  570 */  false,
  /*  571 */  false,
  /*  572 */  false,
  /*  573 */  false,
  /*  574 */  false,
  /*  575 */  false,
  /*  576 */  false,
  /*  577 */  false,
  /*  578 */  false,
  /*  579 */  false,
  /*  580 */  false,
  /*  581 */  false,
  /*  582 */  false,
  /*  583 */  false,
  /*  584 */  false,
  /*  585 */  false,
  /*  586 */  false,
  /*  587 */  false,
  /*  588 */  false,
  /*  589 */  false,
  /*  590 */  false,
  /*  591 */  false,
  /*  592 */  false,
  /*  593 */  false,
  /*  594 */  false,
  /*  595 */  false,
  /*  596 */  false,
  /*  597 */  false,
  /*  598 */  false,
  /*  599 */  false,
  /*  600 */  false,
  /*  601 */  false,
  /*  602 */  false,
  /*  603 */  false,
  /*  604 */  false,
  /*  605 */  false,
  /*  606 */  false,
  /*  607 */  false,
  /*  608 */  false,
  /*  609 */  false,
  /*  610 */  false,
  /*  611 */  false,
  /*  612 */  false,
  /*  613 */  false,
  /*  614 */  false,
  /*  615 */  false,
  /*  616 */  false,
  /*  617 */  false,
  /*  618 */  false,
  /*  619 */  false,
  /*  620 */  false,
  /*  621 */  false,
  /*  622 */  false,
  /*  623 */  false,
  /*  624 */  false,
  /*  625 */  false,
  /*  626 */  false,
  /*  627 */  false,
  /*  628 */  false,
  /*  629 */  false,
  /*  630 */  false,
  /*  631 */  false,
  /*  632 */  false,
  /*  633 */  false,
  /*  634 */  false,
  /*  635 */  false,
  /*  636 */  false,
  /*  637 */  false,
  /*  638 */  false,
  /*  639 */  false,
  /*  640 */  false,
  /*  641 */  false,
  /*  642 */  false,
  /*  643 */  false,
  /*  644 */  false,
  /*  645 */  false,
  /*  646 */  false,
  /*  647 */  false,
  /*  648 */  false,
  /*  649 */  false,
  /*  650 */  false,
  /*  651 */  false,
  /*  652 */  false,
  /*  653 */  false,
  /*  654 */  false,
  /*  655 */  false,
  /*  656 */  false,
  /*  657 */  false,
  /*  658 */  false,
  /*  659 */  false,
  /*  660 */  false,
  /*  661 */  false,
  /*  662 */  false,
  /*  663 */  false,
  /*  664 */  false,
  /*  665 */  false,
  /*  666 */  false,
  /*  667 */  false,
  /*  668 */  false,
  /*  669 */  false,
  /*  670 */  false,
  /*  671 */  false,
  /*  672 */  false,
  /*  673 */  false,
  /*  674 */  false,
  /*  675 */  false,
  /*  676 */  false,
  /*  677 */  false,
  /*  678 */  false,
  /*  679 */  false,
  /*  680 */  false,
  /*  681 */  false,
  /*  682 */  false,
  /*  683 */  false,
  /*  684 */  false,
  /*  685 */  false,
  /*  686 */  false,
  /*  687 */  false,
  /*  688 */  false,
  /*  689 */  false,
  /*  690 */  false,
  /*  691 */  false,
  /*  692 */  false,
  /*  693 */  false,
  /*  694 */  false,
  /*  695 */  false,
  /*  696 */  false,
  /*  697 */  false,
  /*  698 */  false,
  /*  699 */  false,
  /*  700 */  false,
  /*  701 */  false,
  /*  702 */  false,
  /*  703 */  false,
  /*  704 */  false,
  /*  705 */  false,
  /*  706 */  false,
  /*  707 */  false,
  /*  708 */  false,
  /*  709 */  false,
  /*  710 */  false,
  /*  711 */  false,
  /*  712 */  false,
  /*  713 */  false,
  /*  714 */  false,
  /*  715 */  false,
  /*  716 */  false,
  /*  717 */  false,
  /*  718 */  false,
  /*  719 */  false,
  /*  720 */  false,
  /*  721 */  false,
  /*  722 */  false,
  /*  723 */  false,
  /*  724 */  false,
  /*  725 */  false,
  /*  726 */  false,
  /*  727 */  false,
  /*  728 */  false,
  /*  729 */  false,
  /*  730 */  false,
  /*  731 */  false,
  /*  732 */  false,
  /*  733 */  false,
  /*  734 */  false,
  /*  735 */  false,
  /*  736 */  false,
  /*  737 */  false,
  /*  738 */  false,
  /*  739 */  false,
  /*  740 */  false,
  /*  741 */  false,
  /*  742 */  false,
  /*  743 */  false,
  /*  744 */  false,
  /*  745 */  false,
  /*  746 */  false,
  /*  747 */  false,
  /*  748 */  false,
  /*  749 */  false,
  /*  750 */  false,
  /*  751 */  false,
  /*  752 */  false,
  /*  753 */  false,
  /*  754 */  false,
  /*  755 */  false,
  /*  756 */  false,
  /*  757 */  false,
  /*  758 */  false,
  /*  759 */  false,
  /*  760 */  false,
  /*  761 */  false,
  /*  762 */  false,
  /*  763 */  false,
  /*  764 */  false,
  /*  765 */  false,
  /*  766 */  false,
  /*  767 */  false,
  /*  768 */  false,
  /*  769 */  false,
  /*  770 */  false,
  /*  771 */  false,
  /*  772 */  false,
  /*  773 */  false,
  /*  774 */  false,
  /*  775 */  false,
  /*  776 */  false,
  /*  777 */  false,
  /*  778 */  false,
  /*  779 */  false,
  /*  780 */  false,
  /*  781 */  false,
  /*  782 */  false,
  /*  783 */  false,
  /*  784 */  false,
  /*  785 */  false,
  /*  786 */  false,
  /*  787 */  false,
  /*  788 */  false,
  /*  789 */  false,
  /*  790 */  false,
  /*  791 */  false,
  /*  792 */  false,
  /*  793 */  false,
  /*  794 */  false,
  /*  795 */  false,
  /*  796 */  false,
  /*  797 */  false,
  /*  798 */  false,
  /*  799 */  false,
  /*  800 */  false,
  /*  801 */  false,
  /*  802 */  false,
  /*  803 */  false,
  /*  804 */  false,
  /*  805 */  false,
  /*  806 */  false,
  /*  807 */  false,
  /*  808 */  false,
  /*  809 */  false,
  /*  810 */  false,
  /*  811 */  false,
  /*  812 */  false,
  /*  813 */  false,
  /*  814 */  false,
  /*  815 */  false,
  /*  816 */  false,
  /*  817 */  false,
  /*  818 */  false,
  /*  819 */  false,
  /*  820 */  false,
  /*  821 */  false,
  /*  822 */  false,
  /*  823 */  false,
  /*  824 */  false,
  /*  825 */  false,
  /*  826 */  false,
  /*  827 */  false,
  /*  828 */  false,
  /*  829 */  false,
  /*  830 */  false,
  /*  831 */  false,
  /*  832 */  false,
  /*  833 */  false,
  /*  834 */  false,
  /*  835 */  false,
  /*  836 */  false,
  /*  837 */  false,
  /*  838 */  false,
  /*  839 */  false,
  /*  840 */  false,
  /*  841 */  false,
  /*  842 */  false,
  /*  843 */  false,
  /*  844 */  false,
  /*  845 */  false,
  /*  846 */  false,
  /*  847 */  false,
  /*  848 */  false,
  /*  849 */  false,
  /*  850 */  false,
  /*  851 */  false,
  /*  852 */  false,
  /*  853 */  false,
  /*  854 */  false,
  /*  855 */  false,
  /*  856 */  false,
  /*  857 */  false,
  /*  858 */  false,
  /*  859 */  false,
  /*  860 */  false,
  /*  861 */  false,
  /*  862 */  false,
  /*  863 */  false,
  /*  864 */  false,
  /*  865 */  false,
  /*  866 */  false,
  /*  867 */  false,
  /*  868 */  false,
  /*  869 */  false,
  /*  870 */  false,
  /*  871 */  false,
  /*  872 */  false,
  /*  873 */  false,
  /*  874 */  false,
  /*  875 */  false,
  /*  876 */  false,
  /*  877 */  false,
  /*  878 */  false,
  /*  879 */  false,
  /*  880 */  false,
  /*  881 */  false,
  /*  882 */  false,
  /*  883 */  false,
  /*  884 */  false,
  /*  885 */  false,
  /*  886 */  false,
  /*  887 */  false,
  /*  888 */  false,
  /*  889 */  false,
  /*  890 */  false,
  /*  891 */  false,
  /*  892 */  false,
  /*  893 */  false,
  /*  894 */  false,
  /*  895 */  false,
  /*  896 */  false,
  /*  897 */  false,
  /*  898 */  false,
  /*  899 */  false,
  /*  900 */  false,
  /*  901 */  false,
  /*  902 */  false,
  /*  903 */  false,
  /*  904 */  false,
  /*  905 */  false,
  /*  906 */  false,
  /*  907 */  false,
  /*  908 */  false,
  /*  909 */  false,
  /*  910 */  false,
  /*  911 */  false,
  /*  912 */  false,
  /*  913 */  false,
  /*  914 */  false,
  /*  915 */  false,
  /*  916 */  false,
  /*  917 */  false,
  /*  918 */  false,
  /*  919 */  false,
  /*  920 */  false,
  /*  921 */  false,
  /*  922 */  false,
  /*  923 */  false,
  /*  924 */  false,
  /*  925 */  false,
  /*  926 */  false,
  /*  927 */  false,
  /*  928 */  false,
  /*  929 */  false,
  /*  930 */  false,
  /*  931 */  false,
  /*  932 */  false,
  /*  933 */  false,
  /*  934 */  false,
  /*  935 */  false,
  /*  936 */  false,
  /*  937 */  false,
  /*  938 */  false,
  /*  939 */  false,
  /*  940 */  false,
  /*  941 */  false,
  /*  942 */  false,
  /*  943 */  false,
  /*  944 */  false,
  /*  945 */  false,
  /*  946 */  false,
  /*  947 */  false,
  /*  948 */  false,
  /*  949 */  false,
  /*  950 */  false,
  /*  951 */  false,
  /*  952 */  false,
  /*  953 */  false,
  /*  954 */  false,
  /*  955 */  false,
  /*  956 */  false,
  /*  957 */  false,
  /*  958 */  false,
  /*  959 */  false,
  /*  960 */  false,
  /*  961 */  false,
  /*  962 */  false,
  /*  963 */  false,
  /*  964 */  false,
  /*  965 */  false,
  /*  966 */  false,
  /*  967 */  false,
  /*  968 */  false,
  /*  969 */  false,
  /*  970 */  false,
  /*  971 */  false,
  /*  972 */  false,
  /*  973 */  false,
  /*  974 */  false,
  /*  975 */  false,
  /*  976 */  false,
  /*  977 */  false,
  /*  978 */  false,
  /*  979 */  false,
  /*  980 */  false,
  /*  981 */  false,
  /*  982 */  false,
  /*  983 */  false,
  /*  984 */  false,
  /*  985 */  false,
  /*  986 */  false,
  /*  987 */  false,
  /*  988 */  false,
  /*  989 */  false,
  /*  990 */  false,
  /*  991 */  false,
  /*  992 */  false,
  /*  993 */  false,
  /*  994 */  false,
  /*  995 */  false,
  /*  996 */  false,
  /*  997 */  false,
  /*  998 */  false,
  /*  999 */  false,
  /* 1000 */  false,
  /* 1001 */  false,
  /* 1002 */  false,
  /* 1003 */  false,
  /* 1004 */  false,
  /* 1005 */  false,
  /* 1006 */  false,
  /* 1007 */  false,
  /* 1008 */  false,
  /* 1009 */  false,
  /* 1010 */  false,
  /* 1011 */  false,
  /* 1012 */  false,
  /* 1013 */  false,
  /* 1014 */  false,
  /* 1015 */  false,
  /* 1016 */  false,
  /* 1017 */  false,
  /* 1018 */  false,
  /* 1019 */  false,
  /* 1020 */  false,
  /* 1021 */  false,
  /* 1022 */  false,
  /* 1023 */  false,
  /* 1024 */  false,
  /* 1025 */  false,
  /* 1026 */  false,
  /* 1027 */  false,
  /* 1028 */  false,
  /* 1029 */  false,
  /* 1030 */  false,
  /* 1031 */  false,
  /* 1032 */  false,
  /* 1033 */  false,
  /* 1034 */  false,
  /* 1035 */  false,
  /* 1036 */  false,
  /* 1037 */  false,
  /* 1038 */  false,
  /* 1039 */  false,
  /* 1040 */  false,
  /* 1041 */  false,
  /* 1042 */  false,
  /* 1043 */  false,
  /* 1044 */  false,
  /* 1045 */  false,
  /* 1046 */  false,
  /* 1047 */  false,
  /* 1048 */  false,
  /* 1049 */  false,
  /* 1050 */  false,
  /* 1051 */  false,
  /* 1052 */  false,
  /* 1053 */  false,
  /* 1054 */  false,
  /* 1055 */  false,
  /* 1056 */  false,
  /* 1057 */  false,
  /* 1058 */  false,
  /* 1059 */  false,
  /* 1060 */  false,
  /* 1061 */  false,
  /* 1062 */  false,
  /* 1063 */  false,
  /* 1064 */  false,
  /* 1065 */  false,
  /* 1066 */  false,
  /* 1067 */  false,
  /* 1068 */  false,
  /* 1069 */  false,
  /* 1070 */  false,
  /* 1071 */  false,
  /* 1072 */  false,
  /* 1073 */  false,
  /* 1074 */  false,
  /* 1075 */  false,
  /* 1076 */  false,
  /* 1077 */  false,
  /* 1078 */  false,
  /* 1079 */  false,
  /* 1080 */  false,
  /* 1081 */  false,
  /* 1082 */  false,
  /* 1083 */  false,
  /* 1084 */  false,
  /* 1085 */  false,
  /* 1086 */  false,
  /* 1087 */  false,
  /* 1088 */  false,
  /* 1089 */  false,
  /* 1090 */  false,
  /* 1091 */  false,
  /* 1092 */  false,
  /* 1093 */  false,
  /* 1094 */  false,
  /* 1095 */  false,
  /* 1096 */  false,
  /* 1097 */  false,
  /* 1098 */  false,
  /* 1099 */  false,
  /* 1100 */  false,
  /* 1101 */  false,
  /* 1102 */  false,
  /* 1103 */  false,
  /* 1104 */  false,
  /* 1105 */  false,
  /* 1106 */  false,
  /* 1107 */  false,
  /* 1108 */  false,
  /* 1109 */  false,
  /* 1110 */  false,
  /* 1111 */  false,
  /* 1112 */  false,
  /* 1113 */  false,
  /* 1114 */  false,
  /* 1115 */  false,
  /* 1116 */  false,
  /* 1117 */  false,
  /* 1118 */  false,
  /* 1119 */  false,
  /* 1120 */  false,
  /* 1121 */  false,
  /* 1122 */  false,
  /* 1123 */  false,
  /* 1124 */  false,
  /* 1125 */  false,
  /* 1126 */  false,
  /* 1127 */  false,
  /* 1128 */  false,
  /* 1129 */  false,
  /* 1130 */  false,
  /* 1131 */  false,
  /* 1132 */  false,
  /* 1133 */  false,
  /* 1134 */  false,
  /* 1135 */  false,
  /* 1136 */  false,
  /* 1137 */  false,
  /* 1138 */  false,
  /* 1139 */  false,
  /* 1140 */  false,
  /* 1141 */  false,
  /* 1142 */  false,
  /* 1143 */  false,
  /* 1144 */  false,
  /* 1145 */  false,
  /* 1146 */  false,
  /* 1147 */  false,
  /* 1148 */  false,
  /* 1149 */  false,
  /* 1150 */  false,
  /* 1151 */  false,
  /* 1152 */  false,
  /* 1153 */  false,
  /* 1154 */  false,
  /* 1155 */  false,
  /* 1156 */  false,
  /* 1157 */  false,
  /* 1158 */  false,
  /* 1159 */  false,
  /* 1160 */  false,
  /* 1161 */  false,
  /* 1162 */  false,
  /* 1163 */  false,
  /* 1164 */  false,
  /* 1165 */  false,
  /* 1166 */  false,
  /* 1167 */  false,
  /* 1168 */  false,
  /* 1169 */  false,
  /* 1170 */  false,
  /* 1171 */  false,
  /* 1172 */  false,
  /* 1173 */  false,
  /* 1174 */  false,
  /* 1175 */  false,
  /* 1176 */  false,
  /* 1177 */  false,
  /* 1178 */  false,
  /* 1179 */  false,
  /* 1180 */  false,
  /* 1181 */  false,
  /* 1182 */  false,
  /* 1183 */  false,
  /* 1184 */  false,
  /* 1185 */  false,
  /* 1186 */  false,
  /* 1187 */  false,
  /* 1188 */  false,
  /* 1189 */  false,
  /* 1190 */  false,
  /* 1191 */  false,
  /* 1192 */  false,
  /* 1193 */  false,
  /* 1194 */  false,
  /* 1195 */  false,
  /* 1196 */  false,
  /* 1197 */  false,
  /* 1198 */  false,
  /* 1199 */  false,
  /* 1200 */  false,
  /* 1201 */  false,
  /* 1202 */  false,
  /* 1203 */  false,
  /* 1204 */  false,
  /* 1205 */  false,
  /* 1206 */  false,
  /* 1207 */  false,
  /* 1208 */  false,
  /* 1209 */  false,
  /* 1210 */  false,
  /* 1211 */  false,
  /* 1212 */  false,
  /* 1213 */  false,
  /* 1214 */  false,
  /* 1215 */  false,
  /* 1216 */  false,
  /* 1217 */  false,
  /* 1218 */  false,
  /* 1219 */  false,
  /* 1220 */  false,
  /* 1221 */  false,
  /* 1222 */  false,
  /* 1223 */  false,
  /* 1224 */  false,
  /* 1225 */  false,
  /* 1226 */  false,
  /* 1227 */  false,
  /* 1228 */  false,
  /* 1229 */  false,
  /* 1230 */  false,
  /* 1231 */  false,
  /* 1232 */  false,
  /* 1233 */  false,
  /* 1234 */  false,
  /* 1235 */  false,
  /* 1236 */  false,
  /* 1237 */  false,
  /* 1238 */  false,
  /* 1239 */  false,
  /* 1240 */  false,
  /* 1241 */  false,
  /* 1242 */  false,
  /* 1243 */  false,
  /* 1244 */  false,
  /* 1245 */  false,
  /* 1246 */  false,
  /* 1247 */  false,
  /* 1248 */  false,
  /* 1249 */  false,
  /* 1250 */  false,
  /* 1251 */  false,
  /* 1252 */  false,
  /* 1253 */  false,
  /* 1254 */  false,
  /* 1255 */  false,
  /* 1256 */  false,
  /* 1257 */  false,
  /* 1258 */  false,
  /* 1259 */  false,
  /* 1260 */  false,
  /* 1261 */  false,
  /* 1262 */  false,
  /* 1263 */  false,
  /* 1264 */  false,
  /* 1265 */  false,
  /* 1266 */  false,
  /* 1267 */  false,
  /* 1268 */  false,
  /* 1269 */  false,
  /* 1270 */  false,
  /* 1271 */  false,
  /* 1272 */  false,
  /* 1273 */  false,
  /* 1274 */  false,
  /* 1275 */  false,
  /* 1276 */  false,
  /* 1277 */  false,
  /* 1278 */  false,
  /* 1279 */  false,
  /* 1280 */  false,
  /* 1281 */  false,
  /* 1282 */  false,
  /* 1283 */  false,
  /* 1284 */  false,
  /* 1285 */  false,
  /* 1286 */  false,
  /* 1287 */  false,
  /* 1288 */  false,
  /* 1289 */  false,
  /* 1290 */  false,
  /* 1291 */  false,
  /* 1292 */  false,
  /* 1293 */  false,
  /* 1294 */  false,
  /* 1295 */  false,
  /* 1296 */  false,
  /* 1297 */  false,
  /* 1298 */  false,
  /* 1299 */  false,
  /* 1300 */  false,
  /* 1301 */  false,
  /* 1302 */  false,
  /* 1303 */  false,
  /* 1304 */  false,
  /* 1305 */  false,
  /* 1306 */  false,
  /* 1307 */  false,
  /* 1308 */  false,
  /* 1309 */  false,
  /* 1310 */  false,
  /* 1311 */  false,
  /* 1312 */  false,
  /* 1313 */  false,
  /* 1314 */  false,
  /* 1315 */  false,
  /* 1316 */  false,
  /* 1317 */  false,
  /* 1318 */  false,
  /* 1319 */  false,
  /* 1320 */  false,
  /* 1321 */  false,
  /* 1322 */  false,
  /* 1323 */  false,
  /* 1324 */  false,
  /* 1325 */  false,
  /* 1326 */  false,
  /* 1327 */  false,
  /* 1328 */  false,
  /* 1329 */  false,
  /* 1330 */  false,
  /* 1331 */  false,
  /* 1332 */  false,
  /* 1333 */  false,
  /* 1334 */  false,
  /* 1335 */  false,
  /* 1336 */  false,
  /* 1337 */  false,
  /* 1338 */  false,
  /* 1339 */  false,
  /* 1340 */  false,
  /* 1341 */  false,
  /* 1342 */  false,
  /* 1343 */  false,
  /* 1344 */  false,
  /* 1345 */  false,
  /* 1346 */  false,
  /* 1347 */  false,
  /* 1348 */  false,
  /* 1349 */  false,
  /* 1350 */  false,
  /* 1351 */  false,
  /* 1352 */  false,
  /* 1353 */  false,
  /* 1354 */  false,
  /* 1355 */  false,
  /* 1356 */  false,
  /* 1357 */  false,
  /* 1358 */  false,
  /* 1359 */  false,
  /* 1360 */  false,
  /* 1361 */  false,
  /* 1362 */  false,
  /* 1363 */  false,
  /* 1364 */  false,
  /* 1365 */  false,
  /* 1366 */  false,
  /* 1367 */  false,
  /* 1368 */  false,
  /* 1369 */  false,
  /* 1370 */  false,
  /* 1371 */  false,
  /* 1372 */  false,
  /* 1373 */  false,
  /* 1374 */  false,
  /* 1375 */  false,
  /* 1376 */  false,
  /* 1377 */  false,
  /* 1378 */  false,
  /* 1379 */  false,
  /* 1380 */  false,
  /* 1381 */  false,
  /* 1382 */  false,
  /* 1383 */  false,
  /* 1384 */  false,
  /* 1385 */  false,
  /* 1386 */  false,
  /* 1387 */  false,
  /* 1388 */  false,
  /* 1389 */  false,
  /* 1390 */  false,
  /* 1391 */  false,
  /* 1392 */  false,
  /* 1393 */  false,
  /* 1394 */  false,
  /* 1395 */  false,
  /* 1396 */  false,
  /* 1397 */  false,
  /* 1398 */  false,
  /* 1399 */  false,
  /* 1400 */  false,
  /* 1401 */  false,
  /* 1402 */  false,
  /* 1403 */  false,
  /* 1404 */  false,
  /* 1405 */  false,
  /* 1406 */  false,
  /* 1407 */  false,
  /* 1408 */  false,
  /* 1409 */  false,
  /* 1410 */  false,
  /* 1411 */  false,
  /* 1412 */  false,
  /* 1413 */  false,
  /* 1414 */  false,
  /* 1415 */  false,
  /* 1416 */  false,
  /* 1417 */  false,
  /* 1418 */  false,
  /* 1419 */  false,
  /* 1420 */  false,
  /* 1421 */  false,
  /* 1422 */  false,
  /* 1423 */  false,
  /* 1424 */  false,
  /* 1425 */  false,
  /* 1426 */  false,
  /* 1427 */  false,
  /* 1428 */  false,
  /* 1429 */  false,
  /* 1430 */  false,
  /* 1431 */  false,
  /* 1432 */  false,
  /* 1433 */  false,
  /* 1434 */  false,
  /* 1435 */  false,
  /* 1436 */  false,
  /* 1437 */  false,
  /* 1438 */  false,
  /* 1439 */  false,
  /* 1440 */  false,
  /* 1441 */  false,
  /* 1442 */  false,
  /* 1443 */  false,
  /* 1444 */  false,
  /* 1445 */  false,
  /* 1446 */  false,
  /* 1447 */  false,
  /* 1448 */  false,
  /* 1449 */  false,
  /* 1450 */  false,
  /* 1451 */  false,
  /* 1452 */  false,
  /* 1453 */  false,
  /* 1454 */  false,
  /* 1455 */  false,
  /* 1456 */  false,
  /* 1457 */  false,
  /* 1458 */  false,
  /* 1459 */  false,
  /* 1460 */  false,
  /* 1461 */  false,
  /* 1462 */  false,
  /* 1463 */  false,
  /* 1464 */  false,
  /* 1465 */  false,
  /* 1466 */  false,
  /* 1467 */  false,
  /* 1468 */  false,
  /* 1469 */  false,
  /* 1470 */  false,
  /* 1471 */  false,
  /* 1472 */  false,
  /* 1473 */  false,
  /* 1474 */  false,
  /* 1475 */  false,
  /* 1476 */  false,
  /* 1477 */  false,
  /* 1478 */  false,
  /* 1479 */  false,
  /* 1480 */  false,
  /* 1481 */  false,
  /* 1482 */  false,
  /* 1483 */  false,
  /* 1484 */  false,
  /* 1485 */  false,
  /* 1486 */  false,
  /* 1487 */  false,
  /* 1488 */  false,
  /* 1489 */  false,
  /* 1490 */  false,
  /* 1491 */  false,
  /* 1492 */  false,
  /* 1493 */  false,
  /* 1494 */  false,
  /* 1495 */  false,
  /* 1496 */  false,
  /* 1497 */  false,
  /* 1498 */  false,
  /* 1499 */  false,
  /* 1500 */  false,
  /* 1501 */  false,
  /* 1502 */  false,
  /* 1503 */  false,
  /* 1504 */  false,
  /* 1505 */  false,
  /* 1506 */  false,
  /* 1507 */  false,
  /* 1508 */  false,
  /* 1509 */  false,
  /* 1510 */  false,
  /* 1511 */  false,
  /* 1512 */  false,
  /* 1513 */  false,
  /* 1514 */  false,
  /* 1515 */  false,
  /* 1516 */  false,
  /* 1517 */  false,
  /* 1518 */  false,
  /* 1519 */  false,
  /* 1520 */  false,
  /* 1521 */  false,
  /* 1522 */  false,
  /* 1523 */  false,
  /* 1524 */  false,
  /* 1525 */  false,
  /* 1526 */  false,
  /* 1527 */  false,
  /* 1528 */  false,
  /* 1529 */  false,
  /* 1530 */  false,
  /* 1531 */  false,
  /* 1532 */  false,
  /* 1533 */  false,
  /* 1534 */  false,
  /* 1535 */  false,
  /* 1536 */  false,
  /* 1537 */  false,
  /* 1538 */  false,
  /* 1539 */  false,
  /* 1540 */  false,
  /* 1541 */  false,
  /* 1542 */  false,
  /* 1543 */  false,
  /* 1544 */  false,
  /* 1545 */  false,
  /* 1546 */  false,
  /* 1547 */  false,
  /* 1548 */  false,
  /* 1549 */  false,
  /* 1550 */  false,
  /* 1551 */  false,
  /* 1552 */  false,
  /* 1553 */  false,
  /* 1554 */  false,
  /* 1555 */  false,
  /* 1556 */  false,
  /* 1557 */  false,
  /* 1558 */  false,
  /* 1559 */  false,
  /* 1560 */  false,
  /* 1561 */  false,
  /* 1562 */  false,
  /* 1563 */  false,
  /* 1564 */  false,
  /* 1565 */  false,
  /* 1566 */  false,
  /* 1567 */  false,
  /* 1568 */  false,
  /* 1569 */  false,
  /* 1570 */  false,
  /* 1571 */  false,
  /* 1572 */  false,
  /* 1573 */  false,
  /* 1574 */  false,
  /* 1575 */  false,
  /* 1576 */  false,
  /* 1577 */  false,
  /* 1578 */  false,
  /* 1579 */  false,
  /* 1580 */  false,
  /* 1581 */  false,
  /* 1582 */  false,
  /* 1583 */  false,
  /* 1584 */  false,
  /* 1585 */  false,
  /* 1586 */  false,
  /* 1587 */  false,
  /* 1588 */  false,
  /* 1589 */  false,
  /* 1590 */  false,
  /* 1591 */  false,
  /* 1592 */  false,
  /* 1593 */  false,
  /* 1594 */  false,
  /* 1595 */  false,
  /* 1596 */  false,
  /* 1597 */  false,
  /* 1598 */  false,
  /* 1599 */  false,
  /* 1600 */  false,
  /* 1601 */  false,
  /* 1602 */  false,
  /* 1603 */  false,
  /* 1604 */  false,
  /* 1605 */  false,
  /* 1606 */  false,
  /* 1607 */  false,
  /* 1608 */  false,
  /* 1609 */  false,
  /* 1610 */  false,
  /* 1611 */  false,
  /* 1612 */  false,
  /* 1613 */  false,
  /* 1614 */  false,
  /* 1615 */  false,
  /* 1616 */  false,
  /* 1617 */  false,
  /* 1618 */  false,
  /* 1619 */  false,
  /* 1620 */  false,
  /* 1621 */  false,
  /* 1622 */  false,
  /* 1623 */  false,
  /* 1624 */  false,
  /* 1625 */  false,
  /* 1626 */  false,
  /* 1627 */  false,
  /* 1628 */  false,
  /* 1629 */  false,
  /* 1630 */  false,
  /* 1631 */  false,
  /* 1632 */  false,
  /* 1633 */  false,
  /* 1634 */  false,
  /* 1635 */  false,
  /* 1636 */  false,
  /* 1637 */  false,
  /* 1638 */  false,
  /* 1639 */  false,
  /* 1640 */  false,
  /* 1641 */  false,
  /* 1642 */  false,
  /* 1643 */  false,
  /* 1644 */  false,
  /* 1645 */  false,
  /* 1646 */  false,
  /* 1647 */  false,
  /* 1648 */  false,
  /* 1649 */  false,
  /* 1650 */  false,
  /* 1651 */  false,
  /* 1652 */  false,
  /* 1653 */  false,
  /* 1654 */  false,
  /* 1655 */  false,
  /* 1656 */  false,
  /* 1657 */  false,
  /* 1658 */  false,
  /* 1659 */  false,
  /* 1660 */  false,
  /* 1661 */  false,
  /* 1662 */  false,
  /* 1663 */  false,
  /* 1664 */  false,
  /* 1665 */  false,
  /* 1666 */  false,
  /* 1667 */  false,
  /* 1668 */  false,
  /* 1669 */  false,
  /* 1670 */  false,
  /* 1671 */  false,
  /* 1672 */  false,
  /* 1673 */  false,
  /* 1674 */  false,
  /* 1675 */  false,
  /* 1676 */  false,
  /* 1677 */  false,
  /* 1678 */  false,
  /* 1679 */  false,
  /* 1680 */  false,
  /* 1681 */  false,
  /* 1682 */  false,
  /* 1683 */  false,
  /* 1684 */  false,
  /* 1685 */  false,
  /* 1686 */  false,
  /* 1687 */  false,
  /* 1688 */  false,
  /* 1689 */  false,
  /* 1690 */  false,
  /* 1691 */  false,
  /* 1692 */  false,
  /* 1693 */  false,
  /* 1694 */  false,
  /* 1695 */  false,
  /* 1696 */  false,
  /* 1697 */  false,
  /* 1698 */  false,
  /* 1699 */  false,
  /* 1700 */  false,
  /* 1701 */  false,
  /* 1702 */  false,
  /* 1703 */  false,
  /* 1704 */  false,
  /* 1705 */  false,
  /* 1706 */  false,
  /* 1707 */  false,
  /* 1708 */  false,
  /* 1709 */  false,
  /* 1710 */  false,
  /* 1711 */  false,
  /* 1712 */  false,
  /* 1713 */  false,
  /* 1714 */  false,
  /* 1715 */  false,
  /* 1716 */  false,
  /* 1717 */  false,
  /* 1718 */  false,
  /* 1719 */  false,
  /* 1720 */  false,
  /* 1721 */  false,
  /* 1722 */  false,
  /* 1723 */  false,
  /* 1724 */  false,
  /* 1725 */  false,
  /* 1726 */  false,
  /* 1727 */  false,
  /* 1728 */  false,
  /* 1729 */  false,
  /* 1730 */  false,
  /* 1731 */  false,
  /* 1732 */  false,
  /* 1733 */  false,
  /* 1734 */  false,
  /* 1735 */  false,
  /* 1736 */  false,
  /* 1737 */  false,
  /* 1738 */  false,
  /* 1739 */  false,
  /* 1740 */  false,
  /* 1741 */  false,
  /* 1742 */  false,
  /* 1743 */  false,
  /* 1744 */  false,
  /* 1745 */  false,
  /* 1746 */  false,
  /* 1747 */  false,
  /* 1748 */  false,
  /* 1749 */  false,
  /* 1750 */  false,
  /* 1751 */  false,
  /* 1752 */  false,
  /* 1753 */  false,
  /* 1754 */  false,
  /* 1755 */  false,
  /* 1756 */  false,
  /* 1757 */  false,
  /* 1758 */  false,
  /* 1759 */  false,
  /* 1760 */  false,
  /* 1761 */  false,
  /* 1762 */  false,
  /* 1763 */  false,
  /* 1764 */  false,
  /* 1765 */  false,
  /* 1766 */  false,
  /* 1767 */  false,
  /* 1768 */  false,
  /* 1769 */  false,
  /* 1770 */  false,
  /* 1771 */  false,
  /* 1772 */  false,
  /* 1773 */  false,
  /* 1774 */  false,
  /* 1775 */  false,
  /* 1776 */  false,
  /* 1777 */  false,
  /* 1778 */  false,
  /* 1779 */  false,
  /* 1780 */  false,
  /* 1781 */  false,
  /* 1782 */  false,
  /* 1783 */  false,
  /* 1784 */  false,
  /* 1785 */  false,
  /* 1786 */  false,
  /* 1787 */  false,
  /* 1788 */  false,
  /* 1789 */  false,
  /* 1790 */  false,
  /* 1791 */  false,
  /* 1792 */  false,
  /* 1793 */  false,
  /* 1794 */  false,
  /* 1795 */  false,
  /* 1796 */  false,
  /* 1797 */  false,
  /* 1798 */  false,
  /* 1799 */  false,
  /* 1800 */  false,
  /* 1801 */  false,
  /* 1802 */  false,
  // last instruction
  false // no trailing comma
};

// Mapping from machine-independent opcode to boolean
const        char must_clone[] = {
  0, // Node: 0
  0, // Set: 1
  0, // RegN: 2
  0, // RegI: 3
  0, // RegP: 4
  0, // RegF: 5
  0, // RegD: 6
  0, // RegL: 7
  0, // VecA: 8
  0, // VecS: 9
  0, // VecD: 10
  0, // VecX: 11
  0, // VecY: 12
  0, // VecZ: 13
  0, // RegVectMask: 14
  0, // RegFlags: 15
  0, // _last_machine_leaf: 16
  0, // AbsD: 17
  0, // AbsF: 18
  0, // AbsI: 19
  0, // AbsL: 20
  0, // AddD: 21
  0, // AddF: 22
  0, // AddI: 23
  0, // AddL: 24
  0, // AddP: 25
  0, // Allocate: 26
  0, // AllocateArray: 27
  0, // AndI: 28
  0, // AndL: 29
  0, // ArrayCopy: 30
  0, // AryEq: 31
  0, // AtanD: 32
  1, // Binary: 33
  0, // Blackhole: 34
  1, // Bool: 35
  0, // BoxLock: 36
  0, // ReverseBytesI: 37
  0, // ReverseBytesL: 38
  0, // ReverseBytesUS: 39
  0, // ReverseBytesS: 40
  0, // ReverseBytesV: 41
  0, // CProj: 42
  0, // CacheWB: 43
  0, // CacheWBPreSync: 44
  0, // CacheWBPostSync: 45
  0, // CallDynamicJava: 46
  0, // CallJava: 47
  0, // CallLeaf: 48
  0, // CallLeafNoFP: 49
  0, // CallLeafVector: 50
  0, // CallRuntime: 51
  0, // CallStaticJava: 52
  0, // CastDD: 53
  0, // CastFF: 54
  0, // CastII: 55
  0, // CastLL: 56
  0, // CastVV: 57
  0, // CastX2P: 58
  0, // CastP2X: 59
  0, // CastPP: 60
  0, // Catch: 61
  0, // CatchProj: 62
  0, // CheckCastPP: 63
  0, // ClearArray: 64
  0, // CompressBits: 65
  0, // ExpandBits: 66
  0, // CompressBitsV: 67
  0, // ExpandBitsV: 68
  0, // ConstraintCast: 69
  0, // CMoveD: 70
  0, // CMoveF: 71
  0, // CMoveI: 72
  0, // CMoveL: 73
  0, // CMoveP: 74
  0, // CMoveN: 75
  1, // CmpN: 76
  1, // CmpD: 77
  0, // CmpD3: 78
  1, // CmpF: 79
  0, // CmpF3: 80
  1, // CmpI: 81
  1, // CmpL: 82
  0, // CmpL3: 83
  0, // CmpLTMask: 84
  1, // CmpP: 85
  1, // CmpU: 86
  0, // CmpU3: 87
  1, // CmpUL: 88
  0, // CmpUL3: 89
  0, // CompareAndSwapB: 90
  0, // CompareAndSwapS: 91
  0, // CompareAndSwapI: 92
  0, // CompareAndSwapL: 93
  0, // CompareAndSwapP: 94
  0, // CompareAndSwapN: 95
  0, // WeakCompareAndSwapB: 96
  0, // WeakCompareAndSwapS: 97
  0, // WeakCompareAndSwapI: 98
  0, // WeakCompareAndSwapL: 99
  0, // WeakCompareAndSwapP: 100
  0, // WeakCompareAndSwapN: 101
  0, // CompareAndExchangeB: 102
  0, // CompareAndExchangeS: 103
  0, // CompareAndExchangeI: 104
  0, // CompareAndExchangeL: 105
  0, // CompareAndExchangeP: 106
  0, // CompareAndExchangeN: 107
  0, // GetAndAddB: 108
  0, // GetAndAddS: 109
  0, // GetAndAddI: 110
  0, // GetAndAddL: 111
  0, // GetAndSetB: 112
  0, // GetAndSetS: 113
  0, // GetAndSetI: 114
  0, // GetAndSetL: 115
  0, // GetAndSetP: 116
  0, // GetAndSetN: 117
  0, // Con: 118
  0, // ConN: 119
  0, // ConNKlass: 120
  0, // ConD: 121
  0, // ConF: 122
  0, // ConI: 123
  0, // ConL: 124
  0, // ConP: 125
  0, // Conv2B: 126
  0, // ConvD2F: 127
  0, // ConvD2I: 128
  0, // ConvD2L: 129
  0, // ConvF2D: 130
  0, // ConvF2I: 131
  0, // ConvF2L: 132
  0, // ConvI2D: 133
  0, // ConvI2F: 134
  0, // ConvI2L: 135
  0, // ConvL2D: 136
  0, // ConvL2F: 137
  0, // ConvL2I: 138
  0, // ConvF2HF: 139
  0, // ConvHF2F: 140
  0, // CountedLoop: 141
  0, // CountedLoopEnd: 142
  0, // OuterStripMinedLoop: 143
  0, // OuterStripMinedLoopEnd: 144
  0, // LongCountedLoop: 145
  0, // LongCountedLoopEnd: 146
  0, // CountLeadingZerosI: 147
  0, // CountLeadingZerosL: 148
  0, // CountLeadingZerosV: 149
  0, // CountTrailingZerosI: 150
  0, // CountTrailingZerosL: 151
  0, // CountTrailingZerosV: 152
  0, // CreateEx: 153
  0, // DecodeN: 154
  0, // DecodeNKlass: 155
  0, // DivD: 156
  0, // DivF: 157
  0, // DivI: 158
  0, // DivL: 159
  0, // UDivI: 160
  0, // UDivL: 161
  0, // DivMod: 162
  0, // DivModI: 163
  0, // DivModL: 164
  0, // UDivModI: 165
  0, // UDivModL: 166
  0, // EncodeISOArray: 167
  0, // EncodeP: 168
  0, // EncodePKlass: 169
  1, // FastLock: 170
  1, // FastUnlock: 171
  0, // FmaD: 172
  0, // FmaF: 173
  0, // Goto: 174
  0, // Halt: 175
  0, // CountPositives: 176
  0, // If: 177
  0, // RangeCheck: 178
  0, // IfFalse: 179
  0, // IfTrue: 180
  0, // Initialize: 181
  0, // JProj: 182
  0, // Jump: 183
  0, // JumpProj: 184
  0, // LShiftI: 185
  0, // LShiftL: 186
  0, // LoadB: 187
  0, // LoadUB: 188
  0, // LoadUS: 189
  0, // LoadD: 190
  0, // LoadD_unaligned: 191
  0, // LoadF: 192
  0, // LoadI: 193
  0, // LoadKlass: 194
  0, // LoadNKlass: 195
  0, // LoadL: 196
  0, // LoadL_unaligned: 197
  0, // LoadP: 198
  0, // LoadN: 199
  0, // LoadRange: 200
  0, // LoadS: 201
  0, // Lock: 202
  0, // Loop: 203
  0, // LoopLimit: 204
  0, // Mach: 205
  0, // MachNullCheck: 206
  0, // MachProj: 207
  0, // MulAddS2I: 208
  0, // MaxI: 209
  0, // MaxL: 210
  0, // MaxD: 211
  0, // MaxF: 212
  0, // MemBarAcquire: 213
  0, // LoadFence: 214
  0, // MemBarAcquireLock: 215
  0, // MemBarCPUOrder: 216
  0, // MemBarRelease: 217
  0, // StoreFence: 218
  0, // StoreStoreFence: 219
  0, // MemBarReleaseLock: 220
  0, // MemBarVolatile: 221
  0, // MemBarStoreStore: 222
  0, // MergeMem: 223
  0, // MinI: 224
  0, // MinL: 225
  0, // MinF: 226
  0, // MinD: 227
  0, // ModD: 228
  0, // ModF: 229
  0, // ModI: 230
  0, // ModL: 231
  0, // UModI: 232
  0, // UModL: 233
  0, // MoveI2F: 234
  0, // MoveF2I: 235
  0, // MoveL2D: 236
  0, // MoveD2L: 237
  0, // IsInfiniteF: 238
  0, // IsFiniteF: 239
  0, // IsInfiniteD: 240
  0, // IsFiniteD: 241
  0, // MulD: 242
  0, // MulF: 243
  0, // MulHiL: 244
  0, // UMulHiL: 245
  0, // MulI: 246
  0, // MulL: 247
  0, // Multi: 248
  0, // NegI: 249
  0, // NegL: 250
  0, // NegD: 251
  0, // NegF: 252
  0, // NeverBranch: 253
  0, // OnSpinWait: 254
  0, // Opaque1: 255
  0, // OpaqueLoopInit: 256
  0, // OpaqueLoopStride: 257
  0, // OpaqueZeroTripGuard: 258
  0, // Opaque3: 259
  0, // Opaque4: 260
  0, // ProfileBoolean: 261
  0, // OrI: 262
  0, // OrL: 263
  1, // OverflowAddI: 264
  1, // OverflowSubI: 265
  1, // OverflowMulI: 266
  1, // OverflowAddL: 267
  1, // OverflowSubL: 268
  1, // OverflowMulL: 269
  0, // PCTable: 270
  0, // Parm: 271
  0, // ParsePredicate: 272
  0, // PartialSubtypeCheck: 273
  0, // SubTypeCheck: 274
  0, // Phi: 275
  0, // PopCountI: 276
  0, // PopCountL: 277
  0, // PopCountVI: 278
  0, // PopCountVL: 279
  0, // PopulateIndex: 280
  0, // PrefetchAllocation: 281
  0, // Proj: 282
  0, // RShiftI: 283
  0, // RShiftL: 284
  0, // Region: 285
  0, // Rethrow: 286
  0, // Return: 287
  0, // ReverseI: 288
  0, // ReverseL: 289
  0, // ReverseV: 290
  0, // Root: 291
  0, // RoundDouble: 292
  0, // RoundDoubleMode: 293
  0, // RoundDoubleModeV: 294
  0, // RoundFloat: 295
  0, // RotateLeft: 296
  0, // RotateLeftV: 297
  0, // RotateRight: 298
  0, // RotateRightV: 299
  0, // SafePoint: 300
  0, // SafePointScalarObject: 301
  0, // ShenandoahCompareAndExchangeP: 302
  0, // ShenandoahCompareAndExchangeN: 303
  0, // ShenandoahCompareAndSwapN: 304
  0, // ShenandoahCompareAndSwapP: 305
  0, // ShenandoahWeakCompareAndSwapN: 306
  0, // ShenandoahWeakCompareAndSwapP: 307
  0, // ShenandoahIUBarrier: 308
  0, // ShenandoahLoadReferenceBarrier: 309
  0, // SCMemProj: 310
  0, // CopySignD: 311
  0, // CopySignF: 312
  0, // SignumD: 313
  0, // SignumF: 314
  0, // SignumVF: 315
  0, // SignumVD: 316
  0, // SqrtD: 317
  0, // SqrtF: 318
  0, // RoundF: 319
  0, // RoundD: 320
  0, // Start: 321
  0, // StartOSR: 322
  0, // StoreB: 323
  0, // StoreC: 324
  0, // StoreCM: 325
  0, // StoreD: 326
  0, // StoreF: 327
  0, // StoreI: 328
  0, // StoreL: 329
  0, // StoreP: 330
  0, // StoreN: 331
  0, // StoreNKlass: 332
  0, // StrComp: 333
  0, // StrCompressedCopy: 334
  0, // StrEquals: 335
  0, // StrIndexOf: 336
  0, // StrIndexOfChar: 337
  0, // StrInflatedCopy: 338
  0, // SubD: 339
  0, // SubF: 340
  0, // SubI: 341
  0, // SubL: 342
  0, // TailCall: 343
  0, // TailJump: 344
  0, // MacroLogicV: 345
  0, // ThreadLocal: 346
  0, // Unlock: 347
  0, // URShiftB: 348
  0, // URShiftS: 349
  0, // URShiftI: 350
  0, // URShiftL: 351
  0, // XorI: 352
  0, // XorL: 353
  0, // Vector: 354
  0, // AddVB: 355
  0, // AddVS: 356
  0, // AddVI: 357
  0, // AddReductionVI: 358
  0, // AddVL: 359
  0, // AddReductionVL: 360
  0, // AddVF: 361
  0, // AddReductionVF: 362
  0, // AddVD: 363
  0, // AddReductionVD: 364
  0, // SubVB: 365
  0, // SubVS: 366
  0, // SubVI: 367
  0, // SubVL: 368
  0, // SubVF: 369
  0, // SubVD: 370
  0, // MulVB: 371
  0, // MulVS: 372
  0, // MulVI: 373
  0, // MulReductionVI: 374
  0, // MulVL: 375
  0, // MulReductionVL: 376
  0, // MulVF: 377
  0, // MulReductionVF: 378
  0, // MulVD: 379
  0, // MulReductionVD: 380
  0, // MulAddVS2VI: 381
  0, // FmaVD: 382
  0, // FmaVF: 383
  0, // DivVF: 384
  0, // DivVD: 385
  0, // AbsVB: 386
  0, // AbsVS: 387
  0, // AbsVI: 388
  0, // AbsVL: 389
  0, // AbsVF: 390
  0, // AbsVD: 391
  0, // NegVI: 392
  0, // NegVL: 393
  0, // NegVF: 394
  0, // NegVD: 395
  0, // SqrtVD: 396
  0, // SqrtVF: 397
  0, // LShiftCntV: 398
  0, // RShiftCntV: 399
  0, // LShiftVB: 400
  0, // LShiftVS: 401
  0, // LShiftVI: 402
  0, // LShiftVL: 403
  0, // RShiftVB: 404
  0, // RShiftVS: 405
  0, // RShiftVI: 406
  0, // RShiftVL: 407
  0, // URShiftVB: 408
  0, // URShiftVS: 409
  0, // URShiftVI: 410
  0, // URShiftVL: 411
  0, // AndV: 412
  0, // AndReductionV: 413
  0, // OrV: 414
  0, // OrReductionV: 415
  0, // XorV: 416
  0, // XorReductionV: 417
  0, // MinV: 418
  0, // MaxV: 419
  0, // MinReductionV: 420
  0, // MaxReductionV: 421
  0, // CompressV: 422
  0, // CompressM: 423
  0, // ExpandV: 424
  0, // LoadVector: 425
  0, // LoadVectorGather: 426
  0, // LoadVectorGatherMasked: 427
  0, // StoreVector: 428
  0, // StoreVectorScatter: 429
  0, // StoreVectorScatterMasked: 430
  0, // LoadVectorMasked: 431
  0, // StoreVectorMasked: 432
  0, // VectorCmpMasked: 433
  0, // VectorMaskGen: 434
  0, // VectorMaskOp: 435
  0, // VectorMaskTrueCount: 436
  0, // VectorMaskFirstTrue: 437
  0, // VectorMaskLastTrue: 438
  0, // VectorMaskToLong: 439
  0, // VectorLongToMask: 440
  0, // Pack: 441
  0, // PackB: 442
  0, // PackS: 443
  0, // PackI: 444
  0, // PackL: 445
  0, // PackF: 446
  0, // PackD: 447
  0, // Pack2L: 448
  0, // Pack2D: 449
  0, // ReplicateB: 450
  0, // ReplicateS: 451
  0, // ReplicateI: 452
  0, // ReplicateL: 453
  0, // ReplicateF: 454
  0, // ReplicateD: 455
  0, // RoundVF: 456
  0, // RoundVD: 457
  0, // Extract: 458
  0, // ExtractB: 459
  0, // ExtractUB: 460
  0, // ExtractC: 461
  0, // ExtractS: 462
  0, // ExtractI: 463
  0, // ExtractL: 464
  0, // ExtractF: 465
  0, // ExtractD: 466
  0, // Digit: 467
  0, // LowerCase: 468
  0, // UpperCase: 469
  0, // Whitespace: 470
  0, // VectorBox: 471
  0, // VectorBoxAllocate: 472
  0, // VectorUnbox: 473
  0, // VectorMaskWrapper: 474
  0, // VectorMaskCmp: 475
  0, // VectorMaskCast: 476
  1, // VectorTest: 477
  0, // VectorBlend: 478
  0, // VectorRearrange: 479
  0, // VectorLoadMask: 480
  0, // VectorLoadShuffle: 481
  0, // VectorLoadConst: 482
  0, // VectorStoreMask: 483
  0, // VectorReinterpret: 484
  0, // VectorCast: 485
  0, // VectorCastB2X: 486
  0, // VectorCastS2X: 487
  0, // VectorCastI2X: 488
  0, // VectorCastL2X: 489
  0, // VectorCastF2X: 490
  0, // VectorCastD2X: 491
  0, // VectorCastF2HF: 492
  0, // VectorCastHF2F: 493
  0, // VectorUCastB2X: 494
  0, // VectorUCastS2X: 495
  0, // VectorUCastI2X: 496
  0, // VectorizedHashCode: 497
  0, // VectorInsert: 498
  0, // MaskAll: 499
  0, // AndVMask: 500
  0, // OrVMask: 501
  0 // no trailing comma // XorVMask: 502
};
//  The following instructions can cisc-spill



// An array of character pointers to machine register names.
const char *Matcher::regName[REG_COUNT] = {
  "R10",
  "R10_H",
  "R11",
  "R11_H",
  "R12",
  "R12_H",
  "R13",
  "R13_H",
  "R14",
  "R14_H",
  "R15",
  "R15_H",
  "R16",
  "R16_H",
  "R17",
  "R17_H",
  "R18",
  "R18_H",
  "R0",
  "R0_H",
  "R1",
  "R1_H",
  "R2",
  "R2_H",
  "R3",
  "R3_H",
  "R4",
  "R4_H",
  "R5",
  "R5_H",
  "R6",
  "R6_H",
  "R7",
  "R7_H",
  "R19",
  "R19_H",
  "R20",
  "R20_H",
  "R21",
  "R21_H",
  "R22",
  "R22_H",
  "R23",
  "R23_H",
  "R24",
  "R24_H",
  "R25",
  "R25_H",
  "R26",
  "R26_H",
  "R27",
  "R27_H",
  "R28",
  "R28_H",
  "R29",
  "R29_H",
  "R30",
  "R30_H",
  "R31",
  "R31_H",
  "R8",
  "R8_H",
  "R9",
  "R9_H",
  "V16",
  "V16_H",
  "V16_J",
  "V16_K",
  "V17",
  "V17_H",
  "V17_J",
  "V17_K",
  "V18",
  "V18_H",
  "V18_J",
  "V18_K",
  "V19",
  "V19_H",
  "V19_J",
  "V19_K",
  "V20",
  "V20_H",
  "V20_J",
  "V20_K",
  "V21",
  "V21_H",
  "V21_J",
  "V21_K",
  "V22",
  "V22_H",
  "V22_J",
  "V22_K",
  "V23",
  "V23_H",
  "V23_J",
  "V23_K",
  "V24",
  "V24_H",
  "V24_J",
  "V24_K",
  "V25",
  "V25_H",
  "V25_J",
  "V25_K",
  "V26",
  "V26_H",
  "V26_J",
  "V26_K",
  "V27",
  "V27_H",
  "V27_J",
  "V27_K",
  "V28",
  "V28_H",
  "V28_J",
  "V28_K",
  "V29",
  "V29_H",
  "V29_J",
  "V29_K",
  "V30",
  "V30_H",
  "V30_J",
  "V30_K",
  "V31",
  "V31_H",
  "V31_J",
  "V31_K",
  "V0",
  "V0_H",
  "V0_J",
  "V0_K",
  "V1",
  "V1_H",
  "V1_J",
  "V1_K",
  "V2",
  "V2_H",
  "V2_J",
  "V2_K",
  "V3",
  "V3_H",
  "V3_J",
  "V3_K",
  "V4",
  "V4_H",
  "V4_J",
  "V4_K",
  "V5",
  "V5_H",
  "V5_J",
  "V5_K",
  "V6",
  "V6_H",
  "V6_J",
  "V6_K",
  "V7",
  "V7_H",
  "V7_J",
  "V7_K",
  "V8",
  "V8_H",
  "V8_J",
  "V8_K",
  "V9",
  "V9_H",
  "V9_J",
  "V9_K",
  "V10",
  "V10_H",
  "V10_J",
  "V10_K",
  "V11",
  "V11_H",
  "V11_J",
  "V11_K",
  "V12",
  "V12_H",
  "V12_J",
  "V12_K",
  "V13",
  "V13_H",
  "V13_J",
  "V13_K",
  "V14",
  "V14_H",
  "V14_J",
  "V14_K",
  "V15",
  "V15_H",
  "V15_J",
  "V15_K",
  "P0",
  "P1",
  "P2",
  "P3",
  "P4",
  "P5",
  "P6",
  "P8",
  "P9",
  "P10",
  "P11",
  "P12",
  "P13",
  "P14",
  "P15",
  "P7",
  "RFLAGS" // no trailing comma
};

// An array of character pointers to machine register names.
const VMReg OptoReg::opto2vm[REG_COUNT] = {
	r10->as_VMReg()        ,
	r10->as_VMReg()->next(),
	r11->as_VMReg()        ,
	r11->as_VMReg()->next(),
	r12->as_VMReg()        ,
	r12->as_VMReg()->next(),
	r13->as_VMReg()        ,
	r13->as_VMReg()->next(),
	r14->as_VMReg()        ,
	r14->as_VMReg()->next(),
	r15->as_VMReg()        ,
	r15->as_VMReg()->next(),
	r16->as_VMReg()        ,
	r16->as_VMReg()->next(),
	r17->as_VMReg()        ,
	r17->as_VMReg()->next(),
	r18_tls->as_VMReg()        ,
	r18_tls->as_VMReg()->next(),
	r0->as_VMReg()         ,
	r0->as_VMReg()->next() ,
	r1->as_VMReg()         ,
	r1->as_VMReg()->next() ,
	r2->as_VMReg()         ,
	r2->as_VMReg()->next() ,
	r3->as_VMReg()         ,
	r3->as_VMReg()->next() ,
	r4->as_VMReg()         ,
	r4->as_VMReg()->next() ,
	r5->as_VMReg()         ,
	r5->as_VMReg()->next() ,
	r6->as_VMReg()         ,
	r6->as_VMReg()->next() ,
	r7->as_VMReg()         ,
	r7->as_VMReg()->next() ,
	r19->as_VMReg()        ,
	r19->as_VMReg()->next(),
	r20->as_VMReg()        ,
	r20->as_VMReg()->next(),
	r21->as_VMReg()        ,
	r21->as_VMReg()->next(),
	r22->as_VMReg()        ,
	r22->as_VMReg()->next(),
	r23->as_VMReg()        ,
	r23->as_VMReg()->next(),
	r24->as_VMReg()        ,
	r24->as_VMReg()->next(),
	r25->as_VMReg()        ,
	r25->as_VMReg()->next(),
	r26->as_VMReg()        ,
	r26->as_VMReg()->next(),
	r27->as_VMReg()        ,
	r27->as_VMReg()->next(),
	r28->as_VMReg()        ,
	r28->as_VMReg()->next(),
	r29->as_VMReg()        ,
	r29->as_VMReg()->next(),
	r30->as_VMReg()        ,
	r30->as_VMReg()->next(),
	r31_sp->as_VMReg()     ,
	r31_sp->as_VMReg()->next(),
	r8->as_VMReg()         ,
	r8->as_VMReg()->next() ,
	r9->as_VMReg()         ,
	r9->as_VMReg()->next() ,
	v16->as_VMReg()          ,
	v16->as_VMReg()->next()  ,
	v16->as_VMReg()->next(2) ,
	v16->as_VMReg()->next(3) ,
	v17->as_VMReg()          ,
	v17->as_VMReg()->next()  ,
	v17->as_VMReg()->next(2) ,
	v17->as_VMReg()->next(3) ,
	v18->as_VMReg()          ,
	v18->as_VMReg()->next()  ,
	v18->as_VMReg()->next(2) ,
	v18->as_VMReg()->next(3) ,
	v19->as_VMReg()          ,
	v19->as_VMReg()->next()  ,
	v19->as_VMReg()->next(2) ,
	v19->as_VMReg()->next(3) ,
	v20->as_VMReg()          ,
	v20->as_VMReg()->next()  ,
	v20->as_VMReg()->next(2) ,
	v20->as_VMReg()->next(3) ,
	v21->as_VMReg()          ,
	v21->as_VMReg()->next()  ,
	v21->as_VMReg()->next(2) ,
	v21->as_VMReg()->next(3) ,
	v22->as_VMReg()          ,
	v22->as_VMReg()->next()  ,
	v22->as_VMReg()->next(2) ,
	v22->as_VMReg()->next(3) ,
	v23->as_VMReg()          ,
	v23->as_VMReg()->next()  ,
	v23->as_VMReg()->next(2) ,
	v23->as_VMReg()->next(3) ,
	v24->as_VMReg()          ,
	v24->as_VMReg()->next()  ,
	v24->as_VMReg()->next(2) ,
	v24->as_VMReg()->next(3) ,
	v25->as_VMReg()          ,
	v25->as_VMReg()->next()  ,
	v25->as_VMReg()->next(2) ,
	v25->as_VMReg()->next(3) ,
	v26->as_VMReg()          ,
	v26->as_VMReg()->next()  ,
	v26->as_VMReg()->next(2) ,
	v26->as_VMReg()->next(3) ,
	v27->as_VMReg()          ,
	v27->as_VMReg()->next()  ,
	v27->as_VMReg()->next(2) ,
	v27->as_VMReg()->next(3) ,
	v28->as_VMReg()          ,
	v28->as_VMReg()->next()  ,
	v28->as_VMReg()->next(2) ,
	v28->as_VMReg()->next(3) ,
	v29->as_VMReg()          ,
	v29->as_VMReg()->next()  ,
	v29->as_VMReg()->next(2) ,
	v29->as_VMReg()->next(3) ,
	v30->as_VMReg()          ,
	v30->as_VMReg()->next()  ,
	v30->as_VMReg()->next(2) ,
	v30->as_VMReg()->next(3) ,
	v31->as_VMReg()          ,
	v31->as_VMReg()->next()  ,
	v31->as_VMReg()->next(2) ,
	v31->as_VMReg()->next(3) ,
	v0->as_VMReg()          ,
	v0->as_VMReg()->next()  ,
	v0->as_VMReg()->next(2) ,
	v0->as_VMReg()->next(3) ,
	v1->as_VMReg()          ,
	v1->as_VMReg()->next()  ,
	v1->as_VMReg()->next(2) ,
	v1->as_VMReg()->next(3) ,
	v2->as_VMReg()          ,
	v2->as_VMReg()->next()  ,
	v2->as_VMReg()->next(2) ,
	v2->as_VMReg()->next(3) ,
	v3->as_VMReg()          ,
	v3->as_VMReg()->next()  ,
	v3->as_VMReg()->next(2) ,
	v3->as_VMReg()->next(3) ,
	v4->as_VMReg()          ,
	v4->as_VMReg()->next()  ,
	v4->as_VMReg()->next(2) ,
	v4->as_VMReg()->next(3) ,
	v5->as_VMReg()          ,
	v5->as_VMReg()->next()  ,
	v5->as_VMReg()->next(2) ,
	v5->as_VMReg()->next(3) ,
	v6->as_VMReg()          ,
	v6->as_VMReg()->next()  ,
	v6->as_VMReg()->next(2) ,
	v6->as_VMReg()->next(3) ,
	v7->as_VMReg()          ,
	v7->as_VMReg()->next()  ,
	v7->as_VMReg()->next(2) ,
	v7->as_VMReg()->next(3) ,
	v8->as_VMReg()          ,
	v8->as_VMReg()->next()  ,
	v8->as_VMReg()->next(2) ,
	v8->as_VMReg()->next(3) ,
	v9->as_VMReg()          ,
	v9->as_VMReg()->next()  ,
	v9->as_VMReg()->next(2) ,
	v9->as_VMReg()->next(3) ,
	v10->as_VMReg()          ,
	v10->as_VMReg()->next()  ,
	v10->as_VMReg()->next(2) ,
	v10->as_VMReg()->next(3) ,
	v11->as_VMReg()          ,
	v11->as_VMReg()->next()  ,
	v11->as_VMReg()->next(2) ,
	v11->as_VMReg()->next(3) ,
	v12->as_VMReg()          ,
	v12->as_VMReg()->next()  ,
	v12->as_VMReg()->next(2) ,
	v12->as_VMReg()->next(3) ,
	v13->as_VMReg()          ,
	v13->as_VMReg()->next()  ,
	v13->as_VMReg()->next(2) ,
	v13->as_VMReg()->next(3) ,
	v14->as_VMReg()          ,
	v14->as_VMReg()->next()  ,
	v14->as_VMReg()->next(2) ,
	v14->as_VMReg()->next(3) ,
	v15->as_VMReg()          ,
	v15->as_VMReg()->next()  ,
	v15->as_VMReg()->next(2) ,
	v15->as_VMReg()->next(3) ,
	p0->as_VMReg(),
	p1->as_VMReg(),
	p2->as_VMReg(),
	p3->as_VMReg(),
	p4->as_VMReg(),
	p5->as_VMReg(),
	p6->as_VMReg(),
	p8->as_VMReg(),
	p9->as_VMReg(),
	p10->as_VMReg(),
	p11->as_VMReg(),
	p12->as_VMReg(),
	p13->as_VMReg(),
	p14->as_VMReg(),
	p15->as_VMReg(),
	p7->as_VMReg(),
	VMRegImpl::Bad() // no trailing comma
	};

 OptoReg::Name OptoReg::vm2opto[ConcreteRegisterImpl::number_of_registers];

// An array of the machine register encode values
const unsigned char Matcher::_regEncode[REG_COUNT] = {
  (unsigned char)'\xA',  // R10
  (unsigned char)'\xA',  // R10_H
  (unsigned char)'\xB',  // R11
  (unsigned char)'\xB',  // R11_H
  (unsigned char)'\xC',  // R12
  (unsigned char)'\xC',  // R12_H
  (unsigned char)'\xD',  // R13
  (unsigned char)'\xD',  // R13_H
  (unsigned char)'\xE',  // R14
  (unsigned char)'\xE',  // R14_H
  (unsigned char)'\xF',  // R15
  (unsigned char)'\xF',  // R15_H
  (unsigned char)'\x10',  // R16
  (unsigned char)'\x10',  // R16_H
  (unsigned char)'\x11',  // R17
  (unsigned char)'\x11',  // R17_H
  (unsigned char)'\x12',  // R18
  (unsigned char)'\x12',  // R18_H
  (unsigned char)'\x0',  // R0
  (unsigned char)'\x0',  // R0_H
  (unsigned char)'\x1',  // R1
  (unsigned char)'\x1',  // R1_H
  (unsigned char)'\x2',  // R2
  (unsigned char)'\x2',  // R2_H
  (unsigned char)'\x3',  // R3
  (unsigned char)'\x3',  // R3_H
  (unsigned char)'\x4',  // R4
  (unsigned char)'\x4',  // R4_H
  (unsigned char)'\x5',  // R5
  (unsigned char)'\x5',  // R5_H
  (unsigned char)'\x6',  // R6
  (unsigned char)'\x6',  // R6_H
  (unsigned char)'\x7',  // R7
  (unsigned char)'\x7',  // R7_H
  (unsigned char)'\x13',  // R19
  (unsigned char)'\x13',  // R19_H
  (unsigned char)'\x14',  // R20
  (unsigned char)'\x14',  // R20_H
  (unsigned char)'\x15',  // R21
  (unsigned char)'\x15',  // R21_H
  (unsigned char)'\x16',  // R22
  (unsigned char)'\x16',  // R22_H
  (unsigned char)'\x17',  // R23
  (unsigned char)'\x17',  // R23_H
  (unsigned char)'\x18',  // R24
  (unsigned char)'\x18',  // R24_H
  (unsigned char)'\x19',  // R25
  (unsigned char)'\x19',  // R25_H
  (unsigned char)'\x1A',  // R26
  (unsigned char)'\x1A',  // R26_H
  (unsigned char)'\x1B',  // R27
  (unsigned char)'\x1B',  // R27_H
  (unsigned char)'\x1C',  // R28
  (unsigned char)'\x1C',  // R28_H
  (unsigned char)'\x1D',  // R29
  (unsigned char)'\x1D',  // R29_H
  (unsigned char)'\x1E',  // R30
  (unsigned char)'\x1E',  // R30_H
  (unsigned char)'\x1F',  // R31
  (unsigned char)'\x1F',  // R31_H
  (unsigned char)'\x8',  // R8
  (unsigned char)'\x8',  // R8_H
  (unsigned char)'\x9',  // R9
  (unsigned char)'\x9',  // R9_H
  (unsigned char)'\x10',  // V16
  (unsigned char)'\x10',  // V16_H
  (unsigned char)'\x10',  // V16_J
  (unsigned char)'\x10',  // V16_K
  (unsigned char)'\x11',  // V17
  (unsigned char)'\x11',  // V17_H
  (unsigned char)'\x11',  // V17_J
  (unsigned char)'\x11',  // V17_K
  (unsigned char)'\x12',  // V18
  (unsigned char)'\x12',  // V18_H
  (unsigned char)'\x12',  // V18_J
  (unsigned char)'\x12',  // V18_K
  (unsigned char)'\x13',  // V19
  (unsigned char)'\x13',  // V19_H
  (unsigned char)'\x13',  // V19_J
  (unsigned char)'\x13',  // V19_K
  (unsigned char)'\x14',  // V20
  (unsigned char)'\x14',  // V20_H
  (unsigned char)'\x14',  // V20_J
  (unsigned char)'\x14',  // V20_K
  (unsigned char)'\x15',  // V21
  (unsigned char)'\x15',  // V21_H
  (unsigned char)'\x15',  // V21_J
  (unsigned char)'\x15',  // V21_K
  (unsigned char)'\x16',  // V22
  (unsigned char)'\x16',  // V22_H
  (unsigned char)'\x16',  // V22_J
  (unsigned char)'\x16',  // V22_K
  (unsigned char)'\x17',  // V23
  (unsigned char)'\x17',  // V23_H
  (unsigned char)'\x17',  // V23_J
  (unsigned char)'\x17',  // V23_K
  (unsigned char)'\x18',  // V24
  (unsigned char)'\x18',  // V24_H
  (unsigned char)'\x18',  // V24_J
  (unsigned char)'\x18',  // V24_K
  (unsigned char)'\x19',  // V25
  (unsigned char)'\x19',  // V25_H
  (unsigned char)'\x19',  // V25_J
  (unsigned char)'\x19',  // V25_K
  (unsigned char)'\x1A',  // V26
  (unsigned char)'\x1A',  // V26_H
  (unsigned char)'\x1A',  // V26_J
  (unsigned char)'\x1A',  // V26_K
  (unsigned char)'\x1B',  // V27
  (unsigned char)'\x1B',  // V27_H
  (unsigned char)'\x1B',  // V27_J
  (unsigned char)'\x1B',  // V27_K
  (unsigned char)'\x1C',  // V28
  (unsigned char)'\x1C',  // V28_H
  (unsigned char)'\x1C',  // V28_J
  (unsigned char)'\x1C',  // V28_K
  (unsigned char)'\x1D',  // V29
  (unsigned char)'\x1D',  // V29_H
  (unsigned char)'\x1D',  // V29_J
  (unsigned char)'\x1D',  // V29_K
  (unsigned char)'\x1E',  // V30
  (unsigned char)'\x1E',  // V30_H
  (unsigned char)'\x1E',  // V30_J
  (unsigned char)'\x1E',  // V30_K
  (unsigned char)'\x1F',  // V31
  (unsigned char)'\x1F',  // V31_H
  (unsigned char)'\x1F',  // V31_J
  (unsigned char)'\x1F',  // V31_K
  (unsigned char)'\x0',  // V0
  (unsigned char)'\x0',  // V0_H
  (unsigned char)'\x0',  // V0_J
  (unsigned char)'\x0',  // V0_K
  (unsigned char)'\x1',  // V1
  (unsigned char)'\x1',  // V1_H
  (unsigned char)'\x1',  // V1_J
  (unsigned char)'\x1',  // V1_K
  (unsigned char)'\x2',  // V2
  (unsigned char)'\x2',  // V2_H
  (unsigned char)'\x2',  // V2_J
  (unsigned char)'\x2',  // V2_K
  (unsigned char)'\x3',  // V3
  (unsigned char)'\x3',  // V3_H
  (unsigned char)'\x3',  // V3_J
  (unsigned char)'\x3',  // V3_K
  (unsigned char)'\x4',  // V4
  (unsigned char)'\x4',  // V4_H
  (unsigned char)'\x4',  // V4_J
  (unsigned char)'\x4',  // V4_K
  (unsigned char)'\x5',  // V5
  (unsigned char)'\x5',  // V5_H
  (unsigned char)'\x5',  // V5_J
  (unsigned char)'\x5',  // V5_K
  (unsigned char)'\x6',  // V6
  (unsigned char)'\x6',  // V6_H
  (unsigned char)'\x6',  // V6_J
  (unsigned char)'\x6',  // V6_K
  (unsigned char)'\x7',  // V7
  (unsigned char)'\x7',  // V7_H
  (unsigned char)'\x7',  // V7_J
  (unsigned char)'\x7',  // V7_K
  (unsigned char)'\x8',  // V8
  (unsigned char)'\x8',  // V8_H
  (unsigned char)'\x8',  // V8_J
  (unsigned char)'\x8',  // V8_K
  (unsigned char)'\x9',  // V9
  (unsigned char)'\x9',  // V9_H
  (unsigned char)'\x9',  // V9_J
  (unsigned char)'\x9',  // V9_K
  (unsigned char)'\xA',  // V10
  (unsigned char)'\xA',  // V10_H
  (unsigned char)'\xA',  // V10_J
  (unsigned char)'\xA',  // V10_K
  (unsigned char)'\xB',  // V11
  (unsigned char)'\xB',  // V11_H
  (unsigned char)'\xB',  // V11_J
  (unsigned char)'\xB',  // V11_K
  (unsigned char)'\xC',  // V12
  (unsigned char)'\xC',  // V12_H
  (unsigned char)'\xC',  // V12_J
  (unsigned char)'\xC',  // V12_K
  (unsigned char)'\xD',  // V13
  (unsigned char)'\xD',  // V13_H
  (unsigned char)'\xD',  // V13_J
  (unsigned char)'\xD',  // V13_K
  (unsigned char)'\xE',  // V14
  (unsigned char)'\xE',  // V14_H
  (unsigned char)'\xE',  // V14_J
  (unsigned char)'\xE',  // V14_K
  (unsigned char)'\xF',  // V15
  (unsigned char)'\xF',  // V15_H
  (unsigned char)'\xF',  // V15_J
  (unsigned char)'\xF',  // V15_K
  (unsigned char)'\x0',  // P0
  (unsigned char)'\x1',  // P1
  (unsigned char)'\x2',  // P2
  (unsigned char)'\x3',  // P3
  (unsigned char)'\x4',  // P4
  (unsigned char)'\x5',  // P5
  (unsigned char)'\x6',  // P6
  (unsigned char)'\x8',  // P8
  (unsigned char)'\x9',  // P9
  (unsigned char)'\xA',  // P10
  (unsigned char)'\xB',  // P11
  (unsigned char)'\xC',  // P12
  (unsigned char)'\xD',  // P13
  (unsigned char)'\xE',  // P14
  (unsigned char)'\xF',  // P15
  (unsigned char)'\x7',  // P7
  (unsigned char)'\x20' // no trailing comma  // RFLAGS
};


//------------------Define classes derived from MachOper---------------------
MachOper  *labelOper::clone() const {
  return  new labelOper(_label, _block_num);
}
uint labelOper::opcode() const { return LABEL; }

const RegMask *sRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

MachOper  *methodOper::clone() const {
  return  new methodOper(_method);
}
uint methodOper::opcode() const { return METHOD; }

const RegMask *iRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *iRegINoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_REG32_mask();
}

const RegMask *iRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG_mask();
}

const RegMask *iRegLNoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_REG_mask();
}

const RegMask *iRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *iRegPNoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_PTR_REG_mask();
}

const RegMask *iRegPNoSpNoRfpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_NO_RFP_PTR_REG_mask();
}

const RegMask *iRegP_R0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R0_REG_mask();
}

const RegMask *iRegP_R1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R1_REG_mask();
}

const RegMask *iRegP_R2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R2_REG_mask();
}

const RegMask *iRegP_R3Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R3_REG_mask();
}

const RegMask *iRegP_R4Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R4_REG_mask();
}

const RegMask *iRegP_R5Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R5_REG_mask();
}

const RegMask *iRegP_R10Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R10_REG_mask();
}

const RegMask *iRegL_R0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R0_REG_mask();
}

const RegMask *iRegL_R2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R2_REG_mask();
}

const RegMask *iRegL_R3Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R3_REG_mask();
}

const RegMask *iRegL_R11Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R11_REG_mask();
}

const RegMask *iRegP_FPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FP_REG_mask();
}

const RegMask *iRegI_R0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R0_REG_mask();
}

const RegMask *iRegI_R2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R2_REG_mask();
}

const RegMask *iRegI_R3Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R3_REG_mask();
}

const RegMask *iRegI_R4Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R4_REG_mask();
}

const RegMask *iRegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *iRegN_R0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R0_REG_mask();
}

const RegMask *iRegN_R2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R2_REG_mask();
}

const RegMask *iRegN_R3Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R3_REG_mask();
}

const RegMask *iRegNNoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_REG32_mask();
}

const RegMask *vRegFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FLOAT_REG_mask();
}

const RegMask *vRegDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &DOUBLE_REG_mask();
}

const RegMask *vRegOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &RegMask::Empty;
}

const RegMask *vecAOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORA_REG_mask();
}

const RegMask *vecDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORD_REG_mask();
}

const RegMask *vecXOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORX_REG_mask();
}

const RegMask *vRegD_V0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V0_REG_mask();
}

const RegMask *vRegD_V1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V1_REG_mask();
}

const RegMask *vRegD_V2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V2_REG_mask();
}

const RegMask *vRegD_V3Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V3_REG_mask();
}

const RegMask *vRegD_V4Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V4_REG_mask();
}

const RegMask *vRegD_V5Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V5_REG_mask();
}

const RegMask *vRegD_V6Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V6_REG_mask();
}

const RegMask *vRegD_V7Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V7_REG_mask();
}

const RegMask *vRegD_V8Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V8_REG_mask();
}

const RegMask *vRegD_V9Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V9_REG_mask();
}

const RegMask *vRegD_V10Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V10_REG_mask();
}

const RegMask *vRegD_V11Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V11_REG_mask();
}

const RegMask *vRegD_V12Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V12_REG_mask();
}

const RegMask *vRegD_V13Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V13_REG_mask();
}

const RegMask *vRegD_V14Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V14_REG_mask();
}

const RegMask *vRegD_V15Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V15_REG_mask();
}

const RegMask *vRegD_V16Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V16_REG_mask();
}

const RegMask *vRegD_V17Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V17_REG_mask();
}

const RegMask *vRegD_V18Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V18_REG_mask();
}

const RegMask *vRegD_V19Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V19_REG_mask();
}

const RegMask *vRegD_V20Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V20_REG_mask();
}

const RegMask *vRegD_V21Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V21_REG_mask();
}

const RegMask *vRegD_V22Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V22_REG_mask();
}

const RegMask *vRegD_V23Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V23_REG_mask();
}

const RegMask *vRegD_V24Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V24_REG_mask();
}

const RegMask *vRegD_V25Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V25_REG_mask();
}

const RegMask *vRegD_V26Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V26_REG_mask();
}

const RegMask *vRegD_V27Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V27_REG_mask();
}

const RegMask *vRegD_V28Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V28_REG_mask();
}

const RegMask *vRegD_V29Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V29_REG_mask();
}

const RegMask *vRegD_V30Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V30_REG_mask();
}

const RegMask *vRegD_V31Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V31_REG_mask();
}

const RegMask *pRegOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PR_REG_mask();
}

const RegMask *pRegGovOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &GOV_PR_mask();
}

const RegMask *pRegGov_P0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &P0_REG_mask();
}

const RegMask *pRegGov_P1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &P1_REG_mask();
}

const RegMask *rFlagsRegOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask();
}

const RegMask *rFlagsRegUOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask();
}

const RegMask *inline_cache_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &METHOD_REG_mask();
}

const RegMask *thread_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &THREAD_REG_mask();
}

const RegMask *lr_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &LR_REG_mask();
}

const RegMask *indirectOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indIndexScaledI2LOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG32_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indIndexScaledOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indIndexI2LOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG32_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indIndexOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indOffIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffI1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffI2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffI4Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffI8Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffI16Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffL1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffL2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffL4Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffL8Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffL16Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indirectNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indIndexScaledI2LNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indIndexScaledNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG32_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indIndexI2LNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indIndexNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG32_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indOffINOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indOffLNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *thread_anchor_pcOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *stackSlotPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *iRegL2IOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG_mask();
}

const RegMask *vmemA_indOffI4Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *vmemA_indOffL4Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

//------------------Define members for classes derived from MachNode----------
// Build short branch version of this instruction
MachNode *far_cmpL_branch_signNode::short_branch_version() {
  cmpL_branch_signNode *node = new cmpL_branch_signNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpI_branch_signNode::short_branch_version() {
  cmpI_branch_signNode *node = new cmpI_branch_signNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpL_branch_bitNode::short_branch_version() {
  cmpL_branch_bitNode *node = new cmpL_branch_bitNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpI_branch_bitNode::short_branch_version() {
  cmpI_branch_bitNode *node = new cmpI_branch_bitNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}


// Copy _idx, inputs and operands to new node
void MachNode::fill_new_machnode(MachNode* node) const {
  // New node must use same node index
  node->set_idx( _idx );
  // Copy machine-independent inputs
  for( uint j = 0; j < req(); j++ ) {
    node->add_req(in(j));
  }
  // Copy my operands, except for cisc position
  int nopnds = num_opnds();
  assert( node->num_opnds() == (uint)nopnds, "Must have same number of operands");
  MachOper **to = node->_opnds;
  for( int i = 0; i < nopnds; i++ ) {
    if( i != cisc_operand() ) 
      to[i] = _opnds[i]->clone();
  }
  // Do not increment node index counter, since node reuses my index
  Compile* C = Compile::current();
  C->set_unique(C->unique() - 1);
}

void overflowMulI_reg_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void overflowMulI_reg_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void overflowMulL_reg_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void overflowMulL_reg_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConUNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConUNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpI_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpI_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpL_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpL_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpP_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpP_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpN_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpN_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpP_narrowOop_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpP_narrowOop_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpUI_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpUI_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpUL_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpUL_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpL_branch_signNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpL_branch_signNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpI_branch_signNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpI_branch_signNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpL_branch_bitNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(5));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpL_branch_bitNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(5));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpI_branch_bitNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(5));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpI_branch_bitNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(5));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpL_branch_signNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpL_branch_signNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpI_branch_signNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpI_branch_signNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpL_branch_bitNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(5));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpL_branch_bitNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(5));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpI_branch_bitNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(5));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpI_branch_bitNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(5));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchLoopEndNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchLoopEndNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void CallStaticJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallDynamicJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallRuntimeDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafNoFPDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

int loadBNode::reloc() const {
  return 1;
}

int loadB2LNode::reloc() const {
  return 1;
}

int loadUBNode::reloc() const {
  return 1;
}

int loadUB2LNode::reloc() const {
  return 1;
}

int loadSNode::reloc() const {
  return 1;
}

int loadS2LNode::reloc() const {
  return 1;
}

int loadUSNode::reloc() const {
  return 1;
}

int loadUS2LNode::reloc() const {
  return 1;
}

int loadINode::reloc() const {
  return 1;
}

int loadI2LNode::reloc() const {
  return 1;
}

int loadUI2LNode::reloc() const {
  return 1;
}

int loadLNode::reloc() const {
  return 1;
}

int loadRangeNode::reloc() const {
  return 1;
}

int loadPNode::reloc() const {
  return 1;
}

int loadNNode::reloc() const {
  return 1;
}

int loadKlassNode::reloc() const {
  return 1;
}

int loadNKlassNode::reloc() const {
  return 1;
}

int loadFNode::reloc() const {
  return 1;
}

int loadDNode::reloc() const {
  return 1;
}

int loadConPNode::reloc() const {
  return 1;
}

int loadConP0Node::reloc() const {
  return 1;
}

int loadConP1Node::reloc() const {
  return 1;
}

int loadByteMapBaseNode::reloc() const {
  return 1;
}

int loadConF_packedNode::reloc() const {
  return 2;
}

int loadConFNode::reloc() const {
  return 2;
}

int loadConD_packedNode::reloc() const {
  return 2;
}

int loadConDNode::reloc() const {
  return 2;
}

int storeimmCM0Node::reloc() const {
  return 2;
}

int storeimmCM0_orderedNode::reloc() const {
  return 2;
}

int storeBNode::reloc() const {
  return 3;
}

int storeimmB0Node::reloc() const {
  return 2;
}

int storeCNode::reloc() const {
  return 3;
}

int storeimmC0Node::reloc() const {
  return 2;
}

int storeINode::reloc() const {
  return 3;
}

int storeimmI0Node::reloc() const {
  return 2;
}

int storeLNode::reloc() const {
  return 2;
}

int storeimmL0Node::reloc() const {
  return 2;
}

int storePNode::reloc() const {
  return 2;
}

int storeimmP0Node::reloc() const {
  return 3;
}

int storeNNode::reloc() const {
  return 2;
}

int storeImmN0Node::reloc() const {
  return 2;
}

int storeFNode::reloc() const {
  return 2;
}

int storeDNode::reloc() const {
  return 2;
}

int storeNKlassNode::reloc() const {
  return 2;
}

int prefetchallocNode::reloc() const {
  return 1;
}

int storeB_volatileNode::reloc() const {
  return 1;
}

int storeC_volatileNode::reloc() const {
  return 1;
}

int storeI_volatileNode::reloc() const {
  return 1;
}

int storeimmP0_volatileNode::reloc() const {
  return 1;
}

int bytes_reverse_intNode::reloc() const {
  return 1;
}

int bytes_reverse_unsigned_shortNode::reloc() const {
  return 1;
}

int bytes_reverse_shortNode::reloc() const {
  return 1;
}

int countLeadingZerosINode::reloc() const {
  return 1;
}

int countTrailingZerosINode::reloc() const {
  return 1;
}

int popCountINode::reloc() const {
  return 1;
}

int popCountI_memNode::reloc() const {
  return 1;
}

int popCountL_memNode::reloc() const {
  return 1;
}

int get_and_addINode::reloc() const {
  return 1;
}

int get_and_addI_no_resNode::reloc() const {
  return 1;
}

int get_and_addIAcqNode::reloc() const {
  return 1;
}

int get_and_addI_no_resAcqNode::reloc() const {
  return 1;
}

int cmovI_reg_regNode::reloc() const {
  return 2;
}

int cmovUI_reg_regNode::reloc() const {
  return 2;
}

int cmovI_zero_regNode::reloc() const {
  return 1;
}

int cmovUI_zero_regNode::reloc() const {
  return 1;
}

int cmovI_reg_zeroNode::reloc() const {
  return 1;
}

int cmovUI_reg_zeroNode::reloc() const {
  return 1;
}

int cmovP_reg_zeroNode::reloc() const {
  return 1;
}

int cmovUP_reg_zeroNode::reloc() const {
  return 1;
}

int cmovP_zero_regNode::reloc() const {
  return 1;
}

int cmovUP_zero_regNode::reloc() const {
  return 1;
}

int addI_reg_regNode::reloc() const {
  return 2;
}

int addI_reg_immNode::reloc() const {
  return 1;
}

int addP_reg_reg_extNode::reloc() const {
  return 1;
}

int addP_reg_reg_ext_shiftNode::reloc() const {
  return 1;
}

int lshift_extNode::reloc() const {
  return 1;
}

int subI_reg_regNode::reloc() const {
  return 2;
}

int subI_reg_immNode::reloc() const {
  return 1;
}

int negI_regNode::reloc() const {
  return 1;
}

int mulINode::reloc() const {
  return 2;
}

int smulINode::reloc() const {
  return 2;
}

int smulI_0Node::reloc() const {
  return 2;
}

int maddINode::reloc() const {
  return 3;
}

int maddI_0Node::reloc() const {
  return 3;
}

int msubINode::reloc() const {
  return 3;
}

int mnegINode::reloc() const {
  return 2;
}

int mnegI_0Node::reloc() const {
  return 2;
}

int smaddLNode::reloc() const {
  return 2;
}

int smaddL_1Node::reloc() const {
  return 2;
}

int smaddL_0Node::reloc() const {
  return 2;
}

int smaddL_2Node::reloc() const {
  return 2;
}

int smsubLNode::reloc() const {
  return 2;
}

int smsubL_0Node::reloc() const {
  return 2;
}

int smnegLNode::reloc() const {
  return 2;
}

int smnegL_0Node::reloc() const {
  return 2;
}

int muladdS2INode::reloc() const {
  return 4;
}

int divINode::reloc() const {
  return 2;
}

int modINode::reloc() const {
  return 2;
}

int UdivI_reg_regNode::reloc() const {
  return 2;
}

int UmodI_reg_regNode::reloc() const {
  return 2;
}

int lShiftI_reg_regNode::reloc() const {
  return 2;
}

int lShiftI_reg_immNode::reloc() const {
  return 1;
}

int urShiftI_reg_regNode::reloc() const {
  return 2;
}

int urShiftI_reg_immNode::reloc() const {
  return 1;
}

int rShiftI_reg_regNode::reloc() const {
  return 2;
}

int rShiftI_reg_immNode::reloc() const {
  return 1;
}

int lShiftL_reg_regNode::reloc() const {
  return 1;
}

int urShiftL_reg_regNode::reloc() const {
  return 1;
}

int rShiftL_reg_regNode::reloc() const {
  return 1;
}

int regI_not_regNode::reloc() const {
  return 1;
}

int NegI_reg_URShift_regNode::reloc() const {
  return 1;
}

int NegI_reg_RShift_regNode::reloc() const {
  return 1;
}

int NegI_reg_LShift_regNode::reloc() const {
  return 1;
}

int AndI_reg_not_regNode::reloc() const {
  return 2;
}

int AndI_reg_not_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_not_regNode::reloc() const {
  return 2;
}

int OrI_reg_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_not_regNode::reloc() const {
  return 2;
}

int XorI_reg_not_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_URShift_not_regNode::reloc() const {
  return 2;
}

int AndI_reg_URShift_not_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_RShift_not_regNode::reloc() const {
  return 2;
}

int AndI_reg_RShift_not_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_RotateRight_not_regNode::reloc() const {
  return 2;
}

int AndI_reg_RotateRight_not_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_LShift_not_regNode::reloc() const {
  return 2;
}

int AndI_reg_LShift_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_URShift_not_regNode::reloc() const {
  return 2;
}

int XorI_reg_URShift_not_reg_1Node::reloc() const {
  return 2;
}

int XorI_reg_URShift_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_URShift_not_reg_2Node::reloc() const {
  return 2;
}

int XorI_reg_RShift_not_regNode::reloc() const {
  return 2;
}

int XorI_reg_RShift_not_reg_1Node::reloc() const {
  return 2;
}

int XorI_reg_RShift_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_RShift_not_reg_2Node::reloc() const {
  return 2;
}

int XorI_reg_RotateRight_not_regNode::reloc() const {
  return 2;
}

int XorI_reg_RotateRight_not_reg_1Node::reloc() const {
  return 2;
}

int XorI_reg_RotateRight_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_RotateRight_not_reg_2Node::reloc() const {
  return 2;
}

int XorI_reg_LShift_not_regNode::reloc() const {
  return 2;
}

int XorI_reg_LShift_not_reg_1Node::reloc() const {
  return 2;
}

int XorI_reg_LShift_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_LShift_not_reg_2Node::reloc() const {
  return 2;
}

int OrI_reg_URShift_not_regNode::reloc() const {
  return 2;
}

int OrI_reg_URShift_not_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_RShift_not_regNode::reloc() const {
  return 2;
}

int OrI_reg_RShift_not_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_RotateRight_not_regNode::reloc() const {
  return 2;
}

int OrI_reg_RotateRight_not_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_LShift_not_regNode::reloc() const {
  return 2;
}

int OrI_reg_LShift_not_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_URShift_regNode::reloc() const {
  return 2;
}

int AndI_reg_URShift_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_RShift_regNode::reloc() const {
  return 2;
}

int AndI_reg_RShift_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_LShift_regNode::reloc() const {
  return 2;
}

int AndI_reg_LShift_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_RotateRight_regNode::reloc() const {
  return 2;
}

int AndI_reg_RotateRight_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_URShift_regNode::reloc() const {
  return 2;
}

int XorI_reg_URShift_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_RShift_regNode::reloc() const {
  return 2;
}

int XorI_reg_RShift_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_LShift_regNode::reloc() const {
  return 2;
}

int XorI_reg_LShift_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_RotateRight_regNode::reloc() const {
  return 2;
}

int XorI_reg_RotateRight_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_URShift_regNode::reloc() const {
  return 2;
}

int OrI_reg_URShift_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_RShift_regNode::reloc() const {
  return 2;
}

int OrI_reg_RShift_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_LShift_regNode::reloc() const {
  return 2;
}

int OrI_reg_LShift_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_RotateRight_regNode::reloc() const {
  return 2;
}

int OrI_reg_RotateRight_reg_0Node::reloc() const {
  return 2;
}

int AddI_reg_URShift_regNode::reloc() const {
  return 2;
}

int AddI_reg_URShift_reg_0Node::reloc() const {
  return 2;
}

int AddI_reg_RShift_regNode::reloc() const {
  return 2;
}

int AddI_reg_RShift_reg_0Node::reloc() const {
  return 2;
}

int AddI_reg_LShift_regNode::reloc() const {
  return 2;
}

int AddI_reg_LShift_reg_0Node::reloc() const {
  return 2;
}

int SubI_reg_URShift_regNode::reloc() const {
  return 2;
}

int SubI_reg_RShift_regNode::reloc() const {
  return 2;
}

int SubI_reg_LShift_regNode::reloc() const {
  return 2;
}

int sbfmwINode::reloc() const {
  return 1;
}

int ubfmwINode::reloc() const {
  return 1;
}

int ubfxwINode::reloc() const {
  return 1;
}

int ubfxIConvI2LNode::reloc() const {
  return 1;
}

int ubfizwINode::reloc() const {
  return 1;
}

int ubfizwIConvI2LNode::reloc() const {
  return 1;
}

int ubfizIConvI2LNode::reloc() const {
  return 1;
}

int extrOrINode::reloc() const {
  return 2;
}

int extrOrI_0Node::reloc() const {
  return 2;
}

int extrAddINode::reloc() const {
  return 2;
}

int extrAddI_0Node::reloc() const {
  return 2;
}

int AddExtINode::reloc() const {
  return 1;
}

int AddExtI_0Node::reloc() const {
  return 1;
}

int SubExtINode::reloc() const {
  return 1;
}

int AddExtI_sxthNode::reloc() const {
  return 2;
}

int AddExtI_sxth_0Node::reloc() const {
  return 2;
}

int AddExtI_sxtbNode::reloc() const {
  return 2;
}

int AddExtI_sxtb_0Node::reloc() const {
  return 2;
}

int AddExtI_uxtbNode::reloc() const {
  return 2;
}

int AddExtI_uxtb_0Node::reloc() const {
  return 2;
}

int AddExtI_uxtb_andNode::reloc() const {
  return 2;
}

int AddExtI_uxtb_and_0Node::reloc() const {
  return 2;
}

int AddExtI_uxth_andNode::reloc() const {
  return 2;
}

int AddExtI_uxth_and_0Node::reloc() const {
  return 2;
}

int SubExtI_uxtb_andNode::reloc() const {
  return 2;
}

int SubExtI_uxth_andNode::reloc() const {
  return 2;
}

int AddExtI_sxtb_shiftNode::reloc() const {
  return 2;
}

int AddExtI_sxtb_shift_0Node::reloc() const {
  return 2;
}

int AddExtI_sxth_shiftNode::reloc() const {
  return 2;
}

int AddExtI_sxth_shift_0Node::reloc() const {
  return 2;
}

int SubExtI_sxtb_shiftNode::reloc() const {
  return 2;
}

int SubExtI_sxth_shiftNode::reloc() const {
  return 2;
}

int AddExtI_shiftNode::reloc() const {
  return 1;
}

int AddExtI_shift_0Node::reloc() const {
  return 1;
}

int SubExtI_shiftNode::reloc() const {
  return 1;
}

int AddExtI_uxtb_and_shiftNode::reloc() const {
  return 2;
}

int AddExtI_uxtb_and_shift_0Node::reloc() const {
  return 2;
}

int AddExtI_uxth_and_shiftNode::reloc() const {
  return 2;
}

int AddExtI_uxth_and_shift_0Node::reloc() const {
  return 2;
}

int SubExtI_uxtb_and_shiftNode::reloc() const {
  return 2;
}

int SubExtI_uxth_and_shiftNode::reloc() const {
  return 2;
}

int minI_reg_imm0Node::reloc() const {
  return 1;
}

int minI_imm0_regNode::reloc() const {
  return 1;
}

int minI_reg_imm1Node::reloc() const {
  return 1;
}

int minI_imm1_regNode::reloc() const {
  return 1;
}

int minI_reg_immM1Node::reloc() const {
  return 1;
}

int minI_immM1_regNode::reloc() const {
  return 1;
}

int maxI_reg_imm0Node::reloc() const {
  return 1;
}

int maxI_imm0_regNode::reloc() const {
  return 1;
}

int maxI_reg_imm1Node::reloc() const {
  return 1;
}

int maxI_imm1_regNode::reloc() const {
  return 1;
}

int maxI_reg_immM1Node::reloc() const {
  return 1;
}

int maxI_immM1_regNode::reloc() const {
  return 1;
}

int bits_reverse_INode::reloc() const {
  return 1;
}

int mnsubF_reg_regNode::reloc() const {
  return 1;
}

int mnsubD_reg_regNode::reloc() const {
  return 1;
}

int absI_regNode::reloc() const {
  return 1;
}

int andI_reg_regNode::reloc() const {
  return 2;
}

int andI_reg_immNode::reloc() const {
  return 1;
}

int orI_reg_regNode::reloc() const {
  return 2;
}

int orI_reg_immNode::reloc() const {
  return 1;
}

int xorI_reg_regNode::reloc() const {
  return 2;
}

int xorI_reg_immNode::reloc() const {
  return 1;
}

int convI2L_reg_regNode::reloc() const {
  return 1;
}

int convUI2L_reg_regNode::reloc() const {
  return 1;
}

int convI2F_reg_regNode::reloc() const {
  return 1;
}

int convI2D_reg_regNode::reloc() const {
  return 1;
}

int overflowAddI_reg_regNode::reloc() const {
  return 2;
}

int overflowAddI_reg_immNode::reloc() const {
  return 1;
}

int overflowSubI_reg_regNode::reloc() const {
  return 2;
}

int overflowSubI_reg_immNode::reloc() const {
  return 1;
}

int overflowNegI_regNode::reloc() const {
  return 1;
}

int overflowMulI_regNode::reloc() const {
  return 2;
}

int overflowMulI_reg_branchNode::reloc() const {
  return 2;
}

int testP_regNode::reloc() const {
  return 1;
}

int compF_reg_zeroNode::reloc() const {
  return 1;
}

int compD_reg_zeroNode::reloc() const {
  return 1;
}

int compF3_reg_immF0Node::reloc() const {
  return 1;
}

int compD3_reg_immD0Node::reloc() const {
  return 1;
}

int cmpLTMask_reg_regNode::reloc() const {
  return 2;
}

int cmpLTMask_reg_zeroNode::reloc() const {
  return 1;
}

int minI_reg_regNode::reloc() const {
  return 2;
}

int maxI_reg_regNode::reloc() const {
  return 2;
}

int cmpI_imm0_branchNode::reloc() const {
  return 1;
}

int cmpP_imm0_branchNode::reloc() const {
  return 1;
}

int cmpP_narrowOop_imm0_branchNode::reloc() const {
  return 1;
}

int cmpUI_imm0_branchNode::reloc() const {
  return 1;
}

int cmpI_branch_signNode::reloc() const {
  return 1;
}

int cmpI_branch_bitNode::reloc() const {
  return 1;
}

int far_cmpI_branch_signNode::reloc() const {
  return 1;
}

int far_cmpI_branch_bitNode::reloc() const {
  return 1;
}

int cmpI_andNode::reloc() const {
  return 1;
}

int cmpI_and_regNode::reloc() const {
  return 2;
}

int safePointNode::reloc() const {
  return 1;
}

int CallStaticJavaDirectNode::reloc() const {
  return 1;
}

int CallDynamicJavaDirectNode::reloc() const {
  return 1;
}

int CallRuntimeDirectNode::reloc() const {
  return 1;
}

int CallLeafDirectNode::reloc() const {
  return 1;
}

int CallLeafNoFPDirectNode::reloc() const {
  return 1;
}

int TailCalljmpIndNode::reloc() const {
  return 1;
}

int TailjmpIndNode::reloc() const {
  return 1;
}

int RethrowExceptionNode::reloc() const {
  return 1;
}

int RetNode::reloc() const {
  return 1;
}

int partialSubtypeCheckVsZeroNode::reloc() const {
  return 1;
}

int compressBitsI_regNode::reloc() const {
  return 2;
}

int compressBitsI_memconNode::reloc() const {
  return 1;
}

int compressBitsL_memconNode::reloc() const {
  return 1;
}

int expandBitsI_regNode::reloc() const {
  return 2;
}

int expandBitsI_memconNode::reloc() const {
  return 1;
}

int expandBitsL_memconNode::reloc() const {
  return 1;
}

int loadV2Node::reloc() const {
  return 1;
}

int storeV2Node::reloc() const {
  return 2;
}

int loadV4Node::reloc() const {
  return 1;
}

int storeV4Node::reloc() const {
  return 2;
}

int loadV8Node::reloc() const {
  return 1;
}

int storeV8Node::reloc() const {
  return 2;
}

int loadV16Node::reloc() const {
  return 1;
}

int storeV16Node::reloc() const {
  return 2;
}

int loadVNode::reloc() const {
  return 1;
}

int storeVNode::reloc() const {
  return 2;
}

int loadV_maskedNode::reloc() const {
  return 1;
}

int storeV_maskedNode::reloc() const {
  return 2;
}

int vshiftcntLNode::reloc() const {
  return 1;
}

int vshiftcntRNode::reloc() const {
  return 1;
}

int reduce_addI_neonNode::reloc() const {
  return 1;
}

int reduce_addI_sveNode::reloc() const {
  return 1;
}

int reduce_addI_maskedNode::reloc() const {
  return 1;
}

int reduce_mulINode::reloc() const {
  return 1;
}

int reduce_andI_neonNode::reloc() const {
  return 1;
}

int reduce_andI_sveNode::reloc() const {
  return 1;
}

int reduce_andI_maskedNode::reloc() const {
  return 1;
}

int reduce_orI_neonNode::reloc() const {
  return 1;
}

int reduce_orI_sveNode::reloc() const {
  return 1;
}

int reduce_orI_maskedNode::reloc() const {
  return 1;
}

int reduce_xorI_neonNode::reloc() const {
  return 1;
}

int reduce_xorI_sveNode::reloc() const {
  return 1;
}

int reduce_xorI_maskedNode::reloc() const {
  return 1;
}

int reduce_maxI_neonNode::reloc() const {
  return 1;
}

int reduce_maxI_sveNode::reloc() const {
  return 1;
}

int reduce_maxI_maskedNode::reloc() const {
  return 1;
}

int reduce_minI_neonNode::reloc() const {
  return 1;
}

int reduce_minI_sveNode::reloc() const {
  return 1;
}

int reduce_minI_maskedNode::reloc() const {
  return 1;
}

int replicateBNode::reloc() const {
  return 1;
}

int replicateSNode::reloc() const {
  return 1;
}

int replicateINode::reloc() const {
  return 1;
}

int insertI_le128bNode::reloc() const {
  return 1;
}

int insertI_index_lt32Node::reloc() const {
  return 1;
}

int insertI_index_ge32Node::reloc() const {
  return 1;
}

int vloadmask_loadVMaskedNode::reloc() const {
  return 1;
}

int vloadmask_loadVMasked_maskedNode::reloc() const {
  return 1;
}

int storeVMasked_vstoremaskNode::reloc() const {
  return 2;
}

int storeVMasked_vstoremask_maskedNode::reloc() const {
  return 2;
}

int vmaskcmp_zeroF_neonNode::reloc() const {
  return 1;
}

int vmaskcmp_zeroD_neonNode::reloc() const {
  return 1;
}

int vmaskAllINode::reloc() const {
  return 1;
}

int vmaskAllI_maskedNode::reloc() const {
  return 1;
}

int vmask_gen_INode::reloc() const {
  return 1;
}

int populateindexNode::reloc() const {
  return 1;
}

int xLoadPNode::reloc() const {
  return 1;
}

int zLoadPNode::reloc() const {
  return 1;
}

int zStorePNode::reloc() const {
  return 2;
}


void loadBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2846 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrsbw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 1);
  
#line 15167 "ad_aarch64.cpp"
  }
}

void loadB2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2854 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrsb, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 1);
  
#line 15184 "ad_aarch64.cpp"
  }
}

void loadUBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2870 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrb, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 1);
  
#line 15201 "ad_aarch64.cpp"
  }
}

void loadUB2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2870 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrb, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 1);
  
#line 15218 "ad_aarch64.cpp"
  }
}

void loadSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2878 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrshw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 2);
  
#line 15235 "ad_aarch64.cpp"
  }
}

void loadS2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2886 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrsh, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 2);
  
#line 15252 "ad_aarch64.cpp"
  }
}

void loadUSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2902 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrh, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 2);
  
#line 15269 "ad_aarch64.cpp"
  }
}

void loadUS2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2902 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrh, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 2);
  
#line 15286 "ad_aarch64.cpp"
  }
}

void loadINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2918 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 15303 "ad_aarch64.cpp"
  }
}

void loadI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2926 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrsw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 15320 "ad_aarch64.cpp"
  }
}

void loadUI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 2918 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 15338 "ad_aarch64.cpp"
  }
}

void loadLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2934 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
  
#line 15355 "ad_aarch64.cpp"
  }
}

void loadRangeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2918 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 15372 "ad_aarch64.cpp"
  }
}

void loadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2934 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
  
#line 15389 "ad_aarch64.cpp"
  }
}

void loadNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2918 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 15406 "ad_aarch64.cpp"
  }
}

void loadKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2934 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
  
#line 15423 "ad_aarch64.cpp"
  }
}

void loadNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2918 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 15440 "ad_aarch64.cpp"
  }
}

void loadFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2942 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrs, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 15457 "ad_aarch64.cpp"
  }
}

void loadDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2950 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrd, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
  
#line 15474 "ad_aarch64.cpp"
  }
}

void loadConINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3410 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    uint32_t con = (uint32_t)opnd_array(1)->constant();
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    if (con == 0) {
      __ movw(dst_reg, zr);
    } else {
      __ movw(dst_reg, con);
    }
  
#line 15496 "ad_aarch64.cpp"
  }
}

void loadConLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3421 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    uint64_t con = (uint64_t)opnd_array(1)->constantL();
    if (con == 0) {
      __ mov(dst_reg, zr);
    } else {
      __ mov(dst_reg, con);
    }
  
#line 15518 "ad_aarch64.cpp"
  }
}

void loadConPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 3432 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    address con = (address)opnd_array(1)->constant();
    if (con == NULL || con == (address)1) {
      ShouldNotReachHere();
    } else {
      relocInfo::relocType rtype = opnd_array(1)->constant_reloc();
      if (rtype == relocInfo::oop_type) {
        __ movoop(dst_reg, (jobject)con);
      } else if (rtype == relocInfo::metadata_type) {
        __ mov_metadata(dst_reg, (Metadata*)con);
      } else {
        assert(rtype == relocInfo::none, "unexpected reloc type");
        if (! __ is_valid_AArch64_address(con) ||
            con < (address)(uintptr_t)os::vm_page_size()) {
          __ mov(dst_reg, con);
        } else {
          uint64_t offset;
          __ adrp(dst_reg, con, offset);
          __ add(dst_reg, dst_reg, offset);
        }
      }
    }
  
#line 15555 "ad_aarch64.cpp"
  }
}

void loadConP0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 3458 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ mov(dst_reg, zr);
  
#line 15572 "ad_aarch64.cpp"
  }
}

void loadConP1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 3464 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ mov(dst_reg, (uint64_t)1);
  
#line 15589 "ad_aarch64.cpp"
  }
}

void loadByteMapBaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 3470 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    __ load_byte_map_base(opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 15605 "ad_aarch64.cpp"
  }
}

void loadConNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 3475 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    address con = (address)opnd_array(1)->constant();
    if (con == NULL) {
      ShouldNotReachHere();
    } else {
      relocInfo::relocType rtype = opnd_array(1)->constant_reloc();
      assert(rtype == relocInfo::oop_type, "unexpected reloc type");
      __ set_narrow_oop(dst_reg, (jobject)con);
    }
  
#line 15629 "ad_aarch64.cpp"
  }
}

void loadConN0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 3488 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ mov(dst_reg, zr);
  
#line 15646 "ad_aarch64.cpp"
  }
}

void loadConNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 3494 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    address con = (address)opnd_array(1)->constant();
    if (con == NULL) {
      ShouldNotReachHere();
    } else {
      relocInfo::relocType rtype = opnd_array(1)->constant_reloc();
      assert(rtype == relocInfo::metadata_type, "unexpected reloc type");
      __ set_narrow_klass(dst_reg, (Klass *)con);
    }
  
#line 15670 "ad_aarch64.cpp"
  }
}

void loadConF_packedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7320 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmovs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), (double)opnd_array(1)->constantF());
  
#line 15686 "ad_aarch64.cpp"
  }
}

void loadConFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7338 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ldrs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 15702 "ad_aarch64.cpp"
  }
}

void loadConFNode::eval_constant(Compile* C) {
  {

#line 7339 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(1));
#line 15711 "ad_aarch64.cpp"
  }
}
void loadConD_packedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7351 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmovd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->constantD());
  
#line 15726 "ad_aarch64.cpp"
  }
}

void loadConDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7368 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ldrd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 15742 "ad_aarch64.cpp"
  }
}

void loadConDNode::eval_constant(Compile* C) {
  {

#line 7369 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(1));
#line 15751 "ad_aarch64.cpp"
  }
}
void storeimmCM0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2966 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strb, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 1);
  
#line 15768 "ad_aarch64.cpp"
  }
}

void storeimmCM0_orderedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3046 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

      C2_MacroAssembler _masm(&cbuf);
      __ membar(Assembler::StoreStore);
      loadStore(_masm, &MacroAssembler::strb, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 1);
  
#line 15787 "ad_aarch64.cpp"
  }
}

void storeBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2958 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::strb, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 1);
  
#line 15805 "ad_aarch64.cpp"
  }
}

void storeimmB0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2966 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strb, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 1);
  
#line 15823 "ad_aarch64.cpp"
  }
}

void storeCNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2974 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::strh, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 2);
  
#line 15841 "ad_aarch64.cpp"
  }
}

void storeimmC0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2982 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strh, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 2);
  
#line 15859 "ad_aarch64.cpp"
  }
}

void storeINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2990 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::strw, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 15877 "ad_aarch64.cpp"
  }
}

void storeimmI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2998 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strw, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 15895 "ad_aarch64.cpp"
  }
}

void storeLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3006 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    // we sometimes get asked to store the stack pointer into the
    // current thread -- we cannot do that directly on AArch64
    if (src_reg == r31_sp) {
      C2_MacroAssembler _masm(&cbuf);
      assert(as_Register(opnd_array(1)->base(ra_,this,idx1)) == rthread, "unexpected store for sp");
      __ mov(rscratch2, sp);
      src_reg = rscratch2;
    }
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::str, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
  
#line 15921 "ad_aarch64.cpp"
  }
}

void storeimmL0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3022 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::str, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
  
#line 15939 "ad_aarch64.cpp"
  }
}

void storePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3006 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    // we sometimes get asked to store the stack pointer into the
    // current thread -- we cannot do that directly on AArch64
    if (src_reg == r31_sp) {
      C2_MacroAssembler _masm(&cbuf);
      assert(as_Register(opnd_array(1)->base(ra_,this,idx1)) == rthread, "unexpected store for sp");
      __ mov(rscratch2, sp);
      src_reg = rscratch2;
    }
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::str, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
  
#line 15965 "ad_aarch64.cpp"
  }
}

void storeimmP0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3022 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::str, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
  
#line 15983 "ad_aarch64.cpp"
  }
}

void storeNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2990 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::strw, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 16001 "ad_aarch64.cpp"
  }
}

void storeImmN0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2998 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strw, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 16019 "ad_aarch64.cpp"
  }
}

void storeFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3030 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::strs, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 16037 "ad_aarch64.cpp"
  }
}

void storeDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3038 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::strd, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
  
#line 16055 "ad_aarch64.cpp"
  }
}

void storeNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2990 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::strw, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 16073 "ad_aarch64.cpp"
  }
}

void prefetchallocNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {

#line 3389 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
      __ prfm(Address(base, disp), PSTL1KEEP);
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ prfm(Address(base, index_reg, Address::lsl(scale)), PSTL1KEEP);
      } else {
        __ lea(rscratch1, Address(base, disp));
	__ prfm(Address(rscratch1, index_reg, Address::lsl(scale)), PSTL1KEEP);
      }
    }
  
#line 16103 "ad_aarch64.cpp"
  }
}

void loadB_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3143 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    MOV_VOLATILE(dst_reg, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarb);
    __ sxtb(dst_reg, dst_reg);
  
#line 16121 "ad_aarch64.cpp"
  }
}

void loadB2L_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3143 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    MOV_VOLATILE(dst_reg, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarb);
    __ sxtb(dst_reg, dst_reg);
  
#line 16139 "ad_aarch64.cpp"
  }
}

void loadUB_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3155 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarb);
  
#line 16155 "ad_aarch64.cpp"
  }
}

void loadUB2L_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3155 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarb);
  
#line 16171 "ad_aarch64.cpp"
  }
}

void loadS_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3160 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    MOV_VOLATILE(dst_reg, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarh);
    __ sxthw(dst_reg, dst_reg);
  
#line 16189 "ad_aarch64.cpp"
  }
}

void loadUS_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3174 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarh);
  
#line 16205 "ad_aarch64.cpp"
  }
}

void loadUS2L_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3179 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarh);
  
#line 16221 "ad_aarch64.cpp"
  }
}

void loadS2L_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3167 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    MOV_VOLATILE(dst_reg, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarh);
    __ sxth(dst_reg, dst_reg);
  
#line 16239 "ad_aarch64.cpp"
  }
}

void loadI_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3189 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarw);
  
#line 16255 "ad_aarch64.cpp"
  }
}

void loadUI2L_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 3189 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarw);
  
#line 16272 "ad_aarch64.cpp"
  }
}

void loadL_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3194 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldar);
  
#line 16288 "ad_aarch64.cpp"
  }
}

void loadP_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3194 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldar);
  
#line 16304 "ad_aarch64.cpp"
  }
}

void loadN_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3189 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarw);
  
#line 16320 "ad_aarch64.cpp"
  }
}

void loadF_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3199 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(rscratch1, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarw);
    __ fmovs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), rscratch1);
  
#line 16337 "ad_aarch64.cpp"
  }
}

void loadD_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3205 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(rscratch1, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldar);
    __ fmovd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), rscratch1);
  
#line 16354 "ad_aarch64.cpp"
  }
}

void storeB_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3106 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlrb);
  
#line 16371 "ad_aarch64.cpp"
  }
}

void storeimmB0_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3111 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(zr, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlrb);
  
#line 16388 "ad_aarch64.cpp"
  }
}

void storeC_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3116 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlrh);
  
#line 16405 "ad_aarch64.cpp"
  }
}

void storeimmC0_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3121 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(zr, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlrh);
  
#line 16422 "ad_aarch64.cpp"
  }
}

void storeI_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3126 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlrw);
  
#line 16439 "ad_aarch64.cpp"
  }
}

void storeimmI0_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3131 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(zr, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlrw);
  
#line 16456 "ad_aarch64.cpp"
  }
}

void storeL_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3211 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    // we sometimes get asked to store the stack pointer into the
    // current thread -- we cannot do that directly on AArch64
    if (src_reg == r31_sp) {
      C2_MacroAssembler _masm(&cbuf);
      assert(as_Register(opnd_array(1)->base(ra_,this,idx1)) == rthread, "unexpected store for sp");
      __ mov(rscratch2, sp);
      src_reg = rscratch2;
    }
    MOV_VOLATILE(src_reg, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlr);
  
#line 16482 "ad_aarch64.cpp"
  }
}

void storeimmL0_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3225 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(zr, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlr);
  
#line 16499 "ad_aarch64.cpp"
  }
}

void storeP_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3211 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    // we sometimes get asked to store the stack pointer into the
    // current thread -- we cannot do that directly on AArch64
    if (src_reg == r31_sp) {
      C2_MacroAssembler _masm(&cbuf);
      assert(as_Register(opnd_array(1)->base(ra_,this,idx1)) == rthread, "unexpected store for sp");
      __ mov(rscratch2, sp);
      src_reg = rscratch2;
    }
    MOV_VOLATILE(src_reg, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlr);
  
#line 16525 "ad_aarch64.cpp"
  }
}

void storeimmP0_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3225 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(zr, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlr);
  
#line 16542 "ad_aarch64.cpp"
  }
}

void storeN_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3126 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlrw);
  
#line 16559 "ad_aarch64.cpp"
  }
}

void storeimmN0_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3131 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(zr, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlrw);
  
#line 16576 "ad_aarch64.cpp"
  }
}

void storeF_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3230 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    {
      C2_MacroAssembler _masm(&cbuf);
      FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
      __ fmovs(rscratch2, src_reg);
    }
    MOV_VOLATILE(rscratch2, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlrw);
  
#line 16598 "ad_aarch64.cpp"
  }
}

void storeD_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3240 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    {
      C2_MacroAssembler _masm(&cbuf);
      FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
      __ fmovd(rscratch2, src_reg);
    }
    MOV_VOLATILE(rscratch2, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlr);
  
#line 16620 "ad_aarch64.cpp"
  }
}

void cacheWBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8023 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    assert(opnd_array(1)->index_position() < 0, "should be");
    assert(opnd_array(1)->disp(ra_,this,idx1)== 0, "should be");
    __ cache_wb(Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), 0));
  
#line 16638 "ad_aarch64.cpp"
  }
}

void cacheWBPreSyncNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8038 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cache_wbsync(true);
  
#line 16654 "ad_aarch64.cpp"
  }
}

void cacheWBPostSyncNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8051 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cache_wbsync(false);
  
#line 16670 "ad_aarch64.cpp"
  }
}

void bytes_reverse_intNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8066 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ revw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16686 "ad_aarch64.cpp"
  }
}

void bytes_reverse_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8079 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ rev(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16702 "ad_aarch64.cpp"
  }
}

void bytes_reverse_unsigned_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8092 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ rev16w(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16718 "ad_aarch64.cpp"
  }
}

void bytes_reverse_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8106 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ rev16w(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ sbfmw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(0)->reg(ra_,this)/* dst */), 0U, 15U);
  
#line 16735 "ad_aarch64.cpp"
  }
}

void countLeadingZerosINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8122 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ clzw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16751 "ad_aarch64.cpp"
  }
}

void countLeadingZerosLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8134 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ clz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16767 "ad_aarch64.cpp"
  }
}

void countTrailingZerosINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8147 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ rbitw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ clzw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 16784 "ad_aarch64.cpp"
  }
}

void countTrailingZerosLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8161 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ rbit(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ clz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 16801 "ad_aarch64.cpp"
  }
}

void popCountINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8182 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ movw(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */); // ensure top 32 bits 0
    __ mov(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ D, 0, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ cnt(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ addv(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ D, 0);
  
#line 16822 "ad_aarch64.cpp"
  }
}

void popCountI_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8202 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister tmp_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrs, tmp_reg, opnd_array(1)->opcode(),
              as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
    __ cnt(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ addv(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ D, 0);
  
#line 16844 "ad_aarch64.cpp"
  }
}

void popCountLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8224 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mov(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ D, 0, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ cnt(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ addv(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ D, 0);
  
#line 16864 "ad_aarch64.cpp"
  }
}

void popCountL_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8243 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister tmp_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrd, tmp_reg, opnd_array(1)->opcode(),
              as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
    __ cnt(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ addv(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ D, 0);
  
#line 16886 "ad_aarch64.cpp"
  }
}

void load_fenceNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8264 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ membar(Assembler::LoadLoad|Assembler::LoadStore);
  
#line 16902 "ad_aarch64.cpp"
  }
}

void unnecessary_membar_acquireNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8277 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ block_comment("membar_acquire (elided)");
  
#line 16918 "ad_aarch64.cpp"
  }
}

void membar_acquireNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8291 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ block_comment("membar_acquire");
    __ membar(Assembler::LoadLoad|Assembler::LoadStore);
  
#line 16935 "ad_aarch64.cpp"
  }
}

void membar_acquire_lockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8306 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ block_comment("membar_acquire_lock (elided)");
  
#line 16951 "ad_aarch64.cpp"
  }
}

void store_fenceNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8319 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ membar(Assembler::LoadStore|Assembler::StoreStore);
  
#line 16967 "ad_aarch64.cpp"
  }
}

void unnecessary_membar_releaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8332 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ block_comment("membar_release (elided)");
  
#line 16983 "ad_aarch64.cpp"
  }
}

void membar_releaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8345 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ block_comment("membar_release");
    __ membar(Assembler::LoadStore|Assembler::StoreStore);
  
#line 17000 "ad_aarch64.cpp"
  }
}

void membar_storestoreNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8359 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ membar(Assembler::StoreStore);
  
#line 17016 "ad_aarch64.cpp"
  }
}

void membar_storestore_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8359 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ membar(Assembler::StoreStore);
  
#line 17032 "ad_aarch64.cpp"
  }
}

void membar_release_lockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8371 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ block_comment("membar_release_lock (elided)");
  
#line 17048 "ad_aarch64.cpp"
  }
}

void unnecessary_membar_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8385 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ block_comment("membar_volatile (elided)");
  
#line 17064 "ad_aarch64.cpp"
  }
}

void membar_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8399 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ block_comment("membar_volatile");
    __ membar(Assembler::StoreLoad);
  
#line 17081 "ad_aarch64.cpp"
  }
}

void castX2PNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8416 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    if (opnd_array(0)->reg(ra_,this)/* dst */!= opnd_array(1)->reg(ra_,this,idx1)/* src */) {
      __ mov(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    }
  
#line 17099 "ad_aarch64.cpp"
  }
}

void castP2XNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8431 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    if (opnd_array(0)->reg(ra_,this)/* dst */!= opnd_array(1)->reg(ra_,this,idx1)/* src */) {
      __ mov(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    }
  
#line 17117 "ad_aarch64.cpp"
  }
}

void convP2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8446 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ movw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 17133 "ad_aarch64.cpp"
  }
}

void convN2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8462 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ movw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 17149 "ad_aarch64.cpp"
  }
}

void encodeHeapOopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8477 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ encode_heap_oop(d, s);
  
#line 17167 "ad_aarch64.cpp"
  }
}

void encodeHeapOop_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8490 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ encode_heap_oop_not_null(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 17183 "ad_aarch64.cpp"
  }
}

void decodeHeapOopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8502 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ decode_heap_oop(d, s);
  
#line 17201 "ad_aarch64.cpp"
  }
}

void decodeHeapOop_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8516 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ decode_heap_oop_not_null(d, s);
  
#line 17219 "ad_aarch64.cpp"
  }
}

void encodeKlass_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8534 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ encode_klass_not_null(dst_reg, src_reg);
  
#line 17237 "ad_aarch64.cpp"
  }
}

void decodeKlass_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8549 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    if (dst_reg != src_reg) {
      __ decode_klass_not_null(dst_reg, src_reg);
    } else {
      __ decode_klass_not_null(dst_reg);
    }
  
#line 17259 "ad_aarch64.cpp"
  }
}

void checkCastPPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint checkCastPPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castPPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castPPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castIINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castIINode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castLLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castLLNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castFFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castFFNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castDDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castDDNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castVVNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castVVNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castVVMaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castVVMaskNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void compareAndSwapBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3335 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::byte, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17384 "ad_aarch64.cpp"
  }
  {

#line 3381 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17394 "ad_aarch64.cpp"
  }
}

void compareAndSwapSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3327 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::halfword, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17415 "ad_aarch64.cpp"
  }
  {

#line 3381 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17425 "ad_aarch64.cpp"
  }
}

void compareAndSwapINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3319 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17446 "ad_aarch64.cpp"
  }
  {

#line 3381 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17456 "ad_aarch64.cpp"
  }
}

void compareAndSwapLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3311 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17477 "ad_aarch64.cpp"
  }
  {

#line 3381 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17487 "ad_aarch64.cpp"
  }
}

void compareAndSwapPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3311 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17508 "ad_aarch64.cpp"
  }
  {

#line 3381 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17518 "ad_aarch64.cpp"
  }
}

void compareAndSwapNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3319 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17539 "ad_aarch64.cpp"
  }
  {

#line 3381 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17549 "ad_aarch64.cpp"
  }
}

void compareAndSwapBAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3372 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::byte, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17570 "ad_aarch64.cpp"
  }
  {

#line 3381 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17580 "ad_aarch64.cpp"
  }
}

void compareAndSwapSAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3364 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::halfword, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17601 "ad_aarch64.cpp"
  }
  {

#line 3381 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17611 "ad_aarch64.cpp"
  }
}

void compareAndSwapIAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3356 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17632 "ad_aarch64.cpp"
  }
  {

#line 3381 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17642 "ad_aarch64.cpp"
  }
}

void compareAndSwapLAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3348 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17663 "ad_aarch64.cpp"
  }
  {

#line 3381 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17673 "ad_aarch64.cpp"
  }
}

void compareAndSwapPAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3348 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17694 "ad_aarch64.cpp"
  }
  {

#line 3381 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17704 "ad_aarch64.cpp"
  }
}

void compareAndSwapNAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3356 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17725 "ad_aarch64.cpp"
  }
  {

#line 3381 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17735 "ad_aarch64.cpp"
  }
}

void compareAndExchangeBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8907 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::byte, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    __ sxtbw(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17757 "ad_aarch64.cpp"
  }
}

void compareAndExchangeSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8925 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::halfword, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    __ sxthw(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17779 "ad_aarch64.cpp"
  }
}

void compareAndExchangeINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8943 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17800 "ad_aarch64.cpp"
  }
}

void compareAndExchangeLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8960 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17821 "ad_aarch64.cpp"
  }
}

void compareAndExchangeNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8977 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17842 "ad_aarch64.cpp"
  }
}

void compareAndExchangePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8995 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17863 "ad_aarch64.cpp"
  }
}

void compareAndExchangeBAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9013 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::byte, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    __ sxtbw(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17885 "ad_aarch64.cpp"
  }
}

void compareAndExchangeSAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9032 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::halfword, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    __ sxthw(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17907 "ad_aarch64.cpp"
  }
}

void compareAndExchangeIAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9051 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17928 "ad_aarch64.cpp"
  }
}

void compareAndExchangeLAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9069 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17949 "ad_aarch64.cpp"
  }
}

void compareAndExchangeNAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9087 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17970 "ad_aarch64.cpp"
  }
}

void compareAndExchangePAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9105 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17991 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9123 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::byte, /*acquire*/ false, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 18012 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9142 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::halfword, /*acquire*/ false, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 18033 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9161 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ false, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 18054 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9180 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ false, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 18075 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9199 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ false, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 18096 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9219 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ false, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 18117 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapBAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9239 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::byte, /*acquire*/ true, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 18138 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapSAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9259 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::halfword, /*acquire*/ true, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 18159 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapIAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9279 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ true, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 18180 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapLAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9299 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ true, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 18201 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapNAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9319 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ true, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 18222 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapPAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9339 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ true, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 18243 "ad_aarch64.cpp"
  }
}

void get_and_setINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9355 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_xchgw(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18260 "ad_aarch64.cpp"
  }
}

void get_and_setLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9365 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_xchg(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18277 "ad_aarch64.cpp"
  }
}

void get_and_setNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9375 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_xchgw(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18294 "ad_aarch64.cpp"
  }
}

void get_and_setPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9386 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_xchg(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18311 "ad_aarch64.cpp"
  }
}

void get_and_setIAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9397 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_xchgalw(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18328 "ad_aarch64.cpp"
  }
}

void get_and_setLAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9408 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_xchgal(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18345 "ad_aarch64.cpp"
  }
}

void get_and_setNAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9419 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_xchgalw(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18362 "ad_aarch64.cpp"
  }
}

void get_and_setPAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9430 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_xchgal(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18379 "ad_aarch64.cpp"
  }
}

void get_and_addLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9441 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_add(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18396 "ad_aarch64.cpp"
  }
}

void get_and_addL_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9452 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_add(noreg, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18413 "ad_aarch64.cpp"
  }
}

void get_and_addLiNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9462 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_add(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->constantL(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18430 "ad_aarch64.cpp"
  }
}

void get_and_addLi_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9473 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_add(noreg, opnd_array(2)->constantL(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18447 "ad_aarch64.cpp"
  }
}

void get_and_addINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9483 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addw(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18464 "ad_aarch64.cpp"
  }
}

void get_and_addI_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9494 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addw(noreg, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18481 "ad_aarch64.cpp"
  }
}

void get_and_addIiNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9504 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addw(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->constant(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18498 "ad_aarch64.cpp"
  }
}

void get_and_addIi_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9515 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addw(noreg, opnd_array(2)->constant(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18515 "ad_aarch64.cpp"
  }
}

void get_and_addLAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9526 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addal(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18532 "ad_aarch64.cpp"
  }
}

void get_and_addL_no_resAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9537 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addal(noreg, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18549 "ad_aarch64.cpp"
  }
}

void get_and_addLiAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9548 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addal(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->constantL(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18566 "ad_aarch64.cpp"
  }
}

void get_and_addLi_no_resAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9559 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addal(noreg, opnd_array(2)->constantL(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18583 "ad_aarch64.cpp"
  }
}

void get_and_addIAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9570 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addalw(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18600 "ad_aarch64.cpp"
  }
}

void get_and_addI_no_resAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9581 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addalw(noreg, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18617 "ad_aarch64.cpp"
  }
}

void get_and_addIiAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9592 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addalw(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->constant(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18634 "ad_aarch64.cpp"
  }
}

void get_and_addIi_no_resAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9603 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addalw(noreg, opnd_array(2)->constant(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18651 "ad_aarch64.cpp"
  }
}

void cmpU3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9622 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpw(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::NE);
    __ cnegw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::LO);
  
#line 18670 "ad_aarch64.cpp"
  }
}

void cmpU3_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9642 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ subsw(zr, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, (int32_t)opnd_array(2)->constant());
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::NE);
    __ cnegw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::LO);
  
#line 18689 "ad_aarch64.cpp"
  }
}

void cmpUL3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9664 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmp(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::NE);
    __ cnegw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::LO);
  
#line 18708 "ad_aarch64.cpp"
  }
}

void cmpUL3_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9684 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ subs(zr, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, (int32_t)opnd_array(2)->constantL());
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::NE);
    __ cnegw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::LO);
  
#line 18727 "ad_aarch64.cpp"
  }
}

void cmpL3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9706 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmp(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::NE);
    __ cnegw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::LT);
  
#line 18746 "ad_aarch64.cpp"
  }
}

void cmpL3_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9726 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ subs(zr, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, (int32_t)opnd_array(2)->constantL());
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::NE);
    __ cnegw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::LT);
  
#line 18765 "ad_aarch64.cpp"
  }
}

void cmovI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9754 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18787 "ad_aarch64.cpp"
  }
}

void cmovUI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9770 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18809 "ad_aarch64.cpp"
  }
}

void cmovI_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9795 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18831 "ad_aarch64.cpp"
  }
}

void cmovUI_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9811 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18853 "ad_aarch64.cpp"
  }
}

void cmovI_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9827 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18875 "ad_aarch64.cpp"
  }
}

void cmovUI_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9843 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18897 "ad_aarch64.cpp"
  }
}

void cmovI_reg_zero_oneNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9864 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    // equivalently
    // cset(as_Register($dst$$reg),
    //      negate_condition((Assembler::Condition)$cmp$$cmpcode));
    __ csincw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18922 "ad_aarch64.cpp"
  }
}

void cmovUI_reg_zero_oneNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9883 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    // equivalently
    // cset(as_Register($dst$$reg),
    //      negate_condition((Assembler::Condition)$cmp$$cmpcode));
    __ csincw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18947 "ad_aarch64.cpp"
  }
}

void cmovL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9902 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18969 "ad_aarch64.cpp"
  }
}

void cmovUL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9918 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18991 "ad_aarch64.cpp"
  }
}

void cmovL_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9936 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            zr,
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 19013 "ad_aarch64.cpp"
  }
}

void cmovUL_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9952 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            zr,
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 19035 "ad_aarch64.cpp"
  }
}

void cmovL_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9968 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
            zr,
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 19057 "ad_aarch64.cpp"
  }
}

void cmovUL_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9984 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
            zr,
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 19079 "ad_aarch64.cpp"
  }
}

void cmovP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10000 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 19101 "ad_aarch64.cpp"
  }
}

void cmovUP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10016 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 19123 "ad_aarch64.cpp"
  }
}

void cmovP_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10034 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            zr,
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 19145 "ad_aarch64.cpp"
  }
}

void cmovUP_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10050 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            zr,
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 19167 "ad_aarch64.cpp"
  }
}

void cmovP_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10066 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
            zr,
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 19189 "ad_aarch64.cpp"
  }
}

void cmovUP_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10082 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
            zr,
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 19211 "ad_aarch64.cpp"
  }
}

void cmovN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10098 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 19233 "ad_aarch64.cpp"
  }
}

void cmovUN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10114 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 19255 "ad_aarch64.cpp"
  }
}

void cmovN_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10132 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 19277 "ad_aarch64.cpp"
  }
}

void cmovUN_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10148 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 19299 "ad_aarch64.cpp"
  }
}

void cmovN_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10164 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 19321 "ad_aarch64.cpp"
  }
}

void cmovUN_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10180 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 19343 "ad_aarch64.cpp"
  }
}

void cmovF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10197 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ fcsels(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              cond);
  
#line 19366 "ad_aarch64.cpp"
  }
}

void cmovUF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10215 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ fcsels(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              cond);
  
#line 19389 "ad_aarch64.cpp"
  }
}

void cmovD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10233 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ fcseld(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              cond);
  
#line 19412 "ad_aarch64.cpp"
  }
}

void cmovUD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10251 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ fcseld(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              cond);
  
#line 19435 "ad_aarch64.cpp"
  }
}

void addI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10280 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19454 "ad_aarch64.cpp"
  }
}

void addI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3509 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constant();
    // add has primary == 0, subtract has primary == 1
    if ((0x0 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ subw(dst_reg, src_reg, -con);
    } else {
      __ addw(dst_reg, src_reg, con);
    }
  
#line 19480 "ad_aarch64.cpp"
  }
}

void addI_reg_imm_i2lNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3509 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constant();
    // add has primary == 0, subtract has primary == 1
    if ((0x0 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ subw(dst_reg, src_reg, -con);
    } else {
      __ addw(dst_reg, src_reg, con);
    }
  
#line 19506 "ad_aarch64.cpp"
  }
}

void addP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10324 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19525 "ad_aarch64.cpp"
  }
}

void addP_reg_reg_extNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10339 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw);
  
#line 19544 "ad_aarch64.cpp"
  }
}

void addP_reg_reg_lslNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// scale
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10354 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lea(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           Address(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                   Address::lsl(opnd_array(3)->constant())));
  
#line 19564 "ad_aarch64.cpp"
  }
}

void addP_reg_reg_ext_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// scale
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10369 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lea(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           Address(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                   Address::sxtw(opnd_array(3)->constant())));
  
#line 19584 "ad_aarch64.cpp"
  }
}

void lshift_extNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// scale
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10384 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ sbfiz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
          as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
          opnd_array(2)->constant()& 63, MIN2(32, (int)((-opnd_array(2)->constant()) & 63)));
  
#line 19603 "ad_aarch64.cpp"
  }
}

void addP_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3523 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constantL();
    // add has primary == 0, subtract has primary == 1
    if ((0x0 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ sub(dst_reg, src_reg, -con);
    } else {
      __ add(dst_reg, src_reg, con);
    }
  
#line 19629 "ad_aarch64.cpp"
  }
}

void addL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10418 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19648 "ad_aarch64.cpp"
  }
}

void addL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3523 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constantL();
    // add has primary == 0, subtract has primary == 1
    if ((0x0 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ sub(dst_reg, src_reg, -con);
    } else {
      __ add(dst_reg, src_reg, con);
    }
  
#line 19674 "ad_aarch64.cpp"
  }
}

void subI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10449 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19693 "ad_aarch64.cpp"
  }
}

void subI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3509 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constant();
    // add has primary == 0, subtract has primary == 1
    if ((0x1 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ subw(dst_reg, src_reg, -con);
    } else {
      __ addw(dst_reg, src_reg, con);
    }
  
#line 19719 "ad_aarch64.cpp"
  }
}

void subL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10481 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19738 "ad_aarch64.cpp"
  }
}

void subL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3523 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constantL();
    // add has primary == 0, subtract has primary == 1
    if ((0x1 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ sub(dst_reg, src_reg, -con);
    } else {
      __ add(dst_reg, src_reg, con);
    }
  
#line 19764 "ad_aarch64.cpp"
  }
}

void negI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10513 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ negw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */));
  
#line 19782 "ad_aarch64.cpp"
  }
}

void negL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10529 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ neg(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */));
  
#line 19800 "ad_aarch64.cpp"
  }
}

void mulINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10545 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mulw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19819 "ad_aarch64.cpp"
  }
}

void smulINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10560 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smull(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19838 "ad_aarch64.cpp"
  }
}

void smulI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10560 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smull(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */));
  
#line 19857 "ad_aarch64.cpp"
  }
}

void mulLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10577 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mul(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19876 "ad_aarch64.cpp"
  }
}

void mulHiL_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10593 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smulh(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19895 "ad_aarch64.cpp"
  }
}

void umulHiL_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10609 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ umulh(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19914 "ad_aarch64.cpp"
  }
}

void maddINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10626 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ maddw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 19935 "ad_aarch64.cpp"
  }
}

void maddI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10626 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ maddw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 19956 "ad_aarch64.cpp"
  }
}

void msubINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10642 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ msubw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 19977 "ad_aarch64.cpp"
  }
}

void mnegINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10660 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mnegw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */));
  
#line 19997 "ad_aarch64.cpp"
  }
}

void mnegI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10660 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mnegw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */));
  
#line 20017 "ad_aarch64.cpp"
  }
}

void maddLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10677 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ madd(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 20038 "ad_aarch64.cpp"
  }
}

void maddL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10677 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ madd(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 20059 "ad_aarch64.cpp"
  }
}

void msubLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10693 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ msub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 20080 "ad_aarch64.cpp"
  }
}

void mnegLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10711 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mneg(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */));
  
#line 20100 "ad_aarch64.cpp"
  }
}

void mnegL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10711 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mneg(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */));
  
#line 20120 "ad_aarch64.cpp"
  }
}

void smaddLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10728 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smaddl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 20141 "ad_aarch64.cpp"
  }
}

void smaddL_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10728 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smaddl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 20162 "ad_aarch64.cpp"
  }
}

void smaddL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10728 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smaddl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 20183 "ad_aarch64.cpp"
  }
}

void smaddL_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10728 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smaddl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 20204 "ad_aarch64.cpp"
  }
}

void smsubLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10744 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smsubl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 20225 "ad_aarch64.cpp"
  }
}

void smsubL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10744 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smsubl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 20246 "ad_aarch64.cpp"
  }
}

void smnegLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10760 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smnegl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */));
  
#line 20266 "ad_aarch64.cpp"
  }
}

void smnegL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10760 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smnegl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */));
  
#line 20286 "ad_aarch64.cpp"
  }
}

void muladdS2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10778 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mulw(rscratch1, as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
    __ maddw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src3 */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src4 */), rscratch1); 
#line 20305 "ad_aarch64.cpp"
  }
}

void divINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3537 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
   Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
   Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
   Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivl(dst_reg, src1_reg, src2_reg, false, rscratch1);
  
#line 20325 "ad_aarch64.cpp"
  }
}

void divLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3545 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
   Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
   Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
   Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivq(dst_reg, src1_reg, src2_reg, false, rscratch1);
  
#line 20345 "ad_aarch64.cpp"
  }
}

void modINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3553 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
   Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
   Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
   Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivl(dst_reg, src1_reg, src2_reg, true, rscratch1);
  
#line 20365 "ad_aarch64.cpp"
  }
}

void modLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3561 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
   Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
   Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
   Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivq(dst_reg, src1_reg, src2_reg, true, rscratch1);
  
#line 20385 "ad_aarch64.cpp"
  }
}

void UdivI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10843 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ udivw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
  
#line 20402 "ad_aarch64.cpp"
  }
}

void UdivL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10858 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ udiv(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
  
#line 20419 "ad_aarch64.cpp"
  }
}

void UmodI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10874 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ udivw(rscratch1, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
    __ msubw(opnd_array(0)->as_Register(ra_,this)/* dst */, rscratch1, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */);
  
#line 20437 "ad_aarch64.cpp"
  }
}

void UModL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10891 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ udiv(rscratch1, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
    __ msub(opnd_array(0)->as_Register(ra_,this)/* dst */, rscratch1, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */);
  
#line 20455 "ad_aarch64.cpp"
  }
}

void lShiftI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10908 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lslvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 20474 "ad_aarch64.cpp"
  }
}

void lShiftI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10924 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lslw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            opnd_array(2)->constant()& 0x1f);
  
#line 20493 "ad_aarch64.cpp"
  }
}

void urShiftI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10940 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lsrvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 20512 "ad_aarch64.cpp"
  }
}

void urShiftI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10956 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lsrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            opnd_array(2)->constant()& 0x1f);
  
#line 20531 "ad_aarch64.cpp"
  }
}

void rShiftI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10972 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ asrvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 20550 "ad_aarch64.cpp"
  }
}

void rShiftI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10988 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ asrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            opnd_array(2)->constant()& 0x1f);
  
#line 20569 "ad_aarch64.cpp"
  }
}

void lShiftL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11009 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lslv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 20588 "ad_aarch64.cpp"
  }
}

void lShiftL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11025 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lsl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            opnd_array(2)->constant()& 0x3f);
  
#line 20607 "ad_aarch64.cpp"
  }
}

void urShiftL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11041 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lsrv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 20626 "ad_aarch64.cpp"
  }
}

void urShiftL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11057 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lsr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           opnd_array(2)->constant()& 0x3f);
  
#line 20645 "ad_aarch64.cpp"
  }
}

void urShiftP_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11073 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lsr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           opnd_array(2)->constant()& 0x3f);
  
#line 20664 "ad_aarch64.cpp"
  }
}

void rShiftL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11089 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ asrv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 20683 "ad_aarch64.cpp"
  }
}

void rShiftL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11105 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ asr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           opnd_array(2)->constant()& 0x3f);
  
#line 20702 "ad_aarch64.cpp"
  }
}

void regL_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11126 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              zr,
              Assembler::LSL, 0);
  
#line 20722 "ad_aarch64.cpp"
  }
}

void regI_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11145 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              zr,
              Assembler::LSL, 0);
  
#line 20742 "ad_aarch64.cpp"
  }
}

void NegI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11164 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ negw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            Assembler::LSR, opnd_array(3)->constant()& 0x1f);
  
#line 20761 "ad_aarch64.cpp"
  }
}

void NegI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11181 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ negw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            Assembler::ASR, opnd_array(3)->constant()& 0x1f);
  
#line 20780 "ad_aarch64.cpp"
  }
}

void NegI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11198 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ negw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            Assembler::LSL, opnd_array(3)->constant()& 0x1f);
  
#line 20799 "ad_aarch64.cpp"
  }
}

void NegL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11215 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ neg(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            Assembler::LSR, opnd_array(3)->constant()& 0x3f);
  
#line 20818 "ad_aarch64.cpp"
  }
}

void NegL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11232 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ neg(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            Assembler::ASR, opnd_array(3)->constant()& 0x3f);
  
#line 20837 "ad_aarch64.cpp"
  }
}

void NegL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11249 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ neg(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            Assembler::LSL, opnd_array(3)->constant()& 0x3f);
  
#line 20856 "ad_aarch64.cpp"
  }
}

void AndI_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11265 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 20877 "ad_aarch64.cpp"
  }
}

void AndI_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11265 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 20898 "ad_aarch64.cpp"
  }
}

void AndL_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11283 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 20919 "ad_aarch64.cpp"
  }
}

void AndL_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11283 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 20940 "ad_aarch64.cpp"
  }
}

void OrI_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11301 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 20961 "ad_aarch64.cpp"
  }
}

void OrI_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11301 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 20982 "ad_aarch64.cpp"
  }
}

void OrL_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11319 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 21003 "ad_aarch64.cpp"
  }
}

void OrL_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11319 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 21024 "ad_aarch64.cpp"
  }
}

void XorI_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11337 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 21045 "ad_aarch64.cpp"
  }
}

void XorI_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11337 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 21066 "ad_aarch64.cpp"
  }
}

void XorL_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11355 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 21087 "ad_aarch64.cpp"
  }
}

void XorL_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11355 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 21108 "ad_aarch64.cpp"
  }
}

void AndI_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11375 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x1f);
  
#line 21131 "ad_aarch64.cpp"
  }
}

void AndI_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11375 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x1f);
  
#line 21154 "ad_aarch64.cpp"
  }
}

void AndL_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11396 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 21177 "ad_aarch64.cpp"
  }
}

void AndL_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11396 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 21200 "ad_aarch64.cpp"
  }
}

void AndI_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11417 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x1f);
  
#line 21223 "ad_aarch64.cpp"
  }
}

void AndI_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11417 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x1f);
  
#line 21246 "ad_aarch64.cpp"
  }
}

void AndL_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11438 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 21269 "ad_aarch64.cpp"
  }
}

void AndL_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11438 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 21292 "ad_aarch64.cpp"
  }
}

void AndI_reg_RotateRight_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11459 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x1f);
  
#line 21315 "ad_aarch64.cpp"
  }
}

void AndI_reg_RotateRight_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11459 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x1f);
  
#line 21338 "ad_aarch64.cpp"
  }
}

void AndL_reg_RotateRight_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11480 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x3f);
  
#line 21361 "ad_aarch64.cpp"
  }
}

void AndL_reg_RotateRight_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11480 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x3f);
  
#line 21384 "ad_aarch64.cpp"
  }
}

void AndI_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11501 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x1f);
  
#line 21407 "ad_aarch64.cpp"
  }
}

void AndI_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11501 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x1f);
  
#line 21430 "ad_aarch64.cpp"
  }
}

void AndL_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11522 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 21453 "ad_aarch64.cpp"
  }
}

void AndL_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11522 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 21476 "ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11543 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x1f);
  
#line 21499 "ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11543 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x1f);
  
#line 21522 "ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11543 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::LSR,
              opnd_array(4)->constant()& 0x1f);
  
#line 21545 "ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11543 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x1f);
  
#line 21568 "ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11564 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 21591 "ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11564 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 21614 "ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11564 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::LSR,
              opnd_array(4)->constant()& 0x3f);
  
#line 21637 "ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11564 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 21660 "ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11585 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x1f);
  
#line 21683 "ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11585 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x1f);
  
#line 21706 "ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11585 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::ASR,
              opnd_array(4)->constant()& 0x1f);
  
#line 21729 "ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11585 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x1f);
  
#line 21752 "ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11606 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 21775 "ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11606 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 21798 "ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11606 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::ASR,
              opnd_array(4)->constant()& 0x3f);
  
#line 21821 "ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11606 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 21844 "ad_aarch64.cpp"
  }
}

void XorI_reg_RotateRight_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11627 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x1f);
  
#line 21867 "ad_aarch64.cpp"
  }
}

void XorI_reg_RotateRight_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11627 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x1f);
  
#line 21890 "ad_aarch64.cpp"
  }
}

void XorI_reg_RotateRight_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11627 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::ROR,
              opnd_array(4)->constant()& 0x1f);
  
#line 21913 "ad_aarch64.cpp"
  }
}

void XorI_reg_RotateRight_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11627 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x1f);
  
#line 21936 "ad_aarch64.cpp"
  }
}

void XorL_reg_RotateRight_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11648 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x3f);
  
#line 21959 "ad_aarch64.cpp"
  }
}

void XorL_reg_RotateRight_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11648 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x3f);
  
#line 21982 "ad_aarch64.cpp"
  }
}

void XorL_reg_RotateRight_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11648 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::ROR,
              opnd_array(4)->constant()& 0x3f);
  
#line 22005 "ad_aarch64.cpp"
  }
}

void XorL_reg_RotateRight_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11648 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x3f);
  
#line 22028 "ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11669 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x1f);
  
#line 22051 "ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11669 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x1f);
  
#line 22074 "ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11669 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::LSL,
              opnd_array(4)->constant()& 0x1f);
  
#line 22097 "ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11669 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x1f);
  
#line 22120 "ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11690 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 22143 "ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11690 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 22166 "ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11690 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::LSL,
              opnd_array(4)->constant()& 0x3f);
  
#line 22189 "ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11690 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 22212 "ad_aarch64.cpp"
  }
}

void OrI_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11711 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x1f);
  
#line 22235 "ad_aarch64.cpp"
  }
}

void OrI_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11711 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x1f);
  
#line 22258 "ad_aarch64.cpp"
  }
}

void OrL_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11732 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 22281 "ad_aarch64.cpp"
  }
}

void OrL_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11732 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 22304 "ad_aarch64.cpp"
  }
}

void OrI_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11753 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x1f);
  
#line 22327 "ad_aarch64.cpp"
  }
}

void OrI_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11753 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x1f);
  
#line 22350 "ad_aarch64.cpp"
  }
}

void OrL_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11774 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 22373 "ad_aarch64.cpp"
  }
}

void OrL_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11774 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 22396 "ad_aarch64.cpp"
  }
}

void OrI_reg_RotateRight_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11795 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x1f);
  
#line 22419 "ad_aarch64.cpp"
  }
}

void OrI_reg_RotateRight_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11795 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x1f);
  
#line 22442 "ad_aarch64.cpp"
  }
}

void OrL_reg_RotateRight_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11816 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x3f);
  
#line 22465 "ad_aarch64.cpp"
  }
}

void OrL_reg_RotateRight_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11816 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x3f);
  
#line 22488 "ad_aarch64.cpp"
  }
}

void OrI_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11837 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x1f);
  
#line 22511 "ad_aarch64.cpp"
  }
}

void OrI_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11837 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x1f);
  
#line 22534 "ad_aarch64.cpp"
  }
}

void OrL_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11858 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 22557 "ad_aarch64.cpp"
  }
}

void OrL_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11858 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 22580 "ad_aarch64.cpp"
  }
}

void AndI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11879 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x1f);
  
#line 22602 "ad_aarch64.cpp"
  }
}

void AndI_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11879 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x1f);
  
#line 22624 "ad_aarch64.cpp"
  }
}

void AndL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11900 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 22646 "ad_aarch64.cpp"
  }
}

void AndL_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11900 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 22668 "ad_aarch64.cpp"
  }
}

void AndI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11921 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x1f);
  
#line 22690 "ad_aarch64.cpp"
  }
}

void AndI_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11921 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x1f);
  
#line 22712 "ad_aarch64.cpp"
  }
}

void AndL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11942 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 22734 "ad_aarch64.cpp"
  }
}

void AndL_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11942 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 22756 "ad_aarch64.cpp"
  }
}

void AndI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11963 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x1f);
  
#line 22778 "ad_aarch64.cpp"
  }
}

void AndI_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11963 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x1f);
  
#line 22800 "ad_aarch64.cpp"
  }
}

void AndL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11984 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 22822 "ad_aarch64.cpp"
  }
}

void AndL_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11984 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 22844 "ad_aarch64.cpp"
  }
}

void AndI_reg_RotateRight_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12005 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x1f);
  
#line 22866 "ad_aarch64.cpp"
  }
}

void AndI_reg_RotateRight_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12005 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x1f);
  
#line 22888 "ad_aarch64.cpp"
  }
}

void AndL_reg_RotateRight_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12026 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x3f);
  
#line 22910 "ad_aarch64.cpp"
  }
}

void AndL_reg_RotateRight_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12026 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x3f);
  
#line 22932 "ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12047 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x1f);
  
#line 22954 "ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12047 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x1f);
  
#line 22976 "ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12068 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 22998 "ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12068 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 23020 "ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12089 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x1f);
  
#line 23042 "ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12089 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x1f);
  
#line 23064 "ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12110 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 23086 "ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12110 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 23108 "ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12131 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x1f);
  
#line 23130 "ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12131 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x1f);
  
#line 23152 "ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12152 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 23174 "ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12152 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 23196 "ad_aarch64.cpp"
  }
}

void XorI_reg_RotateRight_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12173 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x1f);
  
#line 23218 "ad_aarch64.cpp"
  }
}

void XorI_reg_RotateRight_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12173 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x1f);
  
#line 23240 "ad_aarch64.cpp"
  }
}

void XorL_reg_RotateRight_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12194 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x3f);
  
#line 23262 "ad_aarch64.cpp"
  }
}

void XorL_reg_RotateRight_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12194 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x3f);
  
#line 23284 "ad_aarch64.cpp"
  }
}

void OrI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12215 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x1f);
  
#line 23306 "ad_aarch64.cpp"
  }
}

void OrI_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12215 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x1f);
  
#line 23328 "ad_aarch64.cpp"
  }
}

void OrL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12236 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 23350 "ad_aarch64.cpp"
  }
}

void OrL_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12236 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 23372 "ad_aarch64.cpp"
  }
}

void OrI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12257 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x1f);
  
#line 23394 "ad_aarch64.cpp"
  }
}

void OrI_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12257 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x1f);
  
#line 23416 "ad_aarch64.cpp"
  }
}

void OrL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12278 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 23438 "ad_aarch64.cpp"
  }
}

void OrL_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12278 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 23460 "ad_aarch64.cpp"
  }
}

void OrI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12299 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x1f);
  
#line 23482 "ad_aarch64.cpp"
  }
}

void OrI_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12299 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x1f);
  
#line 23504 "ad_aarch64.cpp"
  }
}

void OrL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12320 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 23526 "ad_aarch64.cpp"
  }
}

void OrL_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12320 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 23548 "ad_aarch64.cpp"
  }
}

void OrI_reg_RotateRight_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12341 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x1f);
  
#line 23570 "ad_aarch64.cpp"
  }
}

void OrI_reg_RotateRight_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12341 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x1f);
  
#line 23592 "ad_aarch64.cpp"
  }
}

void OrL_reg_RotateRight_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12362 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x3f);
  
#line 23614 "ad_aarch64.cpp"
  }
}

void OrL_reg_RotateRight_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12362 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x3f);
  
#line 23636 "ad_aarch64.cpp"
  }
}

void AddI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12383 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x1f);
  
#line 23658 "ad_aarch64.cpp"
  }
}

void AddI_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12383 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x1f);
  
#line 23680 "ad_aarch64.cpp"
  }
}

void AddL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12404 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 23702 "ad_aarch64.cpp"
  }
}

void AddL_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12404 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 23724 "ad_aarch64.cpp"
  }
}

void AddI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12425 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x1f);
  
#line 23746 "ad_aarch64.cpp"
  }
}

void AddI_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12425 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x1f);
  
#line 23768 "ad_aarch64.cpp"
  }
}

void AddL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12446 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 23790 "ad_aarch64.cpp"
  }
}

void AddL_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12446 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 23812 "ad_aarch64.cpp"
  }
}

void AddI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12467 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x1f);
  
#line 23834 "ad_aarch64.cpp"
  }
}

void AddI_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12467 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x1f);
  
#line 23856 "ad_aarch64.cpp"
  }
}

void AddL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12488 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 23878 "ad_aarch64.cpp"
  }
}

void AddL_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12488 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 23900 "ad_aarch64.cpp"
  }
}

void SubI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12509 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x1f);
  
#line 23922 "ad_aarch64.cpp"
  }
}

void SubL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12530 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 23944 "ad_aarch64.cpp"
  }
}

void SubI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12551 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x1f);
  
#line 23966 "ad_aarch64.cpp"
  }
}

void SubL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12572 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 23988 "ad_aarch64.cpp"
  }
}

void SubI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12593 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x1f);
  
#line 24010 "ad_aarch64.cpp"
  }
}

void SubL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12614 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 24032 "ad_aarch64.cpp"
  }
}

void sbfmLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift_count
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift_count
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12635 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    int lshift = opnd_array(2)->constant()& 63;
    int rshift = opnd_array(3)->constant()& 63;
    int s = 63 - lshift;
    int r = (rshift - lshift) & 63;
    __ sbfm(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            r, s);
  
#line 24056 "ad_aarch64.cpp"
  }
}

void sbfmwINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift_count
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift_count
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12658 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    int lshift = opnd_array(2)->constant()& 31;
    int rshift = opnd_array(3)->constant()& 31;
    int s = 31 - lshift;
    int r = (rshift - lshift) & 31;
    __ sbfmw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            r, s);
  
#line 24080 "ad_aarch64.cpp"
  }
}

void ubfmLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift_count
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift_count
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12681 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    int lshift = opnd_array(2)->constant()& 63;
    int rshift = opnd_array(3)->constant()& 63;
    int s = 63 - lshift;
    int r = (rshift - lshift) & 63;
    __ ubfm(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            r, s);
  
#line 24104 "ad_aarch64.cpp"
  }
}

void ubfmwINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift_count
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift_count
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12704 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    int lshift = opnd_array(2)->constant()& 31;
    int rshift = opnd_array(3)->constant()& 31;
    int s = 31 - lshift;
    int r = (rshift - lshift) & 31;
    __ ubfmw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            r, s);
  
#line 24128 "ad_aarch64.cpp"
  }
}

void ubfxwINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12729 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    int rshift = opnd_array(2)->constant()& 31;
    intptr_t mask = opnd_array(3)->constant();
    int width = exact_log2(mask+1);
    __ ubfxw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), rshift, width);
  
#line 24150 "ad_aarch64.cpp"
  }
}

void ubfxLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12749 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    int rshift = opnd_array(2)->constant()& 63;
    intptr_t mask = opnd_array(3)->constantL();
    int width = exact_log2_long(mask+1);
    __ ubfx(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), rshift, width);
  
#line 24172 "ad_aarch64.cpp"
  }
}

void ubfxIConvI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12773 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    int rshift = opnd_array(2)->constant()& 31;
    intptr_t mask = opnd_array(3)->constant();
    int width = exact_log2(mask+1);
    __ ubfx(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), rshift, width);
  
#line 24194 "ad_aarch64.cpp"
  }
}

void ubfizwINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12796 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    int lshift = opnd_array(3)->constant()& 31;
    intptr_t mask = opnd_array(2)->constant();
    int width = exact_log2(mask+1);
    __ ubfizw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
          as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), lshift, width);
  
#line 24216 "ad_aarch64.cpp"
  }
}

void ubfizLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12818 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    int lshift = opnd_array(3)->constant()& 63;
    intptr_t mask = opnd_array(2)->constantL();
    int width = exact_log2_long(mask+1);
    __ ubfiz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
          as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), lshift, width);
  
#line 24238 "ad_aarch64.cpp"
  }
}

void ubfizwIConvI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12840 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    int lshift = opnd_array(3)->constant()& 31;
    intptr_t mask = opnd_array(2)->constant();
    int width = exact_log2(mask+1);
    __ ubfizw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
          as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), lshift, width);
  
#line 24260 "ad_aarch64.cpp"
  }
}

void ubfizLConvL2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12862 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    int lshift = opnd_array(3)->constant()& 63;
    intptr_t mask = opnd_array(2)->constantL();
    int width = exact_log2_long(mask+1);
    __ ubfiz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
          as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), lshift, width);
  
#line 24282 "ad_aarch64.cpp"
  }
}

void ubfizIConvI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12884 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    int lshift = opnd_array(3)->constant()& 63;
    intptr_t mask = opnd_array(2)->constant();
    int width = exact_log2(mask+1);
    __ ubfiz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), lshift, width);
  
#line 24304 "ad_aarch64.cpp"
  }
}

void ubfizLConvL2IxNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12905 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    int lshift = opnd_array(3)->constant()& 31;
    intptr_t mask = opnd_array(2)->constantL();
    int width = exact_log2(mask+1);
    __ ubfiz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), lshift, width);
  
#line 24326 "ad_aarch64.cpp"
  }
}

void ubfizIConvI2LAndINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// msk
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12924 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ubfiz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), 0, exact_log2(opnd_array(2)->constant()+ 1));
  
#line 24343 "ad_aarch64.cpp"
  }
}

void extrOrLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12943 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            opnd_array(4)->constant()& 63);
  
#line 24363 "ad_aarch64.cpp"
  }
}

void extrOrL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12943 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
            opnd_array(2)->constant()& 63);
  
#line 24383 "ad_aarch64.cpp"
  }
}

void extrOrINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12961 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            opnd_array(4)->constant()& 31);
  
#line 24403 "ad_aarch64.cpp"
  }
}

void extrOrI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12961 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
            opnd_array(2)->constant()& 31);
  
#line 24423 "ad_aarch64.cpp"
  }
}

void extrAddLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12979 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            opnd_array(4)->constant()& 63);
  
#line 24443 "ad_aarch64.cpp"
  }
}

void extrAddL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12979 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
            opnd_array(2)->constant()& 63);
  
#line 24463 "ad_aarch64.cpp"
  }
}

void extrAddINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12997 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            opnd_array(4)->constant()& 31);
  
#line 24483 "ad_aarch64.cpp"
  }
}

void extrAddI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12997 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
            opnd_array(2)->constant()& 31);
  
#line 24503 "ad_aarch64.cpp"
  }
}

void rorI_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13013 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               opnd_array(2)->constant()& 0x1f);
  
#line 24521 "ad_aarch64.cpp"
  }
}

void rorL_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13029 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               opnd_array(2)->constant()& 0x3f);
  
#line 24539 "ad_aarch64.cpp"
  }
}

void rorI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13045 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ rorvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 24556 "ad_aarch64.cpp"
  }
}

void rorL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13060 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ rorv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 24573 "ad_aarch64.cpp"
  }
}

void rolI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13075 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ subw(rscratch1, zr, as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
     __ rorvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), rscratch1);
  
#line 24591 "ad_aarch64.cpp"
  }
}

void rolL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13091 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ subw(rscratch1, zr, as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
     __ rorv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), rscratch1);
  
#line 24609 "ad_aarch64.cpp"
  }
}

void AddExtINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13109 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw);
   
#line 24627 "ad_aarch64.cpp"
  }
}

void AddExtI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13109 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtw);
   
#line 24645 "ad_aarch64.cpp"
  }
}

void SubExtINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13124 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw);
   
#line 24663 "ad_aarch64.cpp"
  }
}

void AddExtI_sxthNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13139 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxth);
   
#line 24683 "ad_aarch64.cpp"
  }
}

void AddExtI_sxth_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13139 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxth);
   
#line 24703 "ad_aarch64.cpp"
  }
}

void AddExtI_sxtbNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13154 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtb);
   
#line 24723 "ad_aarch64.cpp"
  }
}

void AddExtI_sxtb_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13154 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtb);
   
#line 24743 "ad_aarch64.cpp"
  }
}

void AddExtI_uxtbNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13169 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 24763 "ad_aarch64.cpp"
  }
}

void AddExtI_uxtb_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13169 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb);
   
#line 24783 "ad_aarch64.cpp"
  }
}

void AddExtL_sxthNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13184 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxth);
   
#line 24803 "ad_aarch64.cpp"
  }
}

void AddExtL_sxth_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13184 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxth);
   
#line 24823 "ad_aarch64.cpp"
  }
}

void AddExtL_sxtwNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13199 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw);
   
#line 24843 "ad_aarch64.cpp"
  }
}

void AddExtL_sxtw_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13199 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtw);
   
#line 24863 "ad_aarch64.cpp"
  }
}

void AddExtL_sxtbNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13214 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtb);
   
#line 24883 "ad_aarch64.cpp"
  }
}

void AddExtL_sxtb_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13214 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtb);
   
#line 24903 "ad_aarch64.cpp"
  }
}

void AddExtL_uxtbNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13229 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 24923 "ad_aarch64.cpp"
  }
}

void AddExtL_uxtb_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13229 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb);
   
#line 24943 "ad_aarch64.cpp"
  }
}

void AddExtI_uxtb_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13244 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 24962 "ad_aarch64.cpp"
  }
}

void AddExtI_uxtb_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13244 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb);
   
#line 24981 "ad_aarch64.cpp"
  }
}

void AddExtI_uxth_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13259 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth);
   
#line 25000 "ad_aarch64.cpp"
  }
}

void AddExtI_uxth_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13259 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxth);
   
#line 25019 "ad_aarch64.cpp"
  }
}

void AddExtL_uxtb_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13274 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 25038 "ad_aarch64.cpp"
  }
}

void AddExtL_uxtb_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13274 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb);
   
#line 25057 "ad_aarch64.cpp"
  }
}

void AddExtL_uxth_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13289 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth);
   
#line 25076 "ad_aarch64.cpp"
  }
}

void AddExtL_uxth_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13289 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxth);
   
#line 25095 "ad_aarch64.cpp"
  }
}

void AddExtL_uxtw_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13304 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtw);
   
#line 25114 "ad_aarch64.cpp"
  }
}

void AddExtL_uxtw_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13304 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtw);
   
#line 25133 "ad_aarch64.cpp"
  }
}

void SubExtI_uxtb_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13319 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 25152 "ad_aarch64.cpp"
  }
}

void SubExtI_uxth_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13334 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth);
   
#line 25171 "ad_aarch64.cpp"
  }
}

void SubExtL_uxtb_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13349 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 25190 "ad_aarch64.cpp"
  }
}

void SubExtL_uxth_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13364 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth);
   
#line 25209 "ad_aarch64.cpp"
  }
}

void SubExtL_uxtw_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13379 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtw);
   
#line 25228 "ad_aarch64.cpp"
  }
}

void AddExtL_sxtb_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// lshift2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13395 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtb, (opnd_array(5)->constant()));
   
#line 25249 "ad_aarch64.cpp"
  }
}

void AddExtL_sxtb_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13395 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtb, (opnd_array(4)->constant()));
   
#line 25270 "ad_aarch64.cpp"
  }
}

void AddExtL_sxth_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// lshift2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13410 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxth, (opnd_array(5)->constant()));
   
#line 25291 "ad_aarch64.cpp"
  }
}

void AddExtL_sxth_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13410 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxth, (opnd_array(4)->constant()));
   
#line 25312 "ad_aarch64.cpp"
  }
}

void AddExtL_sxtw_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// lshift2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13425 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw, (opnd_array(5)->constant()));
   
#line 25333 "ad_aarch64.cpp"
  }
}

void AddExtL_sxtw_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13425 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtw, (opnd_array(4)->constant()));
   
#line 25354 "ad_aarch64.cpp"
  }
}

void SubExtL_sxtb_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// lshift2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13440 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtb, (opnd_array(5)->constant()));
   
#line 25375 "ad_aarch64.cpp"
  }
}

void SubExtL_sxth_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// lshift2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13455 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxth, (opnd_array(5)->constant()));
   
#line 25396 "ad_aarch64.cpp"
  }
}

void SubExtL_sxtw_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// lshift2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13470 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw, (opnd_array(5)->constant()));
   
#line 25417 "ad_aarch64.cpp"
  }
}

void AddExtI_sxtb_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// lshift2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13485 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtb, (opnd_array(5)->constant()));
   
#line 25438 "ad_aarch64.cpp"
  }
}

void AddExtI_sxtb_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13485 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtb, (opnd_array(4)->constant()));
   
#line 25459 "ad_aarch64.cpp"
  }
}

void AddExtI_sxth_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// lshift2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13500 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxth, (opnd_array(5)->constant()));
   
#line 25480 "ad_aarch64.cpp"
  }
}

void AddExtI_sxth_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13500 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxth, (opnd_array(4)->constant()));
   
#line 25501 "ad_aarch64.cpp"
  }
}

void SubExtI_sxtb_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// lshift2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13515 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtb, (opnd_array(5)->constant()));
   
#line 25522 "ad_aarch64.cpp"
  }
}

void SubExtI_sxth_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// lshift2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13530 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxth, (opnd_array(5)->constant()));
   
#line 25543 "ad_aarch64.cpp"
  }
}

void AddExtI_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13545 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw, (opnd_array(3)->constant()));
   
#line 25562 "ad_aarch64.cpp"
  }
}

void AddExtI_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13545 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtw, (opnd_array(2)->constant()));
   
#line 25581 "ad_aarch64.cpp"
  }
}

void SubExtI_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13560 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw, (opnd_array(3)->constant()));
   
#line 25600 "ad_aarch64.cpp"
  }
}

void AddExtL_uxtb_and_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13575 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb, (opnd_array(4)->constant()));
   
#line 25620 "ad_aarch64.cpp"
  }
}

void AddExtL_uxtb_and_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13575 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb, (opnd_array(3)->constant()));
   
#line 25640 "ad_aarch64.cpp"
  }
}

void AddExtL_uxth_and_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13590 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth, (opnd_array(4)->constant()));
   
#line 25660 "ad_aarch64.cpp"
  }
}

void AddExtL_uxth_and_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13590 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxth, (opnd_array(3)->constant()));
   
#line 25680 "ad_aarch64.cpp"
  }
}

void AddExtL_uxtw_and_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13605 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtw, (opnd_array(4)->constant()));
   
#line 25700 "ad_aarch64.cpp"
  }
}

void AddExtL_uxtw_and_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13605 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtw, (opnd_array(3)->constant()));
   
#line 25720 "ad_aarch64.cpp"
  }
}

void SubExtL_uxtb_and_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13620 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb, (opnd_array(4)->constant()));
   
#line 25740 "ad_aarch64.cpp"
  }
}

void SubExtL_uxth_and_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13635 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth, (opnd_array(4)->constant()));
   
#line 25760 "ad_aarch64.cpp"
  }
}

void SubExtL_uxtw_and_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13650 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtw, (opnd_array(4)->constant()));
   
#line 25780 "ad_aarch64.cpp"
  }
}

void AddExtI_uxtb_and_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13665 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb, (opnd_array(4)->constant()));
   
#line 25800 "ad_aarch64.cpp"
  }
}

void AddExtI_uxtb_and_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13665 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb, (opnd_array(3)->constant()));
   
#line 25820 "ad_aarch64.cpp"
  }
}

void AddExtI_uxth_and_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13680 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth, (opnd_array(4)->constant()));
   
#line 25840 "ad_aarch64.cpp"
  }
}

void AddExtI_uxth_and_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13680 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxth, (opnd_array(3)->constant()));
   
#line 25860 "ad_aarch64.cpp"
  }
}

void SubExtI_uxtb_and_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13695 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb, (opnd_array(4)->constant()));
   
#line 25880 "ad_aarch64.cpp"
  }
}

void SubExtI_uxth_and_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13710 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth, (opnd_array(4)->constant()));
   
#line 25900 "ad_aarch64.cpp"
  }
}

void cmovI_reg_reg_ltNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13725 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(opnd_array(0)->as_Register(ra_,this)/* dst */,
             opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
             opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */,
             Assembler::LT);
  
#line 25921 "ad_aarch64.cpp"
  }
}

void cmovI_reg_reg_gtNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13742 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(opnd_array(0)->as_Register(ra_,this)/* dst */,
             opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
             opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */,
             Assembler::GT);
  
#line 25942 "ad_aarch64.cpp"
  }
}

void cmovI_reg_imm0_ltNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13759 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(opnd_array(0)->as_Register(ra_,this)/* dst */,
             opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
             zr,
             Assembler::LT);
  
#line 25962 "ad_aarch64.cpp"
  }
}

void cmovI_reg_imm0_gtNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13776 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(opnd_array(0)->as_Register(ra_,this)/* dst */,
             opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
             zr,
             Assembler::GT);
  
#line 25982 "ad_aarch64.cpp"
  }
}

void cmovI_reg_imm1_leNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13793 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csincw(opnd_array(0)->as_Register(ra_,this)/* dst */,
             opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
             zr,
             Assembler::LE);
  
#line 26002 "ad_aarch64.cpp"
  }
}

void cmovI_reg_imm1_gtNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13810 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csincw(opnd_array(0)->as_Register(ra_,this)/* dst */,
             opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
             zr,
             Assembler::GT);
  
#line 26022 "ad_aarch64.cpp"
  }
}

void cmovI_reg_immM1_ltNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13827 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csinvw(opnd_array(0)->as_Register(ra_,this)/* dst */,
             opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
             zr,
             Assembler::LT);
  
#line 26042 "ad_aarch64.cpp"
  }
}

void cmovI_reg_immM1_geNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13844 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csinvw(opnd_array(0)->as_Register(ra_,this)/* dst */,
             opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
             zr,
             Assembler::GE);
  
#line 26062 "ad_aarch64.cpp"
  }
}

void bits_reverse_INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14016 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ rbitw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 26078 "ad_aarch64.cpp"
  }
}

void bits_reverse_LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14029 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ rbit(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 26094 "ad_aarch64.cpp"
  }
}

void addF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14048 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fadds(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26113 "ad_aarch64.cpp"
  }
}

void addD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14063 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ faddd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26132 "ad_aarch64.cpp"
  }
}

void subF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14078 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fsubs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26151 "ad_aarch64.cpp"
  }
}

void subD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14093 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fsubd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26170 "ad_aarch64.cpp"
  }
}

void mulF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14108 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmuls(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26189 "ad_aarch64.cpp"
  }
}

void mulD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14123 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmuld(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26208 "ad_aarch64.cpp"
  }
}

void maddF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14139 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmadds(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
             as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 26229 "ad_aarch64.cpp"
  }
}

void maddD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14156 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmaddd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
             as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 26250 "ad_aarch64.cpp"
  }
}

void msubF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14174 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmsubs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 26271 "ad_aarch64.cpp"
  }
}

void msubF_reg_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14174 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmsubs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 26292 "ad_aarch64.cpp"
  }
}

void msubD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14192 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmsubd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 26313 "ad_aarch64.cpp"
  }
}

void msubD_reg_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14192 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmsubd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 26334 "ad_aarch64.cpp"
  }
}

void mnaddF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14210 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fnmadds(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
               as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
               as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 26355 "ad_aarch64.cpp"
  }
}

void mnaddF_reg_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14210 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fnmadds(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
               as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
               as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 26376 "ad_aarch64.cpp"
  }
}

void mnaddD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14228 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fnmaddd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
               as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
               as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 26397 "ad_aarch64.cpp"
  }
}

void mnaddD_reg_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14228 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fnmaddd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
               as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
               as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 26418 "ad_aarch64.cpp"
  }
}

void mnsubF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14245 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fnmsubs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
               as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
               as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 26439 "ad_aarch64.cpp"
  }
}

void mnsubD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14262 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

  // n.b. insn name should be fnmsubd
    __ fnmsub(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 26461 "ad_aarch64.cpp"
  }
}

void maxF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14279 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmaxs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26480 "ad_aarch64.cpp"
  }
}

void minF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14293 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmins(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26499 "ad_aarch64.cpp"
  }
}

void maxD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14307 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmaxd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26518 "ad_aarch64.cpp"
  }
}

void minD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14321 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmind(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26537 "ad_aarch64.cpp"
  }
}

void divF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14337 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fdivs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26556 "ad_aarch64.cpp"
  }
}

void divD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14352 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fdivd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26575 "ad_aarch64.cpp"
  }
}

void negF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14367 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fnegs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26592 "ad_aarch64.cpp"
  }
}

void negD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14381 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fnegd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26609 "ad_aarch64.cpp"
  }
}

void absI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14399 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpw(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), zr);
    __ cnegw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), Assembler::LT);
  
#line 26626 "ad_aarch64.cpp"
  }
}

void absL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14416 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmp(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), zr);
    __ cneg(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), Assembler::LT);
  
#line 26643 "ad_aarch64.cpp"
  }
}

void absF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14428 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fabss(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26660 "ad_aarch64.cpp"
  }
}

void absD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14441 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fabsd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26677 "ad_aarch64.cpp"
  }
}

void absdF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14454 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fabds(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26696 "ad_aarch64.cpp"
  }
}

void absdD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14468 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fabdd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26715 "ad_aarch64.cpp"
  }
}

void sqrtD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14482 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fsqrtd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26732 "ad_aarch64.cpp"
  }
}

void sqrtF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14495 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fsqrts(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26749 "ad_aarch64.cpp"
  }
}

void roundD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rmode
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14507 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    switch (opnd_array(2)->constant()) {
      case RoundDoubleModeNode::rmode_rint:
        __ frintnd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
                   as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
        break;
      case RoundDoubleModeNode::rmode_floor:
        __ frintmd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
                   as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
        break;
      case RoundDoubleModeNode::rmode_ceil:
        __ frintpd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
                   as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
        break;
    }
  
#line 26779 "ad_aarch64.cpp"
  }
}

void copySignD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14530 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister dst = as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */),
                  src1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
                  src2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                  zero = as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* zero */);
    __ fnegd(dst, zero);
    __ bsl(dst, __ T8B, src2, src1);
  
#line 26803 "ad_aarch64.cpp"
  }
}

void copySignF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14545 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister dst = as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */),
                  src1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
                  src2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ movi(dst, __ T2S, 0x80, 24);
    __ bsl(dst, __ T8B, src2, src1);
  
#line 26825 "ad_aarch64.cpp"
  }
}

void signumD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14559 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                  dst = as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */),
                  zero = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* zero */),
                  one = as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* one */);
    __ facgtd(dst, src, zero); // dst=0 for +-0.0 and NaN. 0xFFF..F otherwise
    __ ushrd(dst, dst, 1);     // dst=0 for +-0.0 and NaN. 0x7FF..F otherwise
    // Bit selection instruction gets bit from "one" for each enabled bit in
    // "dst", otherwise gets a bit from "src". For "src" that contains +-0.0 or
    // NaN the whole "src" will be copied because "dst" is zero. For all other
    // "src" values dst is 0x7FF..F, which means only the sign bit is copied
    // from "src", and all other bits are copied from 1.0.
    __ bsl(dst, __ T8B, one, src);
  
#line 26855 "ad_aarch64.cpp"
  }
}

void signumF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14580 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                  dst = as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */),
                  zero = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* zero */),
                  one = as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* one */);
    __ facgts(dst, src, zero);    // dst=0 for +-0.0 and NaN. 0xFFF..F otherwise
    __ ushr(dst, __ T2S, dst, 1); // dst=0 for +-0.0 and NaN. 0x7FF..F otherwise
    // Bit selection instruction gets bit from "one" for each enabled bit in
    // "dst", otherwise gets a bit from "src". For "src" that contains +-0.0 or
    // NaN the whole "src" will be copied because "dst" is zero. For all other
    // "src" values dst is 0x7FF..F, which means only the sign bit is copied
    // from "src", and all other bits are copied from 1.0.
    __ bsl(dst, __ T8B, one, src);
  
#line 26885 "ad_aarch64.cpp"
  }
}

void onspinwaitNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14603 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ spin_wait();
  
#line 26901 "ad_aarch64.cpp"
  }
}

void andI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14623 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26920 "ad_aarch64.cpp"
  }
}

void andI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14638 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (uint64_t)(opnd_array(2)->constant()));
  
#line 26939 "ad_aarch64.cpp"
  }
}

void orI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14655 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26958 "ad_aarch64.cpp"
  }
}

void orI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14670 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (uint64_t)(opnd_array(2)->constant()));
  
#line 26977 "ad_aarch64.cpp"
  }
}

void xorI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14687 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26996 "ad_aarch64.cpp"
  }
}

void xorI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14702 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (uint64_t)(opnd_array(2)->constant()));
  
#line 27015 "ad_aarch64.cpp"
  }
}

void andL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14720 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 27034 "ad_aarch64.cpp"
  }
}

void andL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14735 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (uint64_t)(opnd_array(2)->constantL()));
  
#line 27053 "ad_aarch64.cpp"
  }
}

void orL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14752 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 27072 "ad_aarch64.cpp"
  }
}

void orL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14767 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           (uint64_t)(opnd_array(2)->constantL()));
  
#line 27091 "ad_aarch64.cpp"
  }
}

void xorL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14784 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 27110 "ad_aarch64.cpp"
  }
}

void xorL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14799 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           (uint64_t)(opnd_array(2)->constantL()));
  
#line 27129 "ad_aarch64.cpp"
  }
}

void convI2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14814 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ sbfm(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, 0, 31);
  
#line 27145 "ad_aarch64.cpp"
  }
}

void convUI2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14827 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ubfm(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, 0, 31);
  
#line 27162 "ad_aarch64.cpp"
  }
}

void convL2I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14840 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ movw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 27178 "ad_aarch64.cpp"
  }
}

void convD2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14853 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fcvtd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 27194 "ad_aarch64.cpp"
  }
}

void convF2D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14866 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fcvts(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 27210 "ad_aarch64.cpp"
  }
}

void convF2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14879 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fcvtzsw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 27226 "ad_aarch64.cpp"
  }
}

void convF2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14892 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fcvtzs(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 27242 "ad_aarch64.cpp"
  }
}

void convF2HF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14905 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

      __ flt_to_flt16(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
  
#line 27259 "ad_aarch64.cpp"
  }
}

void convHF2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14917 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

      __ flt16_to_flt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
  
#line 27276 "ad_aarch64.cpp"
  }
}

void convI2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14929 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ scvtfws(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 27292 "ad_aarch64.cpp"
  }
}

void convL2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14942 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ scvtfs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 27308 "ad_aarch64.cpp"
  }
}

void convD2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14955 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fcvtzdw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 27324 "ad_aarch64.cpp"
  }
}

void convD2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14968 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fcvtzd(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 27340 "ad_aarch64.cpp"
  }
}

void convI2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14981 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ scvtfwd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 27356 "ad_aarch64.cpp"
  }
}

void convL2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14994 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ scvtfd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 27372 "ad_aarch64.cpp"
  }
}

void round_double_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ftmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15006 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ java_round_double(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                         as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* ftmp */));
  
#line 27391 "ad_aarch64.cpp"
  }
}

void round_float_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ftmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15018 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ java_round_float(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                        as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* ftmp */));
  
#line 27410 "ad_aarch64.cpp"
  }
}

void MoveF2I_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15037 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ldrw(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 27426 "ad_aarch64.cpp"
  }
}

void MoveI2F_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15055 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ldrs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 27442 "ad_aarch64.cpp"
  }
}

void MoveD2L_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15073 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ldr(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 27458 "ad_aarch64.cpp"
  }
}

void MoveL2D_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15091 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ldrd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 27474 "ad_aarch64.cpp"
  }
}

void MoveF2I_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15109 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ strs(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 27490 "ad_aarch64.cpp"
  }
}

void MoveI2F_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15127 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ strw(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 27506 "ad_aarch64.cpp"
  }
}

void MoveD2L_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15145 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ strd(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 27522 "ad_aarch64.cpp"
  }
}

void MoveL2D_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15163 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ str(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 27538 "ad_aarch64.cpp"
  }
}

void MoveF2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15181 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmovs(opnd_array(0)->as_Register(ra_,this)/* dst */, as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 27554 "ad_aarch64.cpp"
  }
}

void MoveI2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15199 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmovs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 27570 "ad_aarch64.cpp"
  }
}

void MoveD2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15217 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmovd(opnd_array(0)->as_Register(ra_,this)/* dst */, as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 27586 "ad_aarch64.cpp"
  }
}

void MoveL2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15235 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmovd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 27602 "ad_aarch64.cpp"
  }
}

void clearArray_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15254 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    address tpc = __ zero_words(opnd_array(2)->as_Register(ra_,this,idx2)/* base */, opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */);
    if (tpc == NULL) {
      ciEnv::current()->record_failure("CodeCache is full");
      return;
    }
  
#line 27623 "ad_aarch64.cpp"
  }
}

void clearArray_imm_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// temp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15275 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    address tpc = __ zero_words(opnd_array(2)->as_Register(ra_,this,idx2)/* base */, (uint64_t)opnd_array(1)->constantL());
    if (tpc == NULL) {
      ciEnv::current()->record_failure("CodeCache is full");
      return;
    }
  
#line 27645 "ad_aarch64.cpp"
  }
}

void overflowAddI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15295 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmnw(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 27662 "ad_aarch64.cpp"
  }
}

void overflowAddI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15308 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmnw(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constant());
  
#line 27679 "ad_aarch64.cpp"
  }
}

void overflowAddL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15321 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmn(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 27696 "ad_aarch64.cpp"
  }
}

void overflowAddL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15334 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ adds(zr, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constantL());
  
#line 27713 "ad_aarch64.cpp"
  }
}

void overflowSubI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15347 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpw(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 27730 "ad_aarch64.cpp"
  }
}

void overflowSubI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15360 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpw(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constant());
  
#line 27747 "ad_aarch64.cpp"
  }
}

void overflowSubL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15373 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmp(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 27764 "ad_aarch64.cpp"
  }
}

void overflowSubL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15386 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ subs(zr, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constantL());
  
#line 27781 "ad_aarch64.cpp"
  }
}

void overflowNegI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15399 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpw(zr, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */);
  
#line 27798 "ad_aarch64.cpp"
  }
}

void overflowNegL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15412 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmp(zr, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */);
  
#line 27815 "ad_aarch64.cpp"
  }
}

void overflowMulI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15429 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smull(rscratch1, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
    __ subs(zr, rscratch1, rscratch1, ext::sxtw);      // NE => overflow
    __ movw(rscratch1, 0x80000000);                    // Develop 0 (EQ),
    __ cselw(rscratch1, rscratch1, zr, Assembler::NE); // or 0x80000000 (NE)
    __ cmpw(rscratch1, 1);                             // 0x80000000 - 1 => VS
  
#line 27836 "ad_aarch64.cpp"
  }
}

void overflowMulI_reg_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15451 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ smull(rscratch1, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* op2 */);
    __ subs(zr, rscratch1, rscratch1, ext::sxtw);      // NE => overflow
    __ br(cond == Assembler::VS ? Assembler::NE : Assembler::EQ, *L);
  
#line 27859 "ad_aarch64.cpp"
  }
}

void overflowMulL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15473 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mul(rscratch1, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);   // Result bits 0..63
    __ smulh(rscratch2, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */); // Result bits 64..127
    __ cmp(rscratch2, rscratch1, Assembler::ASR, 63);    // Top is pure sign ext
    __ movw(rscratch1, 0x80000000);                    // Develop 0 (EQ),
    __ cselw(rscratch1, rscratch1, zr, Assembler::NE); // or 0x80000000 (NE)
    __ cmpw(rscratch1, 1);                             // 0x80000000 - 1 => VS
  
#line 27881 "ad_aarch64.cpp"
  }
}

void overflowMulL_reg_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15497 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ mul(rscratch1, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* op2 */);   // Result bits 0..63
    __ smulh(rscratch2, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* op2 */); // Result bits 64..127
    __ cmp(rscratch2, rscratch1, Assembler::ASR, 63);    // Top is pure sign ext
    __ br(cond == Assembler::VS ? Assembler::NE : Assembler::EQ, *L);
  
#line 27905 "ad_aarch64.cpp"
  }
}

void compI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3571 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmpw(reg1, reg2);
  
#line 27924 "ad_aarch64.cpp"
  }
}

void compI_reg_immI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3578 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int32_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subsw(zr, reg, val);
    } else {
      __ addsw(zr, reg, -val);
    }
  
#line 27947 "ad_aarch64.cpp"
  }
}

void compI_reg_immIAddSubNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3578 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int32_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subsw(zr, reg, val);
    } else {
      __ addsw(zr, reg, -val);
    }
  
#line 27970 "ad_aarch64.cpp"
  }
}

void compI_reg_immINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3589 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    uint32_t val = (uint32_t)opnd_array(2)->constant();
    __ movw(rscratch1, val);
    __ cmpw(reg1, rscratch1);
  
#line 27990 "ad_aarch64.cpp"
  }
}

void compU_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3571 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmpw(reg1, reg2);
  
#line 28009 "ad_aarch64.cpp"
  }
}

void compU_reg_immI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3578 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int32_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subsw(zr, reg, val);
    } else {
      __ addsw(zr, reg, -val);
    }
  
#line 28032 "ad_aarch64.cpp"
  }
}

void compU_reg_immIAddSubNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3578 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int32_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subsw(zr, reg, val);
    } else {
      __ addsw(zr, reg, -val);
    }
  
#line 28055 "ad_aarch64.cpp"
  }
}

void compU_reg_immINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3589 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    uint32_t val = (uint32_t)opnd_array(2)->constant();
    __ movw(rscratch1, val);
    __ cmpw(reg1, rscratch1);
  
#line 28075 "ad_aarch64.cpp"
  }
}

void compL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3597 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmp(reg1, reg2);
  
#line 28094 "ad_aarch64.cpp"
  }
}

void compL_reg_immL0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3604 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int64_t val = opnd_array(2)->constantL();
    if (val >= 0) {
      __ subs(zr, reg, val);
    } else if (val != -val) {
      __ adds(zr, reg, -val);
    } else {
    // aargh, Long.MIN_VALUE is a special case
      __ orr(rscratch1, zr, (uint64_t)val);
      __ subs(zr, reg, rscratch1);
    }
  
#line 28121 "ad_aarch64.cpp"
  }
}

void compL_reg_immLAddSubNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3604 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int64_t val = opnd_array(2)->constantL();
    if (val >= 0) {
      __ subs(zr, reg, val);
    } else if (val != -val) {
      __ adds(zr, reg, -val);
    } else {
    // aargh, Long.MIN_VALUE is a special case
      __ orr(rscratch1, zr, (uint64_t)val);
      __ subs(zr, reg, rscratch1);
    }
  
#line 28148 "ad_aarch64.cpp"
  }
}

void compL_reg_immLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3619 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    uint64_t val = (uint64_t)opnd_array(2)->constantL();
    __ mov(rscratch1, val);
    __ cmp(reg1, rscratch1);
  
#line 28168 "ad_aarch64.cpp"
  }
}

void compUL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3597 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmp(reg1, reg2);
  
#line 28187 "ad_aarch64.cpp"
  }
}

void compUL_reg_immL0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3604 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int64_t val = opnd_array(2)->constantL();
    if (val >= 0) {
      __ subs(zr, reg, val);
    } else if (val != -val) {
      __ adds(zr, reg, -val);
    } else {
    // aargh, Long.MIN_VALUE is a special case
      __ orr(rscratch1, zr, (uint64_t)val);
      __ subs(zr, reg, rscratch1);
    }
  
#line 28214 "ad_aarch64.cpp"
  }
}

void compUL_reg_immLAddSubNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3604 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int64_t val = opnd_array(2)->constantL();
    if (val >= 0) {
      __ subs(zr, reg, val);
    } else if (val != -val) {
      __ adds(zr, reg, -val);
    } else {
    // aargh, Long.MIN_VALUE is a special case
      __ orr(rscratch1, zr, (uint64_t)val);
      __ subs(zr, reg, rscratch1);
    }
  
#line 28241 "ad_aarch64.cpp"
  }
}

void compUL_reg_immLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3619 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    uint64_t val = (uint64_t)opnd_array(2)->constantL();
    __ mov(rscratch1, val);
    __ cmp(reg1, rscratch1);
  
#line 28261 "ad_aarch64.cpp"
  }
}

void compP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3627 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmp(reg1, reg2);
  
#line 28280 "ad_aarch64.cpp"
  }
}

void compN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3634 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmpw(reg1, reg2);
  
#line 28299 "ad_aarch64.cpp"
  }
}

void testP_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3641 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    __ cmp(reg, zr);
  
#line 28317 "ad_aarch64.cpp"
  }
}

void testN_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3647 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    __ cmpw(reg, zr);
  
#line 28335 "ad_aarch64.cpp"
  }
}

void compF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15808 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fcmps(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 28352 "ad_aarch64.cpp"
  }
}

void compF_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15822 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fcmps(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), 0.0);
  
#line 28369 "ad_aarch64.cpp"
  }
}

void compD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15837 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fcmpd(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 28386 "ad_aarch64.cpp"
  }
}

void compD_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15851 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fcmpd(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), 0.0);
  
#line 28403 "ad_aarch64.cpp"
  }
}

void compF3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15869 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Label done;
    FloatRegister s1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister s2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    Register d = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ fcmps(s1, s2);
    // installs 0 if EQ else -1
    __ csinvw(d, zr, zr, Assembler::EQ);
    // keeps -1 if less or unordered else installs 1
    __ csnegw(d, d, d, Assembler::LT);
    __ bind(done);
  
#line 28429 "ad_aarch64.cpp"
  }
}

void compD3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15897 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Label done;
    FloatRegister s1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister s2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    Register d = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ fcmpd(s1, s2);
    // installs 0 if EQ else -1
    __ csinvw(d, zr, zr, Assembler::EQ);
    // keeps -1 if less or unordered else installs 1
    __ csnegw(d, d, d, Assembler::LT);
    __ bind(done);
  
#line 28455 "ad_aarch64.cpp"
  }
}

void compF3_reg_immF0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15924 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Label done;
    FloatRegister s1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register d = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ fcmps(s1, 0.0);
    // installs 0 if EQ else -1
    __ csinvw(d, zr, zr, Assembler::EQ);
    // keeps -1 if less or unordered else installs 1
    __ csnegw(d, d, d, Assembler::LT);
    __ bind(done);
  
#line 28480 "ad_aarch64.cpp"
  }
}

void compD3_reg_immD0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15951 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Label done;
    FloatRegister s1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register d = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ fcmpd(s1, 0.0);
    // installs 0 if EQ else -1
    __ csinvw(d, zr, zr, Assembler::EQ);
    // keeps -1 if less or unordered else installs 1
    __ csnegw(d, d, d, Assembler::LT);
    __ bind(done);
  
#line 28505 "ad_aarch64.cpp"
  }
}

void cmpLTMask_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// p
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// q
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15978 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpw(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* p */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* q */));
    __ csetw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Assembler::LT);
    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), zr, as_Register(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 28524 "ad_aarch64.cpp"
  }
}

void cmpLTMask_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15996 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ asrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), 31);
  
#line 28541 "ad_aarch64.cpp"
  }
}

void compI_reg_imm0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16014 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpw(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, 0);
  
#line 28557 "ad_aarch64.cpp"
  }
}

void branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 3653 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(1)->label();
    __ b(*L);
  
#line 28574 "ad_aarch64.cpp"
  }
}

void branchConNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 3659 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(3)->label();
    __ br ((Assembler::Condition)opnd_array(1)->ccode(), *L);
  
#line 28593 "ad_aarch64.cpp"
  }
}

void branchConUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 3665 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(3)->label();
    __ br ((Assembler::Condition)opnd_array(1)->ccode(), *L);
  
#line 28612 "ad_aarch64.cpp"
  }
}

void cmpI_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16115 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ)
      __ cbzw(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
    else
      __ cbnzw(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
  
#line 28636 "ad_aarch64.cpp"
  }
}

void cmpL_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16132 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ)
      __ cbz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
    else
      __ cbnz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
  
#line 28660 "ad_aarch64.cpp"
  }
}

void cmpP_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16149 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ)
      __ cbz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
    else
      __ cbnz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
  
#line 28684 "ad_aarch64.cpp"
  }
}

void cmpN_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16166 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ)
      __ cbzw(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
    else
      __ cbnzw(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
  
#line 28708 "ad_aarch64.cpp"
  }
}

void cmpP_narrowOop_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// oop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16183 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ)
      __ cbzw(opnd_array(2)->as_Register(ra_,this,idx2)/* oop */, *L);
    else
      __ cbnzw(opnd_array(2)->as_Register(ra_,this,idx2)/* oop */, *L);
  
#line 28732 "ad_aarch64.cpp"
  }
}

void cmpUI_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16200 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ || cond == Assembler::LS)
      __ cbzw(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
    else
      __ cbnzw(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
  
#line 28756 "ad_aarch64.cpp"
  }
}

void cmpUL_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16217 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ || cond == Assembler::LS)
      __ cbz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
    else
      __ cbnz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
  
#line 28780 "ad_aarch64.cpp"
  }
}

void cmpL_branch_signNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16237 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond =
      ((Assembler::Condition)opnd_array(1)->ccode()== Assembler::LT) ? Assembler::NE : Assembler::EQ;
    __ tbr(cond, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, 63, *L);
  
#line 28802 "ad_aarch64.cpp"
  }
}

void cmpI_branch_signNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16253 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond =
      ((Assembler::Condition)opnd_array(1)->ccode()== Assembler::LT) ? Assembler::NE : Assembler::EQ;
    __ tbr(cond, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, 31, *L);
  
#line 28824 "ad_aarch64.cpp"
  }
}

void cmpL_branch_bitNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// labl
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16270 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(5)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    int bit = exact_log2_long(opnd_array(3)->constantL());
    __ tbr(cond, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, bit, *L);
  
#line 28847 "ad_aarch64.cpp"
  }
}

void cmpI_branch_bitNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// labl
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16287 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(5)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    int bit = exact_log2((juint)opnd_array(3)->constant());
    __ tbr(cond, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, bit, *L);
  
#line 28870 "ad_aarch64.cpp"
  }
}

void far_cmpL_branch_signNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16304 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond =
      ((Assembler::Condition)opnd_array(1)->ccode()== Assembler::LT) ? Assembler::NE : Assembler::EQ;
    __ tbr(cond, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, 63, *L, /*far*/true);
  
#line 28892 "ad_aarch64.cpp"
  }
}

void far_cmpI_branch_signNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16319 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond =
      ((Assembler::Condition)opnd_array(1)->ccode()== Assembler::LT) ? Assembler::NE : Assembler::EQ;
    __ tbr(cond, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, 31, *L, /*far*/true);
  
#line 28914 "ad_aarch64.cpp"
  }
}

void far_cmpL_branch_bitNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// labl
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16335 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(5)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    int bit = exact_log2_long(opnd_array(3)->constantL());
    __ tbr(cond, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, bit, *L, /*far*/true);
  
#line 28937 "ad_aarch64.cpp"
  }
}

void far_cmpI_branch_bitNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// labl
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16351 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(5)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    int bit = exact_log2((juint)opnd_array(3)->constant());
    __ tbr(cond, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, bit, *L, /*far*/true);
  
#line 28960 "ad_aarch64.cpp"
  }
}

void cmpL_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16369 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ tst(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constantL());
  
#line 28978 "ad_aarch64.cpp"
  }
}

void cmpI_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16382 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ tstw(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constant());
  
#line 28996 "ad_aarch64.cpp"
  }
}

void cmpL_and_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16393 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ tst(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 29014 "ad_aarch64.cpp"
  }
}

void cmpI_and_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16404 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ tstw(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 29032 "ad_aarch64.cpp"
  }
}

void branchLoopEndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 3659 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(3)->label();
    __ br ((Assembler::Condition)opnd_array(1)->ccode(), *L);
  
#line 29051 "ad_aarch64.cpp"
  }
}

void cmpFastLockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16448 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fast_lock(opnd_array(1)->as_Register(ra_,this,idx1)/* object */, opnd_array(2)->as_Register(ra_,this,idx2)/* box */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp3 */);
  
#line 29071 "ad_aarch64.cpp"
  }
}

void cmpFastUnlockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16463 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fast_unlock(opnd_array(1)->as_Register(ra_,this,idx1)/* object */, opnd_array(2)->as_Register(ra_,this,idx2)/* box */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */);
  
#line 29090 "ad_aarch64.cpp"
  }
}

void safePointNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16485 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ read_polling_page(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* poll */), relocInfo::poll_type);
  
#line 29106 "ad_aarch64.cpp"
  }
}

void CallStaticJavaDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 3689 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);

    address addr = (address)opnd_array(1)->method();
    address call;
    if (!_method) {
      // A call to a runtime wrapper, e.g. new, new_typeArray_Java, uncommon_trap.
      call = __ trampoline_call(Address(addr, relocInfo::runtime_call_type));
      if (call == NULL) {
        ciEnv::current()->record_failure("CodeCache is full");
        return;
      }
    } else if (_method->intrinsic_id() == vmIntrinsicID::_ensureMaterializedForStackWalk) {
      // The NOP here is purely to ensure that eliding a call to
      // JVM_EnsureMaterializedForStackWalk doesn't change the code size.
      __ nop();
      __ block_comment("call JVM_EnsureMaterializedForStackWalk (elided)");
    } else {
      int method_index = resolved_method_index(cbuf);
      RelocationHolder rspec = _optimized_virtual ? opt_virtual_call_Relocation::spec(method_index)
                                                  : static_call_Relocation::spec(method_index);
      call = __ trampoline_call(Address(addr, rspec));
      if (call == NULL) {
        ciEnv::current()->record_failure("CodeCache is full");
        return;
      }
      if (CodeBuffer::supports_shared_stubs() && _method->can_be_statically_bound()) {
        // Calls of the same statically bound method can share
        // a stub to the interpreter.
        cbuf.shared_stub_to_interp_for(_method, call - cbuf.insts_begin());
      } else {
        // Emit stub for static call
        address stub = CompiledStaticCall::emit_to_interp_stub(cbuf, call);
        if (stub == NULL) {
          ciEnv::current()->record_failure("CodeCache is full");
          return;
        }
      }
    }

    __ post_call_nop();

    // Only non uncommon_trap calls need to reinitialize ptrue.
    if (Compile::current()->max_vector_size() > 0 && uncommon_trap_request() == 0) {
      __ reinitialize_ptrue();
    }
  
#line 29165 "ad_aarch64.cpp"
  }
  {

#line 3751 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    if (VerifyStackAtCalls) {
      // Check that stack depth is unchanged: find majik cookie on stack
      __ call_Unimplemented();
    }
  
#line 29177 "ad_aarch64.cpp"
  }
}

void CallDynamicJavaDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 3737 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    int method_index = resolved_method_index(cbuf);
    address call = __ ic_call((address)opnd_array(1)->method(), method_index);
    if (call == NULL) {
      ciEnv::current()->record_failure("CodeCache is full");
      return;
    }
    __ post_call_nop();
    if (Compile::current()->max_vector_size() > 0) {
      __ reinitialize_ptrue();
    }
  
#line 29202 "ad_aarch64.cpp"
  }
  {

#line 3751 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    if (VerifyStackAtCalls) {
      // Check that stack depth is unchanged: find majik cookie on stack
      __ call_Unimplemented();
    }
  
#line 29214 "ad_aarch64.cpp"
  }
}

void CallRuntimeDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 3759 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);

    // some calls to generated routines (arraycopy code) are scheduled
    // by C2 as runtime calls. if so we can call them using a br (they
    // will be in a reachable segment) otherwise we have to use a blr
    // which loads the absolute address into a register.
    address entry = (address)opnd_array(1)->method();
    CodeBlob *cb = CodeCache::find_blob(entry);
    if (cb) {
      address call = __ trampoline_call(Address(entry, relocInfo::runtime_call_type));
      if (call == NULL) {
        ciEnv::current()->record_failure("CodeCache is full");
        return;
      }
      __ post_call_nop();
    } else {
      Label retaddr;
      __ adr(rscratch2, retaddr);
      __ lea(rscratch1, RuntimeAddress(entry));
      // Leave a breadcrumb for JavaFrameAnchor::capture_last_Java_pc()
      __ stp(zr, rscratch2, Address(__ pre(sp, -2 * wordSize)));
      __ blr(rscratch1);
      __ bind(retaddr);
      __ post_call_nop();
      __ add(sp, sp, 2 * wordSize);
    }
    if (Compile::current()->max_vector_size() > 0) {
      __ reinitialize_ptrue();
    }
  
#line 29257 "ad_aarch64.cpp"
  }
}

void CallLeafDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 3759 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);

    // some calls to generated routines (arraycopy code) are scheduled
    // by C2 as runtime calls. if so we can call them using a br (they
    // will be in a reachable segment) otherwise we have to use a blr
    // which loads the absolute address into a register.
    address entry = (address)opnd_array(1)->method();
    CodeBlob *cb = CodeCache::find_blob(entry);
    if (cb) {
      address call = __ trampoline_call(Address(entry, relocInfo::runtime_call_type));
      if (call == NULL) {
        ciEnv::current()->record_failure("CodeCache is full");
        return;
      }
      __ post_call_nop();
    } else {
      Label retaddr;
      __ adr(rscratch2, retaddr);
      __ lea(rscratch1, RuntimeAddress(entry));
      // Leave a breadcrumb for JavaFrameAnchor::capture_last_Java_pc()
      __ stp(zr, rscratch2, Address(__ pre(sp, -2 * wordSize)));
      __ blr(rscratch1);
      __ bind(retaddr);
      __ post_call_nop();
      __ add(sp, sp, 2 * wordSize);
    }
    if (Compile::current()->max_vector_size() > 0) {
      __ reinitialize_ptrue();
    }
  
#line 29300 "ad_aarch64.cpp"
  }
}

void CallLeafNoFPDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 3759 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);

    // some calls to generated routines (arraycopy code) are scheduled
    // by C2 as runtime calls. if so we can call them using a br (they
    // will be in a reachable segment) otherwise we have to use a blr
    // which loads the absolute address into a register.
    address entry = (address)opnd_array(1)->method();
    CodeBlob *cb = CodeCache::find_blob(entry);
    if (cb) {
      address call = __ trampoline_call(Address(entry, relocInfo::runtime_call_type));
      if (call == NULL) {
        ciEnv::current()->record_failure("CodeCache is full");
        return;
      }
      __ post_call_nop();
    } else {
      Label retaddr;
      __ adr(rscratch2, retaddr);
      __ lea(rscratch1, RuntimeAddress(entry));
      // Leave a breadcrumb for JavaFrameAnchor::capture_last_Java_pc()
      __ stp(zr, rscratch2, Address(__ pre(sp, -2 * wordSize)));
      __ blr(rscratch1);
      __ bind(retaddr);
      __ post_call_nop();
      __ add(sp, sp, 2 * wordSize);
    }
    if (Compile::current()->max_vector_size() > 0) {
      __ reinitialize_ptrue();
    }
  
#line 29343 "ad_aarch64.cpp"
  }
}

void TailCalljmpIndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// method_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {

#line 3806 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register target_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* jump_target */);
    __ br(target_reg);
  
#line 29361 "ad_aarch64.cpp"
  }
}

void TailjmpIndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// ex_oop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {

#line 3812 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register target_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* jump_target */);
    // exception oop should be in r0
    // ret addr has been popped into lr
    // callee expects it in r3
    __ mov(r3, lr);
    __ br(target_reg);
  
#line 29383 "ad_aarch64.cpp"
  }
}

void CreateExceptionNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint CreateExceptionNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void RethrowExceptionNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 3791 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    __ far_jump(RuntimeAddress(OptoRuntime::rethrow_stub()));
  
#line 29412 "ad_aarch64.cpp"
  }
}

void RetNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 3796 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
#ifdef ASSERT
    if (Compile::current()->max_vector_size() > 0) {
      __ verify_ptrue();
    }
#endif
    __ ret(lr);
  
#line 29433 "ad_aarch64.cpp"
  }
}

void ShouldNotReachHereNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16667 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    if (is_reachable()) {
      __ stop(_halt_reason);
    }
  
#line 29451 "ad_aarch64.cpp"
  }
}

void partialSubtypeCheckNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// sub
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// super
  {

#line 3672 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     Register sub_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* sub */);
     Register super_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* super */);
     Register temp_reg = as_Register(R2_enc);
     Register result_reg = as_Register(opnd_array(0)->reg(ra_,this)/* result */);

     Label miss;
     C2_MacroAssembler _masm(&cbuf);
     __ check_klass_subtype_slow_path(sub_reg, super_reg, temp_reg, result_reg,
                                     NULL, &miss,
                                     /*set_cond_codes:*/ true);
     if ((0x1 /*primary()*/)) {
       __ mov(result_reg, zr);
     }
     __ bind(miss);
  
#line 29480 "ad_aarch64.cpp"
  }
}

void partialSubtypeCheckVsZeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// sub
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// super
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 3672 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

     Register sub_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* sub */);
     Register super_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* super */);
     Register temp_reg = as_Register(R2_enc);
     Register result_reg = as_Register(R5_enc);

     Label miss;
     C2_MacroAssembler _masm(&cbuf);
     __ check_klass_subtype_slow_path(sub_reg, super_reg, temp_reg, result_reg,
                                     NULL, &miss,
                                     /*set_cond_codes:*/ true);
     if ((0x0 /*primary()*/)) {
       __ mov(result_reg, zr);
     }
     __ bind(miss);
  
#line 29510 "ad_aarch64.cpp"
  }
}

void string_compareUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16724 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    // Count is in 8-bit bytes; non-Compact chars are 16 bits.
    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      as_Register(R10_enc), as_Register(R11_enc),
                      fnoreg, fnoreg, fnoreg, pnoreg, pnoreg, StrIntrinsicNode::UU);
  
#line 29533 "ad_aarch64.cpp"
  }
}

void string_compareLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16742 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      as_Register(R10_enc), as_Register(R11_enc),
                      fnoreg, fnoreg, fnoreg, pnoreg, pnoreg, StrIntrinsicNode::LL);
  
#line 29555 "ad_aarch64.cpp"
  }
}

void string_compareULNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16761 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      as_Register(R10_enc), as_Register(R11_enc),
                      as_FloatRegister(V0_enc), as_FloatRegister(V1_enc),
                      as_FloatRegister(V2_enc), pnoreg, pnoreg, StrIntrinsicNode::UL);
  
#line 29578 "ad_aarch64.cpp"
  }
}

void string_compareLUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16781 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      as_Register(R10_enc), as_Register(R11_enc),
                      as_FloatRegister(V0_enc), as_FloatRegister(V1_enc),
                      as_FloatRegister(V2_enc), pnoreg, pnoreg, StrIntrinsicNode::LU);
  
#line 29601 "ad_aarch64.cpp"
  }
}

void string_compareLL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// vtmp1
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// vtmp2
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// pgtmp1
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// pgtmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16806 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    // Count is in 8-bit bytes; non-Compact chars are 16 bits.
    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* vtmp1 */, opnd_array(8)->as_FloatRegister(ra_,this,idx8)/* vtmp2 */, fnoreg,
                      as_PRegister(opnd_array(9)->reg(ra_,this,idx9)/* pgtmp1 */), as_PRegister(opnd_array(10)->reg(ra_,this,idx10)/* pgtmp2 */),
                      StrIntrinsicNode::LL);
  
#line 29632 "ad_aarch64.cpp"
  }
}

void string_compareLU_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// vtmp1
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// vtmp2
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// pgtmp1
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// pgtmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16829 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    // Count is in 8-bit bytes; non-Compact chars are 16 bits.
    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* vtmp1 */, opnd_array(8)->as_FloatRegister(ra_,this,idx8)/* vtmp2 */, fnoreg,
                      as_PRegister(opnd_array(9)->reg(ra_,this,idx9)/* pgtmp1 */), as_PRegister(opnd_array(10)->reg(ra_,this,idx10)/* pgtmp2 */),
                      StrIntrinsicNode::LU);
  
#line 29663 "ad_aarch64.cpp"
  }
}

void string_compareUL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// vtmp1
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// vtmp2
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// pgtmp1
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// pgtmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16852 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    // Count is in 8-bit bytes; non-Compact chars are 16 bits.
    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* vtmp1 */, opnd_array(8)->as_FloatRegister(ra_,this,idx8)/* vtmp2 */, fnoreg,
                      as_PRegister(opnd_array(9)->reg(ra_,this,idx9)/* pgtmp1 */), as_PRegister(opnd_array(10)->reg(ra_,this,idx10)/* pgtmp2 */),
                      StrIntrinsicNode::UL);
  
#line 29694 "ad_aarch64.cpp"
  }
}

void string_compareUU_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// vtmp1
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// vtmp2
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// pgtmp1
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// pgtmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16875 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    // Count is in 8-bit bytes; non-Compact chars are 16 bits.
    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* vtmp1 */, opnd_array(8)->as_FloatRegister(ra_,this,idx8)/* vtmp2 */, fnoreg,
                      as_PRegister(opnd_array(9)->reg(ra_,this,idx9)/* pgtmp1 */), as_PRegister(opnd_array(10)->reg(ra_,this,idx10)/* pgtmp2 */),
                      StrIntrinsicNode::UU);
  
#line 29725 "ad_aarch64.cpp"
  }
}

void string_indexofUUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp4
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// tmp5
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// tmp6
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// vtmp0
  unsigned idx12 = idx11 + opnd_array(11)->num_edges(); 	// vtmp1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16900 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp4 */,
                      opnd_array(9)->as_Register(ra_,this,idx9)/* tmp5 */, opnd_array(10)->as_Register(ra_,this,idx10)/* tmp6 */,
                      -1, opnd_array(0)->as_Register(ra_,this)/* result */, StrIntrinsicNode::UU);
  
#line 29757 "ad_aarch64.cpp"
  }
}

void string_indexofLLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp4
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// tmp5
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// tmp6
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// vtmp0
  unsigned idx12 = idx11 + opnd_array(11)->num_edges(); 	// vtmp1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16924 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp4 */,
                      opnd_array(9)->as_Register(ra_,this,idx9)/* tmp5 */, opnd_array(10)->as_Register(ra_,this,idx10)/* tmp6 */,
                      -1, opnd_array(0)->as_Register(ra_,this)/* result */, StrIntrinsicNode::LL);
  
#line 29789 "ad_aarch64.cpp"
  }
}

void string_indexofULNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp4
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// tmp5
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// tmp6
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// vtmp0
  unsigned idx12 = idx11 + opnd_array(11)->num_edges(); 	// vtmp1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16948 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp4 */,
                      opnd_array(9)->as_Register(ra_,this,idx9)/* tmp5 */, opnd_array(10)->as_Register(ra_,this,idx10)/* tmp6 */,
                      -1, opnd_array(0)->as_Register(ra_,this)/* result */, StrIntrinsicNode::UL);
  
#line 29821 "ad_aarch64.cpp"
  }
}

void string_indexof_conUUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// int_cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16970 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    int icnt2 = (int)opnd_array(4)->constant();
    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, zr,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp4 */, zr, zr,
                      icnt2, opnd_array(0)->as_Register(ra_,this)/* result */, StrIntrinsicNode::UU);
  
#line 29849 "ad_aarch64.cpp"
  }
}

void string_indexof_conLLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// int_cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16992 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    int icnt2 = (int)opnd_array(4)->constant();
    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, zr,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp4 */, zr, zr,
                      icnt2, opnd_array(0)->as_Register(ra_,this)/* result */, StrIntrinsicNode::LL);
  
#line 29877 "ad_aarch64.cpp"
  }
}

void string_indexof_conULNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// int_cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17014 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    int icnt2 = (int)opnd_array(4)->constant();
    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, zr,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp4 */, zr, zr,
                      icnt2, opnd_array(0)->as_Register(ra_,this)/* result */, StrIntrinsicNode::UL);
  
#line 29905 "ad_aarch64.cpp"
  }
}

void string_indexof_charNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ch
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17036 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ string_indexof_char(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* ch */,
                           opnd_array(0)->as_Register(ra_,this)/* result */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp2 */,
                           opnd_array(6)->as_Register(ra_,this,idx6)/* tmp3 */);
  
#line 29928 "ad_aarch64.cpp"
  }
}

void stringL_indexof_charNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ch
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17055 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ stringL_indexof_char(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* ch */,
                            opnd_array(0)->as_Register(ra_,this)/* result */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp2 */,
                            opnd_array(6)->as_Register(ra_,this,idx6)/* tmp3 */);
  
#line 29951 "ad_aarch64.cpp"
  }
}

void stringL_indexof_char_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ch
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// ztmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// ztmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// pgtmp
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// ptmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17070 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ string_indexof_char_sve(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* ch */,
                               opnd_array(0)->as_Register(ra_,this)/* result */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* ztmp1 */,
                               opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* ztmp2 */, opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */,
                               opnd_array(7)->as_PRegister(ra_,this,idx7)/* ptmp */, true /* isL */);
  
#line 29976 "ad_aarch64.cpp"
  }
}

void stringU_indexof_char_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ch
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// ztmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// ztmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// pgtmp
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// ptmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17086 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ string_indexof_char_sve(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* ch */,
                               opnd_array(0)->as_Register(ra_,this)/* result */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* ztmp1 */,
                               opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* ztmp2 */, opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */,
                               opnd_array(7)->as_PRegister(ra_,this,idx7)/* ptmp */, false /* isL */);
  
#line 30001 "ad_aarch64.cpp"
  }
}

void string_equalsLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// str2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17103 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    // Count is in 8-bit bytes; non-Compact chars are 16 bits.
    __ string_equals(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* str2 */,
                     opnd_array(0)->as_Register(ra_,this)/* result */, opnd_array(3)->as_Register(ra_,this,idx3)/* cnt */, 1);
  
#line 30021 "ad_aarch64.cpp"
  }
}

void string_equalsUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// str2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17119 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    // Count is in 8-bit bytes; non-Compact chars are 16 bits.
    __ string_equals(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* str2 */,
                     opnd_array(0)->as_Register(ra_,this)/* result */, opnd_array(3)->as_Register(ra_,this,idx3)/* cnt */, 2);
  
#line 30041 "ad_aarch64.cpp"
  }
}

void array_equalsBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ary2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// vtmp0
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// vtmp1
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// vtmp2
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// vtmp3
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// vtmp4
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// vtmp5
  unsigned idx12 = idx11 + opnd_array(11)->num_edges(); 	// vtmp6
  unsigned idx13 = idx12 + opnd_array(12)->num_edges(); 	// vtmp7
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17140 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    address tpc = __ arrays_equals(opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* ary2 */,
                                   opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp3 */,
                                   opnd_array(0)->as_Register(ra_,this)/* result */, as_Register(R10_enc), 1);
    if (tpc == NULL) {
      ciEnv::current()->record_failure("CodeCache is full");
      return;
    }
  
#line 30075 "ad_aarch64.cpp"
  }
}

void array_equalsCNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ary2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// vtmp0
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// vtmp1
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// vtmp2
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// vtmp3
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// vtmp4
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// vtmp5
  unsigned idx12 = idx11 + opnd_array(11)->num_edges(); 	// vtmp6
  unsigned idx13 = idx12 + opnd_array(12)->num_edges(); 	// vtmp7
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17165 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    address tpc = __ arrays_equals(opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* ary2 */,
                                   opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp3 */,
                                   opnd_array(0)->as_Register(ra_,this)/* result */, as_Register(R10_enc), 2);
    if (tpc == NULL) {
      ciEnv::current()->record_failure("CodeCache is full");
      return;
    }
  
#line 30109 "ad_aarch64.cpp"
  }
}

void count_positivesNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// len
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17182 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    address tpc = __ count_positives(opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* len */, opnd_array(0)->as_Register(ra_,this)/* result */);
    if (tpc == NULL) {
      ciEnv::current()->record_failure("CodeCache is full");
      return;
    }
  
#line 30130 "ad_aarch64.cpp"
  }
}

void string_compressNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp0
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// vtmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// vtmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// vtmp4
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// vtmp5
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17203 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ char_array_compress(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                           opnd_array(0)->as_Register(ra_,this)/* result */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* vtmp0 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* vtmp1 */,
                           opnd_array(6)->as_FloatRegister(ra_,this,idx6)/* vtmp2 */, opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* vtmp3 */,
                           opnd_array(8)->as_FloatRegister(ra_,this,idx8)/* vtmp4 */, opnd_array(9)->as_FloatRegister(ra_,this,idx9)/* vtmp5 */);
  
#line 30157 "ad_aarch64.cpp"
  }
}

void string_inflateNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp0
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// vtmp1
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// vtmp2
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// vtmp3
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// vtmp4
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// vtmp5
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// vtmp6
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17223 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    address tpc = __ byte_array_inflate(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                                        opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* vtmp0 */, opnd_array(6)->as_FloatRegister(ra_,this,idx6)/* vtmp1 */,
                                        opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* vtmp2 */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */);
    if (tpc == NULL) {
      ciEnv::current()->record_failure("CodeCache is full");
      return;
    }
  
#line 30189 "ad_aarch64.cpp"
  }
}

void encode_iso_arrayNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17247 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ encode_iso_array(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                        opnd_array(0)->as_Register(ra_,this)/* result */, false,
                        as_FloatRegister(V0_enc), as_FloatRegister(V1_enc),
                        as_FloatRegister(V2_enc), as_FloatRegister(V3_enc),
                        as_FloatRegister(V4_enc), as_FloatRegister(V5_enc));
  
#line 30211 "ad_aarch64.cpp"
  }
}

void encode_ascii_arrayNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17268 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ encode_iso_array(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                        opnd_array(0)->as_Register(ra_,this)/* result */, true,
                        as_FloatRegister(V0_enc), as_FloatRegister(V1_enc),
                        as_FloatRegister(V2_enc), as_FloatRegister(V3_enc),
                        as_FloatRegister(V4_enc), as_FloatRegister(V5_enc));
  
#line 30233 "ad_aarch64.cpp"
  }
}

void compressBitsI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tdst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tsrc
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17289 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mov(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, __ S, 0, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ mov(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */, __ S, 0, opnd_array(2)->as_Register(ra_,this,idx2)/* mask */);
    __ sve_bext(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ S, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ S, 0);
  
#line 30256 "ad_aarch64.cpp"
  }
}

void compressBitsI_memconNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tdst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tsrc
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17307 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrs, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(1)->opcode(),
              as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
    __ ldrs(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */, InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ sve_bext(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ S, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ S, 0);
  
#line 30280 "ad_aarch64.cpp"
  }
}

void compressBitsI_memconNode::eval_constant(Compile* C) {
  {

#line 17310 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 30289 "ad_aarch64.cpp"
  }
}
void compressBitsL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tdst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tsrc
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17326 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mov(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, __ D, 0, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ mov(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */, __ D, 0, opnd_array(2)->as_Register(ra_,this,idx2)/* mask */);
    __ sve_bext(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ D, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ D, 0);
  
#line 30311 "ad_aarch64.cpp"
  }
}

void compressBitsL_memconNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tdst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tsrc
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17344 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrd, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(1)->opcode(),
              as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
    __ ldrd(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */, InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ sve_bext(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ D, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ D, 0);
  
#line 30335 "ad_aarch64.cpp"
  }
}

void compressBitsL_memconNode::eval_constant(Compile* C) {
  {

#line 17347 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 30344 "ad_aarch64.cpp"
  }
}
void expandBitsI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tdst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tsrc
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17363 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mov(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, __ S, 0, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ mov(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */, __ S, 0, opnd_array(2)->as_Register(ra_,this,idx2)/* mask */);
    __ sve_bdep(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ S, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ S, 0);
  
#line 30366 "ad_aarch64.cpp"
  }
}

void expandBitsI_memconNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tdst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tsrc
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17381 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrs, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(1)->opcode(),
              as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
    __ ldrs(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */, InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ sve_bdep(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ S, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ S, 0);
  
#line 30390 "ad_aarch64.cpp"
  }
}

void expandBitsI_memconNode::eval_constant(Compile* C) {
  {

#line 17384 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 30399 "ad_aarch64.cpp"
  }
}
void expandBitsL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tdst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tsrc
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17400 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mov(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, __ D, 0, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ mov(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */, __ D, 0, opnd_array(2)->as_Register(ra_,this,idx2)/* mask */);
    __ sve_bdep(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ D, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ D, 0);
  
#line 30421 "ad_aarch64.cpp"
  }
}

void expandBitsL_memconNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tdst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tsrc
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17419 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrd, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(1)->opcode(),
              as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
    __ ldrd(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */, InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ sve_bdep(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ D, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ D, 0);
  
#line 30445 "ad_aarch64.cpp"
  }
}

void expandBitsL_memconNode::eval_constant(Compile* C) {
  {

#line 17422 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 30454 "ad_aarch64.cpp"
  }
}
void tlsLoadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint tlsLoadPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void loadV2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3056 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, MacroAssembler::H,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30483 "ad_aarch64.cpp"
  }
}

void storeV2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3080 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::str, src_reg, MacroAssembler::H,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30501 "ad_aarch64.cpp"
  }
}

void loadV4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3062 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, MacroAssembler::S,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30518 "ad_aarch64.cpp"
  }
}

void storeV4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3086 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::str, src_reg, MacroAssembler::S,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30536 "ad_aarch64.cpp"
  }
}

void loadV8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3068 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, MacroAssembler::D,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30553 "ad_aarch64.cpp"
  }
}

void storeV8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3092 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::str, src_reg, MacroAssembler::D,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30571 "ad_aarch64.cpp"
  }
}

void loadV16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3074 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, MacroAssembler::Q,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30588 "ad_aarch64.cpp"
  }
}

void storeV16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3098 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::str, src_reg, MacroAssembler::Q,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30606 "ad_aarch64.cpp"
  }
}

void loadVNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 414 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), /* is_store */ false,
                          opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, ptrue, bt, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30628 "ad_aarch64.cpp"
  }
}

void storeVNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 431 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), /* is_store */ true,
                          opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, ptrue, bt, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30651 "ad_aarch64.cpp"
  }
}

void loadV_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 449 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), /* is_store */ false, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */,
                          opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, bt, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30671 "ad_aarch64.cpp"
  }
}

void storeV_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 462 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), /* is_store */ true, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */,
                          opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, bt, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30692 "ad_aarch64.cpp"
  }
}

void vloadconNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 476 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    if (UseSVE == 0) {
      uint length_in_bytes = Matcher::vector_length_in_bytes(this);
      assert(length_in_bytes <= 16, "must be");
      // The iota indices are ordered by type B/S/I/L/F/D, and the offset between two types is 16.
      int offset = exact_log2(type2aelembytes(bt)) << 4;
      if (is_floating_point_type(bt)) {
        offset += 32;
      }
      __ lea(rscratch1, ExternalAddress(StubRoutines::aarch64::vector_iota_indices() + offset));
      if (length_in_bytes == 16) {
        __ ldrq(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, rscratch1);
      } else {
        __ ldrd(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, rscratch1);
      }
    } else {
      Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
      __ sve_index(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size, 0, 1);
      if (is_floating_point_type(bt)) {
        __ sve_scvtf(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size, ptrue, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size);
      }
    }
  
#line 30729 "ad_aarch64.cpp"
  }
}

void vaddBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 510 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ addv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_add(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 30753 "ad_aarch64.cpp"
  }
}

void vaddSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 526 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ addv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_add(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ H, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 30777 "ad_aarch64.cpp"
  }
}

void vaddINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 542 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ addv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_add(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 30801 "ad_aarch64.cpp"
  }
}

void vaddLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 558 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ addv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_add(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 30825 "ad_aarch64.cpp"
  }
}

void vaddFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 574 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fadd(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fadd(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 30849 "ad_aarch64.cpp"
  }
}

void vaddDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 590 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fadd(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fadd(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 30873 "ad_aarch64.cpp"
  }
}

void vaddB_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 609 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_add(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ B, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 30891 "ad_aarch64.cpp"
  }
}

void vaddS_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 619 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_add(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ H, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 30909 "ad_aarch64.cpp"
  }
}

void vaddI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 629 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_add(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 30927 "ad_aarch64.cpp"
  }
}

void vaddL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 639 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_add(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 30945 "ad_aarch64.cpp"
  }
}

void vaddF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 649 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fadd(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 30963 "ad_aarch64.cpp"
  }
}

void vaddD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 659 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fadd(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 30981 "ad_aarch64.cpp"
  }
}

void vaddImmBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 671 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int val = (int)opnd_array(2)->constant();
    if (val > 0) {
      __ sve_add(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ B, val);
    } else {
      __ sve_sub(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ B, -val);
    }
  
#line 31003 "ad_aarch64.cpp"
  }
}

void vaddImmB_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 671 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int val = (int)opnd_array(1)->constant();
    if (val > 0) {
      __ sve_add(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ B, val);
    } else {
      __ sve_sub(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ B, -val);
    }
  
#line 31025 "ad_aarch64.cpp"
  }
}

void vaddImmSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 686 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int val = (int)opnd_array(2)->constant();
    if (val > 0) {
      __ sve_add(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ H, val);
    } else {
      __ sve_sub(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ H, -val);
    }
  
#line 31047 "ad_aarch64.cpp"
  }
}

void vaddImmS_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 686 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int val = (int)opnd_array(1)->constant();
    if (val > 0) {
      __ sve_add(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ H, val);
    } else {
      __ sve_sub(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ H, -val);
    }
  
#line 31069 "ad_aarch64.cpp"
  }
}

void vaddImmINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 701 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int val = (int)opnd_array(2)->constant();
    if (val > 0) {
      __ sve_add(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ S, val);
    } else {
      __ sve_sub(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ S, -val);
    }
  
#line 31091 "ad_aarch64.cpp"
  }
}

void vaddImmI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 701 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int val = (int)opnd_array(1)->constant();
    if (val > 0) {
      __ sve_add(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ S, val);
    } else {
      __ sve_sub(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ S, -val);
    }
  
#line 31113 "ad_aarch64.cpp"
  }
}

void vaddImmLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 716 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int val = (int)opnd_array(2)->constantL();
    if (val > 0) {
      __ sve_add(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D, val);
    } else {
      __ sve_sub(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D, -val);
    }
  
#line 31135 "ad_aarch64.cpp"
  }
}

void vaddImmL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 716 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int val = (int)opnd_array(1)->constantL();
    if (val > 0) {
      __ sve_add(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ D, val);
    } else {
      __ sve_sub(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ D, -val);
    }
  
#line 31157 "ad_aarch64.cpp"
  }
}

void vsubBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 734 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ subv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_sub(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 31181 "ad_aarch64.cpp"
  }
}

void vsubSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 750 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ subv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_sub(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ H, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 31205 "ad_aarch64.cpp"
  }
}

void vsubINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 766 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ subv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_sub(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 31229 "ad_aarch64.cpp"
  }
}

void vsubLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 782 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ subv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_sub(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 31253 "ad_aarch64.cpp"
  }
}

void vsubFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 798 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fsub(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fsub(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 31277 "ad_aarch64.cpp"
  }
}

void vsubDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 814 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fsub(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fsub(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 31301 "ad_aarch64.cpp"
  }
}

void vsubB_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 833 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_sub(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ B, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31319 "ad_aarch64.cpp"
  }
}

void vsubS_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 843 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_sub(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ H, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31337 "ad_aarch64.cpp"
  }
}

void vsubI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 853 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_sub(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31355 "ad_aarch64.cpp"
  }
}

void vsubL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 863 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_sub(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31373 "ad_aarch64.cpp"
  }
}

void vsubF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 873 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fsub(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31391 "ad_aarch64.cpp"
  }
}

void vsubD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 883 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fsub(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31409 "ad_aarch64.cpp"
  }
}

void vmulB_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 897 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ mulv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31427 "ad_aarch64.cpp"
  }
}

void vmulB_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 908 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_mul(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ B, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31445 "ad_aarch64.cpp"
  }
}

void vmulS_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 919 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ mulv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31463 "ad_aarch64.cpp"
  }
}

void vmulS_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 930 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_mul(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ H, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31481 "ad_aarch64.cpp"
  }
}

void vmulI_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 941 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ mulv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31499 "ad_aarch64.cpp"
  }
}

void vmulI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 952 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_mul(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31517 "ad_aarch64.cpp"
  }
}

void vmulL_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 965 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == 16, "must be");
    __ umov(rscratch1, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, __ D, 0);
    __ umov(rscratch2, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, __ D, 0);
    __ mul(rscratch2, rscratch2, rscratch1);
    __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, 0, rscratch2);
    __ umov(rscratch1, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, __ D, 1);
    __ umov(rscratch2, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, __ D, 1);
    __ mul(rscratch2, rscratch2, rscratch1);
    __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, 1, rscratch2);
  
#line 31543 "ad_aarch64.cpp"
  }
}

void vmulL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 984 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_mul(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31560 "ad_aarch64.cpp"
  }
}

void vmulFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 995 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fmul(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fmul(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 31584 "ad_aarch64.cpp"
  }
}

void vmulDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1011 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fmul(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fmul(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 31608 "ad_aarch64.cpp"
  }
}

void vmulB_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1030 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_mul(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ B, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31626 "ad_aarch64.cpp"
  }
}

void vmulS_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1040 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_mul(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ H, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31644 "ad_aarch64.cpp"
  }
}

void vmulI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1050 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_mul(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31662 "ad_aarch64.cpp"
  }
}

void vmulL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1060 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_mul(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31680 "ad_aarch64.cpp"
  }
}

void vmulF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1070 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fmul(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31698 "ad_aarch64.cpp"
  }
}

void vmulD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1080 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fmul(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31716 "ad_aarch64.cpp"
  }
}

void vdivF_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1094 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ fdiv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31734 "ad_aarch64.cpp"
  }
}

void vdivF_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1105 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_fdiv(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31752 "ad_aarch64.cpp"
  }
}

void vdivD_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1116 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ fdiv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31770 "ad_aarch64.cpp"
  }
}

void vdivD_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1127 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_fdiv(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31788 "ad_aarch64.cpp"
  }
}

void vdivF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1140 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fdiv(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31806 "ad_aarch64.cpp"
  }
}

void vdivD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1150 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fdiv(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31824 "ad_aarch64.cpp"
  }
}

void vandNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1163 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ andr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_and(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 31848 "ad_aarch64.cpp"
  }
}

void vand_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1182 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_and(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31868 "ad_aarch64.cpp"
  }
}

void vandImmBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1196 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_and(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ B, (uint64_t)(opnd_array(2)->constant()));
  
#line 31885 "ad_aarch64.cpp"
  }
}

void vandImmB_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1196 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_and(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ B, (uint64_t)(opnd_array(1)->constant()));
  
#line 31902 "ad_aarch64.cpp"
  }
}

void vandImmSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1206 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_and(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ H, (uint64_t)(opnd_array(2)->constant()));
  
#line 31919 "ad_aarch64.cpp"
  }
}

void vandImmS_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1206 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_and(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ H, (uint64_t)(opnd_array(1)->constant()));
  
#line 31936 "ad_aarch64.cpp"
  }
}

void vandImmINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1216 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_and(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ S, (uint64_t)(opnd_array(2)->constant()));
  
#line 31953 "ad_aarch64.cpp"
  }
}

void vandImmI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1216 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_and(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ S, (uint64_t)(opnd_array(1)->constant()));
  
#line 31970 "ad_aarch64.cpp"
  }
}

void vandImmLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1226 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_and(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D, (uint64_t)(opnd_array(2)->constantL()));
  
#line 31987 "ad_aarch64.cpp"
  }
}

void vandImmL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1226 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_and(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ D, (uint64_t)(opnd_array(1)->constantL()));
  
#line 32004 "ad_aarch64.cpp"
  }
}

void vorNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1239 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 32028 "ad_aarch64.cpp"
  }
}

void vor_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1258 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_orr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 32048 "ad_aarch64.cpp"
  }
}

void vorImmBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1272 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_orr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ B, (uint64_t)(opnd_array(2)->constant()));
  
#line 32065 "ad_aarch64.cpp"
  }
}

void vorImmB_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1272 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_orr(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ B, (uint64_t)(opnd_array(1)->constant()));
  
#line 32082 "ad_aarch64.cpp"
  }
}

void vorImmSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1282 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_orr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ H, (uint64_t)(opnd_array(2)->constant()));
  
#line 32099 "ad_aarch64.cpp"
  }
}

void vorImmS_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1282 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_orr(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ H, (uint64_t)(opnd_array(1)->constant()));
  
#line 32116 "ad_aarch64.cpp"
  }
}

void vorImmINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1292 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_orr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ S, (uint64_t)(opnd_array(2)->constant()));
  
#line 32133 "ad_aarch64.cpp"
  }
}

void vorImmI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1292 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_orr(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ S, (uint64_t)(opnd_array(1)->constant()));
  
#line 32150 "ad_aarch64.cpp"
  }
}

void vorImmLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1302 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_orr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D, (uint64_t)(opnd_array(2)->constantL()));
  
#line 32167 "ad_aarch64.cpp"
  }
}

void vorImmL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1302 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_orr(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ D, (uint64_t)(opnd_array(1)->constantL()));
  
#line 32184 "ad_aarch64.cpp"
  }
}

void vxorNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1315 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 32208 "ad_aarch64.cpp"
  }
}

void vxor_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1334 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_eor(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 32228 "ad_aarch64.cpp"
  }
}

void vxorImmBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1348 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ B, (uint64_t)(opnd_array(2)->constant()));
  
#line 32245 "ad_aarch64.cpp"
  }
}

void vxorImmB_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1348 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ B, (uint64_t)(opnd_array(1)->constant()));
  
#line 32262 "ad_aarch64.cpp"
  }
}

void vxorImmSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1358 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ H, (uint64_t)(opnd_array(2)->constant()));
  
#line 32279 "ad_aarch64.cpp"
  }
}

void vxorImmS_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1358 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ H, (uint64_t)(opnd_array(1)->constant()));
  
#line 32296 "ad_aarch64.cpp"
  }
}

void vxorImmINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1368 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ S, (uint64_t)(opnd_array(2)->constant()));
  
#line 32313 "ad_aarch64.cpp"
  }
}

void vxorImmI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1368 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ S, (uint64_t)(opnd_array(1)->constant()));
  
#line 32330 "ad_aarch64.cpp"
  }
}

void vxorImmLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1378 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D, (uint64_t)(opnd_array(2)->constantL()));
  
#line 32347 "ad_aarch64.cpp"
  }
}

void vxorImmL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1378 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ D, (uint64_t)(opnd_array(1)->constantL()));
  
#line 32364 "ad_aarch64.cpp"
  }
}

void veor3_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1391 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ eor3(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T16B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */,
            opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 32383 "ad_aarch64.cpp"
  }
}

void veor3_neon_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1391 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ eor3(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T16B, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */,
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src3 */);
  
#line 32402 "ad_aarch64.cpp"
  }
}

void veor3_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1402 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor3(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 32420 "ad_aarch64.cpp"
  }
}

void veor3_sve_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst_src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1402 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor3(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst_src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src3 */);
  
#line 32438 "ad_aarch64.cpp"
  }
}

void vnotINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1417 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ notr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_not(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 32462 "ad_aarch64.cpp"
  }
}

void vnotI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1417 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ notr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_not(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */);
    }
  
#line 32486 "ad_aarch64.cpp"
  }
}

void vnotI_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1417 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ notr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_not(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 32510 "ad_aarch64.cpp"
  }
}

void vnotI_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1417 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ notr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_not(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */);
    }
  
#line 32534 "ad_aarch64.cpp"
  }
}

void vnotI_3Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1417 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ notr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_not(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 32558 "ad_aarch64.cpp"
  }
}

void vnotI_4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1417 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ notr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_not(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */);
    }
  
#line 32582 "ad_aarch64.cpp"
  }
}

void vnotLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1433 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ notr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_not(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 32606 "ad_aarch64.cpp"
  }
}

void vnotL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1433 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ notr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_not(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */);
    }
  
#line 32630 "ad_aarch64.cpp"
  }
}

void vnotI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1454 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_not(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 32650 "ad_aarch64.cpp"
  }
}

void vnotI_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1454 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_not(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 32670 "ad_aarch64.cpp"
  }
}

void vnotI_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1454 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_not(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 32690 "ad_aarch64.cpp"
  }
}

void vnotL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1466 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_not(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 32710 "ad_aarch64.cpp"
  }
}

void vand_notINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1483 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 32735 "ad_aarch64.cpp"
  }
}

void vand_notI_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1483 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
    }
  
#line 32760 "ad_aarch64.cpp"
  }
}

void vand_notI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1483 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
    }
  
#line 32785 "ad_aarch64.cpp"
  }
}

void vand_notI_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1483 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 32810 "ad_aarch64.cpp"
  }
}

void vand_notI_3Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1483 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 32835 "ad_aarch64.cpp"
  }
}

void vand_notI_5Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1483 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
    }
  
#line 32860 "ad_aarch64.cpp"
  }
}

void vand_notI_4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1483 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
    }
  
#line 32885 "ad_aarch64.cpp"
  }
}

void vand_notI_6Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1483 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 32910 "ad_aarch64.cpp"
  }
}

void vand_notI_7Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1483 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 32935 "ad_aarch64.cpp"
  }
}

void vand_notI_9Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1483 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
    }
  
#line 32960 "ad_aarch64.cpp"
  }
}

void vand_notI_8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1483 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
    }
  
#line 32985 "ad_aarch64.cpp"
  }
}

void vand_notI_10Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1483 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 33010 "ad_aarch64.cpp"
  }
}

void vand_notLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1499 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 33035 "ad_aarch64.cpp"
  }
}

void vand_notL_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1499 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
    }
  
#line 33060 "ad_aarch64.cpp"
  }
}

void vand_notL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1499 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
    }
  
#line 33085 "ad_aarch64.cpp"
  }
}

void vand_notL_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1499 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 33110 "ad_aarch64.cpp"
  }
}

void vand_notI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1520 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_bic(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 33131 "ad_aarch64.cpp"
  }
}

void vand_notI_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1520 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_bic(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 33152 "ad_aarch64.cpp"
  }
}

void vand_notI_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1520 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_bic(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 33173 "ad_aarch64.cpp"
  }
}

void vand_notI_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1520 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_bic(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 33194 "ad_aarch64.cpp"
  }
}

void vand_notI_masked_3Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1520 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_bic(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 33215 "ad_aarch64.cpp"
  }
}

void vand_notI_masked_4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1520 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_bic(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 33236 "ad_aarch64.cpp"
  }
}

void vand_notL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1532 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_bic(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 33257 "ad_aarch64.cpp"
  }
}

void vand_notL_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1532 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_bic(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 33278 "ad_aarch64.cpp"
  }
}

void vabsBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1547 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ absr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_abs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ B, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 33300 "ad_aarch64.cpp"
  }
}

void vabsSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1562 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ absr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_abs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ H, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 33322 "ad_aarch64.cpp"
  }
}

void vabsINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1577 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ absr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_abs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 33344 "ad_aarch64.cpp"
  }
}

void vabsLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1592 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ absr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_abs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 33366 "ad_aarch64.cpp"
  }
}

void vabsFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1607 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fabs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fabs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 33388 "ad_aarch64.cpp"
  }
}

void vabsDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1622 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fabs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fabs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 33410 "ad_aarch64.cpp"
  }
}

void vabsB_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1640 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_abs(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ B, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 33427 "ad_aarch64.cpp"
  }
}

void vabsS_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1650 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_abs(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ H, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 33444 "ad_aarch64.cpp"
  }
}

void vabsI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1660 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_abs(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ S, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 33461 "ad_aarch64.cpp"
  }
}

void vabsL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1670 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_abs(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 33478 "ad_aarch64.cpp"
  }
}

void vabsF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1680 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fabs(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ S, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 33495 "ad_aarch64.cpp"
  }
}

void vabsD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1690 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fabs(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 33512 "ad_aarch64.cpp"
  }
}

void vfabd_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1705 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ fabd(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 33530 "ad_aarch64.cpp"
  }
}

void vfabd_neon_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1705 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ fabd(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 33548 "ad_aarch64.cpp"
  }
}

void vfabd_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1717 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fabd(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 33568 "ad_aarch64.cpp"
  }
}

void vfabd_sve_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1717 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fabd(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 33588 "ad_aarch64.cpp"
  }
}

void vfabd_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1733 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fabd(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 33608 "ad_aarch64.cpp"
  }
}

void vfabd_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1733 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fabd(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 33628 "ad_aarch64.cpp"
  }
}

void vnegINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1748 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ negr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      BasicType bt = Matcher::vector_element_basic_type(this);
      __ sve_neg(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 33652 "ad_aarch64.cpp"
  }
}

void vnegLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1765 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ negr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_neg(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 33674 "ad_aarch64.cpp"
  }
}

void vnegFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1780 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fneg(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fneg(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 33696 "ad_aarch64.cpp"
  }
}

void vnegDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1795 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fneg(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fneg(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 33718 "ad_aarch64.cpp"
  }
}

void vnegI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1813 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_neg(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 33737 "ad_aarch64.cpp"
  }
}

void vnegL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1825 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_neg(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 33754 "ad_aarch64.cpp"
  }
}

void vnegF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1835 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fneg(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ S, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 33771 "ad_aarch64.cpp"
  }
}

void vnegD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1845 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fneg(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 33788 "ad_aarch64.cpp"
  }
}

void vsqrtFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1858 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fsqrt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fsqrt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 33810 "ad_aarch64.cpp"
  }
}

void vsqrtDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1873 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fsqrt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fsqrt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 33832 "ad_aarch64.cpp"
  }
}

void vsqrtF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1891 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fsqrt(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ S, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 33849 "ad_aarch64.cpp"
  }
}

void vsqrtD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1901 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fsqrt(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 33866 "ad_aarch64.cpp"
  }
}

void vminL_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1916 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ cm(Assembler::GT, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T2D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ bsl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T16B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */);
  
#line 33885 "ad_aarch64.cpp"
  }
}

void vminL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1927 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_smin(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 33902 "ad_aarch64.cpp"
  }
}

void vmin_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1940 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    if (is_floating_point_type(bt)) {
      __ fmin(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(is_integral_type(bt) && bt != T_LONG, "unsupported type");
      __ minv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 33927 "ad_aarch64.cpp"
  }
}

void vmin_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1959 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    if (is_floating_point_type(bt)) {
      __ sve_fmin(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(is_integral_type(bt) && bt != T_LONG, "unsupported type");
      __ sve_smin(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 33953 "ad_aarch64.cpp"
  }
}

void vmin_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1980 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    if (is_floating_point_type(bt)) {
      __ sve_fmin(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(is_integral_type(bt), "unsupported type");
      __ sve_smin(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 33979 "ad_aarch64.cpp"
  }
}

void vmaxL_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2003 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ cm(Assembler::GT, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T2D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ bsl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T16B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 33998 "ad_aarch64.cpp"
  }
}

void vmaxL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2014 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_smax(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 34015 "ad_aarch64.cpp"
  }
}

void vmax_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2027 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    if (is_floating_point_type(bt)) {
      __ fmax(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(is_integral_type(bt) && bt != T_LONG, "unsupported type");
      __ maxv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 34040 "ad_aarch64.cpp"
  }
}

void vmax_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2046 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    if (is_floating_point_type(bt)) {
      __ sve_fmax(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(is_integral_type(bt) && bt != T_LONG, "unsupported type");
      __ sve_smax(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 34066 "ad_aarch64.cpp"
  }
}

void vmax_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2067 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    if (is_floating_point_type(bt)) {
      __ sve_fmax(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(is_integral_type(bt), "unsupported type");
      __ sve_smax(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 34092 "ad_aarch64.cpp"
  }
}

void vmlaNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2091 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ mlav(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_mla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 34119 "ad_aarch64.cpp"
  }
}

void vmla_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst_src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2091 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ mlav(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst_src1 */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_mla(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src3 */);
    }
  
#line 34146 "ad_aarch64.cpp"
  }
}

void vmla_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2091 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ mlav(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_mla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 34173 "ad_aarch64.cpp"
  }
}

void vmla_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst_src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2091 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ mlav(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst_src1 */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_mla(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src3 */);
    }
  
#line 34200 "ad_aarch64.cpp"
  }
}

void vmla_3Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2091 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ mlav(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_mla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 34227 "ad_aarch64.cpp"
  }
}

void vmla_4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst_src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2091 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ mlav(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst_src1 */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_mla(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src3 */);
    }
  
#line 34254 "ad_aarch64.cpp"
  }
}

void vmlaLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2110 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34274 "ad_aarch64.cpp"
  }
}

void vmlaL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst_src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2110 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mla(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst_src1 */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src3 */);
  
#line 34294 "ad_aarch64.cpp"
  }
}

void vmla_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2125 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34315 "ad_aarch64.cpp"
  }
}

void vmla_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2125 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34336 "ad_aarch64.cpp"
  }
}

void vmla_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2125 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34357 "ad_aarch64.cpp"
  }
}

void vmla_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2125 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34378 "ad_aarch64.cpp"
  }
}

void vfmlaNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2141 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fmla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      BasicType bt = Matcher::vector_element_basic_type(this);
      __ sve_fmla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 34405 "ad_aarch64.cpp"
  }
}

void vfmla_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2141 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fmla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      BasicType bt = Matcher::vector_element_basic_type(this);
      __ sve_fmla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 34432 "ad_aarch64.cpp"
  }
}

void vfmad_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2164 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fmad(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34453 "ad_aarch64.cpp"
  }
}

void vfmad_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2164 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fmad(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34474 "ad_aarch64.cpp"
  }
}

void vmlsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2180 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ mlsv(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_mls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 34501 "ad_aarch64.cpp"
  }
}

void vmls_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2180 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ mlsv(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_mls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 34528 "ad_aarch64.cpp"
  }
}

void vmls_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2180 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ mlsv(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_mls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 34555 "ad_aarch64.cpp"
  }
}

void vmlsLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2199 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34575 "ad_aarch64.cpp"
  }
}

void vmls_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2214 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34596 "ad_aarch64.cpp"
  }
}

void vmls_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2214 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34617 "ad_aarch64.cpp"
  }
}

void vmls_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2214 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34638 "ad_aarch64.cpp"
  }
}

void vmls_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2214 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34659 "ad_aarch64.cpp"
  }
}

void vfmls1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2230 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fmls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      BasicType bt = Matcher::vector_element_basic_type(this);
      __ sve_fmls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 34686 "ad_aarch64.cpp"
  }
}

void vfmls1_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2230 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fmls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      BasicType bt = Matcher::vector_element_basic_type(this);
      __ sve_fmls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 34713 "ad_aarch64.cpp"
  }
}

void vfmls2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2251 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fmls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      BasicType bt = Matcher::vector_element_basic_type(this);
      __ sve_fmls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 34740 "ad_aarch64.cpp"
  }
}

void vfmls2_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2251 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fmls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      BasicType bt = Matcher::vector_element_basic_type(this);
      __ sve_fmls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 34767 "ad_aarch64.cpp"
  }
}

void vfmsb_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2274 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fmsb(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34788 "ad_aarch64.cpp"
  }
}

void vfmsb_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2274 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fmsb(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34809 "ad_aarch64.cpp"
  }
}

void vfnmla1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2290 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fnmla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34829 "ad_aarch64.cpp"
  }
}

void vfnmla1_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2290 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fnmla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34849 "ad_aarch64.cpp"
  }
}

void vfnmla2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2304 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fnmla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34869 "ad_aarch64.cpp"
  }
}

void vfnmla2_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2304 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fnmla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34889 "ad_aarch64.cpp"
  }
}

void vfnmad_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2320 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fnmad(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34910 "ad_aarch64.cpp"
  }
}

void vfnmad_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2320 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fnmad(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34931 "ad_aarch64.cpp"
  }
}

void vfnmlsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2336 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fnmls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34951 "ad_aarch64.cpp"
  }
}

void vfnmls_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2336 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fnmls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34971 "ad_aarch64.cpp"
  }
}

void vfnmsb_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2352 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fnmsb(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34992 "ad_aarch64.cpp"
  }
}

void vfnmsb_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2352 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fnmsb(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 35013 "ad_aarch64.cpp"
  }
}

void vmuladdS2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2369 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ smullv(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, __ T4H, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ smullv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T8H, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ addpv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T4S, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 35034 "ad_aarch64.cpp"
  }
}

void vshiftcntLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cnt
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2413 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */);
    } else {
      assert(UseSVE > 0, "must be sve");
      BasicType bt = Matcher::vector_element_basic_type(this);
      __ sve_dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */);
    }
  
#line 35057 "ad_aarch64.cpp"
  }
}

void vshiftcntRNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cnt
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2429 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    if (UseSVE == 0) {
      uint length_in_bytes = Matcher::vector_length_in_bytes(this);
      assert(length_in_bytes <= 16, "must be");
      __ negw(rscratch1, opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */);
      __ dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), rscratch1);
    } else {
      BasicType bt = Matcher::vector_element_basic_type(this);
      __ sve_dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */);
    }
  
#line 35081 "ad_aarch64.cpp"
  }
}

void vlsl_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2452 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sshl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35099 "ad_aarch64.cpp"
  }
}

void vlsl_neon_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2452 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sshl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35117 "ad_aarch64.cpp"
  }
}

void vlsl_neon_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2452 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sshl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35135 "ad_aarch64.cpp"
  }
}

void vlsl_neon_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2452 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sshl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35153 "ad_aarch64.cpp"
  }
}

void vlsl_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2466 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35173 "ad_aarch64.cpp"
  }
}

void vlsl_sve_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2466 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35193 "ad_aarch64.cpp"
  }
}

void vlsl_sve_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2466 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35213 "ad_aarch64.cpp"
  }
}

void vlsl_sve_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2466 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35233 "ad_aarch64.cpp"
  }
}

void vasr_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2484 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sshl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35251 "ad_aarch64.cpp"
  }
}

void vasr_neon_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2484 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sshl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35269 "ad_aarch64.cpp"
  }
}

void vasr_neon_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2484 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sshl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35287 "ad_aarch64.cpp"
  }
}

void vasr_neon_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2484 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sshl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35305 "ad_aarch64.cpp"
  }
}

void vasr_neon_varNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2499 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ negr(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
            opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ sshl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 35327 "ad_aarch64.cpp"
  }
}

void vasr_neon_var_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2499 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ negr(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
            opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ sshl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 35349 "ad_aarch64.cpp"
  }
}

void vasr_neon_var_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2499 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ negr(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
            opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ sshl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 35371 "ad_aarch64.cpp"
  }
}

void vasr_neon_var_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2499 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ negr(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
            opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ sshl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 35393 "ad_aarch64.cpp"
  }
}

void vasr_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2516 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35412 "ad_aarch64.cpp"
  }
}

void vasr_sve_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2516 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35431 "ad_aarch64.cpp"
  }
}

void vasr_sve_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2516 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35450 "ad_aarch64.cpp"
  }
}

void vasr_sve_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2516 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35469 "ad_aarch64.cpp"
  }
}

void vlsr_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2533 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ ushl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35487 "ad_aarch64.cpp"
  }
}

void vlsr_neon_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2533 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ ushl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35505 "ad_aarch64.cpp"
  }
}

void vlsr_neon_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2533 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ ushl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35523 "ad_aarch64.cpp"
  }
}

void vlsr_neon_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2533 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ ushl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35541 "ad_aarch64.cpp"
  }
}

void vlsr_neon_varNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2548 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ negr(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
            opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ ushl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 35563 "ad_aarch64.cpp"
  }
}

void vlsr_neon_var_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2548 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ negr(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
            opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ ushl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 35585 "ad_aarch64.cpp"
  }
}

void vlsr_neon_var_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2548 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ negr(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
            opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ ushl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 35607 "ad_aarch64.cpp"
  }
}

void vlsr_neon_var_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2548 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ negr(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
            opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ ushl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 35629 "ad_aarch64.cpp"
  }
}

void vlsr_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2565 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35648 "ad_aarch64.cpp"
  }
}

void vlsr_sve_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2565 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35667 "ad_aarch64.cpp"
  }
}

void vlsr_sve_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2565 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35686 "ad_aarch64.cpp"
  }
}

void vlsr_sve_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2565 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 35705 "ad_aarch64.cpp"
  }
}

void vlsl_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2582 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Optimize for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) {
        if (VM_Version::use_neon_for_vector(length_in_bytes)) {
          __ eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        } else {
          assert(UseSVE > 0, "must be sve");
          __ sve_eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
        return;
      }
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ shl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_lsl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 35744 "ad_aarch64.cpp"
  }
}

void vlsl_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2582 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Optimize for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) {
        if (VM_Version::use_neon_for_vector(length_in_bytes)) {
          __ eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        } else {
          assert(UseSVE > 0, "must be sve");
          __ sve_eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
        return;
      }
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ shl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_lsl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 35783 "ad_aarch64.cpp"
  }
}

void vlsl_imm_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2582 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Optimize for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) {
        if (VM_Version::use_neon_for_vector(length_in_bytes)) {
          __ eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        } else {
          assert(UseSVE > 0, "must be sve");
          __ sve_eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
        return;
      }
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ shl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_lsl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 35822 "ad_aarch64.cpp"
  }
}

void vlsl_imm_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2582 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Optimize for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) {
        if (VM_Version::use_neon_for_vector(length_in_bytes)) {
          __ eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        } else {
          assert(UseSVE > 0, "must be sve");
          __ sve_eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
        return;
      }
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ shl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_lsl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 35861 "ad_aarch64.cpp"
  }
}

void vasr_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2617 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ sshr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_asr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 35891 "ad_aarch64.cpp"
  }
}

void vasr_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2617 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ sshr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_asr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 35921 "ad_aarch64.cpp"
  }
}

void vasr_imm_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2617 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ sshr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_asr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 35951 "ad_aarch64.cpp"
  }
}

void vasr_imm_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2617 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ sshr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_asr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 35981 "ad_aarch64.cpp"
  }
}

void vlsr_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2643 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Optimize for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) {
        if (VM_Version::use_neon_for_vector(length_in_bytes)) {
          __ eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        } else {
          assert(UseSVE > 0, "must be sve");
          __ sve_eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
        return;
      }
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ ushr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_lsr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 36020 "ad_aarch64.cpp"
  }
}

void vlsr_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2643 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Optimize for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) {
        if (VM_Version::use_neon_for_vector(length_in_bytes)) {
          __ eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        } else {
          assert(UseSVE > 0, "must be sve");
          __ sve_eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
        return;
      }
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ ushr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_lsr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 36059 "ad_aarch64.cpp"
  }
}

void vlsr_imm_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2643 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Optimize for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) {
        if (VM_Version::use_neon_for_vector(length_in_bytes)) {
          __ eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        } else {
          assert(UseSVE > 0, "must be sve");
          __ sve_eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
        return;
      }
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ ushr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_lsr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 36098 "ad_aarch64.cpp"
  }
}

void vlsr_imm_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2643 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Optimize for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) {
        if (VM_Version::use_neon_for_vector(length_in_bytes)) {
          __ eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        } else {
          assert(UseSVE > 0, "must be sve");
          __ sve_eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
        return;
      }
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ ushr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_lsr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 36137 "ad_aarch64.cpp"
  }
}

void vasra_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2680 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(3)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    __ ssra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
  
#line 36162 "ad_aarch64.cpp"
  }
}

void vasra_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2680 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    __ ssra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
  
#line 36187 "ad_aarch64.cpp"
  }
}

void vasra_imm_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2680 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(3)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    __ ssra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
  
#line 36212 "ad_aarch64.cpp"
  }
}

void vasra_imm_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2680 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    __ ssra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
  
#line 36237 "ad_aarch64.cpp"
  }
}

void vasra_imm_3Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2680 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(3)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    __ ssra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
  
#line 36262 "ad_aarch64.cpp"
  }
}

void vasra_imm_4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2680 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    __ ssra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
  
#line 36287 "ad_aarch64.cpp"
  }
}

void vasra_imm_5Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2680 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(3)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    __ ssra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
  
#line 36312 "ad_aarch64.cpp"
  }
}

void vasra_imm_6Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2680 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    __ ssra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
  
#line 36337 "ad_aarch64.cpp"
  }
}

void vlsra_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2700 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(3)->constant();
    if (is_subword_type(bt)) { // for B/H
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con < esize_in_bits) {
        __ usra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
      }
    } else { // for S/D
      assert(type2aelembytes(bt) == 4 || type2aelembytes(bt) == 8, "unsupported type");
      __ usra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
    }
  
#line 36365 "ad_aarch64.cpp"
  }
}

void vlsra_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2700 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) { // for B/H
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con < esize_in_bits) {
        __ usra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
      }
    } else { // for S/D
      assert(type2aelembytes(bt) == 4 || type2aelembytes(bt) == 8, "unsupported type");
      __ usra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 36393 "ad_aarch64.cpp"
  }
}

void vlsra_imm_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2700 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(3)->constant();
    if (is_subword_type(bt)) { // for B/H
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con < esize_in_bits) {
        __ usra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
      }
    } else { // for S/D
      assert(type2aelembytes(bt) == 4 || type2aelembytes(bt) == 8, "unsupported type");
      __ usra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
    }
  
#line 36421 "ad_aarch64.cpp"
  }
}

void vlsra_imm_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2700 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) { // for B/H
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con < esize_in_bits) {
        __ usra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
      }
    } else { // for S/D
      assert(type2aelembytes(bt) == 4 || type2aelembytes(bt) == 8, "unsupported type");
      __ usra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 36449 "ad_aarch64.cpp"
  }
}

void vlsra_imm_3Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2700 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(3)->constant();
    if (is_subword_type(bt)) { // for B/H
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con < esize_in_bits) {
        __ usra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
      }
    } else { // for S/D
      assert(type2aelembytes(bt) == 4 || type2aelembytes(bt) == 8, "unsupported type");
      __ usra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
    }
  
#line 36477 "ad_aarch64.cpp"
  }
}

void vlsra_imm_4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2700 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) { // for B/H
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con < esize_in_bits) {
        __ usra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
      }
    } else { // for S/D
      assert(type2aelembytes(bt) == 4 || type2aelembytes(bt) == 8, "unsupported type");
      __ usra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 36505 "ad_aarch64.cpp"
  }
}

void vlsra_imm_5Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2700 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(3)->constant();
    if (is_subword_type(bt)) { // for B/H
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con < esize_in_bits) {
        __ usra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
      }
    } else { // for S/D
      assert(type2aelembytes(bt) == 4 || type2aelembytes(bt) == 8, "unsupported type");
      __ usra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
    }
  
#line 36533 "ad_aarch64.cpp"
  }
}

void vlsra_imm_6Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2700 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) { // for B/H
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con < esize_in_bits) {
        __ usra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
      }
    } else { // for S/D
      assert(type2aelembytes(bt) == 4 || type2aelembytes(bt) == 8, "unsupported type");
      __ usra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 36561 "ad_aarch64.cpp"
  }
}

void vlsl_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2725 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 36581 "ad_aarch64.cpp"
  }
}

void vlsl_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2725 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 36601 "ad_aarch64.cpp"
  }
}

void vlsl_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2725 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 36621 "ad_aarch64.cpp"
  }
}

void vlsl_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2725 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 36641 "ad_aarch64.cpp"
  }
}

void vasr_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2740 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 36661 "ad_aarch64.cpp"
  }
}

void vasr_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2740 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 36681 "ad_aarch64.cpp"
  }
}

void vasr_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2740 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 36701 "ad_aarch64.cpp"
  }
}

void vasr_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2740 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 36721 "ad_aarch64.cpp"
  }
}

void vlsr_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2755 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 36741 "ad_aarch64.cpp"
  }
}

void vlsr_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2755 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 36761 "ad_aarch64.cpp"
  }
}

void vlsr_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2755 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 36781 "ad_aarch64.cpp"
  }
}

void vlsr_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2755 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 36801 "ad_aarch64.cpp"
  }
}

void vlsl_imm_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2772 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con >= 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 36824 "ad_aarch64.cpp"
  }
}

void vlsl_imm_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2772 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con >= 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 36847 "ad_aarch64.cpp"
  }
}

void vlsl_imm_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2772 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con >= 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 36870 "ad_aarch64.cpp"
  }
}

void vlsl_imm_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2772 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con >= 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 36893 "ad_aarch64.cpp"
  }
}

void vasr_imm_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2790 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con > 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 36916 "ad_aarch64.cpp"
  }
}

void vasr_imm_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2790 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con > 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 36939 "ad_aarch64.cpp"
  }
}

void vasr_imm_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2790 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con > 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 36962 "ad_aarch64.cpp"
  }
}

void vasr_imm_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2790 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con > 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 36985 "ad_aarch64.cpp"
  }
}

void vlsr_imm_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2808 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con > 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 37008 "ad_aarch64.cpp"
  }
}

void vlsr_imm_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2808 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con > 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 37031 "ad_aarch64.cpp"
  }
}

void vlsr_imm_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2808 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con > 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 37054 "ad_aarch64.cpp"
  }
}

void vlsr_imm_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2808 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con > 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 37077 "ad_aarch64.cpp"
  }
}

void reduce_addI_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2828 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_add_integral(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                                opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                                length_in_bytes, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 37100 "ad_aarch64.cpp"
  }
}

void reduce_addI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2843 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 37125 "ad_aarch64.cpp"
  }
}

void reduce_addL_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2862 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_add_integral(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                                opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                                length_in_bytes, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 37148 "ad_aarch64.cpp"
  }
}

void reduce_addL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2877 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 37173 "ad_aarch64.cpp"
  }
}

void reduce_add2F_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// fsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2898 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ faddp(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, __ S);
    __ fadds(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* fsrc */);
  
#line 37192 "ad_aarch64.cpp"
  }
}

void reduce_add4F_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// fsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2910 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ faddp(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, __ T4S, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
    __ faddp(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, __ S);
    __ fadds(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* fsrc */);
  
#line 37213 "ad_aarch64.cpp"
  }
}

void reduce_addF_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2922 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_fadda(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 37232 "ad_aarch64.cpp"
  }
}

void reduce_addD_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2939 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ faddp(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, __ D);
    __ faddd(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dsrc */);
  
#line 37251 "ad_aarch64.cpp"
  }
}

void reduce_addD_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2950 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_fadda(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 37270 "ad_aarch64.cpp"
  }
}

void reduce_addI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2965 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 37293 "ad_aarch64.cpp"
  }
}

void reduce_addL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2979 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 37316 "ad_aarch64.cpp"
  }
}

void reduce_addF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2992 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fadda(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S,
                 opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 37335 "ad_aarch64.cpp"
  }
}

void reduce_addD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3003 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fadda(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D,
                 opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 37354 "ad_aarch64.cpp"
  }
}

void reduce_mulINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3019 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_mul_integral(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt, opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */,
                                opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, length_in_bytes,
                                opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */);
  
#line 37378 "ad_aarch64.cpp"
  }
}

void reduce_mulLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3034 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ neon_reduce_mul_integral(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, T_LONG, opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */,
                                opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, 16, fnoreg, fnoreg);
  
#line 37397 "ad_aarch64.cpp"
  }
}

void reduce_mulFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// fsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3046 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_mul_fp(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, T_FLOAT, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* fsrc */,
                          opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, length_in_bytes, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 37418 "ad_aarch64.cpp"
  }
}

void reduce_mulDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3059 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ neon_reduce_mul_fp(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, T_DOUBLE, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dsrc */,
                          opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, 16, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 37438 "ad_aarch64.cpp"
  }
}

void reduce_andI_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3075 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_logical(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, length_in_bytes);
  
#line 37459 "ad_aarch64.cpp"
  }
}

void reduce_andI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3089 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 37483 "ad_aarch64.cpp"
  }
}

void reduce_andL_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3107 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_logical(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, length_in_bytes);
  
#line 37504 "ad_aarch64.cpp"
  }
}

void reduce_andL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3121 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 37528 "ad_aarch64.cpp"
  }
}

void reduce_andI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3139 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 37551 "ad_aarch64.cpp"
  }
}

void reduce_andL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3153 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 37574 "ad_aarch64.cpp"
  }
}

void reduce_orI_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3171 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_logical(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, length_in_bytes);
  
#line 37595 "ad_aarch64.cpp"
  }
}

void reduce_orI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3185 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 37619 "ad_aarch64.cpp"
  }
}

void reduce_orL_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3203 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_logical(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, length_in_bytes);
  
#line 37640 "ad_aarch64.cpp"
  }
}

void reduce_orL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3217 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 37664 "ad_aarch64.cpp"
  }
}

void reduce_orI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3235 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 37687 "ad_aarch64.cpp"
  }
}

void reduce_orL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3249 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 37710 "ad_aarch64.cpp"
  }
}

void reduce_xorI_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3267 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_logical(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, length_in_bytes);
  
#line 37731 "ad_aarch64.cpp"
  }
}

void reduce_xorI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3281 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 37755 "ad_aarch64.cpp"
  }
}

void reduce_xorL_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3299 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_logical(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, length_in_bytes);
  
#line 37776 "ad_aarch64.cpp"
  }
}

void reduce_xorL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3313 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 37800 "ad_aarch64.cpp"
  }
}

void reduce_xorI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3331 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 37823 "ad_aarch64.cpp"
  }
}

void reduce_xorL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3345 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 37846 "ad_aarch64.cpp"
  }
}

void reduce_maxI_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3367 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_minmax_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                                   opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                                   length_in_bytes, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 37869 "ad_aarch64.cpp"
  }
}

void reduce_maxI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3386 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 37894 "ad_aarch64.cpp"
  }
}

void reduce_maxL_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3405 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ neon_reduce_minmax_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, T_LONG,
                                   opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                                   /* vector_length_in_bytes */ 16, fnoreg);
  
#line 37914 "ad_aarch64.cpp"
  }
}

void reduce_maxL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3419 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, T_LONG,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 37937 "ad_aarch64.cpp"
  }
}

void reduce_maxFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// fsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3436 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      if (length_in_bytes == 8) {
        __ fmaxp(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, __ S);
      } else {
        __ fmaxv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T4S, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
      }
    } else {
      assert(UseSVE > 0, "must be sve");
      assert(length_in_bytes == MaxVectorSize, "invalid vector length");
      __ sve_fmaxv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ S, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
    }
    __ fmaxs(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* fsrc */);
  
#line 37967 "ad_aarch64.cpp"
  }
}

void reduce_maxDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3461 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fmaxp(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, __ D);
    } else {
      assert(UseSVE > 0, "must be sve");
      assert(length_in_bytes == MaxVectorSize, "invalid vector length");
      __ sve_fmaxv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ D, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
    }
    __ fmaxd(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dsrc */);
  
#line 37993 "ad_aarch64.cpp"
  }
}

void reduce_maxI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3486 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 38016 "ad_aarch64.cpp"
  }
}

void reduce_maxL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3501 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 38039 "ad_aarch64.cpp"
  }
}

void reduce_maxF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// fsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3515 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fmaxv(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ S, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
    __ fmaxs(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* fsrc */);
  
#line 38059 "ad_aarch64.cpp"
  }
}

void reduce_maxD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3527 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fmaxv(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ D, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
    __ fmaxd(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dsrc */);
  
#line 38079 "ad_aarch64.cpp"
  }
}

void reduce_minI_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3547 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_minmax_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                                   opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                                   length_in_bytes, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 38102 "ad_aarch64.cpp"
  }
}

void reduce_minI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3566 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 38127 "ad_aarch64.cpp"
  }
}

void reduce_minL_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3585 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ neon_reduce_minmax_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, T_LONG,
                                   opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                                   /* vector_length_in_bytes */ 16, fnoreg);
  
#line 38147 "ad_aarch64.cpp"
  }
}

void reduce_minL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3599 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, T_LONG,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 38170 "ad_aarch64.cpp"
  }
}

void reduce_minFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// fsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3616 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      if (length_in_bytes == 8) {
        __ fminp(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, __ S);
      } else {
        __ fminv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T4S, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
      }
    } else {
      assert(UseSVE > 0, "must be sve");
      assert(length_in_bytes == MaxVectorSize, "invalid vector length");
      __ sve_fminv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ S, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
    }
    __ fmins(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* fsrc */);
  
#line 38200 "ad_aarch64.cpp"
  }
}

void reduce_minDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3641 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fminp(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, __ D);
    } else {
      assert(UseSVE > 0, "must be sve");
      assert(length_in_bytes == MaxVectorSize, "invalid vector length");
      __ sve_fminv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ D, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
    }
    __ fmind(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dsrc */);
  
#line 38226 "ad_aarch64.cpp"
  }
}

void reduce_minI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3666 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 38249 "ad_aarch64.cpp"
  }
}

void reduce_minL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3681 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 38272 "ad_aarch64.cpp"
  }
}

void reduce_minF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// fsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3695 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fminv(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ S, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
    __ fmins(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* fsrc */);
  
#line 38292 "ad_aarch64.cpp"
  }
}

void reduce_minD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3707 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fminv(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ D, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
    __ fmind(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dsrc */);
  
#line 38312 "ad_aarch64.cpp"
  }
}

void reinterpret_same_sizeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  // User did not define which encode class to use.
}

void reinterpret_resize_le128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3731 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes_src = Matcher::vector_length_in_bytes(this, opnd_array(1));
    uint length_in_bytes_dst = Matcher::vector_length_in_bytes(this);
    // The higher bits in "dst" register must be cleared to zero.
    if ((length_in_bytes_src == 4 && length_in_bytes_dst == 8) ||
        (length_in_bytes_src == 8 && length_in_bytes_dst == 4)) {
      // Reinterpret between 32 bits and 64 bits
      __ dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else if ((length_in_bytes_src == 4 && length_in_bytes_dst == 16) ||
               (length_in_bytes_src == 16 && length_in_bytes_dst == 4)) {
      // Reinterpret between 32 bits and 128 bits
      __ dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else if ((length_in_bytes_src == 8 && length_in_bytes_dst == 16) ||
               (length_in_bytes_src == 16 && length_in_bytes_dst == 8)) {
      // Reinterpret between 64 bits and 128 bits
      __ orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T8B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(false, "invalid vector length");
      ShouldNotReachHere();
    }
  
#line 38354 "ad_aarch64.cpp"
  }
}

void reinterpret_resize_gt128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ptmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3762 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    uint length_in_bytes_src = Matcher::vector_length_in_bytes(this, opnd_array(1));
    uint length_in_bytes_dst = Matcher::vector_length_in_bytes(this);
    uint length_in_bytes_resize = length_in_bytes_src < length_in_bytes_dst ?
                                  length_in_bytes_src : length_in_bytes_dst;
    assert(length_in_bytes_src <= MaxVectorSize && length_in_bytes_dst <= MaxVectorSize,
           "invalid vector length");
    __ sve_gen_mask_imm(opnd_array(3)->as_PRegister(ra_,this,idx3)/* ptmp */, T_BYTE, length_in_bytes_resize);
    __ sve_dup(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ B, 0);
    __ sve_sel(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ B, opnd_array(3)->as_PRegister(ra_,this,idx3)/* ptmp */,
               opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */);
  
#line 38382 "ad_aarch64.cpp"
  }
}

void vcvtBtoXNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3785 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      // 4B to 4S/4I/4F, 8B to 8S
      __ neon_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, bt == T_FLOAT ? T_INT : bt,
                            length_in_bytes, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, T_BYTE);
      if (bt == T_FLOAT) {
        __ scvtfv(__ T4S, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
      }
    } else {
      assert(UseSVE > 0, "must be sve");
      Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
      __ sve_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ B);
      if (is_floating_point_type(bt)) {
        __ sve_scvtf(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size, ptrue, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size);
      }
    }
  
#line 38414 "ad_aarch64.cpp"
  }
}

void vcvtStoB_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3814 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // 4S/8S to 4B/8B
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    __ neon_vector_narrow(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, T_BYTE,
                          opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, T_SHORT, length_in_bytes);
  
#line 38433 "ad_aarch64.cpp"
  }
}

void vcvtStoB_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3829 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_vector_narrow(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ B,
                         opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ H, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
  
#line 38452 "ad_aarch64.cpp"
  }
}

void vcvtStoX_extendNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3841 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      // 4S to 4I/4F
      __ neon_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, T_INT, length_in_bytes,
                            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, T_SHORT);
      if (bt == T_FLOAT) {
        __ scvtfv(__ T4S, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
      }
    } else {
      assert(UseSVE > 0, "must be sve");
      Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
      __ sve_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ H);
      if (is_floating_point_type(bt)) {
        __ sve_scvtf(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size, ptrue, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size);
      }
    }
  
#line 38484 "ad_aarch64.cpp"
  }
}

void vcvtItoX_narrow_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3872 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // 4I to 4B/4S
    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    __ neon_vector_narrow(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, bt,
                          opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, T_INT, length_in_bytes);
  
#line 38505 "ad_aarch64.cpp"
  }
}

void vcvtItoX_narrow_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3889 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_vector_narrow(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ elemType_to_regVariant(bt),
                         opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ S, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 38526 "ad_aarch64.cpp"
  }
}

void vcvtItoXNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3902 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes =  Matcher::vector_length_in_bytes(this);
    if (bt == T_FLOAT) {
      if (VM_Version::use_neon_for_vector(length_in_bytes)) {
        // 2I/4I to 2F/4F
        __ scvtfv(get_arrangement(this), opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      } else {
        assert(UseSVE > 0, "must be sve");
        __ sve_scvtf(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ S);
      }
    } else {
      assert(type2aelembytes(bt) == 8, "unsupported type");
      if (VM_Version::use_neon_for_vector(length_in_bytes)) {
        // 2I to 2L/2D
        __ neon_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, T_LONG, length_in_bytes,
                              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, T_INT);
        if (bt == T_DOUBLE) {
          __ scvtfv(__ T2D, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
        }
      } else {
        assert(UseSVE > 0, "must be sve");
        __ sve_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ S);
        if (bt == T_DOUBLE) {
          __ sve_scvtf(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D);
        }
      }
    }
  
#line 38568 "ad_aarch64.cpp"
  }
}

void vcvtLtoI_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3941 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // 2L to 2I
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    __ neon_vector_narrow(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, T_INT,
                          opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, T_LONG, length_in_bytes);
  
#line 38587 "ad_aarch64.cpp"
  }
}

void vcvtLtoI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3958 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_vector_narrow(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ elemType_to_regVariant(bt),
                         opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 38608 "ad_aarch64.cpp"
  }
}

void vcvtLtoF_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3972 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // 2L to 2F
    __ umov(rscratch1, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D, 0);
    __ scvtfs(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, rscratch1);
    __ umov(rscratch1, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D, 1);
    __ scvtfs(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, rscratch1);
    __ ins(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ S, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, 1, 0);
  
#line 38631 "ad_aarch64.cpp"
  }
}

void vcvtLtoF_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3988 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_scvtf(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D);
    __ sve_vector_narrow(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ S,
                         opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ D, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 38651 "ad_aarch64.cpp"
  }
}

void vcvtLtoDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4000 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      // 2L to 2D
      __ scvtfv(__ T2D, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_scvtf(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D);
    }
  
#line 38674 "ad_aarch64.cpp"
  }
}

void vcvtFtoX_narrow_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4022 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // 4F to 4B/4S
    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    __ fcvtzs(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ T4S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ neon_vector_narrow(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, bt,
                          opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, T_INT, length_in_bytes);
  
#line 38696 "ad_aarch64.cpp"
  }
}

void vcvtFtoX_narrow_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4040 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fcvtzs(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ S);
    __ sve_vector_narrow(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ elemType_to_regVariant(bt),
                         opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ S, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 38718 "ad_aarch64.cpp"
  }
}

void vcvtFtoXNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4054 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes =  Matcher::vector_length_in_bytes(this);
    if (bt == T_INT) {
      if (VM_Version::use_neon_for_vector(length_in_bytes)) {
        // 2F/4F to 2I/4I
        __ fcvtzs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      } else {
        assert(UseSVE > 0, "must be sve");
        __ sve_fcvtzs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ S);
      }
    } else if (bt == T_LONG) {
      if (UseSVE == 0) {
        // 2F to 2L
        __ fcvtl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ T2S);
        __ fcvtzs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2D, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
      } else {
        __ sve_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ S);
        __ sve_fcvtzs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S);
      }
    } else {
      assert(bt == T_DOUBLE, "unsupported type");
      if (length_in_bytes == 16) {
        // 2F to 2D
        __ fcvtl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ T2S);
      } else {
        assert(UseSVE > 0 && length_in_bytes > 16, "must be");
        __ sve_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ S);
        __ sve_fcvt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S);
      }
    }
  
#line 38763 "ad_aarch64.cpp"
  }
}

void vcvtDtoI_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4096 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // 2D to 2I
    __ ins(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0, 1);
    // We can't use fcvtzs(vector, integer) instruction here because we need
    // saturation arithmetic. See JDK-8276151.
    __ fcvtzdw(rscratch1, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ fcvtzdw(rscratch2, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */);
    __ fmovs(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, rscratch1);
    __ mov(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ S, 1, rscratch2);
  
#line 38787 "ad_aarch64.cpp"
  }
}

void vcvtDtoI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4117 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fcvtzs(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D);
    __ sve_vector_narrow(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ elemType_to_regVariant(bt),
                         opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ D, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 38808 "ad_aarch64.cpp"
  }
}

void vcvtDtoLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4130 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes =  Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      // 2D to 2L
      __ fcvtzs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fcvtzs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D);
    }
  
#line 38831 "ad_aarch64.cpp"
  }
}

void vcvtDtoF_64bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4148 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // 2D to 2F
    __ fcvtn(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ T2D);
  
#line 38848 "ad_aarch64.cpp"
  }
}

void vcvtDtoF_gt64bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4161 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_fcvt(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D);
    __ sve_vector_narrow(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ S,
                         opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ D, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 38869 "ad_aarch64.cpp"
  }
}

void vcvtHFtoFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4175 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      // 4HF to 4F
      __ fcvtl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T4S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ T4H);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ H);
      __ sve_fcvt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, ptrue, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ H);
    }
  
#line 38893 "ad_aarch64.cpp"
  }
}

void vcvtFtoHF_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4195 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // 4F to 4HF
    __ fcvtn(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T4H, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ T4S);
  
#line 38910 "ad_aarch64.cpp"
  }
}

void vcvtFtoHF_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4207 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_fcvt(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ H, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ S);
    __ sve_vector_narrow(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ H,
                         opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ S, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 38931 "ad_aarch64.cpp"
  }
}

void replicateBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4223 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ B, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    }
  
#line 38953 "ad_aarch64.cpp"
  }
}

void replicateSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4238 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ H, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    }
  
#line 38975 "ad_aarch64.cpp"
  }
}

void replicateINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4253 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    }
  
#line 38997 "ad_aarch64.cpp"
  }
}

void replicateLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4268 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    }
  
#line 39019 "ad_aarch64.cpp"
  }
}

void replicateFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4283 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_cpy(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 39041 "ad_aarch64.cpp"
  }
}

void replicateDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4298 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_cpy(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 39063 "ad_aarch64.cpp"
  }
}

void replicateI_imm_le128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4318 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int imm = (int)opnd_array(1)->constant();
    if (type2aelembytes(bt) == 1) {
      // Refine imm for B
      imm = imm & 0xff;
    } else if (type2aelembytes(bt) == 2) {
      // Refine imm for S
      imm = imm & 0xffff;
    }
    __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), imm);
  
#line 39088 "ad_aarch64.cpp"
  }
}

void replicateI_imm_le128b_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4318 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int imm = (int)opnd_array(1)->constant();
    if (type2aelembytes(bt) == 1) {
      // Refine imm for B
      imm = imm & 0xff;
    } else if (type2aelembytes(bt) == 2) {
      // Refine imm for S
      imm = imm & 0xffff;
    }
    __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), imm);
  
#line 39113 "ad_aarch64.cpp"
  }
}

void replicateI_imm_le128b_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4318 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int imm = (int)opnd_array(1)->constant();
    if (type2aelembytes(bt) == 1) {
      // Refine imm for B
      imm = imm & 0xff;
    } else if (type2aelembytes(bt) == 2) {
      // Refine imm for S
      imm = imm & 0xffff;
    }
    __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), imm);
  
#line 39138 "ad_aarch64.cpp"
  }
}

void replicateB_imm8_gt128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4337 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ B, (int)(opnd_array(1)->constant()));
  
#line 39155 "ad_aarch64.cpp"
  }
}

void replicateS_imm8_gt128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4348 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ H, (int)(opnd_array(1)->constant()));
  
#line 39172 "ad_aarch64.cpp"
  }
}

void replicateI_imm8_gt128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4359 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, (int)(opnd_array(1)->constant()));
  
#line 39189 "ad_aarch64.cpp"
  }
}

void replicateL_imm_128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4370 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2D, (uint64_t)(opnd_array(1)->constantL()));
  
#line 39205 "ad_aarch64.cpp"
  }
}

void replicateL_imm8_gt128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4380 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, (int)(opnd_array(1)->constantL()));
  
#line 39222 "ad_aarch64.cpp"
  }
}

void insertI_le128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4398 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (opnd_array(0)->as_FloatRegister(ra_,this)/* dst */!= opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
      __ orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
    __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
           (int)(opnd_array(3)->constant()), opnd_array(2)->as_Register(ra_,this,idx2)/* val */);
  
#line 39247 "ad_aarch64.cpp"
  }
}

void insertI_index_lt32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4421 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_index(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, size, -16, 1);
    __ sve_cmp(Assembler::EQ, opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, size, ptrue,
               opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, (int)(opnd_array(3)->constant()) - 16);
    if (opnd_array(0)->as_FloatRegister(ra_,this)/* dst */!= opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
      __ sve_orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
    __ sve_cpy(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size, opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* val */);
  
#line 39276 "ad_aarch64.cpp"
  }
}

void insertI_index_ge32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4445 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_index(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, size, 0, 1);
    __ sve_dup(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, size, (int)(opnd_array(3)->constant()));
    __ sve_cmp(Assembler::EQ, opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */, size, ptrue,
               opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */);
    if (opnd_array(0)->as_FloatRegister(ra_,this)/* dst */!= opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
      __ sve_orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
    __ sve_cpy(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size, opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* val */);
  
#line 39307 "ad_aarch64.cpp"
  }
}

void insertL_128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4468 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    if (opnd_array(0)->as_FloatRegister(ra_,this)/* dst */!= opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
      __ orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T16B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
    __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, (int)(opnd_array(3)->constant()), opnd_array(2)->as_Register(ra_,this,idx2)/* val */);
  
#line 39328 "ad_aarch64.cpp"
  }
}

void insertL_gt128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4484 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_index(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, __ D, -16, 1);
    __ sve_cmp(Assembler::EQ, opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, __ D, ptrue,
               opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, (int)(opnd_array(3)->constant()) - 16);
    if (opnd_array(0)->as_FloatRegister(ra_,this)/* dst */!= opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
      __ sve_orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
    __ sve_cpy(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* val */);
  
#line 39355 "ad_aarch64.cpp"
  }
}

void insertF_le128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4505 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */!= opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
      __ orr(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
    __ ins(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ S, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* val */, (int)(opnd_array(3)->constant()), 0);
  
#line 39379 "ad_aarch64.cpp"
  }
}

void insertF_index_lt32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4524 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_index(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ S, -16, 1);
    __ sve_cmp(Assembler::EQ, opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, __ S, ptrue,
               opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, (int)(opnd_array(3)->constant()) - 16);
    __ sve_orr(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ sve_cpy(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ S, opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* val */);
  
#line 39404 "ad_aarch64.cpp"
  }
}

void insertF_index_ge32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4542 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_index(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */, __ S, 0, 1);
    __ sve_dup(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ S, (int)(opnd_array(3)->constant()));
    __ sve_cmp(Assembler::EQ, opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */, __ S, ptrue,
               opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */);
    __ sve_orr(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ sve_cpy(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ S, opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* val */);
  
#line 39431 "ad_aarch64.cpp"
  }
}

void insertD_128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4562 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    if (opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */!= opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
      __ orr(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ T16B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
    __ ins(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ D, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* val */, (int)(opnd_array(3)->constant()), 0);
  
#line 39453 "ad_aarch64.cpp"
  }
}

void insertD_gt128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4578 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_index(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ D, -16, 1);
    __ sve_cmp(Assembler::EQ, opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, __ D, ptrue,
               opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, (int)(opnd_array(3)->constant()) - 16);
    __ sve_orr(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ sve_cpy(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ D, opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* val */);
  
#line 39478 "ad_aarch64.cpp"
  }
}

void extractB_index_lt16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4596 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ smov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ B, (int)(opnd_array(2)->constant()));
  
#line 39495 "ad_aarch64.cpp"
  }
}

void extractB_index_ge16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4607 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_extract_integral(opnd_array(0)->as_Register(ra_,this)/* dst */, T_BYTE, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                            (int)(opnd_array(2)->constant()), opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 39515 "ad_aarch64.cpp"
  }
}

void extractS_index_lt8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4621 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ smov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ H, (int)(opnd_array(2)->constant()));
  
#line 39532 "ad_aarch64.cpp"
  }
}

void extractS_index_ge8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4632 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_extract_integral(opnd_array(0)->as_Register(ra_,this)/* dst */, T_SHORT, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                            (int)(opnd_array(2)->constant()), opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 39552 "ad_aarch64.cpp"
  }
}

void extractI_index_lt4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4646 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ umov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ S, (int)(opnd_array(2)->constant()));
  
#line 39569 "ad_aarch64.cpp"
  }
}

void extractI_index_ge4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4657 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_extract_integral(opnd_array(0)->as_Register(ra_,this)/* dst */, T_INT, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                            (int)(opnd_array(2)->constant()), opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 39589 "ad_aarch64.cpp"
  }
}

void extractL_index_lt2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4671 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ umov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D, (int)(opnd_array(2)->constant()));
  
#line 39606 "ad_aarch64.cpp"
  }
}

void extractL_index_ge2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4682 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_extract_integral(opnd_array(0)->as_Register(ra_,this)/* dst */, T_LONG, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                            (int)(opnd_array(2)->constant()), opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 39626 "ad_aarch64.cpp"
  }
}

void extractFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4696 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int index = (int)opnd_array(2)->constant();
    if (index == 0) {
      __ fmovs(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else if (index < 4) {
      __ ins(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0, index);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_orr(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      __ sve_ext(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, index << 2);
    }
  
#line 39653 "ad_aarch64.cpp"
  }
}

void extractDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4717 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int index = (int)opnd_array(2)->constant();
    if (index == 0) {
      __ fmovd(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else if (index < 2) {
      __ ins(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0, index);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_orr(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      __ sve_ext(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, index << 3);
    }
  
#line 39680 "ad_aarch64.cpp"
  }
}

void vloadmask_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4742 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    if (bt == T_BYTE) {
      uint length_in_bytes = Matcher::vector_length_in_bytes(this);
      __ negr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      __ uxtl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T8H, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ T8B);
      if (type2aelembytes(bt) >= 4) {
        __ uxtl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T4S, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T4H);
      }
      if (type2aelembytes(bt) == 8) {
        __ uxtl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2D, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2S);
      }
      __ negr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
    }
  
#line 39710 "ad_aarch64.cpp"
  }
}

void vloadmaskB_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4767 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, __ B,
               ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0);
  
#line 39727 "ad_aarch64.cpp"
  }
}

void vloadmask_extend_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4779 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_vector_extend(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, size, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ B);
    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, size, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, 0);
  
#line 39747 "ad_aarch64.cpp"
  }
}

void vloadmaskB_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4793 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, __ B,
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0);
  
#line 39765 "ad_aarch64.cpp"
  }
}

void vloadmask_extend_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4805 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_vector_extend(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, size, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ B);
    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, size,
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, 0);
  
#line 39787 "ad_aarch64.cpp"
  }
}

void vstoremaskB_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4821 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == 8 || length_in_bytes == 16, "must be");
    __ negr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 39807 "ad_aarch64.cpp"
  }
}

void vstoremask_narrow_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4834 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int esize = (int)opnd_array(2)->constant();
    if (esize == 2) {
      __ xtn(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T8B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ T8H);
    } else if (esize == 4) {
      __ xtn(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T4H, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ T4S);
      __ xtn(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T8B, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T8H);
    } else {
      assert(esize == 8, "must be");
      __ xtn(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ T2D);
      __ xtn(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T4H, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T4S);
      __ xtn(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T8B, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T8H);
    }
    __ negr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T8B, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
  
#line 39836 "ad_aarch64.cpp"
  }
}

void vstoremaskB_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4858 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_cpy(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ B, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src */, 1, false);
  
#line 39853 "ad_aarch64.cpp"
  }
}

void vstoremask_narrow_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4869 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::SIMD_RegVariant size = __ elemBytes_to_regVariant((int)opnd_array(2)->constant());
    __ sve_cpy(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, size, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src */, 1, false);
    __ sve_vector_narrow(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ B,
                         opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, size, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 39875 "ad_aarch64.cpp"
  }
}

void vloadmask_loadVNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4887 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Load mask values which are boolean type, and extend them to the
    // defined vector element type. Convert the vector to predicate.
    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), false, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */,
                          ptrue, T_BOOLEAN, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, 0);
  
#line 39901 "ad_aarch64.cpp"
  }
}

void vloadmask_loadV_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4910 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Load valid mask values which are boolean type, and extend them to the
    // defined vector element type. Convert the vector to predicate.
    BasicType bt = Matcher::vector_element_basic_type(this);
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), false, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */,
                          opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, T_BOOLEAN, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, 0);
  
#line 39926 "ad_aarch64.cpp"
  }
}

void vloadmask_loadVMaskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4930 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Load mask values which are boolean type, and extend them to the
    // defined vector element type. Convert the vector to predicate.
    //
    // Note that we cannot use "pg" here, since it is the predicate used
    // for the vector load with boolean type. But the predicate used in
    // the extending "sve_ld1b" is based on the final extended vector type,
    // which is the full-sized predicate (ptrue) used in VectorLoadMask.
    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), false, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */,
                          ptrue, T_BOOLEAN, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, 0);
  
#line 39958 "ad_aarch64.cpp"
  }
}

void vloadmask_loadVMasked_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4958 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Load valid mask values which are boolean type, and extend them to the
    // defined vector element type. Convert the vector to predicate.
    //
    // Note that we cannot use "pg1" here, since it is the predicate used
    // for the vector load with boolean type. But the predicate used in
    // the extending "sve_ld1b" is based on the final extended vector type,
    // which is the "pg2" used in VectorLoadMask.
    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), false, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */,
                          opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg2 */, T_BOOLEAN, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg2 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, 0);
  
#line 39991 "ad_aarch64.cpp"
  }
}

void storeV_vstoremaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// esize
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4987 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Convert the valid src predicate to vector, and store the vector elements
    // as boolean values.
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    assert(type2aelembytes(bt) == (int)opnd_array(3)->constant(), "unsupported type");
    Assembler::SIMD_RegVariant size = __ elemBytes_to_regVariant(opnd_array(3)->constant());
    __ sve_cpy(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, size, opnd_array(2)->as_PRegister(ra_,this,idx2)/* src */, 1, false);
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), true, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */,
                          ptrue, T_BOOLEAN, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 40018 "ad_aarch64.cpp"
  }
}

void storeV_vstoremask_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// esize
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5009 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Convert the valid src predicate to vector, and store the vector elements
    // as boolean values.
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_cpy(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, size, opnd_array(2)->as_PRegister(ra_,this,idx2)/* src */, 1, false);
    __ sve_gen_mask_imm(opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, bt, Matcher::vector_length(this, opnd_array(2)));
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), true, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */,
                          opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, T_BOOLEAN, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 40046 "ad_aarch64.cpp"
  }
}

void storeVMasked_vstoremaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// esize
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5030 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Convert the valid src predicate to vector, and store the vector elements
    // as boolean values.
    //
    // Note that we cannot use "pg" here, since it is the predicate used
    // for the vector store with boolean type. But the predicate used in
    // the narrowing "sve_st1b" is based on the "src" vector type, which
    // is the full-sized predicate (ptrue) here.
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    assert(type2aelembytes(bt) == (int)opnd_array(3)->constant(), "unsupported type.");
    Assembler::SIMD_RegVariant size = __ elemBytes_to_regVariant(opnd_array(3)->constant());
    __ sve_cpy(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */, size, opnd_array(2)->as_PRegister(ra_,this,idx2)/* src */, 1, false);
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), true, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */,
                          ptrue, T_BOOLEAN, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 40079 "ad_aarch64.cpp"
  }
}

void storeVMasked_vstoremask_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// esize
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5057 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Convert the valid src predicate to vector, and store the vector elements
    // as boolean values.
    //
    // Note that we cannot use "pg" here, since it is the predicate used for the
    // vector store with boolean type. But the predicate used in the narrowing
    // "sve_st1b" is based on the "src" vector type, which needed to be generated
    // here.
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_cpy(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */, size, opnd_array(2)->as_PRegister(ra_,this,idx2)/* src */, 1, false);
    __ sve_gen_mask_imm(opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */, bt, Matcher::vector_length(this, opnd_array(2)));
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), true, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */,
                          opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */, T_BOOLEAN, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 40113 "ad_aarch64.cpp"
  }
}

void vmask_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// pn
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5084 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_and(opnd_array(0)->as_PRegister(ra_,this)/* pd */, ptrue, opnd_array(1)->as_PRegister(ra_,this,idx1)/* pn */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pm */);
  
#line 40130 "ad_aarch64.cpp"
  }
}

void vmask_orNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// pn
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5094 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_orr(opnd_array(0)->as_PRegister(ra_,this)/* pd */, ptrue, opnd_array(1)->as_PRegister(ra_,this,idx1)/* pn */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pm */);
  
#line 40147 "ad_aarch64.cpp"
  }
}

void vmask_xorNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// pn
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5104 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor(opnd_array(0)->as_PRegister(ra_,this)/* pd */, ptrue, opnd_array(1)->as_PRegister(ra_,this,idx1)/* pn */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pm */);
  
#line 40164 "ad_aarch64.cpp"
  }
}

void vmask_and_notINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// pn
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5114 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_bic(opnd_array(0)->as_PRegister(ra_,this)/* pd */, ptrue, opnd_array(1)->as_PRegister(ra_,this,idx1)/* pn */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pm */);
  
#line 40182 "ad_aarch64.cpp"
  }
}

void vmask_and_notLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// pn
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5124 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_bic(opnd_array(0)->as_PRegister(ra_,this)/* pd */, ptrue, opnd_array(1)->as_PRegister(ra_,this,idx1)/* pn */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pm */);
  
#line 40200 "ad_aarch64.cpp"
  }
}

void vmaskcmp_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5138 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ neon_compare(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, bt, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */,
                    opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, condition, /* isQ */ length_in_bytes == 16);
  
#line 40222 "ad_aarch64.cpp"
  }
}

void vmaskcmp_zeroI_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5154 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ neon_compare_zero(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, bt, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                         condition, /* isQ */ length_in_bytes == 16);
  
#line 40244 "ad_aarch64.cpp"
  }
}

void vmaskcmp_zeroI_neon_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5154 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ neon_compare_zero(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, bt, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                         condition, /* isQ */ length_in_bytes == 16);
  
#line 40266 "ad_aarch64.cpp"
  }
}

void vmaskcmp_zeroI_neon_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5154 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ neon_compare_zero(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, bt, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                         condition, /* isQ */ length_in_bytes == 16);
  
#line 40288 "ad_aarch64.cpp"
  }
}

void vmaskcmp_zeroL_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5168 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ neon_compare_zero(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, T_LONG, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                         condition, /* isQ */ length_in_bytes == 16);
  
#line 40309 "ad_aarch64.cpp"
  }
}

void vmaskcmp_zeroF_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5181 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ neon_compare_zero(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, T_FLOAT, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                         condition, /* isQ */ length_in_bytes == 16);
  
#line 40330 "ad_aarch64.cpp"
  }
}

void vmaskcmp_zeroD_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5194 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ neon_compare_zero(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, T_DOUBLE, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                         condition, /* isQ */ length_in_bytes == 16);
  
#line 40351 "ad_aarch64.cpp"
  }
}

void vmaskcmp_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5208 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_compare(opnd_array(0)->as_PRegister(ra_,this)/* dst */, bt, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */,
                   opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, condition);
  
#line 40374 "ad_aarch64.cpp"
  }
}

void vmaskcmp_immB_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5224 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_cmp(condition, opnd_array(0)->as_PRegister(ra_,this)/* dst */, __ B, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant());
  
#line 40395 "ad_aarch64.cpp"
  }
}

void vmaskcmpU_immB_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5238 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_cmp(condition, opnd_array(0)->as_PRegister(ra_,this)/* dst */, __ B, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant());
  
#line 40416 "ad_aarch64.cpp"
  }
}

void vmaskcmp_immS_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5252 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_cmp(condition, opnd_array(0)->as_PRegister(ra_,this)/* dst */, __ H, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant());
  
#line 40437 "ad_aarch64.cpp"
  }
}

void vmaskcmpU_immS_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5266 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_cmp(condition, opnd_array(0)->as_PRegister(ra_,this)/* dst */, __ H, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant());
  
#line 40458 "ad_aarch64.cpp"
  }
}

void vmaskcmp_immI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5280 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_cmp(condition, opnd_array(0)->as_PRegister(ra_,this)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant());
  
#line 40479 "ad_aarch64.cpp"
  }
}

void vmaskcmpU_immI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5294 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_cmp(condition, opnd_array(0)->as_PRegister(ra_,this)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant());
  
#line 40500 "ad_aarch64.cpp"
  }
}

void vmaskcmp_immL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5308 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_cmp(condition, opnd_array(0)->as_PRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constantL());
  
#line 40521 "ad_aarch64.cpp"
  }
}

void vmaskcmpU_immL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5322 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_cmp(condition, opnd_array(0)->as_PRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constantL());
  
#line 40542 "ad_aarch64.cpp"
  }
}

void vmaskcmp_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5337 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_compare(opnd_array(0)->as_PRegister(ra_,this)/* dst */, bt, opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */,
                   opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, condition);
  
#line 40564 "ad_aarch64.cpp"
  }
}

void vmaskcast_same_esize_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  // User did not define which encode class to use.
}

void vmaskcast_extend_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5364 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType dst_bt = Matcher::vector_element_basic_type(this);
    if (is_floating_point_type(dst_bt)) {
      dst_bt = (dst_bt == T_FLOAT) ? T_INT : T_LONG;
    }
    uint length_in_bytes_dst = Matcher::vector_length_in_bytes(this);
    BasicType src_bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    if (is_floating_point_type(src_bt)) {
      src_bt = (src_bt == T_FLOAT) ? T_INT : T_LONG;
    }
    __ neon_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, dst_bt, length_in_bytes_dst,
                          opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, src_bt);
  
#line 40598 "ad_aarch64.cpp"
  }
}

void vmaskcast_narrow_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5385 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType dst_bt = Matcher::vector_element_basic_type(this);
    if (is_floating_point_type(dst_bt)) {
      dst_bt = (dst_bt == T_FLOAT) ? T_INT : T_LONG;
    }
    BasicType src_bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    if (is_floating_point_type(src_bt)) {
      src_bt = (src_bt == T_FLOAT) ? T_INT : T_LONG;
    }
    uint length_in_bytes_src = Matcher::vector_length_in_bytes(this, opnd_array(1));
    __ neon_vector_narrow(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, dst_bt,
                          opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, src_bt, length_in_bytes_src);
  
#line 40624 "ad_aarch64.cpp"
  }
}

void vmaskcast_same_esize_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  // User did not define which encode class to use.
}

void vmaskcast_extend_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5416 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes_dst = Matcher::vector_length_in_bytes(this);
    uint length_in_bytes_src = Matcher::vector_length_in_bytes(this, opnd_array(1));
    assert(length_in_bytes_dst == 2 * length_in_bytes_src ||
           length_in_bytes_dst == 4 * length_in_bytes_src ||
           length_in_bytes_dst == 8 * length_in_bytes_src, "invalid vector length");
    __ sve_vmaskcast_extend(opnd_array(0)->as_PRegister(ra_,this)/* dst */, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src */,
                            length_in_bytes_dst, length_in_bytes_src);
  
#line 40654 "ad_aarch64.cpp"
  }
}

void vmaskcast_narrow_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ptmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5434 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes_dst = Matcher::vector_length_in_bytes(this);
    uint length_in_bytes_src = Matcher::vector_length_in_bytes(this, opnd_array(1));
    assert(length_in_bytes_dst * 2 == length_in_bytes_src ||
           length_in_bytes_dst * 4 == length_in_bytes_src ||
           length_in_bytes_dst * 8 == length_in_bytes_src, "invalid vector length");
    __ sve_vmaskcast_narrow(opnd_array(2)->as_PRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_PRegister(ra_,this,idx3)/* ptmp */,
                            length_in_bytes_dst, length_in_bytes_src);
  
#line 40678 "ad_aarch64.cpp"
  }
}

void vmask_reinterpret_same_esizeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  // User did not define which encode class to use.
}

void vmask_reinterpret_diff_esizeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5466 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType from_bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    Assembler::SIMD_RegVariant from_size = __ elemType_to_regVariant(from_bt);
    BasicType to_bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant to_size = __ elemType_to_regVariant(to_bt);
    __ sve_cpy(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, from_size, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src */, -1, false);
    __ sve_cmp(Assembler::EQ, opnd_array(0)->as_PRegister(ra_,this)/* dst */, to_size, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, -1);
  
#line 40708 "ad_aarch64.cpp"
  }
}

void vmask_truecount_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5486 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Input "src" is a vector of boolean represented as bytes with
    // 0x00/0x01 as element values.
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    assert(bt == T_BOOLEAN, "unsupported type");
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    __ addv(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, length_in_bytes == 16 ? __ T16B : __ T8B,
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ umov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ B, 0);
  
#line 40732 "ad_aarch64.cpp"
  }
}

void vmask_truecount_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5503 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ sve_cntp(opnd_array(0)->as_Register(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
                ptrue, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src */);
  
#line 40750 "ad_aarch64.cpp"
  }
}

void vstoremask_truecount_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5517 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Input "src" is a vector mask represented as lanes with
    // 0/-1 as element values.
    uint esize = (uint)opnd_array(2)->constant();
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    Assembler::SIMD_Arrangement arrangement = Assembler::esize2arrangement(esize,
                                                                           /* isQ */ length_in_bytes == 16);
    if (arrangement == __ T2D || arrangement == __ T2S) {
      __ addpv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* vtmp */, arrangement, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      __ addv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* vtmp */, arrangement, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
    __ smov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* vtmp */, __ B, 0);
    __ neg(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 40780 "ad_aarch64.cpp"
  }
}

void vmask_firsttrue_lt8eNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5543 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Returns the index of the first active lane of the
    // vector mask, or VLENGTH if no lane is active.
    //
    // Input "src" is a vector of boolean represented as
    // bytes with 0x00/0x01 as element values.
    //
    // Computed by reversing the bits and counting the leading
    // zero bytes.
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    assert(bt == T_BOOLEAN, "unsupported type");
    __ fmovd(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ rbit(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
    __ clz(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
    __ lsrw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, 3);
    __ movw(rscratch1, Matcher::vector_length(this, opnd_array(1)));
    __ cmpw(opnd_array(0)->as_Register(ra_,this)/* dst */, rscratch1);
    __ cselw(opnd_array(0)->as_Register(ra_,this)/* dst */, rscratch1, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::GE);
  
#line 40812 "ad_aarch64.cpp"
  }
}

void vmask_firsttrue_8or16eNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5570 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Returns the index of the first active lane of the
    // vector mask, or VLENGTH if no lane is active.
    //
    // Input "src" is a vector of boolean represented as
    // bytes with 0x00/0x01 as element values.
    //
    // Computed by reversing the bits and counting the leading
    // zero bytes.

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    assert(bt == T_BOOLEAN, "unsupported type");
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    if (length_in_bytes == 8) {
      __ fmovd(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      __ rbit(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
      __ clz(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
      __ lsrw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, 3);
    } else {
      assert(length_in_bytes == 16, "must be");
      Label FIRST_TRUE_INDEX;

      // Try to compute the result from lower 64 bits.
      __ fmovd(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      __ movw(rscratch1, zr);
      __ cbnz(opnd_array(0)->as_Register(ra_,this)/* dst */, FIRST_TRUE_INDEX);

      // Compute the result from the higher 64 bits.
      __ fmovhid(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      __ movw(rscratch1, 8);

      // Reverse the bits and count the leading zero bytes.
      __ bind(FIRST_TRUE_INDEX);
      __ rbit(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
      __ clz(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
      __ addw(opnd_array(0)->as_Register(ra_,this)/* dst */, rscratch1, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::LSR, 3);
    }
  
#line 40863 "ad_aarch64.cpp"
  }
}

void vmask_firsttrue_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ptmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5619 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_brkb(opnd_array(2)->as_PRegister(ra_,this,idx2)/* ptmp */, ptrue, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src */, false);
    __ sve_cntp(opnd_array(0)->as_Register(ra_,this)/* dst */, __ elemType_to_regVariant(bt), ptrue, opnd_array(2)->as_PRegister(ra_,this,idx2)/* ptmp */);
  
#line 40884 "ad_aarch64.cpp"
  }
}

void vmask_firsttrue_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ptmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5634 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ sve_brkb(opnd_array(3)->as_PRegister(ra_,this,idx3)/* ptmp */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src */, false);
    __ sve_cntp(opnd_array(0)->as_Register(ra_,this)/* dst */, __ elemType_to_regVariant(bt), ptrue, opnd_array(3)->as_PRegister(ra_,this,idx3)/* ptmp */);
  
#line 40904 "ad_aarch64.cpp"
  }
}

void vmask_lasttrue_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5648 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Returns the index of the last active lane of the
    // vector mask, or -1 if no lane is active.
    //
    // Input "src" is a vector of boolean represented as
    // bytes with 0x00/0x01 as element values.

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    assert(bt == T_BOOLEAN, "unsupported type");
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    if (length_in_bytes <= 8) {
      // Computed by counting the leading zero bytes and
      // subtracting it by 7 (VLENGTH - 1).
      __ fmovd(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      __ clz(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
      __ movw(rscratch1, 7);
      __ subw(opnd_array(0)->as_Register(ra_,this)/* dst */, rscratch1, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::LSR, 3);
    } else {
      assert(length_in_bytes == 16, "must be");
      Label LAST_TRUE_INDEX;

      // Try to compute the result from higher 64 bits.
      __ fmovhid(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      __ movw(rscratch1, 16 - 1);
      __ cbnz(opnd_array(0)->as_Register(ra_,this)/* dst */, LAST_TRUE_INDEX);

      // Compute the result from the lower 64 bits.
      __ fmovd(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      __ movw(rscratch1, 8 - 1);

      // Count the leading zero bytes and subtract it by 15 (VLENGTH - 1).
      __ bind(LAST_TRUE_INDEX);
      __ clz(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
      __ subw(opnd_array(0)->as_Register(ra_,this)/* dst */, rscratch1, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::LSR, 3);
    }
  
#line 40953 "ad_aarch64.cpp"
  }
}

void vmask_lasttrue_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ptmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5692 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ sve_vmask_lasttrue(opnd_array(0)->as_Register(ra_,this)/* dst */, bt, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* ptmp */);
  
#line 40971 "ad_aarch64.cpp"
  }
}

void vmask_tolong_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5705 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Input "src" is a vector of boolean represented as
    // bytes with 0x00/0x01 as element values.

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    if (length_in_bytes <= 8) {
      __ fmovd(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      __ bytemask_compress(opnd_array(0)->as_Register(ra_,this)/* dst */);
    } else {
      assert(length_in_bytes == 16, "must be");
      __ umov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D, 0);
      __ umov(rscratch1, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D, 1);
      __ bytemask_compress(opnd_array(0)->as_Register(ra_,this)/* dst */);
      __ bytemask_compress(rscratch1);
      __ orr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, rscratch1, Assembler::LSL, 8);
    }
  
#line 41001 "ad_aarch64.cpp"
  }
}

void vmask_tolong_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5730 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_vmask_tolong(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src */,
                        Matcher::vector_element_basic_type(this, opnd_array(1)),
                        Matcher::vector_length(this, opnd_array(1)),
                        opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp2 */);
  
#line 41022 "ad_aarch64.cpp"
  }
}

void vmask_fromlongNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5745 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_vmask_fromlong(opnd_array(0)->as_PRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */,
                          Matcher::vector_element_basic_type(this),
                          Matcher::vector_length(this),
                          opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp2 */);
  
#line 41043 "ad_aarch64.cpp"
  }
}

void vmaskAll_immINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5763 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int con = (int)opnd_array(1)->constant();
    if (con == 0) {
      __ sve_pfalse(opnd_array(0)->as_PRegister(ra_,this)/* dst */);
    } else {
      assert(con == -1, "invalid constant value for mask");
      BasicType bt = Matcher::vector_element_basic_type(this);
      __ sve_gen_mask_imm(opnd_array(0)->as_PRegister(ra_,this)/* dst */, bt, Matcher::vector_length(this));
    }
  
#line 41066 "ad_aarch64.cpp"
  }
}

void vmaskAllINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5781 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_dup(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, size, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, size, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, 0);
  
#line 41088 "ad_aarch64.cpp"
  }
}

void vmaskAllI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5797 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_dup(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, size, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, size,
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, 0);
  
#line 41110 "ad_aarch64.cpp"
  }
}

void vmaskAll_immLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5812 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    long con = (long)opnd_array(1)->constantL();
    if (con == 0) {
      __ sve_pfalse(opnd_array(0)->as_PRegister(ra_,this)/* dst */);
    } else {
      assert(con == -1, "invalid constant value for mask");
      BasicType bt = Matcher::vector_element_basic_type(this);
      __ sve_gen_mask_imm(opnd_array(0)->as_PRegister(ra_,this)/* dst */, bt, Matcher::vector_length(this));
    }
  
#line 41133 "ad_aarch64.cpp"
  }
}

void vmaskAllLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5830 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_dup(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, size, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, size, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, 0);
  
#line 41155 "ad_aarch64.cpp"
  }
}

void vmaskAllL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5846 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_dup(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, size, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, size,
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, 0);
  
#line 41177 "ad_aarch64.cpp"
  }
}

void vmask_gen_INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5863 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_whileltw(opnd_array(0)->as_PRegister(ra_,this)/* pd */, __ elemType_to_regVariant(bt), zr, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 41194 "ad_aarch64.cpp"
  }
}

void vmask_gen_LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5875 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_whilelt(opnd_array(0)->as_PRegister(ra_,this)/* pd */, __ elemType_to_regVariant(bt), zr, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 41211 "ad_aarch64.cpp"
  }
}

void vmask_gen_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5887 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_gen_mask_imm(opnd_array(0)->as_PRegister(ra_,this)/* pd */, bt, (uint)(opnd_array(1)->constantL()));
  
#line 41228 "ad_aarch64.cpp"
  }
}

void vmask_gen_subNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5899 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_whilelt(opnd_array(0)->as_PRegister(ra_,this)/* pd */, __ elemType_to_regVariant(bt), opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */);
  
#line 41246 "ad_aarch64.cpp"
  }
}

void vpopcountINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5913 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (bt == T_BYTE) {
      if (VM_Version::use_neon_for_vector(length_in_bytes)) {
        __ cnt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
               opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      } else {
        assert(UseSVE > 0, "must be sve");
        __ sve_cnt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ B, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      }
    } else {
      assert(bt == T_SHORT || bt == T_INT, "unsupported");
      if (UseSVE == 0) {
        assert(length_in_bytes == 8 || length_in_bytes == 16, "unsupported");
        __ cnt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
               opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        __ uaddlp(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                  opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
        if (bt == T_INT) {
          __ uaddlp(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T8H : __ T4H,
                    opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
        }
      } else {
        __ sve_cnt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
                   ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      }
    }
  
#line 41288 "ad_aarch64.cpp"
  }
}

void vpopcountLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5950 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    if (UseSVE == 0) {
      __ cnt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T16B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      __ uaddlp(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T16B, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
      __ uaddlp(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T8H, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
      __ uaddlp(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T4S, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
    } else {
      __ sve_cnt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 41311 "ad_aarch64.cpp"
  }
}

void vpopcountI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5969 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_cnt(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 41330 "ad_aarch64.cpp"
  }
}

void vpopcountL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5981 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_cnt(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D,
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 41348 "ad_aarch64.cpp"
  }
}

void vblend_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5994 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == 8 || length_in_bytes == 16, "must be");
    __ bsl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
           opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */);
  
#line 41369 "ad_aarch64.cpp"
  }
}

void vblend_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6007 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_sel(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */);
  
#line 41389 "ad_aarch64.cpp"
  }
}

void vround_le128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6026 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ vector_round_neon(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                         opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp2 */,
                         opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp3 */, get_arrangement(this));
  
#line 41411 "ad_aarch64.cpp"
  }
}

void vround_le128b_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6026 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ vector_round_neon(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                         opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp2 */,
                         opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp3 */, get_arrangement(this));
  
#line 41433 "ad_aarch64.cpp"
  }
}

void vround_gt128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6041 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vector_round_sve(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                        opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp2 */,
                        opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, __ elemType_to_regVariant(bt));
  
#line 41457 "ad_aarch64.cpp"
  }
}

void vround_gt128b_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6041 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vector_round_sve(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                        opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp2 */,
                        opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, __ elemType_to_regVariant(bt));
  
#line 41481 "ad_aarch64.cpp"
  }
}

void vroundDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rmode
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6059 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      switch (opnd_array(2)->constant()) {
        case RoundDoubleModeNode::rmode_rint:
          __ frintn(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
          break;
        case RoundDoubleModeNode::rmode_floor:
          __ frintm(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
          break;
        case RoundDoubleModeNode::rmode_ceil:
          __ frintp(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
          break;
        default:
          assert(false, "unsupported");
          ShouldNotReachHere();
      }
    } else {
      assert(UseSVE > 0, "must be sve");
      switch (opnd_array(2)->constant()) {
        case RoundDoubleModeNode::rmode_rint:
          __ sve_frintn(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
          break;
        case RoundDoubleModeNode::rmode_floor:
          __ sve_frintm(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
          break;
        case RoundDoubleModeNode::rmode_ceil:
          __ sve_frintp(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
          break;
        default:
          assert(false, "unsupported");
          ShouldNotReachHere();
      }
    }
  
#line 41530 "ad_aarch64.cpp"
  }
}

void vtest_anytrue_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6107 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // No need to use src2.
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    assert(length_in_bytes == 8 || length_in_bytes == 16, "must be");
    __ addv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, length_in_bytes == 16 ? __ T16B : __ T8B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */);
    __ umov(rscratch1, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, __ B, 0);
    __ cmpw(rscratch1, zr);
  
#line 41553 "ad_aarch64.cpp"
  }
}

void vtest_anytrue_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6123 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // "src2" is not used for sve.
    __ sve_ptest(ptrue, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src1 */);
  
#line 41571 "ad_aarch64.cpp"
  }
}

void vtest_alltrue_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6138 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // No need to use src2.
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    assert(length_in_bytes == 8 || length_in_bytes == 16, "must be");
    __ uminv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, length_in_bytes == 16 ? __ T16B : __ T8B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */);
    __ umov(rscratch1, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, __ B, 0);
    __ cmpw(rscratch1, 0xff);
  
#line 41594 "ad_aarch64.cpp"
  }
}

void vtest_alltrue_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ptmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6155 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eors(opnd_array(3)->as_PRegister(ra_,this,idx3)/* ptmp */, ptrue, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* src2 */);
  
#line 41612 "ad_aarch64.cpp"
  }
}

void loadshuffleNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6166 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (bt == T_BYTE) {
      if (opnd_array(0)->as_FloatRegister(ra_,this)/* dst */!= opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
        if (VM_Version::use_neon_for_vector(length_in_bytes)) {
          __ orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        } else {
          assert(UseSVE > 0, "must be sve");
          __ sve_orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
      }
    } else {
      if (VM_Version::use_neon_for_vector(length_in_bytes)) {
        // 4S/8S, 4I, 4F
        __ uxtl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T8H, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ T8B);
        if (type2aelembytes(bt) == 4) {
          __ uxtl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T4S, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T4H);
        }
      } else {
        assert(UseSVE > 0, "must be sve");
        __ sve_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */,  __ elemType_to_regVariant(bt),
                             opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ B);
      }
    }
  
#line 41652 "ad_aarch64.cpp"
  }
}

void rearrange_HS_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shuffle
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6226 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    if (bt == T_SHORT) {
      uint length_in_bytes = Matcher::vector_length_in_bytes(this);
      assert(length_in_bytes == 8 || length_in_bytes == 16, "must be");
      Assembler::SIMD_Arrangement size1 = length_in_bytes == 16 ? __ T16B : __ T8B;
      Assembler::SIMD_Arrangement size2 = length_in_bytes == 16 ? __ T8H : __ T4H;
      __ mov(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, size1, 0x02);
      __ mov(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, size2, 0x0100);
      __ mulv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, size2, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shuffle */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */);
      __ addv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, size1, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */);
      __ tbl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, size1, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 1, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
    } else {
      assert(bt == T_INT || bt == T_FLOAT, "unsupported type");
      __ mov(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, __ T16B, 0x04);
      __ mov(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, __ T4S, 0x03020100);
      __ mulv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T4S, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shuffle */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */);
      __ addv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T16B, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */);
      __ tbl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T16B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 1, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
    }
  
#line 41690 "ad_aarch64.cpp"
  }
}

void rearrangeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shuffle
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6254 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt_dst = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (bt_dst == T_BYTE && VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ tbl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 1, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shuffle */);
    } else {
      assert(UseSVE > 0, "must be sve");
      BasicType bt_src = Matcher::vector_element_basic_type(this, opnd_array(1));
      __ sve_tbl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt_src),
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shuffle */);
    }
  
#line 41717 "ad_aarch64.cpp"
  }
}

void gather_loadSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6277 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_ld1w_gather(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, ptrue,
                       as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* idx */);
 
#line 41737 "ad_aarch64.cpp"
  }
}

void gather_loadDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6292 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_uunpklo(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, __ D, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* idx */);
    __ sve_ld1d_gather(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, ptrue, as_Register(opnd_array(1)->base(ra_,this,idx1)),
                       opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 41759 "ad_aarch64.cpp"
  }
}

void gather_loadS_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6307 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_ld1w_gather(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */,
                       as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* idx */);
  
#line 41778 "ad_aarch64.cpp"
  }
}

void gather_loadD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6320 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_uunpklo(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, __ D, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* idx */);
    __ sve_ld1d_gather(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */,
                       as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 41799 "ad_aarch64.cpp"
  }
}

void scatter_storeSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6335 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_st1w_scatter(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, ptrue,
                        as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* idx */);
  
#line 41820 "ad_aarch64.cpp"
  }
}

void scatter_storeDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6350 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_uunpklo(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, __ D, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* idx */);
    __ sve_st1d_scatter(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, ptrue,
                        as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 41843 "ad_aarch64.cpp"
  }
}

void scatter_storeS_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6365 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_st1w_scatter(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */,
                        as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* idx */);
  
#line 41863 "ad_aarch64.cpp"
  }
}

void scatter_storeD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6378 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_uunpklo(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */, __ D, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* idx */);
    __ sve_st1d_scatter(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */,
                        as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 41885 "ad_aarch64.cpp"
  }
}

void vcountLeadingZerosNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6391 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (bt == T_LONG) {
      if (UseSVE == 0) {
        __ umov(rscratch1, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D, 0);
        __ clz(rscratch1, rscratch1);
        __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, 0, rscratch1);
        __ umov(rscratch1, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D, 1);
        __ clz(rscratch1, rscratch1);
        __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, 1, rscratch1);
      } else {
        __ sve_clz(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      }
    } else {
      if (VM_Version::use_neon_for_vector(length_in_bytes)) {
        __ clz(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      } else {
        assert(UseSVE > 0, "must be sve");
        __ sve_clz(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
                   ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      }
    }
  
#line 41922 "ad_aarch64.cpp"
  }
}

void vcountLeadingZeros_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6425 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_clz(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 41941 "ad_aarch64.cpp"
  }
}

void vcountTrailingZerosNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6438 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (bt == T_BYTE) {
      if (VM_Version::use_neon_for_vector(length_in_bytes)) {
        __ rbit(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        __ clz(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
      } else {
        assert(UseSVE > 0, "must be sve");
        __ sve_rbit(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ B, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        __ sve_clz(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ B, ptrue, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
      }
    } else {
      assert(bt == T_SHORT || bt == T_INT || bt == T_LONG, "unsupported type");
      if (UseSVE == 0) {
        assert(length_in_bytes == 8 || length_in_bytes == 16, "unsupported");
        __ neon_reverse_bits(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                             bt, /* isQ */ length_in_bytes == 16);
        if (bt != T_LONG) {
          __ clz(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
        } else {
          __ umov(rscratch1, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, 0);
          __ clz(rscratch1, rscratch1);
          __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, 0, rscratch1);
          __ umov(rscratch1, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, 1);
          __ clz(rscratch1, rscratch1);
          __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, 1, rscratch1);
        }
      } else {
        Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
        __ sve_rbit(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        __ sve_clz(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size, ptrue, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
      }
    }
  
#line 41990 "ad_aarch64.cpp"
  }
}

void vcountTrailingZeros_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6483 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_rbit(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, size,
                opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
    __ sve_clz(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, size,
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 42012 "ad_aarch64.cpp"
  }
}

void vreverseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6499 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (bt == T_BYTE) {
      if (VM_Version::use_neon_for_vector(length_in_bytes)) {
        __ rbit(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      } else {
        assert(UseSVE > 0, "must be sve");
        __ sve_rbit(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ B, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      }
    } else {
      assert(bt == T_SHORT || bt == T_INT || bt == T_LONG, "unsupported type");
      if (UseSVE == 0) {
        assert(length_in_bytes == 8 || length_in_bytes == 16, "unsupported");
        __ neon_reverse_bits(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                             bt, /* isQ */ length_in_bytes == 16);
      } else {
        __ sve_rbit(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
                    ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      }
    }
  
#line 42048 "ad_aarch64.cpp"
  }
}

void vreverse_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6532 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_rbit(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 42067 "ad_aarch64.cpp"
  }
}

void vreverseBytesNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6545 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      assert(length_in_bytes == 8 || length_in_bytes == 16, "unsupported");
      if (bt == T_BYTE) {
        if (opnd_array(0)->as_FloatRegister(ra_,this)/* dst */!= opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
          __ orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
      } else {
        __ neon_reverse_bytes(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                              bt, /* isQ */ length_in_bytes == 16);
      }
    } else {
      assert(UseSVE > 0, "must be sve");
      if (bt == T_BYTE) {
        if (opnd_array(0)->as_FloatRegister(ra_,this)/* dst */!= opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
          __ sve_orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
      } else {
        __ sve_revb(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
                    ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      }
    }
  
#line 42106 "ad_aarch64.cpp"
  }
}

void vreverseBytes_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6580 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    if (bt == T_BYTE) {
      // do nothing
    } else {
      __ sve_revb(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
                  opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
    }
  
#line 42129 "ad_aarch64.cpp"
  }
}

void populateindexNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6598 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_index(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
                 opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, (int)(opnd_array(2)->constant()));
  
#line 42148 "ad_aarch64.cpp"
  }
}

void mcompressNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6613 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_cntp(rscratch1, size, ptrue, opnd_array(1)->as_PRegister(ra_,this,idx1)/* pg */);
    __ sve_whilelt(as_PRegister(opnd_array(0)->reg(ra_,this)/* dst */), size, zr, rscratch1);
  
#line 42167 "ad_aarch64.cpp"
  }
}

void vcompressNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6627 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_compact(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
                   opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */);
  
#line 42186 "ad_aarch64.cpp"
  }
}

void vcompressBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// ptmp
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6641 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_compress_byte(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */,
                         opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */,opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */,
                         opnd_array(6)->as_FloatRegister(ra_,this,idx6)/* tmp3 */,opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* tmp4 */,
                         opnd_array(8)->as_PRegister(ra_,this,idx8)/* ptmp */, opnd_array(9)->as_PRegister(ra_,this,idx9)/* pgtmp */);
  
#line 42213 "ad_aarch64.cpp"
  }
}

void vcompressSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6656 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_compress_short(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */,
                          opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */,opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */);
  
#line 42235 "ad_aarch64.cpp"
  }
}

void vexpandNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6667 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Example input:   src   = 1 2 3 4 5 6 7 8
    //                  pg    = 1 0 0 1 1 0 1 1
    // Expected result: dst   = 4 0 0 5 6 0 7 8

    // The basic idea is to use TBL which can shuffle the elements in the given
    // vector flexibly. HISTCNT + SUB is used to generate the second source input
    // for TBL whose value is used to select the indexed element from src vector.

    BasicType bt = Matcher::vector_element_basic_type(this);
    assert(UseSVE == 2 && !is_subword_type(bt), "unsupported");
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    // dst = 0 0 0 0 0 0 0 0
    __ sve_dup(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, size, 0);
    // dst = 5 0 0 4 3 0 2 1
    __ sve_histcnt(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, size, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */,
                   opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
    // dst = 4 -1 -1 3 2 -1 1 0
    __ sve_sub(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, size, 1);
    // dst = 4 0 0 5 6 0 7 8
    __ sve_tbl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, size, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 42272 "ad_aarch64.cpp"
  }
}

void vsignum_le128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6702 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ vector_signum_neon(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* zero */,
                          opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* one */, get_arrangement(this));
  
#line 42292 "ad_aarch64.cpp"
  }
}

void vsignum_le128b_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6702 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ vector_signum_neon(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* zero */,
                          opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* one */, get_arrangement(this));
  
#line 42312 "ad_aarch64.cpp"
  }
}

void vsignum_gt128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6715 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vector_signum_sve(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* zero */,
                         opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* one */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */, opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */,
                         __ elemType_to_regVariant(bt));
  
#line 42337 "ad_aarch64.cpp"
  }
}

void vsignum_gt128b_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6715 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vector_signum_sve(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* zero */,
                         opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* one */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */, opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */,
                         __ elemType_to_regVariant(bt));
  
#line 42362 "ad_aarch64.cpp"
  }
}

void vcompressBitsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6730 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_bext(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size,
                opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 42382 "ad_aarch64.cpp"
  }
}

void vexpandBitsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6744 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_bdep(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size,
                opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 42402 "ad_aarch64.cpp"
  }
}

void compareAndSwapP_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 31 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ false, /*release*/ true, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 42425 "ad_aarch64.cpp"
  }
}

void compareAndSwapN_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 77 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, /*acquire*/ false, /*release*/ true, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 42446 "ad_aarch64.cpp"
  }
}

void compareAndSwapPAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 40 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ true, /*release*/ true, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 42469 "ad_aarch64.cpp"
  }
}

void compareAndSwapNAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 115 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, /*acquire*/ true, /*release*/ true, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 42490 "ad_aarch64.cpp"
  }
}

void compareAndExchangeN_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 131 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    Register tmp = opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ false, /*release*/ true, /*is_cae*/ true, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 42513 "ad_aarch64.cpp"
  }
}

void compareAndExchangeP_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 147 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    Register tmp = opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ false, /*release*/ true, /*is_cae*/ true, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 42536 "ad_aarch64.cpp"
  }
}

void compareAndExchangeNAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 164 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    Register tmp = opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ true, /*release*/ true, /*is_cae*/ true, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 42559 "ad_aarch64.cpp"
  }
}

void compareAndExchangePAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 181 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    Register tmp = opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ true, /*release*/ true, /*is_cae*/ true, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 42582 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapN_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 198 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    // Weak is not currently supported by ShenandoahBarrierSet::cmpxchg_oop
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ false, /*release*/ true, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 42605 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapP_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 215 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    // Weak is not currently supported by ShenandoahBarrierSet::cmpxchg_oop
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ false, /*release*/ true, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 42628 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapNAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 234 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    // Weak is not currently supported by ShenandoahBarrierSet::cmpxchg_oop
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ true, /*release*/ true, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 42651 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapPAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 253 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    // Weak is not currently supported by ShenandoahBarrierSet::cmpxchg_oop
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ true, /*release*/ true, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 42674 "ad_aarch64.cpp"
  }
}

void xLoadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 64 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"

    const Address ref_addr = mem2address(opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
    __ ldr(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, ref_addr);
    x_load_barrier(_masm, this, ref_addr, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, rscratch2 /* tmp */, barrier_data());
  
#line 42693 "ad_aarch64.cpp"
  }
}

void xLoadPVolatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 84 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"

    __ ldar(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    x_load_barrier(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, rscratch2 /* tmp */, barrier_data());
  
#line 42711 "ad_aarch64.cpp"
  }
}

void xCompareAndSwapPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 103 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
               false /* acquire */, true /* release */, false /* weak */, rscratch2);
    __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
    if (barrier_data() != XLoadBarrierElided) {
      Label good;
      __ ldr(rscratch1, Address(rthread, XThreadLocalData::address_bad_mask_offset()));
      __ andr(rscratch1, rscratch1, rscratch2);
      __ cbz(rscratch1, good);
      x_load_barrier_slow_path(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), rscratch2 /* ref */, rscratch1 /* tmp */);
      __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
                 false /* acquire */, true /* release */, false /* weak */, rscratch2);
      __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
      __ bind(good);
    }
  
#line 42744 "ad_aarch64.cpp"
  }
}

void xCompareAndSwapP_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 103 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
               false /* acquire */, true /* release */, false /* weak */, rscratch2);
    __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
    if (barrier_data() != XLoadBarrierElided) {
      Label good;
      __ ldr(rscratch1, Address(rthread, XThreadLocalData::address_bad_mask_offset()));
      __ andr(rscratch1, rscratch1, rscratch2);
      __ cbz(rscratch1, good);
      x_load_barrier_slow_path(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), rscratch2 /* ref */, rscratch1 /* tmp */);
      __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
                 false /* acquire */, true /* release */, false /* weak */, rscratch2);
      __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
      __ bind(good);
    }
  
#line 42777 "ad_aarch64.cpp"
  }
}

void xCompareAndSwapPAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 135 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
               true /* acquire */, true /* release */, false /* weak */, rscratch2);
    __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
    if (barrier_data() != XLoadBarrierElided) {
      Label good;
      __ ldr(rscratch1, Address(rthread, XThreadLocalData::address_bad_mask_offset()));
      __ andr(rscratch1, rscratch1, rscratch2);
      __ cbz(rscratch1, good);
      x_load_barrier_slow_path(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), rscratch2 /* ref */, rscratch1 /* tmp */ );
      __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
                 true /* acquire */, true /* release */, false /* weak */, rscratch2);
      __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
      __ bind(good);
    }
  
#line 42810 "ad_aarch64.cpp"
  }
}

void xCompareAndSwapPAcq_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 135 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
               true /* acquire */, true /* release */, false /* weak */, rscratch2);
    __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
    if (barrier_data() != XLoadBarrierElided) {
      Label good;
      __ ldr(rscratch1, Address(rthread, XThreadLocalData::address_bad_mask_offset()));
      __ andr(rscratch1, rscratch1, rscratch2);
      __ cbz(rscratch1, good);
      x_load_barrier_slow_path(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), rscratch2 /* ref */, rscratch1 /* tmp */ );
      __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
                 true /* acquire */, true /* release */, false /* weak */, rscratch2);
      __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
      __ bind(good);
    }
  
#line 42843 "ad_aarch64.cpp"
  }
}

void xCompareAndExchangePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 165 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
               false /* acquire */, true /* release */, false /* weak */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    if (barrier_data() != XLoadBarrierElided) {
      Label good;
      __ ldr(rscratch1, Address(rthread, XThreadLocalData::address_bad_mask_offset()));
      __ andr(rscratch1, rscratch1, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
      __ cbz(rscratch1, good);
      x_load_barrier_slow_path(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), opnd_array(4)->as_Register(ra_,this,idx4)/* res */, rscratch1 /* tmp */);
      __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
                 false /* acquire */, true /* release */, false /* weak */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
      __ bind(good);
    }
  
#line 42874 "ad_aarch64.cpp"
  }
}

void xCompareAndExchangePAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 193 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
               true /* acquire */, true /* release */, false /* weak */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    if (barrier_data() != XLoadBarrierElided) {
      Label good;
      __ ldr(rscratch1, Address(rthread, XThreadLocalData::address_bad_mask_offset()));
      __ andr(rscratch1, rscratch1, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
      __ cbz(rscratch1, good);
      x_load_barrier_slow_path(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), opnd_array(4)->as_Register(ra_,this,idx4)/* res */, rscratch1 /* tmp */);
      __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
                 true /* acquire */, true /* release */, false /* weak */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
      __ bind(good);
    }
  
#line 42905 "ad_aarch64.cpp"
  }
}

void xGetAndSetPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// prev
  {
    C2_MacroAssembler _masm(&cbuf);

#line 221 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"

    __ atomic_xchg(opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    x_load_barrier(_masm, this, Address(noreg, 0), opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, rscratch2 /* tmp */, barrier_data());
  
#line 42924 "ad_aarch64.cpp"
  }
}

void xGetAndSetPAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// prev
  {
    C2_MacroAssembler _masm(&cbuf);

#line 238 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"

    __ atomic_xchgal(opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    x_load_barrier(_masm, this, Address(noreg, 0), opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, rscratch2 /* tmp */, barrier_data());
  
#line 42943 "ad_aarch64.cpp"
  }
}

void zLoadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 113 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    const Address ref_addr = mem2address(opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
    __ ldr(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, ref_addr);
    z_load_barrier(_masm, this, ref_addr, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, rscratch1);
  
#line 42962 "ad_aarch64.cpp"
  }
}

void zLoadPVolatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 133 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    const Address ref_addr = Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    __ ldar(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_load_barrier(_masm, this, ref_addr, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, rscratch1);
  
#line 42981 "ad_aarch64.cpp"
  }
}

void zStorePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 151 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    const Address ref_addr = mem2address(opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
    z_store_barrier(_masm, this, ref_addr, opnd_array(2)->as_Register(ra_,this,idx2)/* src */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, rscratch2, false /* is_atomic */);
    __ str(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, ref_addr);
  
#line 43001 "ad_aarch64.cpp"
  }
}

void zStorePVolatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 168 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    const Address ref_addr = Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_store_barrier(_masm, this, ref_addr, opnd_array(2)->as_Register(ra_,this,idx2)/* src */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, rscratch2, false /* is_atomic */);
    __ stlr(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
  
#line 43021 "ad_aarch64.cpp"
  }
}

void zCompareAndSwapPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// oldval_tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// newval_tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 187 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    Address ref_addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_store_barrier(_masm, this, ref_addr, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, rscratch2, true /* is_atomic */);
    z_color(_masm, this, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, Assembler::xword,
               false /* acquire */, true /* release */, false /* weak */, noreg);
    __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
  
#line 43048 "ad_aarch64.cpp"
  }
}

void zCompareAndSwapP_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// oldval_tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// newval_tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 187 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    Address ref_addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_store_barrier(_masm, this, ref_addr, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, rscratch2, true /* is_atomic */);
    z_color(_masm, this, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, Assembler::xword,
               false /* acquire */, true /* release */, false /* weak */, noreg);
    __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
  
#line 43075 "ad_aarch64.cpp"
  }
}

void zCompareAndSwapPAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// oldval_tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// newval_tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 211 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    Address ref_addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_store_barrier(_masm, this, ref_addr, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, rscratch2, true /* is_atomic */);
    z_color(_masm, this, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, Assembler::xword,
               true /* acquire */, true /* release */, false /* weak */, noreg);
    __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
  
#line 43102 "ad_aarch64.cpp"
  }
}

void zCompareAndSwapPAcq_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// oldval_tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// newval_tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 211 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    Address ref_addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_store_barrier(_masm, this, ref_addr, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, rscratch2, true /* is_atomic */);
    z_color(_masm, this, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, Assembler::xword,
               true /* acquire */, true /* release */, false /* weak */, noreg);
    __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
  
#line 43129 "ad_aarch64.cpp"
  }
}

void zCompareAndExchangePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// oldval_tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// newval_tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 235 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    Address ref_addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_store_barrier(_masm, this, ref_addr, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, rscratch2, true /* is_atomic */);
    z_color(_masm, this, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, Assembler::xword,
               false /* acquire */, true /* release */, false /* weak */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    z_uncolor(_masm, this, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 43156 "ad_aarch64.cpp"
  }
}

void zCompareAndExchangePAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// oldval_tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// newval_tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 258 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    Address ref_addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_store_barrier(_masm, this, ref_addr, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, rscratch2, true /* is_atomic */);
    z_color(_masm, this, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, Assembler::xword,
               true /* acquire */, true /* release */, false /* weak */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    z_uncolor(_masm, this, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 43183 "ad_aarch64.cpp"
  }
}

void zGetAndSetPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// prev
  {
    C2_MacroAssembler _masm(&cbuf);

#line 280 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    z_store_barrier(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, rscratch2, true /* is_atomic */);
    __ atomic_xchg(opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_uncolor(_masm, this, opnd_array(3)->as_Register(ra_,this,idx3)/* prev */);
  
#line 43203 "ad_aarch64.cpp"
  }
}

void zGetAndSetPAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// prev
  {
    C2_MacroAssembler _masm(&cbuf);

#line 298 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    z_store_barrier(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, rscratch2, true /* is_atomic */);
    __ atomic_xchgal(opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_uncolor(_masm, this, opnd_array(3)->as_Register(ra_,this,idx3)/* prev */);
  
#line 43223 "ad_aarch64.cpp"
  }
}

const MachOper* loadBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadB2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUB2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadINode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadLNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadRangeNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadPNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadNNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadNKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadFNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadDNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmCM0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmCM0_orderedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeBNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmB0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeCNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmC0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeINode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmI0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeLNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmL0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storePNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmP0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeNNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmN0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeFNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeDNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeNKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchallocNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadB_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadB2L_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUB_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUB2L_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2L_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS2L_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUI2L_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadL_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadP_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadN_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadF_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadD_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeB_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmB0_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeC_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmC0_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeI_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmI0_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeL_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmL0_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeP_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmP0_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeN_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmN0_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeF_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeD_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* cacheWBNode::memory_operand() const { return _opnds[1]; }
const MachOper* popCountI_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* popCountL_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapBNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapSNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapINode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapLNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapPNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapNNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapBAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapSAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapIAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapLAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapPAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapNAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeBNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeSNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeINode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeLNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeNNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangePNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeBAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeSAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeIAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeLAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeNAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangePAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapBNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapSNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapINode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapLNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapNNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapPNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapBAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapSAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapIAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapLAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapNAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapPAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setINode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setLNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setNNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setPNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setIAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setLAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setNAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setPAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addL_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLiNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLi_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addINode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addI_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addIiNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addIi_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addL_no_resAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLiAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLi_no_resAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addIAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addI_no_resAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addIiAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addIi_no_resAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compressBitsI_memconNode::memory_operand() const { return _opnds[1]; }
const MachOper* compressBitsL_memconNode::memory_operand() const { return _opnds[1]; }
const MachOper* expandBitsI_memconNode::memory_operand() const { return _opnds[1]; }
const MachOper* expandBitsL_memconNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadV2Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeV2Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadV4Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeV4Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadV8Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeV8Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadV16Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeV16Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadVNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeVNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadV_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeV_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* vloadmask_loadVNode::memory_operand() const { return _opnds[1]; }
const MachOper* vloadmask_loadV_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* vloadmask_loadVMaskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* vloadmask_loadVMasked_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeV_vstoremaskNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeV_vstoremask_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeVMasked_vstoremaskNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeVMasked_vstoremask_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* gather_loadSNode::memory_operand() const { return _opnds[1]; }
const MachOper* gather_loadDNode::memory_operand() const { return _opnds[1]; }
const MachOper* gather_loadS_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* gather_loadD_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* scatter_storeSNode::memory_operand() const { return _opnds[1]; }
const MachOper* scatter_storeDNode::memory_operand() const { return _opnds[1]; }
const MachOper* scatter_storeS_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* scatter_storeD_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapP_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapN_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapPAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapNAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeN_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeP_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeNAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangePAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapN_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapP_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapNAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapPAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* xLoadPNode::memory_operand() const { return _opnds[1]; }
const MachOper* xLoadPVolatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* xCompareAndSwapPNode::memory_operand() const { return _opnds[1]; }
const MachOper* xCompareAndSwapP_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* xCompareAndSwapPAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* xCompareAndSwapPAcq_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* xCompareAndExchangePNode::memory_operand() const { return _opnds[1]; }
const MachOper* xCompareAndExchangePAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* xGetAndSetPNode::memory_operand() const { return _opnds[1]; }
const MachOper* xGetAndSetPAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* zLoadPNode::memory_operand() const { return _opnds[1]; }
const MachOper* zLoadPVolatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* zStorePNode::memory_operand() const { return _opnds[1]; }
const MachOper* zStorePVolatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* zCompareAndSwapPNode::memory_operand() const { return _opnds[1]; }
const MachOper* zCompareAndSwapP_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* zCompareAndSwapPAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* zCompareAndSwapPAcq_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* zCompareAndExchangePNode::memory_operand() const { return _opnds[1]; }
const MachOper* zCompareAndExchangePAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* zGetAndSetPNode::memory_operand() const { return _opnds[1]; }
const MachOper* zGetAndSetPAcqNode::memory_operand() const { return _opnds[1]; }


const bool Matcher::has_match_rule(int opcode) {
  assert(_last_machine_leaf < opcode && opcode < _last_opcode, "opcode in range");
  return _hasMatchRule[opcode];
}

const bool Matcher::_hasMatchRule[_last_opcode] = {
    false,  // Node
    false,  // Set
    false,  // RegN
    false,  // RegI
    false,  // RegP
    false,  // RegF
    false,  // RegD
    false,  // RegL
    false,  // VecA
    false,  // VecS
    false,  // VecD
    false,  // VecX
    false,  // VecY
    false,  // VecZ
    false,  // RegVectMask
    false,  // RegFlags
    false,  // _last_machine_leaf
    true ,  // AbsD
    true ,  // AbsF
    true ,  // AbsI
    true ,  // AbsL
    true ,  // AddD
    true ,  // AddF
    true ,  // AddI
    true ,  // AddL
    true ,  // AddP
    false,  // Allocate
    false,  // AllocateArray
    true ,  // AndI
    true ,  // AndL
    false,  // ArrayCopy
    true ,  // AryEq
    false,  // AtanD
    true ,  // Binary
    false,  // Blackhole
    true ,  // Bool
    false,  // BoxLock
    true ,  // ReverseBytesI
    true ,  // ReverseBytesL
    true ,  // ReverseBytesUS
    true ,  // ReverseBytesS
    true ,  // ReverseBytesV
    false,  // CProj
    true ,  // CacheWB
    true ,  // CacheWBPreSync
    true ,  // CacheWBPostSync
    true ,  // CallDynamicJava
    false,  // CallJava
    true ,  // CallLeaf
    true ,  // CallLeafNoFP
    false,  // CallLeafVector
    true ,  // CallRuntime
    true ,  // CallStaticJava
    true ,  // CastDD
    true ,  // CastFF
    true ,  // CastII
    true ,  // CastLL
    true ,  // CastVV
    true ,  // CastX2P
    true ,  // CastP2X
    true ,  // CastPP
    false,  // Catch
    false,  // CatchProj
    true ,  // CheckCastPP
    true ,  // ClearArray
    true ,  // CompressBits
    true ,  // ExpandBits
    true ,  // CompressBitsV
    true ,  // ExpandBitsV
    false,  // ConstraintCast
    true ,  // CMoveD
    true ,  // CMoveF
    true ,  // CMoveI
    true ,  // CMoveL
    true ,  // CMoveP
    true ,  // CMoveN
    true ,  // CmpN
    true ,  // CmpD
    true ,  // CmpD3
    true ,  // CmpF
    true ,  // CmpF3
    true ,  // CmpI
    true ,  // CmpL
    true ,  // CmpL3
    true ,  // CmpLTMask
    true ,  // CmpP
    true ,  // CmpU
    true ,  // CmpU3
    true ,  // CmpUL
    true ,  // CmpUL3
    true ,  // CompareAndSwapB
    true ,  // CompareAndSwapS
    true ,  // CompareAndSwapI
    true ,  // CompareAndSwapL
    true ,  // CompareAndSwapP
    true ,  // CompareAndSwapN
    true ,  // WeakCompareAndSwapB
    true ,  // WeakCompareAndSwapS
    true ,  // WeakCompareAndSwapI
    true ,  // WeakCompareAndSwapL
    true ,  // WeakCompareAndSwapP
    true ,  // WeakCompareAndSwapN
    true ,  // CompareAndExchangeB
    true ,  // CompareAndExchangeS
    true ,  // CompareAndExchangeI
    true ,  // CompareAndExchangeL
    true ,  // CompareAndExchangeP
    true ,  // CompareAndExchangeN
    false,  // GetAndAddB
    false,  // GetAndAddS
    true ,  // GetAndAddI
    true ,  // GetAndAddL
    false,  // GetAndSetB
    false,  // GetAndSetS
    true ,  // GetAndSetI
    true ,  // GetAndSetL
    true ,  // GetAndSetP
    true ,  // GetAndSetN
    false,  // Con
    true ,  // ConN
    true ,  // ConNKlass
    true ,  // ConD
    true ,  // ConF
    true ,  // ConI
    true ,  // ConL
    true ,  // ConP
    false,  // Conv2B
    true ,  // ConvD2F
    true ,  // ConvD2I
    true ,  // ConvD2L
    true ,  // ConvF2D
    true ,  // ConvF2I
    true ,  // ConvF2L
    true ,  // ConvI2D
    true ,  // ConvI2F
    true ,  // ConvI2L
    true ,  // ConvL2D
    true ,  // ConvL2F
    true ,  // ConvL2I
    true ,  // ConvF2HF
    true ,  // ConvHF2F
    false,  // CountedLoop
    true ,  // CountedLoopEnd
    false,  // OuterStripMinedLoop
    false,  // OuterStripMinedLoopEnd
    false,  // LongCountedLoop
    false,  // LongCountedLoopEnd
    true ,  // CountLeadingZerosI
    true ,  // CountLeadingZerosL
    true ,  // CountLeadingZerosV
    true ,  // CountTrailingZerosI
    true ,  // CountTrailingZerosL
    true ,  // CountTrailingZerosV
    true ,  // CreateEx
    true ,  // DecodeN
    true ,  // DecodeNKlass
    true ,  // DivD
    true ,  // DivF
    true ,  // DivI
    true ,  // DivL
    true ,  // UDivI
    true ,  // UDivL
    false,  // DivMod
    false,  // DivModI
    false,  // DivModL
    false,  // UDivModI
    false,  // UDivModL
    true ,  // EncodeISOArray
    true ,  // EncodeP
    true ,  // EncodePKlass
    true ,  // FastLock
    true ,  // FastUnlock
    true ,  // FmaD
    true ,  // FmaF
    true ,  // Goto
    true ,  // Halt
    true ,  // CountPositives
    true ,  // If
    false,  // RangeCheck
    false,  // IfFalse
    false,  // IfTrue
    false,  // Initialize
    false,  // JProj
    false,  // Jump
    false,  // JumpProj
    true ,  // LShiftI
    true ,  // LShiftL
    true ,  // LoadB
    true ,  // LoadUB
    true ,  // LoadUS
    true ,  // LoadD
    false,  // LoadD_unaligned
    true ,  // LoadF
    true ,  // LoadI
    true ,  // LoadKlass
    true ,  // LoadNKlass
    true ,  // LoadL
    false,  // LoadL_unaligned
    true ,  // LoadP
    true ,  // LoadN
    true ,  // LoadRange
    true ,  // LoadS
    false,  // Lock
    false,  // Loop
    false,  // LoopLimit
    false,  // Mach
    false,  // MachNullCheck
    false,  // MachProj
    true ,  // MulAddS2I
    true ,  // MaxI
    false,  // MaxL
    true ,  // MaxD
    true ,  // MaxF
    true ,  // MemBarAcquire
    true ,  // LoadFence
    true ,  // MemBarAcquireLock
    false,  // MemBarCPUOrder
    true ,  // MemBarRelease
    true ,  // StoreFence
    true ,  // StoreStoreFence
    true ,  // MemBarReleaseLock
    true ,  // MemBarVolatile
    true ,  // MemBarStoreStore
    false,  // MergeMem
    true ,  // MinI
    false,  // MinL
    true ,  // MinF
    true ,  // MinD
    false,  // ModD
    false,  // ModF
    true ,  // ModI
    true ,  // ModL
    true ,  // UModI
    true ,  // UModL
    true ,  // MoveI2F
    true ,  // MoveF2I
    true ,  // MoveL2D
    true ,  // MoveD2L
    false,  // IsInfiniteF
    false,  // IsFiniteF
    false,  // IsInfiniteD
    false,  // IsFiniteD
    true ,  // MulD
    true ,  // MulF
    true ,  // MulHiL
    true ,  // UMulHiL
    true ,  // MulI
    true ,  // MulL
    false,  // Multi
    false,  // NegI
    false,  // NegL
    true ,  // NegD
    true ,  // NegF
    false,  // NeverBranch
    true ,  // OnSpinWait
    false,  // Opaque1
    false,  // OpaqueLoopInit
    false,  // OpaqueLoopStride
    false,  // OpaqueZeroTripGuard
    false,  // Opaque3
    false,  // Opaque4
    false,  // ProfileBoolean
    true ,  // OrI
    true ,  // OrL
    true ,  // OverflowAddI
    true ,  // OverflowSubI
    true ,  // OverflowMulI
    true ,  // OverflowAddL
    true ,  // OverflowSubL
    true ,  // OverflowMulL
    false,  // PCTable
    false,  // Parm
    false,  // ParsePredicate
    true ,  // PartialSubtypeCheck
    false,  // SubTypeCheck
    false,  // Phi
    true ,  // PopCountI
    true ,  // PopCountL
    true ,  // PopCountVI
    true ,  // PopCountVL
    true ,  // PopulateIndex
    true ,  // PrefetchAllocation
    false,  // Proj
    true ,  // RShiftI
    true ,  // RShiftL
    false,  // Region
    true ,  // Rethrow
    true ,  // Return
    true ,  // ReverseI
    true ,  // ReverseL
    true ,  // ReverseV
    false,  // Root
    false,  // RoundDouble
    true ,  // RoundDoubleMode
    true ,  // RoundDoubleModeV
    false,  // RoundFloat
    true ,  // RotateLeft
    false,  // RotateLeftV
    true ,  // RotateRight
    false,  // RotateRightV
    true ,  // SafePoint
    false,  // SafePointScalarObject
    true ,  // ShenandoahCompareAndExchangeP
    true ,  // ShenandoahCompareAndExchangeN
    true ,  // ShenandoahCompareAndSwapN
    true ,  // ShenandoahCompareAndSwapP
    true ,  // ShenandoahWeakCompareAndSwapN
    true ,  // ShenandoahWeakCompareAndSwapP
    false,  // ShenandoahIUBarrier
    false,  // ShenandoahLoadReferenceBarrier
    false,  // SCMemProj
    true ,  // CopySignD
    true ,  // CopySignF
    true ,  // SignumD
    true ,  // SignumF
    true ,  // SignumVF
    true ,  // SignumVD
    true ,  // SqrtD
    true ,  // SqrtF
    true ,  // RoundF
    true ,  // RoundD
    false,  // Start
    false,  // StartOSR
    true ,  // StoreB
    true ,  // StoreC
    true ,  // StoreCM
    true ,  // StoreD
    true ,  // StoreF
    true ,  // StoreI
    true ,  // StoreL
    true ,  // StoreP
    true ,  // StoreN
    true ,  // StoreNKlass
    true ,  // StrComp
    true ,  // StrCompressedCopy
    true ,  // StrEquals
    true ,  // StrIndexOf
    true ,  // StrIndexOfChar
    true ,  // StrInflatedCopy
    true ,  // SubD
    true ,  // SubF
    true ,  // SubI
    true ,  // SubL
    true ,  // TailCall
    true ,  // TailJump
    false,  // MacroLogicV
    true ,  // ThreadLocal
    false,  // Unlock
    false,  // URShiftB
    false,  // URShiftS
    true ,  // URShiftI
    true ,  // URShiftL
    true ,  // XorI
    true ,  // XorL
    false,  // Vector
    true ,  // AddVB
    true ,  // AddVS
    true ,  // AddVI
    true ,  // AddReductionVI
    true ,  // AddVL
    true ,  // AddReductionVL
    true ,  // AddVF
    true ,  // AddReductionVF
    true ,  // AddVD
    true ,  // AddReductionVD
    true ,  // SubVB
    true ,  // SubVS
    true ,  // SubVI
    true ,  // SubVL
    true ,  // SubVF
    true ,  // SubVD
    true ,  // MulVB
    true ,  // MulVS
    true ,  // MulVI
    true ,  // MulReductionVI
    true ,  // MulVL
    true ,  // MulReductionVL
    true ,  // MulVF
    true ,  // MulReductionVF
    true ,  // MulVD
    true ,  // MulReductionVD
    true ,  // MulAddVS2VI
    true ,  // FmaVD
    true ,  // FmaVF
    true ,  // DivVF
    true ,  // DivVD
    true ,  // AbsVB
    true ,  // AbsVS
    true ,  // AbsVI
    true ,  // AbsVL
    true ,  // AbsVF
    true ,  // AbsVD
    true ,  // NegVI
    true ,  // NegVL
    true ,  // NegVF
    true ,  // NegVD
    true ,  // SqrtVD
    true ,  // SqrtVF
    true ,  // LShiftCntV
    true ,  // RShiftCntV
    true ,  // LShiftVB
    true ,  // LShiftVS
    true ,  // LShiftVI
    true ,  // LShiftVL
    true ,  // RShiftVB
    true ,  // RShiftVS
    true ,  // RShiftVI
    true ,  // RShiftVL
    true ,  // URShiftVB
    true ,  // URShiftVS
    true ,  // URShiftVI
    true ,  // URShiftVL
    true ,  // AndV
    true ,  // AndReductionV
    true ,  // OrV
    true ,  // OrReductionV
    true ,  // XorV
    true ,  // XorReductionV
    true ,  // MinV
    true ,  // MaxV
    true ,  // MinReductionV
    true ,  // MaxReductionV
    true ,  // CompressV
    true ,  // CompressM
    true ,  // ExpandV
    true ,  // LoadVector
    true ,  // LoadVectorGather
    true ,  // LoadVectorGatherMasked
    true ,  // StoreVector
    true ,  // StoreVectorScatter
    true ,  // StoreVectorScatterMasked
    true ,  // LoadVectorMasked
    true ,  // StoreVectorMasked
    false,  // VectorCmpMasked
    true ,  // VectorMaskGen
    false,  // VectorMaskOp
    true ,  // VectorMaskTrueCount
    true ,  // VectorMaskFirstTrue
    true ,  // VectorMaskLastTrue
    true ,  // VectorMaskToLong
    true ,  // VectorLongToMask
    false,  // Pack
    false,  // PackB
    false,  // PackS
    false,  // PackI
    false,  // PackL
    false,  // PackF
    false,  // PackD
    false,  // Pack2L
    false,  // Pack2D
    true ,  // ReplicateB
    true ,  // ReplicateS
    true ,  // ReplicateI
    true ,  // ReplicateL
    true ,  // ReplicateF
    true ,  // ReplicateD
    true ,  // RoundVF
    true ,  // RoundVD
    false,  // Extract
    true ,  // ExtractB
    false,  // ExtractUB
    false,  // ExtractC
    true ,  // ExtractS
    true ,  // ExtractI
    true ,  // ExtractL
    true ,  // ExtractF
    true ,  // ExtractD
    false,  // Digit
    false,  // LowerCase
    false,  // UpperCase
    false,  // Whitespace
    false,  // VectorBox
    false,  // VectorBoxAllocate
    false,  // VectorUnbox
    false,  // VectorMaskWrapper
    true ,  // VectorMaskCmp
    true ,  // VectorMaskCast
    true ,  // VectorTest
    true ,  // VectorBlend
    true ,  // VectorRearrange
    true ,  // VectorLoadMask
    true ,  // VectorLoadShuffle
    true ,  // VectorLoadConst
    true ,  // VectorStoreMask
    true ,  // VectorReinterpret
    false,  // VectorCast
    true ,  // VectorCastB2X
    true ,  // VectorCastS2X
    true ,  // VectorCastI2X
    true ,  // VectorCastL2X
    true ,  // VectorCastF2X
    true ,  // VectorCastD2X
    true ,  // VectorCastF2HF
    true ,  // VectorCastHF2F
    false,  // VectorUCastB2X
    false,  // VectorUCastS2X
    false,  // VectorUCastI2X
    false,  // VectorizedHashCode
    true ,  // VectorInsert
    true ,  // MaskAll
    true ,  // AndVMask
    true ,  // OrVMask
    true    // XorVMask
};


int Compile::sync_stack_slots() const { return 2; }

uint Matcher::stack_alignment_in_bytes() { return StackAlignmentInBytes; }

OptoReg::Name Matcher::return_addr() const { return OptoReg::stack2reg(- 2 +
              align_up((Compile::current()->in_preserve_stack_slots() +
                        Compile::current()->fixed_slots()),
                       stack_alignment_in_slots())); }

uint Compile::varargs_C_out_slots_killed() const { return frame::arg_reg_save_area_bytes/BytesPerInt; }

OptoRegPair Matcher::return_value(uint ideal_reg) {

#line 3923 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    // TODO do we allow ideal_reg == Op_RegN???
    assert(ideal_reg >= Op_RegI && ideal_reg <= Op_RegL,
           "only return normal values");

    static const int lo[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      R0_num,                            // Op_RegN
      R0_num,                            // Op_RegI
      R0_num,                            // Op_RegP
      V0_num,                            // Op_RegF
      V0_num,                            // Op_RegD
      R0_num                             // Op_RegL
    };

    static const int hi[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      OptoReg::Bad,                      // Op_RegN
      OptoReg::Bad,                      // Op_RegI
      R0_H_num,                          // Op_RegP
      OptoReg::Bad,                      // Op_RegF
      V0_H_num,                          // Op_RegD
      R0_H_num                           // Op_RegL
    };

    return OptoRegPair(hi[ideal_reg], lo[ideal_reg]);
  
#line 43979 "ad_aarch64.cpp"

}

OptoRegPair Matcher::c_return_value(uint ideal_reg) {

#line 3923 "/builddir/build/BUILD/java-21-openjdk-21.0.6.0.7-1.fc40.aarch64/jdk-21.0.6+7/src/hotspot/cpu/aarch64/aarch64.ad"

    // TODO do we allow ideal_reg == Op_RegN???
    assert(ideal_reg >= Op_RegI && ideal_reg <= Op_RegL,
           "only return normal values");

    static const int lo[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      R0_num,                            // Op_RegN
      R0_num,                            // Op_RegI
      R0_num,                            // Op_RegP
      V0_num,                            // Op_RegF
      V0_num,                            // Op_RegD
      R0_num                             // Op_RegL
    };

    static const int hi[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      OptoReg::Bad,                      // Op_RegN
      OptoReg::Bad,                      // Op_RegI
      R0_H_num,                          // Op_RegP
      OptoReg::Bad,                      // Op_RegF
      V0_H_num,                          // Op_RegD
      R0_H_num                           // Op_RegL
    };

    return OptoRegPair(hi[ideal_reg], lo[ideal_reg]);
  
#line 44015 "ad_aarch64.cpp"

}

OptoReg::Name Matcher::inline_cache_reg() { return OptoReg::Name(R12_num); }

int Matcher::inline_cache_reg_encode() { return _regEncode[inline_cache_reg()]; }

OptoReg::Name Matcher::interpreter_frame_pointer_reg() { return OptoReg::Name(R29_num); }

OptoReg::Name Matcher::c_frame_pointer() const { return OptoReg::Name(R31_num); }

// Number of callee-save + always-save registers
int  Matcher::number_of_saved_registers() {
  return 0;
};

bool Compile::needs_deep_clone_jvms() { return false; }

// Check consistency of C++ compilation with ADLC options:
// Check adlc -DLINUX=1
#ifndef LINUX
#  error "LINUX must be defined"
#endif // LINUX
// Check adlc -D_GNU_SOURCE=1
#ifndef _GNU_SOURCE
#  error "_GNU_SOURCE must be defined"
#endif // _GNU_SOURCE
// Check adlc -DAARCH64=1
#ifndef AARCH64
#  error "AARCH64 must be defined"
#endif // AARCH64
// Check adlc -D_LP64=1
#ifndef _LP64
#  error "_LP64 must be defined"
#endif // _LP64
// Check adlc -DASSERT=1
#ifndef ASSERT
#  error "ASSERT must be defined"
#endif // ASSERT
